import BLAS.{axpy, scal}
import MOWOATSKM.{WriteToFile, findClosest}
import org.apache.spark.SparkContext
import org.apache.spark.mllib.linalg.{Matrix, Vector, Vectors}
import org.apache.spark.rdd._
import org.apache.spark.sql.{DataFrame, Row, SparkSession}
import org.apache.spark.ml.stat.Correlation
import org.apache.spark.sql.types.{StringType, StructField, StructType}

import scala.collection.mutable.ListBuffer
//import org.apache.spark.sql.DataFrame
import java.io.InputStream
import java.io.InputStreamReader
import java.util.StringTokenizer
import java.io.BufferedReader
import java.io.FileInputStream
import java.io.IOException

import org.apache.spark.sql.{Column, DataFrame, Dataset}
import org.apache.spark.sql.functions.{avg, col, udf}

import scala.io.Source
import com.github.martincooper

import collection.mutable.Map




class BioValidIndice extends java.io.Serializable
{
  var k : Int = 0
  var spark : SparkSession = null
  var GOFrame : DataFrame = null

  //<Distance desc="Pearson Distance Function">
  def PearCorCenters(centers: Array[Vector], p: Vector): (Int, Double) =
  {
    var index : Int = 0
    var MinDist: Double = 0
    var Temp = SpearmanCor(centers(0), p)
    MinDist = Temp._1
    index = 0

    for ( i<- 1 until centers.length)
    {
      //"go_id"
      val Temp = SpearmanCor(centers(i), p)
      //best value for
      // pearson correlation is bigger than zero to be positive correlated
      //pearson correlation zero, there is no relation among two genes
      //pearson correlation less than zero, genes are negatively correlated
      if (Temp._1 < MinDist )
        {
          MinDist = Temp._1
          index = i
        }
    }


    return(index, MinDist)
  }


  def PearCor(x: Vector, y: Vector): Double =
  {
    var n : Int = x.size
    var sum_X : Double = 0.0
    var sum_Y : Double = 0.0
    var sum_XY : Double = 0.0
    var squareSum_X : Double = 0.0
    var squareSum_Y : Double = 0.0
    var corr : Double = 0.0

    for ( i <- 0  until n)
    {
      sum_X = sum_X + x(i);
      sum_Y = sum_Y + y(i);
    }
    var mx : Double = sum_X / n.asInstanceOf[Double]
    var my : Double = sum_Y / n.asInstanceOf[Double]
    var up : Double = 0.0
    var downX : Double = 0.0
    var downY : Double = 0.0
    var v1 : Double = 0.0
    var v2 : Double = 0.0

    for ( i <- 0  until n)
    {
      v1 = x(i) - mx
      v2 = y(i) - my
      up = up + ( v1 * v2    )
      downX = downX + math.pow(v1, 2)
      downY = downY + math.pow(v2, 2)
    }

    if  (math.sqrt(downX*downY) == 0 ) {
      corr = 2
      }
    else {
      corr = up / math.sqrt(downX * downY)
      corr = 1.0 - corr
    }

    val t = (corr * math.sqrt(n-2) )/ math.sqrt( 1 - math.pow(corr, 2) )

    return corr;

  }

  def SpearmanCorRow2Row(x: org.apache.spark.sql.Row, y: org.apache.spark.sql.Row,
              except:ListBuffer[String] = ListBuffer[String]("") ): (Double, Double) =
  {

    var resultMap = new  Array[Tuple2[Double, Int] ](x.size -except.length ) //= null
    var j : Int =   0
    for (i<- 0 until x.size)
    {
      if (except.contains(x.schema.fields(i).name) == false) {
        resultMap(j) = Tuple2(x.getDouble(i), j)
        j += 1
      }
    }

    var ttt = resultMap.toSeq.sortBy(_._1)
    var rank_X : Array[Int] = new Array[Int](ttt.length)

    for (i<- 0 until ttt.length)
    {
      rank_X(ttt(i)._2) = i+1
    }

    ///////YYY
    resultMap  = new  Array[Tuple2[Double, Int] ](rank_X.length )
    j  =   0
    for (i<- 0 until y.size)
    {
      if (except.contains(y.schema.fields(i).name) == false) {
        resultMap(j) = Tuple2(y.getDouble(i), j)
        j += 1
      }
    }

    ttt = resultMap.toSeq.sortBy(_._1)
    var rank_Y : Array[Int] = new Array[Int](ttt.length)

    for (i<- 0 until ttt.length)
    {
      rank_Y(ttt(i)._2) = i+1
    }


    var n : Int = rank_X.length
    var sum_X : Double = 0.0
    var sum_Y : Double = 0.0
    var sum_XY : Double = 0.0
    var squareSum_X : Double = 0.0
    var squareSum_Y : Double = 0.0
    var corr : Double = 0.0
    var dist : Double =   0.0

    for ( i <- 0  until n)
    {
      sum_X = sum_X + rank_X(i);
      sum_Y = sum_Y + rank_Y(i);
      sum_XY = sum_XY + ( rank_X(i) * rank_Y(i) )
      squareSum_X = squareSum_X + ( rank_X(i) * rank_X(i) )
      squareSum_Y = squareSum_Y + ( rank_Y(i) * rank_Y(i) )
      dist = dist + math.pow(rank_X(i) - rank_Y(i) ,2)
    }

    var up : Double = 0.0
    var downX : Double = 0.0
    var downY : Double = 0.0

    up =  (  sum_XY -  ( (sum_X * sum_Y) / n.asInstanceOf[Double] )  )
    downX = math.sqrt(squareSum_X - (math.pow(sum_X, 2) / n.asInstanceOf[Double]))
    downY = math.sqrt(squareSum_Y - (math.pow(sum_Y, 2) / n.asInstanceOf[Double]))

    corr = up / (downX * downY)

    if  ((downX*downY) == 0 )
    {     corr = 2    }
    else
    {   corr = 1.0 - corr   }

    var temp = 1 - ( (6 * dist) / (n * (math.pow(n,2) - 1)) )
    val sect = 1 - temp
    if ( temp  >  0 )
    {
      temp = (-1) * temp
    }
    temp = 1 + temp


    val t = (corr * math.sqrt(n-2) ) / math.sqrt( 1 - math.pow(corr, 2) )

    return (temp,sect) ;

  }

  def SpearmanCorRow(x: Vector, y: org.apache.spark.sql.Row, except:ListBuffer[String] = ListBuffer[String]("") ):
  (Double, Double) =
  {

    var resultMap = x.toArray.zipWithIndex

    var ttt = resultMap.toSeq.sortBy(_._1)
    var rank_X : Array[Int] = new Array[Int](ttt.length)

    for (i<- 0 until ttt.length)
    {
      rank_X(ttt(i)._2) = i+1
    }

    //resultMap = y.toSeq.zipWithIndex //    toSeq.zipWithIndex
    resultMap = new Array[Tuple2[Double, Int] ](rank_X.length)
    var j : Int =   0
    for (i<- 0 until y.size)
    {
      if (except.contains(y.schema.fields(i).name) == false) {
        resultMap(j) = Tuple2(y.getDouble(i), j)
        j += 1
      }
    }


    ttt = resultMap.toSeq.sortBy(_._1)
    var rank_Y : Array[Int] = new Array[Int](ttt.length)

    for (i<- 0 until ttt.length)
    {
      rank_Y(ttt(i)._2) = i+1
    }

    var n : Int = rank_X.length
    var sum_X : Double = 0.0
    var sum_Y : Double = 0.0
    var sum_XY : Double = 0.0
    var squareSum_X : Double = 0.0
    var squareSum_Y : Double = 0.0
    var corr : Double = 0.0
    var dist : Double =   0.0

    for ( i <- 0  until n)
    {
      sum_X = sum_X + rank_X(i);
      sum_Y = sum_Y + rank_Y(i);
      sum_XY = sum_XY + ( rank_X(i) * rank_Y(i) )
      squareSum_X = squareSum_X + ( rank_X(i) * rank_X(i) )
      squareSum_Y = squareSum_Y + ( rank_Y(i) * rank_Y(i) )
      dist = dist + math.pow(rank_X(i) - rank_Y(i) ,2)
    }

    var up : Double = 0.0
    var downX : Double = 0.0
    var downY : Double = 0.0

    up =  (  sum_XY -  ( (sum_X * sum_Y) / n.asInstanceOf[Double] )  )
    downX = math.sqrt(squareSum_X - (math.pow(sum_X, 2) / n.asInstanceOf[Double]))
    downY = math.sqrt(squareSum_Y - (math.pow(sum_Y, 2) / n.asInstanceOf[Double]))

    corr = up / (downX * downY)

    if  ((downX*downY) == 0 )
    {     corr = 2    }
    else
    {   corr = 1.0 - corr   }

    var temp = 1 - ( (6 * dist) / (n * (math.pow(n,2) - 1)) )
    val sect = 1- temp
    if ( temp  >  0 )
    {
      temp = (-1) * temp
    }
    temp = 1 + temp
    //temp = 1 - temp

    val t = (corr * math.sqrt(n-2) ) / math.sqrt( 1 - math.pow(corr, 2) )

    return (temp, sect);

  }

  def SpearmanCor(x: Vector, y: Vector, exception:ListBuffer[String] = ListBuffer[String]("") ):
  (Double, Double) =
  {

    var resultMap = x.toArray.zipWithIndex
    var ttt = resultMap.toSeq.sortBy(_._1)
    var rank_X : Array[Int] = new Array[Int](ttt.length)

    for (i<- 0 until ttt.length)
    {
      rank_X(ttt(i)._2) = i+1
    }

    resultMap = y.toArray.zipWithIndex
    ttt = resultMap.toSeq.sortBy(_._1)
    var rank_Y : Array[Int] = new Array[Int](ttt.length)

    for (i<- 0 until ttt.length)
    {
      rank_Y(ttt(i)._2) = i+1
    }

    var n : Int = rank_Y.length
    var sum_X : Double = 0.0
    var sum_Y : Double = 0.0
    var sum_XY : Double = 0.0
    var squareSum_X : Double = 0.0
    var squareSum_Y : Double = 0.0
    var corr : Double = 0.0
    var dist : Double =   0.0

    for ( i <- 0  until n)
    {
      sum_X = sum_X + rank_X(i);
      sum_Y = sum_Y + rank_Y(i);
      sum_XY = sum_XY + ( rank_X(i) * rank_Y(i) )
      squareSum_X = squareSum_X + ( rank_X(i) * rank_X(i) )
      squareSum_Y = squareSum_Y + ( rank_Y(i) * rank_Y(i) )
      dist = dist + math.pow(rank_X(i) - rank_Y(i) ,2)
    }

    var up : Double = 0.0
    var downX : Double = 0.0
    var downY : Double = 0.0

    up =  (  sum_XY -  ( (sum_X * sum_Y) / n.asInstanceOf[Double] )  )
    downX = math.sqrt(squareSum_X - (math.pow(sum_X, 2) / n.asInstanceOf[Double]))
    downY = math.sqrt(squareSum_Y - (math.pow(sum_Y, 2) / n.asInstanceOf[Double]))

    corr = up / (downX * downY)

    if  ((downX*downY) == 0 )
    {     corr = 2    }
    else
    {   corr = 1.0 - corr   }

    var temp = 1 - ( (6 * dist) / (n * (math.pow(n,2) - 1)) )
    val sect = 1 -temp
    if ( temp  >  0 )
    {
      temp = (-1) * temp
    }
    temp = 1 + temp
    //temp = 1 - temp

    val t = (corr * math.sqrt(n-2) ) / math.sqrt( 1 - math.pow(corr, 2) )

    return (temp, sect);

  }

  def ObjFunCent(p1: Vector, p2: Vector)
  : Double =
  {
    //, except: ListBuffer[String]): Double = {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)

    for (i<- 0 until p2.size)
    {
      //if (except.contains(p2.(i).name) == false) {
      squaredDistance = squaredDistance +
        math.pow(p1(i).asInstanceOf[Double] - p2(i).asInstanceOf[Double], 2)
    }
    //}

    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance = math.pow(squaredDistance, 2)
    return squaredDistance

  }

  def SilPoint(p: Vector, centers: Array[Vector]) : Double =
  {
    var Fmin : Double = 0.0
    var Findex : Int = 0
    var Nmin : Double = 0.0
    var Nindex : Int = 0
    var Dist : Tuple2[Double,Double] = (0.0,0.0)

    Dist = SpearmanCor(p, centers(0))
    Fmin = Dist._1
    Findex = 0

    Dist = SpearmanCor(p, centers(1))
    if ( Dist._1 < Fmin)
    {
      Nmin = Fmin
      Nindex = Findex

      Fmin = Dist._1
      Findex = 1
    }
    else {
        Nmin = Dist._1
        Nindex = 1
    }

    for (i<- 2 until centers.length)
    {
      Dist = SpearmanCor(p, centers(i))

      if ( Dist._1 < Fmin)
      {
        Nmin = Fmin
        Nindex = Findex

        Fmin = Dist._1
        Findex = i
      }
      else if ( Dist._1 < Nmin)
      {
        Nmin = Dist._1
        Nindex = i
      }
    }

    val sil : Double = 1 - (Fmin / Nmin )
    //maximization function

    return sil

  }

  def ObjFun(p1: Vector, p2: Vector): Double =
  {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance = math.pow(squaredDistance,2)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  //data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):(Double,Array[Vector])={

  def ClustSep(centers: Array[Vector] ):Double=
  {
    //Maximization Function
    var k : Int = centers.length
    var Tot : Double = 0.0

    for (i <- 0 until k)
    {
      for (j <- 0 until k)
      {
        if ( i != j)
        {
          Tot = Tot + PearCor(centers(i), centers(j))//ObjFunCent(centers(i), centers(j))
        }
      }
    }

    return (Tot * 2) / (k * (k-1)).asInstanceOf[Double] //MinClustDist.asInstanceOf[Double])

  }

  def MultDisFun( data: RDD[Vector], sc:SparkContext, centers: Array[Vector]) :
  (Array[Vector], ListBuffer[Double]) =
  {
    //val Sep = ClustSep(centers) //Maximization Function

    var n : Long = data.count()
    k = centers.length

    var MinClustDist : Double = Double.MaxValue
    var temp : Double  =  0.0
    for (i <- 0 until k-1)
    {
      for (j <- i+1 until k)
      {
        temp = math.pow(SpearmanCor(centers(i), centers(j))._1,2)//ObjFunCent(centers(i), centers(j))
        if (temp < MinClustDist )
        {
          MinClustDist = temp
        }
      }
    }

    MinClustDist = n.asInstanceOf[Double] * MinClustDist


    val XieAccum = sc.doubleAccumulator
    val DevAccum = sc.doubleAccumulator
    val SilAccum = sc.doubleAccumulator
    //val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)

    // Find the new centers
    val newCenters = data.mapPartitions { points =>
    val thisCenters = bcCenters.value
    val dims = thisCenters.head.size

    val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
    val counts = Array.fill(thisCenters.length)(0L)
    var c : Int = -1

    //val Dist = Array.fill(thisCenters.length)(0.0D)

    points.foreach { point =>

      val (pindex, pcost) = PearCorCenters(thisCenters, point)
      val sil = SilPoint(point, thisCenters)
      SilAccum.add(sil)
      c += 1
      //WriteToFile(c.toString +":"+sil.toString, true)
      println(c + " s" + pcost)
      counts(pindex) += 1
      val sum = sums(pindex)
      axpy(1.0, point, sum)
      //val (windex, wcost) = WangDistCenters(thisCenters, point) //ClustSep
      //val windex = 2
      //val wcost = 1
      //val tempcost = pcost //+ (1-wcost) //cost //* cost
      XieAccum.add(pcost*pcost)
      DevAccum.add(pcost)

    }
    counts.indices.filter(counts(_) > 0).map(j => (j, (sums(j), counts(j)))).iterator
  }.reduceByKey { case ((sum1, count1), (sum2, count2)) =>

      //***************UnKonwn Comment
      //println("1111111111111")
      //println("sum2:" + sum2 + "sum1:" + sum1)
      axpy(1.0, sum2, sum1)
      //println("count1: " + count1)
      (sum1, count1 + count2)
    }.mapValues { case (sum, count) =>
      scal(1.0 / count.asInstanceOf[Double], sum)
      Vectors.dense(sum.toArray)

    }.collectAsMap()

    val xie = XieAccum.value / MinClustDist.asInstanceOf[Double] //Euclidean Distance
    val overall = DevAccum.value // SSEE Distance
    val s = SilAccum.value / n.asInstanceOf[Double]

    /*if ( b_RetNewCent == true)
   {
     val newCenters = collected.mapValues { case (sum, count) =>
        distanceMeasureInstance.centroid(sum, count)
        }


      // Update the cluster centers and costs
      converged = true
      newCenters.foreach { case (j, newCenter) =>
        centers(j) = newCenter
      }
   }*/

    //println("newCenters")
    /*newCenters.foreach{x=>
      println(x)
     }*/

    bcCenters.destroy()

    return (centers, ListBuffer(xie,s,overall))
  }

  def ComputeSil(p: Array[Vector], data: RDD[Vector], sc:SparkContext ) : Double =
  {
    var s : Double = 0.0
    var a: Double = 0.0
    var b: Double = 0.0




    return s

  }

  def OverAllClustRDD(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false,
                 exception : ListBuffer[String]  ):Double=
  {

    //Minimization Function
    var Eval: ListBuffer[MOFMEval] = new ListBuffer[MOFMEval]
    //var rIndex = -1
    var n: Int = 0
    k = centers.length

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)

    // Find the new centers
    data.mapPartitions { points =>
      val thisCenters = bcCenters.value

      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        val cost = findClosest(thisCenters, point)._2

        val tempcost = cost //* cost
        costAccum.add(tempcost)
      }
      Dist.indices.map(j => (j, (Dist(j), counts(j)))).iterator
    }.reduceByKey { case ((d1, c1), (d2, c2)) =>
      (d1 + d2, c1 + c2)
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    bcCenters.destroy()

    //val Retcost = costAccum.value / data.count().asInstanceOf[Double] //Euclidean Distance
    val Retcost = costAccum.value // SSEE Distance

    return (Retcost) //MinClustDist.asInstanceOf[Double])

  }

  def XieBeniRDD(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false,
                   exception : ListBuffer[String]  ):Double=
  {

    //Minimization Function
    //var rIndex = -1
    var n : Int = 0
    k = centers.length

    var MinClustDist : Double = Double.PositiveInfinity
    var temp : Double = 0.0
    for (i <- 0 until k-1)
    {
      for (j <- i+1 until k)
      {
        temp = ObjFunCent(centers(i), centers(j))
        if (temp < MinClustDist )
        {
          MinClustDist = temp
        }
      }
    }

    MinClustDist = n.asInstanceOf[Double] * MinClustDist

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)

    // Find the new centers
    data.mapPartitions { points =>
      val thisCenters = bcCenters.value

      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        //val cost = findClosest(thisCenters, point)._2
        var cost : Double = 0.0
        for ( m <-0 until thisCenters.length)
          {
            cost = cost + PearCor(thisCenters(m), point)
          }

        //val cost = findClosest(thisCenters, point)._2
        val tempcost = cost * cost
        costAccum.add(tempcost)
      }
      Dist.indices.map(j => (j, ( Dist(j), counts(j) ))).iterator
    }.reduceByKey { case ( (d1, c1), (d2, c2) ) =>
      ( d1 + d2, c1 + c2 )
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    bcCenters.destroy()

    //val Retcost = costAccum.value / data.count().asInstanceOf[Double] //Euclidean Distance
    val Retcost = costAccum.value  // SSEE Distance

    return (Retcost / MinClustDist.asInstanceOf[Double])

  }

  def XieBeniSeq(dataframe: DataFrame, DataNum: Int, centers: Array[Vector],
                 exception : ListBuffer[String]  ):Double=
  {
    k = centers.length
    var Eval: ListBuffer[MOFMEval] = new ListBuffer[MOFMEval]
    //var rIndex = -1
    var n : Int = 0

    for (i<- 0 until k)
    {
      Eval += new MOFMEval(k)
      for (j<- 0 until k)
      {
        Eval(i).CountCluster(j)= 0
      }
    }

    dataframe.collect().foreach { r =>
      val bIndex = findClosestRow(centers, r, exception)._1

      Eval(bIndex).Points += r
      //rIndex = rIndex + 1
      n=n+1

      try
      {
        Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) =
          Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) + 1
      }
      catch {
        case e: Throwable => println("Exception:" + e.toString)
          System.exit(1)
      }
    }

    var MinClustDist : Double = Double.PositiveInfinity
    var temp : Double = 0.0
    for (i <- 0 until k-1)
      {
        for (j <- i+1 until k)
          {
            temp = ObjFunCent(centers(i), centers(j))
            if (temp < MinClustDist )
              {
                MinClustDist = temp
              }
          }
      }

    MinClustDist = n.asInstanceOf[Double] * MinClustDist

    var Tot : Double = 0.0
    for ( j <- 0 until k)
      {
        for ( i <- 0 until n )
          {
            //temp = ObjFunRowExc(centers(j), dataframe.rdd(i), exception )
            Tot += temp
          }
      }


    return (Tot / MinClustDist.asInstanceOf[Double])

  }

  def Silhoutte(dataframe: DataFrame, DataNum: Int, centers: Array[Vector],
                exception : ListBuffer[String]  ):Double=
  {

    var sil : Double = 0.0
    var Eval: ListBuffer[MOFMEval] = new ListBuffer[MOFMEval]
    //var rIndex = -1
    var n : Int = 0
    k= centers.length

    for (i<- 0 until k)
    {
      Eval += new MOFMEval(k)
      for (j<- 0 until k)
      {
        Eval(i).CountCluster(j)= 0
      }
    }

    dataframe.collect().foreach { r =>
      val bIndex = findClosestRow(centers, r, exception)._1

      Eval(bIndex).Points += r
      //rIndex = rIndex + 1
      n=n+1

      try
      {
        Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) =
          Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) + 1
      }
      catch {
        case e: Throwable => println("Exception:" + e.toString)
          System.exit(1)
      }
    }

    val coefficients = new Array[Double](k)
    val j = 0
    val distance = 0
    val size = .0
    val vectorDistances = .0
    val a = 0
    val b = 0
    var SilBuf: ListBuffer[Double] = new ListBuffer[Double]()


    for ( i<- 0 until Eval.length)
      {
        for ( j <-0 until Eval(i).Points.length)
          {
            val a = calculateA(Eval(i).Points, j, exception )

            val b = calculateB(Eval, i, j, exception)

            SilBuf += calculateS(a, b)

          }
      }




    return  avgOfCoefficients(SilBuf);

  }

  def calculateA(Points: ListBuffer[Row], PIndex: Int, except: ListBuffer[String] ) : Double =
  {
    var sil: Double = 0.0

    for ( i<-0 until Points.length )
      {
        if (PIndex != i)
          {
            sil += ObjFunRow(Points(PIndex), Points(i), except)
          }
      }

    return (sil/Points.length.asInstanceOf[Double])
  }

  def calculateB(Eval: ListBuffer[MOFMEval], CIndex : Int, PIndex: Int, except: ListBuffer[String]) : Double =
  {
    var sil : Double = 0.0
    var NoPoints: Int = 0
    var silList: ListBuffer[Double] = new ListBuffer[Double]()


    for ( i<- 0 until Eval.length)
      {
        if (i != CIndex)
          {
            NoPoints = NoPoints + Eval(i).Points.length

            for (j<-0 until Eval(i).Points.length)
            {
              sil += ObjFunRow(Eval(CIndex).Points(PIndex), Eval(i).Points(j), except)
            }
            silList += (sil / Eval(i).Points.length.asInstanceOf[Double])
          }
      }

    var min: Double= silList(0)
    for( i<-1 until silList.length )
      {
        if (silList(i) < min )
          {
            min = silList(i)
          }
      }


    return min // / NoPoints.asInstanceOf[Double])
  }

  /**
    * Calculates an individual silhouette coefficient
    *
    * @param a - the average distance from a point to all other points in its cluster
    * @param b - the minimum average distance from a point to another cluster
    * @return - a double that presents the silhouette coefficient for a point
    */
  def calculateS(a: Double, b: Double): Double =
  {
    var s = 0.0
    if (a > b) s = (b - a) / a
    else s = (b - a) / b
    s
  }

  /**
    * This will calculate the average of all the coefficients calculated
    *
    * @param coefficients - the array that holds all of the coefficients
    * @return - a double that presents the average silhouette coefficient for all points
    */
  def avgOfCoefficients(coefficients: ListBuffer[Double]): Double =
  {
    var sum : Double = 0.0
    var i : Int = 0
    for ( i<- 0 until coefficients.length)
    {
      sum += coefficients(i)
    }
    return (sum / coefficients.length.toDouble)
  }

  /*
  /**
    * This will calculate the value of b, which is the distance from one point to points outside
    * of its own cluster.
    *
    * @param clusterWeights - a Hashmap that will hold the sum of all the distances from one point
    *                       to all points in another cluster
    * @param clusterSizes   - a Hashmap that will hold the size of all the other clusters
    * @return the smallest average distance from a single point to all points in other clusters
    */
  def calculateB(clusterWeights: Nothing, clusterSizes: Nothing): Double = {
    val keySet = clusterWeights.keySet
    val iter = keySet.iterator
    var b = 1000000
    //Iterate through all sum of all the distances in a cluster
    while ( {
      iter.hasNext
    }) {
      val i = iter.next
      //Find the smallest avg
      val avg = clusterWeights.get(i) / clusterSizes.get(i)
      if (avg < b) b = avg
    }
    b
  }*/

  def findClosestRow(centers: TraversableOnce[Vector], p: org.apache.spark.sql.Row, except: ListBuffer[String]): (Int, Double) = {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFunRowExc(center, p, except) //center.norm - point.norm
      if (Dist < bestDistance) {
        bestDistance = Dist
        bestIndex = i
        //println("bestIndex " + bestIndex)
      }
      //println("Dist " + i + ":" + Dist)
    }
    (bestIndex, bestDistance)
  }

  def ObjFunRow(p1: org.apache.spark.sql.Row, p2: org.apache.spark.sql.Row, except: ListBuffer[String])
  : Double = {
                //, except: ListBuffer[String]): Double = {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p2.schema.fields.length)
    {
      if (except.contains(p2.schema.fields(i).name) == false) {
        squaredDistance = squaredDistance +
          math.pow(p1.get(i).asInstanceOf[Double] - p2.get(i).asInstanceOf[Double], 2)
      }
    }

    squaredDistance = math.sqrt(squaredDistance)
    return squaredDistance

  }

  def ObjFunRowExc(p1: Vector, p2: org.apache.spark.sql.Row, except: ListBuffer[String]): Double =
  {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      if (except.contains(p2.schema.fields(i).name) == false)
      {
        squaredDistance = squaredDistance + math.pow(p1(i) - p2.get(i).asInstanceOf[Double], 2)
      }
    }

    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  def ReadFile(fileName: String) : ListBuffer[Point] =
  {
    //fileName = "/home/amr/Downloads/Pareto Front Values/UF/UF1.pf"
    //var inputStream : InputStream = createInputStream(fileName) ;

    var PF : ListBuffer[Point] = new ListBuffer[Point]
    var inputStream : InputStream = createInputStream(fileName) ;

    var isr : InputStreamReader = new InputStreamReader(inputStream);
    var br : BufferedReader = new BufferedReader(isr);

    //List<Point> list = new ArrayList<>();

    try
    {
      var nObj : Int = 0
      var aux : String = ""

      aux = br.readLine();

      while (aux != null)
      {
        var tokenizer : StringTokenizer  = new StringTokenizer(aux);
        var i : Int  = 0;
        if (nObj == 0)
        {
          nObj = tokenizer.countTokens();
        }
        else if (nObj != tokenizer.countTokens())
        {
          throw new Exception("Invalid number of points read. "
            + "Expected: " + nObj + ", received: " + tokenizer.countTokens()) ;
        }

        var point : Point  = new Point(nObj) ;
        while (tokenizer.hasMoreTokens())
        {
          var value : Double  = tokenizer.nextToken().toDouble    //new Double(tokenizer.nextToken());
          //point.setDimensionValue(i, value);
          point.values += value
          i += 1;
        }
        //list.add(point);
        PF += point
        aux = br.readLine();
      }
      br.close();
    }
    catch
      {
        case (e: IOException) =>
        {
          throw new Exception("Error reading file", e);
        }
        case ( e: NumberFormatException ) =>
        {
          throw new Exception("Format number exception when reading file", e);
        }
      }

    val numberOfPoints : Int = PF.length;

    return PF

  }

  def createInputStream(fileName : String) : InputStream =
  {

    val source = Source.fromFile("/home/amr/Downloads/MOWOATS/gotbl.txt")
    val lines = source.getLines()
    val data = lines.map(line => line.split(";").toList)
    source.close()

    var inputStream : InputStream  = getClass().getResourceAsStream(fileName);
    if (inputStream == null)
    {
      inputStream = new FileInputStream(fileName) ;
    }

    return inputStream ;
  }




/*
  /**
    * This method will calculate the silhouette coefficient based off of the distances
    * in weightsTable and how the points are clustered.
    * @return a double that represents the silhouette coefficient
    */
  def calculateCoefficient()
  {
    var coefficients : ListBuffer[Double] = new ListBuffer[Double](weightsTable.size());
    var j : Int = 0;
    var distance : Double = 0.0
    var size : Double = 0.0
    var vectorDistances: Double = 0.0
    var a : Double = 0.0
    var b: Double = 0.0
    PointsVector v1 = null;
    PointsVector v2 = null;

    //Loops through "columns" of the weightsTable
    for(ArrayList<WeightedEdge> list : weightsTable)
    {
      HashMap <Integer, Double> clusterWeights = new HashMap <Integer, Double>();
      HashMap <Integer, Double> clusterSizes = new HashMap<Integer, Double>();
      vectorDistances = 0;
      size = 0;

      //Loop through "rows" of the weightsTable
      for(WeightedEdge we : list)
      {
        distance = we.getWeight();
        v1 = (PointsVector) we.getV1();
        v2 = (PointsVector) we.getV2();
        //We do not want to do anything with the distance between a vector and itself
        //In a table this would be when x=y, i.e. (1,1), (2,2), (3,3), etc.
        if(v1 != v2)
        {
          //Check if they are in the same cluster
          if(v1.getCluster().contains(v2))
          {
            vectorDistances += distance;
            size++;
          }
          else //Not in the same cluster
          {
            Double temp = clusterWeights.get(v2.getCluster().getID());
            //Check if v2's cluster is already in the table
            if(temp != null)
            {
              temp += distance;
              clusterWeights.put(v2.getCluster().getID(), temp);
              double tempsize = clusterSizes.get(v2.getCluster().getID());
              tempsize++;
              clusterSizes.put(v2.getCluster().getID(), tempsize);
            }
            else //v2's cluster needs to be added
            {
              clusterWeights.put(v2.getCluster().getID(), distance);
              clusterSizes.put(v2.getCluster().getID(), 1.0);
            }
          }
        }
      }

      if(size != 0) //Don't divide by 0
      {
        a = vectorDistances / size;
      }
      b = calculateB(clusterWeights, clusterSizes);

      //put the coefficient for this point in the array
      //All coefficients will be averaged below
      coefficients[j] = calculateS(a, b);
      j++;
    }

    return avgOfCoefficients(coefficients);
  }

  /**
    * This will create the copy of the weightsTable that is needed in order to calculate the coefficient.
    * It doesn't created entirely new copies of the vectors since the references to the vectors that will
    * be clustered needs to be maintained.
    * @param weightsTable - the table to copy
    */
  def createCopyOfWeightsTable(ArrayList<ArrayList<WeightedEdge>> weightsTable)
  {
    ArrayList<ArrayList<WeightedEdge>> copy = new ArrayList<ArrayList<WeightedEdge>>();
    for(ArrayList<WeightedEdge> list : weightsTable)
    {
      ArrayList<WeightedEdge> copyList = new ArrayList<WeightedEdge>();

      for(WeightedEdge we : list)
      {
        WeightedEdge copyWe = new WeightedEdge(we.getWeight(), we.getV1(), we.getV2());
        copyList.add(copyWe);
      }
      copy.add(copyList);
    }

    setWeightsTable(copy);
  }

  /**
    * This will calculate the value of b, which is the distance from one point to points outside
    * of its own cluster.
    * @param clusterWeights - a Hashmap that will hold the sum of all the distances from one point
    * to all points in another cluster
    * @param clusterSizes - a Hashmap that will hold the size of all the other clusters
    * @return the smallest average distance from a single point to all points in other clusters
    */
  protected double calculateB(HashMap <Integer, Double> clusterWeights, HashMap <Integer, Double> clusterSizes)
  {
    Set<Integer> keySet = clusterWeights.keySet();
    Iterator<Integer> iter = keySet.iterator();

    var b : Double = 1000000;
    //Iterate through all sum of all the distances in a cluster
    while(iter.hasNext())
    {
      Integer i = iter.next();
      //Find the smallest avg
      double avg = clusterWeights.get(i) / clusterSizes.get(i);
      if(avg < b)
      {
        b = avg;
      }
    }

    return b;
  }

  /**
    * This will calculate the average of all the coefficients calculated
    * @param coefficients - the array that holds all of the coefficients
    * @return - a double that presents the average silhouette coefficient for all points
    */
  def avgOfCoefficients(coefficients : ListBuffer[Double] ) : Double =
  {
    var sum : Double = 0.0;
    for( i<- 0 until  coefficients.length )
    {
      sum = sum + coefficients(i)
    }

    return sum/(coefficients.length.asInstanceOf[Double]);
  }

  /**
    * Calculates an individual silhouette coefficient
    * @param a - the average distance from a point to all other points in its cluster
    * @param b - the minimum average distance from a point to another cluster
    * @return - a double that presents the silhouette coefficient for a point
    */
  def calculateS( a : Double, b: Double) : Double =
  {
    var s : Double = 0.0;
    if( a > b )
    {
      s = (b-a)/a;
    }
    else
    {
      s = (b-a)/b;
    }

    return s;
  }

  public ArrayList<Cluster> getClusters() {
    return clusters;
  }

  public void setClusters(ArrayList<Cluster> clusters) {
    this.clusters = clusters;
  }

  public ArrayList<ArrayList<WeightedEdge>> getWeightsTable() {
    return weightsTable;
  }

  public void setWeightsTable(ArrayList<ArrayList<WeightedEdge>> weightsTable) {
    this.weightsTable = weightsTable;
  }

  private ArrayList<Cluster> clusters;
  protected ArrayList<ArrayList<WeightedEdge>> weightsTable;
  */

}
