

import org.apache.spark.sql.{DataFrame, SparkSession}
import org.apache.spark._
import org.apache.spark.util.Utils

import scala.collection.JavaConverters._
import java.util.Random

import breeze.linalg.squaredDistance.Impl2
import breeze.linalg.{ZippedValues, zipValues}
//import scala.util.Random
import scala.math.exp
import scala.collection.mutable.HashMap
import scala.collection.mutable.HashSet
import breeze.linalg.{squaredDistance, DenseVector, Vector}


object ConTest {

  val N = 1000
  val R = 1000    // Scaling factor
  val D = 10
  val K = 3
  val convergeDist = 0.001
  val rand = new Random(42)


  def generateData: Array[DenseVector[Double]] = {
    def generatePoint(i: Int): DenseVector[Double] = {
      DenseVector.fill(D) {rand.nextDouble * R}
    }
    Array.tabulate(N)(generatePoint)
  }

  def parseVector(line: String): Vector[Double] = {
    DenseVector(line.split(',').map(_.toDouble))
  }

  def closestPoint(p: Vector[Double], centers: Array[Vector[Double]]):Int =
  {
    // (Int, Double) =
    var bestIndex = 0
    var closest = Double.PositiveInfinity

    for (i <- 0 until centers.length) {
      val tempDist = ObjFun(p, centers(i))
      if (tempDist < closest) {
        closest = tempDist
        bestIndex = i
      }
    }

    //return (bestIndex, closest)
    bestIndex
  }

 def ObjFun(p1: Vector[Double], p2: Vector[Double]): Double=
 {
   var squaredDistance = 0.0
   zipValues(p1, p2).foreach { (a, b) =>
     val score = a - b
     squaredDistance += (score * score)
   }
   return squaredDistance
 }


  ///usr/local/hadoop/share/hadoop/hdfs
  def main(args: Array[String]): Unit = {


    val p1=parseVector("10,20,30,40")
    val p2=parseVector("20,30,40,50")
    println(ObjFun(p1, p2))
    //spark://ubuntu:7077
    //val spark = SparkSession.builder().master("[*]").getOrCreate()

    //println(for (x<- generateData){ println(x(1))})



    println("Creating SparkSession")
    val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test")
      .getOrCreate()
   import spark.implicits._



    //val lines = spark.read.option("inferSchema", true).option("header", false).csv("hdfs://localhost:9000/amr/iris.csv").rdd

    val lines = spark.read.textFile("hdfs://localhost:9000/amr/iris2").rdd//"hdfs://localhost:9000/amr/iris.csv").rdd
    val data = lines.map(parseVector _).cache()
    val kPoints = data.takeSample(withReplacement = false, K, 42)

    for (x<-kPoints){println(x)}

    var tempDist = 1.0
    var key : Int = 1
    var fit : Double = 1

    while(tempDist > convergeDist) {
      //(key, fit) = closestPoint(p, kPoints)

      /*val closest = data.foreach( p =>
        (key, fit) = closestPoint(p, kPoints)
        (key, (p, 1, fit))
      )*/

      //(key, fit) = closestPoint(p, kPoints)

      val closest = data.map(p => (closestPoint(p, kPoints), (p, 1)))
      println("Closest Class: " + closest.getClass.toString())

      print("Closest")
      for (x <- closest) {
        println(x)
      }

      val pointStats = closest.reduceByKey{case ((p1, c1), (p2, c2)) => (p1 + p2, c1 + c2)}
      print("point Stats")
      for (x<- pointStats) {println(x)}

      val newPoints = pointStats.map {pair =>
        (pair._1, pair._2._1 * (1.0 / pair._2._2))}.collectAsMap()

      print("newPoints")
      for (x<- newPoints) {println(x)}

      tempDist = 0.0
      for (i <- 0 until K) {
        tempDist += ObjFun(kPoints(i), newPoints(i))
      }

      for (newP <- newPoints) {
        kPoints(newP._1) = newP._2
      }
      println("Finished iteration (delta = " + tempDist + ")")
    }

    println("Final centers:")
    kPoints.foreach(println)

    spark.stop()

    /*val file = spark.read.option("inferSchema", true).option("header", false).
      csv("hdfs://localhost:9000/amr/iris.csv").rdd
    val mapped = file.map(s => s.length).cache()
    for (iter <- 1 to 10) {
      val start = System.currentTimeMillis()
      for (x <- mapped) { println(x) }
      val end = System.currentTimeMillis()
      println("Iteration " + iter + " took " + (end-start) + " ms")
    }*/




    //impt spark.implicits._
    /*import spark.implicits._
    val dataWithoutHeader = spark.read.
      option("inferSchema", true).
      option("header", false).
      csv("hdfs:///amr/iris.csv")
    val colNames = Seq("id", "pwidth", "swidth", "plength", "slength", "class")
    val data = dataWithoutHeader.toDF(colNames: _*)//.
      //withColumn("Cover_Type", $"Cover_Type".cast("double"))
    data.show()
    data.head*/
  }


}

