
import org.apache.spark.sql.{DataFrame, SparkSession}
import org.apache.spark._
import org.apache.spark.util.Utils

import scala.collection.JavaConverters._
import java.util.Random

import breeze.linalg.squaredDistance.Impl2
import breeze.linalg.{DenseVector, ZippedValues, zipValues}
import org.apache.spark.broadcast.Broadcast

//import scala.util.Random
import scala.math.exp
import scala.collection.mutable.HashMap
import scala.collection.mutable.HashSet

import org.apache.spark.mllib.clustering.{KMeans, KMeansModel}

import org.apache.spark.rdd._
//import org.apache.spark.util.random.XORShiftRandom
//import org.apache.spark.mllib.linalg.BLAS.{axpy, scal}
import org.apache.spark.mllib.linalg.{Vector, Vectors, DenseVector,SparseVector}
import org.apache.spark.ml.linalg.SparseVector
import breeze.linalg.{squaredDistance, DenseVector}
//org.apache.spark.ml.linalg.{DenseVector, Vectors, Vector, SparseVector}
//org.apache.spark.ml.linalg.DenseVector
//org.apache.spark.ml.linalg.Vectors
//org.apache.spark.ml.linalg.SparseVector
import BLAS._
import scala.collection.mutable.ArrayBuffer
import org.apache.spark.storage.StorageLevel
//import org.apache.spark.mllib.clustering.LocalKMeans
//import org.apache.spark.util.random.XORShiftRandom
import XORShiftRandom._

object KmeansDist {

  var k: Int = 3
  var n: Int = 0
  var d: Int = 0
  var maxIterations: Int = 300
  var initializationMode: String = "parallel"
  var epsilon: Double = 1e-4

  def ObjFun(p1: Vector, p2: Vector): Double = {
    /*var squaredDistance : Double = 0.0
    println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow(p1(i) - p2(i), 2)
    }
    squaredDistance = math.sqrt(squaredDistance)*/

    math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)
    //println("row Dist:"+squaredDistance)
    //println("Distance function is Valid")
    //squaredDistance

  }

  /*def ObjFun(xs: Array[Double], ys: Array[Double]):Double = {
    math.sqrt((xs zip ys).map { case (x,y) => math.pow(y - x, 2) }.sum)
  }*/

  def parseVector(line: String): Vector = {
    val x = line.split(',').map(_.toDouble)
    Vectors.dense(x)
  }


  def findClosest(centers: TraversableOnce[Vector], p: Vector): (Int, Double) = {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFun(center, p) //center.norm - point.norm
      if (Dist < bestDistance) {
        bestDistance = Dist
        bestIndex = i
        //println("bestIndex " + bestIndex)
      }
      //println("Dist " + i + ":" + Dist)
    }
    (bestIndex, bestDistance)
  }

  /*
    * Initialize a set of cluster centers at random.

  private def initRandom(data: RDD[Vector]): Array[Vector] = {
    // Select without replacement; may still produce duplicates if the data has < k distinct
    // points, so deduplicate the centroids to match the behavior of k-means|| in the same situation
    data.takeSample(false, k, new XORShiftRandom(scala.util.Random.nextLong()).nextInt())
      .map(_).distinct.map(new Vector(_))
  }*/

  def main(args: Array[String]): Unit = {

    val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test")
      .getOrCreate()
    val sc = spark.sparkContext
    import spark.implicits._

    val lines = spark.read.textFile("hdfs://localhost:9000/amr/iris2").rdd
    //"hdfs://localhost:9000/amr/iris.csv").rdd
    val data = lines.map(parseVector _).cache()

    println("data type: "+ data.getClass)

    val centers = initKMeansParallel(data)
    //val centers = data.takeSample(withReplacement = false, k, scala.util.Random.nextLong())

    centers.foreach { x => println(x) }

    var converged = false
    var cost = 0.0
    var iteration = 0

    val iterationStartTime = System.nanoTime()

    while (iteration < maxIterations) {
      //&& !converged) {

      val costAccum = sc.doubleAccumulator
      //println(costAccum )
      val bcCenters = sc.broadcast(centers)
      println(bcCenters)

      // Find the new centers
      val newCenters = data.mapPartitions { points =>
        val thisCenters = bcCenters.value
        val dims = thisCenters.head.size
        //println("dims: " + dims)

        val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
        println("sums: " + sums.toString)
        val counts = Array.fill(thisCenters.length)(0L)
        println("counts: " + counts)

        points.foreach { point =>
          val (bestCenter, cost) = findClosest(thisCenters, point)
          println("Single Cost:" + cost + " : Best Center = " + bestCenter.toString)

          costAccum.add(cost)
          //println("costAccum:" + costAccum.value )
          val sum = sums(bestCenter)
          //***************UnKonwn Comment
          axpy(1.0, point, sum)
          //Add2Vec(1.0,point,sum)
          //println("point size:" + point.size + " class:" + point.getClass)
          //println("sum size:" +  sum.size + "   class:" + sum)
          //org.apache.spark.ml.linalg
          //sums.map(x=>println(x))
          counts(bestCenter) += 1
          println("counts(bestCenter): " + counts(bestCenter))
        }

        counts.indices.filter(counts(_) > 0).map(j => (j, (sums(j), counts(j)))).iterator
      }.reduceByKey { case ((sum1, count1), (sum2, count2)) =>

        //***************UnKonwn Comment
        //println("1111111111111")
        //println("sum2:" + sum2 + "sum1:" + sum1)
        axpy(1.0, sum2, sum1)
        //println("count1: " + count1)
        (sum1, count1 + count2)
      }.mapValues { case (sum, count) =>
        //***************UnKonwn Comment
        scal(1.0 / count, sum)
        //***************UnKonwn Comment
        //new Vectors.dense(sum.toArray) //do not why this is used
        Vectors.dense(sum.toArray)
      }.collectAsMap()

      bcCenters.destroy()

      // Update the cluster centers and costs
      //***************UnKonwn Comment
      converged = true
      //var j = 0
      newCenters.foreach { case (j, newCenter) =>

        /*if (converged && ObjFun(newCenter, centers(j)) > epsilon * epsilon) {
         converged = false
        }*/
        if (iteration == 300) {
          converged = false
        }

        centers(j) = newCenter
      }
      //println("newCenters")
      //newCenters.foreach{x=>
      //  println(x)
      // }

      //println("iteration: " + iteration)
      cost = costAccum.value
      iteration += 1
    }

    centers.foreach { x => println(x) }

    val iterationTimeInSeconds = (System.nanoTime() - iterationStartTime) / 1e9
    println(f"Iterations took $iterationTimeInSeconds%.3f seconds.")

    if (iteration == maxIterations) {
      println(s"KMeans reached the max number of iterations: $maxIterations.")
    } else {
      println(s"KMeans converged in $iteration iterations.")
    }

    println(s"The cost is $cost.")

    //new KMeansModel(centers.map(_.vector))
  }


  // instead of axpy
  private def Add2Vec(a: Double, x: Vector, y: Vector): Unit = {

    val nnz = x.toArray.length

    if (a == 1.0) {
      var k = 0
      while (k < nnz) {
        y.toArray(k) += x.toArray(k)
        k += 1
      }
    } else {
      var k = 0
      while (k < nnz) {
        y.toArray(k) += a * x.toArray(k)
        k += 1
      }
    }
  }

  /**
    * Initialize a set of cluster centers using the k-means|| algorithm by Bahmani et al.
    * (Bahmani et al., Scalable K-Means++, VLDB 2012). This is a variant of k-means++ that tries
    * to find dissimilar cluster centers by starting with a random center and then doing
    * passes where more centers are chosen with probability proportional to their squared distance
    * to the current cluster set. It results in a provable approximation to an optimal clustering.
    *
    * The original paper can be found at http://theory.stanford.edu/~sergei/papers/vldb12-kmpar.pdf.
    */
  def initKMeansParallel(data: RDD[Vector]): Array[Vector] = {
    //
    // Initialize empty centers and point costs.
    var costs = data.map(_ => Double.PositiveInfinity)
    val initializationSteps = 2

    // Initialize the first center to a random point.

    val seed = new XORShiftRandom(scala.util.Random.nextLong()).nextInt()
    //val seed = scala.util.Random.nextLong()
    val sample = data.takeSample(false, 1, seed)
    // Could be empty if data is empty; fail with a better message early:
    require(sample.nonEmpty, s"No samples available from $data")

    val centers = ArrayBuffer[Vector]()
    var newCenters = Seq(sample.head.toDense)
    centers ++= newCenters

    // On each step, sample 2 * k points on average with probability proportional
    // to their squared distance from the centers. Note that only distances between points
    // and new centers are computed in each iteration.
    var step = 0
    val bcNewCentersList = ArrayBuffer[Broadcast[_]]()
    while (step < initializationSteps) {
      val bcNewCenters = data.context.broadcast(newCenters)
      bcNewCentersList += bcNewCenters
      val preCosts = costs
      costs = data.zip(preCosts).map { case (point, cost) =>
        math.min(findClosest(bcNewCenters.value, point)._2, cost)
      }.persist(StorageLevel.MEMORY_AND_DISK)
      val sumCosts = costs.sum()

      bcNewCenters.unpersist(blocking = false)
      preCosts.unpersist(blocking = false)

      val chosen = data.zip(costs).mapPartitionsWithIndex { (index, pointCosts) =>
        //**********To Be Returned
        val rand = new XORShiftRandom(seed ^ (step << 16) ^ index)
        //val rand = scala.util.Random
        pointCosts.filter { case (_, c) => rand.nextDouble() < 2.0 * c * k / sumCosts }.map(_._1)
      }.collect()
      newCenters = chosen.map(_.toDense)
      centers ++= newCenters
      step += 1
    }

    costs.unpersist(blocking = false)
    //bcNewCentersList.foreach(_.destroy(false))
    bcNewCentersList.foreach(_.destroy())

    println("Centers Type:" + centers.getClass)
    println("Centers Elements:" + centers)
    /*for (i<- 1 to centers.length) {
      println("i:" + i)
      println("Type: " + centers(i).getClass + ":" + centers(i))
    }*/

    val distinctCenters = centers.distinct //centers.map(_).distinct
    //.map(parseDVector(_)) //new Vector(_))

    println("distinct Type: " + distinctCenters.getClass())
    println("distinct Elements: " + distinctCenters)

    //distinctCenters.map (x=> println("Elemnt Type:" + x.getClass + " Value: " + x)

    if (distinctCenters.size <= k) {
      distinctCenters.toArray
    } else {
      // Finally, we might have a set of more than k distinct candidate centers; weight each
      // candidate by the number of points in the dataset mapping to it and run a local k-means++
      // on the weighted centers to pick k of them
      val bcCenters = data.context.broadcast(distinctCenters)
      val countMap = data.map(findClosest(bcCenters.value, _)._1).countByValue()

      //bcCenters.destroy(blocking = false)
      bcCenters.destroy()

      val myWeights = distinctCenters.indices.map(countMap.getOrElse(_, 0L).toDouble).toArray
      kMeansPlusPlus(0, distinctCenters.toArray, myWeights, k, 30)
    }
  }

  def parseDVector(p :Vector) : Array[Double] ={
    p.toArray
  }

  /**
    * Run K-means++ on the weighted point set `points`. This first does the K-means++
    * initialization procedure and then rounds of Lloyd's algorithm.
    */
  def kMeansPlusPlus(
                      seed: Int,
                      points: Array[Vector],
                      weights: Array[Double],
                      k: Int,
                      maxIterations: Int
                    ): Array[Vector] = {
    val rand = new Random(seed)
    val dimensions = points(0).size
    val centers = new Array[Vector](k)

    // Initialize centers by sampling using the k-means++ procedure.
    centers(0) = pickWeighted(rand, points, weights).toDense
    val costArray = points.map(ObjFun(_, centers(0)))

    for (i <- 1 until k) {
      val sum = costArray.zip(weights).map(p => p._1 * p._2).sum
      val r = rand.nextDouble() * sum
      var cumulativeScore = 0.0
      var j = 0
      while (j < points.length && cumulativeScore < r) {
        cumulativeScore += weights(j) * costArray(j)
        j += 1
      }
      if (j == 0) {
        println("kMeansPlusPlus initialization ran out of distinct points for centers." +
          s" Using duplicate point for center k = $i.")
        centers(i) = points(0).toDense
      } else {
        centers(i) = points(j - 1).toDense
      }

      // update costArray
      for (p <- points.indices) {
        costArray(p) = math.min(ObjFun(points(p), centers(i)), costArray(p))
      }

    }

    // Run up to maxIterations iterations of Lloyd's algorithm
    val oldClosest = Array.fill(points.length)(-1)
    var iteration = 0
    var moved = true
    while (moved && iteration < maxIterations) {
      moved = false
      val counts = Array.fill(k)(0.0)
      val sums = Array.fill(k)(Vectors.zeros(dimensions))
      var i = 0
      while (i < points.length) {
        val p = points(i)
        val index = findClosest(centers, p)._1
        axpy(weights(i), p, sums(index))
        counts(index) += weights(i)
        if (index != oldClosest(i)) {
          moved = true
          oldClosest(i) = index
        }
        i += 1
      }
      // Update centers
      var j = 0
      while (j < k) {
        if (counts(j) == 0.0) {
          // Assign center to a random point
          centers(j) = points(rand.nextInt(points.length)).toDense
        } else {
          scal(1.0 / counts(j), sums(j))
          centers(j) = Vectors.dense(sums(j).toArray)//new Vector(sums(j))
        }
        j += 1
      }
      iteration += 1
    }

    if (iteration == maxIterations) {
      println(s"Local KMeans++ reached the max number of iterations: $maxIterations.")
    } else {
      println(s"Local KMeans++ converged in $iteration iterations.")
    }

    centers
  }

  private def pickWeighted[T](rand: Random, data: Array[T], weights: Array[Double]): T = {
    val r = rand.nextDouble() * weights.sum
    var i = 0
    var curWeight = 0.0
    while (i < data.length && curWeight < r) {
      curWeight += weights(i)
      i += 1
    }
    data(i - 1)
  }

}
