import scala.collection.mutable.ListBuffer
import math._
import java.io.FileNotFoundException
import java.util

import MOWOATS.WriteToFile
import PFValues._



object MOQtyInd {

  val referenceParetoFront: String = "jmetal-problem/src/test/resources/pareto_fronts/ZDT1.pf"
  var gFunName : String = "UF1"
  val p : Double = 2.0
  var front : ListBuffer[Point] = new ListBuffer[Point]
  var f : ListBuffer[Point] = new ListBuffer[Point]
  var r : ListBuffer[Point] = new ListBuffer[Point]

  def invertedGenerationalDistance( fileName: String ,Result : ListBuffer[Point]) : Double =
  {
    //front : ListBuffer[Point]
    front.clear()
    f.clear()
    r.clear()
    if (gFunName.contains("UF") == true)
    {
      //WriteToFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" )
    }
    else if (gFunName.contains("DTLZ2:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.2D/DTLZ"+fileName.split(":")(1)+".2D.pf" )
    }
    else if (gFunName.contains("DTLZ3:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.3D/DTLZ"+fileName.split(":")(1)+".3D.pf" )
    }
    else if (gFunName.contains("ZDT") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" )
    }


    //WriteToFile( "fileName: " + fileName  ,true)
    //WriteToFile( "front.length: " + front.length  ,true)
    //WriteToFile( "Result.length: " + Result.length  ,true)

    //f = front.clone()   //front.sortWith{(leftE,rightE) => ( compare( leftE, rightE ) ) }

    //r = Result.clone()  //Result.sortWith{(leftE,rightE) => ( compare( leftE, rightE ) ) }


    var sum : Double = 0.0;
    for ( i <- 0 until front.length)
    {
      /*if ( gFunName == "UF8" )
        {
          WriteToFile( " i: " + i + "   Length:" + r(i).values.length   ,true)
        }*/

      sum = sum + ( Math.pow(distanceToClosestPoint(front(i), Result), 2) );
    }

    //WriteToFile( "sum: " + sum  ,true)

    val ret = Math.sqrt(sum);

    //WriteToFile( "ret: " + ret  ,true)
    //WriteToFile( "front.length: " + front.length  ,true)

    return (ret / front.length.asInstanceOf[Double]) //f.length.asInstanceOf[Double];
  }

  def EuclideanDistance(s1: ListBuffer[Double], s2: ListBuffer[Double]) : Double =
  {
    var distance : Double = 0.0;

    //println(s1.length)
    //println(s2.length)
    for ( i <- 0 until s1.length)
    {
      distance = distance +  pow( s1(i) - s2(i), 2.0);
    }

    return sqrt(distance);
  }

  def main(args: Array[String]): Unit =
  {

    //val front = ReadFile("/home/amr/Downloads/Pareto Front Values/UF/UF1.pf")

    //val x = front.sortWith{(leftE,rightE) => ( compare( leftE, rightE ) ) }
  }


  def distanceToClosestPointDouble( p : Point, frontP : ListBuffer[Point]) : Double =
  {

    var Index : Int = 0
    var Min : Double = Double.MaxValue
    var Dist : Double = 0.0

    for ( i<- 0 until frontP.length )
    {
      Dist = math.pow( EuclideanDistance(p.values, frontP(i).values), 2)
      if ( Dist < Min)
      {
        Min = Dist
        Index = i
      }
    }

    //WriteToFile("Min: " + Min, true)
    return Min
  }


  def distanceToClosestPoint( p : Point, frontP : ListBuffer[Point]) : Double =
  {

    var Index : Int = 0
    var Min : Double = Double.MaxValue
    var Dist : Double = 0.0

    for ( i<- 0 until frontP.length )
      {
        Dist = EuclideanDistance(p.values, frontP(i).values)
        if ( Dist < Min)
          {
            Min = Dist
            Index = i
          }
      }

    //WriteToFile("Min: " + Min, true)
    return Min
  }

  def SPdistanceToClosestPoint( p : Point, frontP : ListBuffer[Point]) : Double =
  {

    var Index : Int = 0
    var Min : Double = Double.MaxValue
    var Dist : Double = 0.0

    for ( i<- 0 until frontP.length )
    {
      Dist = 0//EuclideanDistance(p.values, frontP(i).values)
      for ( v<-0 until p.values.length)
        {
          Dist = Dist + Math.abs(p.values(v) -  frontP(i).values(v) )
        }
      if ( Dist < Min)
      {
        Min = Dist
        Index = i
      }
    }

    return Min
  }

  def invertedGenerationalDistanceR2Ind( fileName: String, Result : ListBuffer[Point]) : Double =
  {
    front.clear()
    f.clear()
    r.clear()
    //front : ListBuffer[Point]
    if (gFunName.contains("UF") == true)
    {
      //WriteToFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" )
    }
    else if (gFunName.contains("DTLZ2:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.2D/DTLZ"+fileName.split(":")(1)+".2D.pf" )
    }
    else if (gFunName.contains("DTLZ3:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.3D/DTLZ"+fileName.split(":")(1)+".3D.pf" )
    }
    else if (gFunName.contains("ZDT") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" )
    }


    //f = front.clone()   //front.sortWith{(leftE,rightE) => ( compare( leftE, rightE ) ) }
    //r = Result.clone()  //Result.sortWith{(leftE,rightE) => ( compare( leftE, rightE ) ) }


    var sum : Double = 0.0;
    for ( i <- 0 until front.length)
    {
      /*if ( gFunName == "UF8" )
      {
        WriteToFile( " i: " + i + "   Length:" + r(i).values.length   ,true)
      }*/

      sum = sum + distanceToClosestPointDouble(front(i), Result);
    }

    //sum = Math.pow(sum, 1.0 / p);

    return (sum / front.length.asInstanceOf[Double]) //f.length.asInstanceOf[Double];

  }



  def SP( fileName: String ,Result : ListBuffer[Point]) : Double =
  {
    front.clear()
    f.clear()
    r.clear()

    if (gFunName.contains("UF") == true)
    {
      //WriteToFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" )
    }
    else if (gFunName.contains("DTLZ2:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.2D/"+fileName+".2D.pf" )
    }
    else if (gFunName.contains("DTLZ3:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" )
    }
    else if (gFunName.contains("ZDT") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" )
    }


    var Dist : ListBuffer[Double] = new ListBuffer[Double]
    var sum : Double = 0.0;
    var d : Double = 0.0
    for ( i <- 0 until Result.length)
    {
      d = SPdistanceToClosestPoint(Result(i), front)
      Dist += d
      sum += d
    }

    val mean : Double = sum / Result.length.asInstanceOf[Double]
    sum = 0.0

    for ( i <- 0 until Result.length)
    {
      sum += math.pow( mean - Dist(i) , 2)
    }

    sum = sum / (Result.length - 1.0).asInstanceOf[Double]

    return math.sqrt(sum)
  }

  def GetMaxObj(data : ListBuffer[Point], Index : Int) : Double =
  {
    var Max : Double = data(0).values(Index)

    for ( i <-1 until(data.length))
      {
          if (data(i).values(Index) > Max)
            {
              Max = data(i).values(Index)
            }
      }

    return Max
  }

  def GetMinObj(data : ListBuffer[Point], Index : Int) : Double =
  {
    var Min : Double = data(0).values(Index)

    for ( i <-1 until(data.length))
    {
      if (data(i).values(Index) < Min)
      {
        Min = data(i).values(Index)
      }
    }

    return Min
  }

  def EuclideanDistVal(a : Double, b: Double) : Double =
  {
    var ret : Double = 0.0
    ret = math.pow(a-b, 2)

    return  math.sqrt(ret)
  }

  def MS( fileName: String ,Result : ListBuffer[Point]) : Double =
  {
    front.clear()
    f.clear()
    r.clear()

    /*if (gFunName.contains("UF") == true)
    {
      //WriteToFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" )
    }
    else if (gFunName.contains("DTLZ2:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.2D/"+fileName+".2D.pf" )
    }
    else if (gFunName.contains("DTLZ3:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" )
    }
    else if (gFunName.contains("ZDT") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" )
    }*/


    var sum : Double = 0.0;
    var max : Double = 0.0
    var min : Double = 0.0
    for ( i <- 0 until Result(0).values.length)
    {
      max = GetMaxObj(Result, i)
      min = GetMinObj(Result, i)

      sum += EuclideanDistVal(max, min)

    }

    return math.sqrt(sum)
  }

  def Spread(fileName: String ,Result : ListBuffer[Point]) : Double =
  {

    front.clear()
    f.clear()
    r.clear()

    if (gFunName.contains("UF") == true)
    {
      //WriteToFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/UF/"+fileName+".pf" )
    }
    else if (gFunName.contains("DTLZ2:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.2D/"+fileName+".2D.pf" )
    }
    else if (gFunName.contains("DTLZ3:") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/DTLZ.3D/"+fileName+".3D.pf" )
    }
    else if (gFunName.contains("ZDT") == true)
    {
      //WriteToFile( "/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" ,true)
      front = ReadFile("/home/amr/Downloads/Pareto Front Values/ZDT/"+fileName+".pf" )
    }

    // STEP 2. Compute df and dl (See specifications in Deb's description of the metric)
    //double df = distance.compute(front.getPoint(0), referenceFront.getPoint(0)) ;
    val df = EuclideanDistance(Result(0).values, front(0).values)

    //double dl = distance.compute(front.getPoint(front.getNumberOfPoints() - 1),
    //  referenceFront.getPoint(referenceFront.getNumberOfPoints() - 1)) ;

    val dl = EuclideanDistance(Result(Result.length-1).values, front(front.length-1).values)

    var mean : Double = 0.0;
    var diversitySum : Double  = df + dl;

    var numberOfPoints : Int = Result.length

    // STEP 3. Calculate the mean of distances between points i and (i - 1).
    // (the points are in lexicografical order)
    for ( i <- 0 until  (numberOfPoints - 1))
    {
     // mean += distance.compute(front.getPoint(i), front.getPoint(i + 1));

      mean += EuclideanDistance(Result(i).values, Result(i + 1 ).values)
    }

    mean = mean / (numberOfPoints - 1).asInstanceOf[Double];

    // STEP 4. If there are more than a single point, continue computing the
    // metric. In other case, return the worse value (1.0, see metric's description).
    if (numberOfPoints > 1)
    {
      for ( i <- 0 until (numberOfPoints - 1))
      {
        //diversitySum += Math.abs(distance.compute(front.getPoint(i), front.getPoint(i + 1)) - mean);
        diversitySum += Math.abs(  EuclideanDistance(Result(i).values, Result(i + 1 ).values) - mean);
      }
      return diversitySum / (df + dl + (numberOfPoints - 1) * mean);
    }
    else
    {
      return 1.0;
    }
  }

  def compare( pointOne : Point, pointTwo : Point) : Boolean =
  {
    // Determine the first i such as pointOne[i] != pointTwo[i];
    var index : Int = 0;
    while  ( ( index < pointOne.values.length & index < pointTwo.values.length )
      &&  ( pointOne.values(index) == pointTwo.values(index)  ) )
    {
      index = index + 1
    }

    var result : Boolean = false ;
    //if ((index >= pointOne.Obj) || (index >= pointTwo.Obj)) {
     // result = 0;
    //}
    if (pointOne.values(index) < pointTwo.values(index))
      {
        result = false;
      }
    else if (pointOne.values(index) > pointTwo.values(index))
      {
        result = true;
      }
    return result ;
  }


  def invertedGenerationalDistancePlus(front : ListBuffer[Point], Result : ListBuffer[Point]) : Double =
  {

    var sum : Double = 0.0;
    for ( i <- 0 until Result.length )
    {
      sum += distanceToClosestPointDominance(Result(i), front);
    }

    // STEP 4. Divide the sum by the maximum number of points of the reference Pareto front
    return sum / Result.length;
  }


  def DominanceDistance( a : Point, b : Point) : Double =
  {
    if (a == null) {
      throw new Exception("The first point is null") ;
    } else if (b == null) {
      throw new Exception("The second point is null") ;
    } else if (a.values.length  != b.values.length)
    {
      throw new Exception("The dimensions of the points are different: "
        + a.values.length + ", " + b.values.length) ;
    }

    var distance : Double = 0.0;

    for ( i <- 0 until  a.values.length )
    {
      val max = Math.max(b.values(i) - a.values(i), 0.0) ;
      distance += Math.pow(max, 2);
    }
    return Math.sqrt(distance);
  }

  def distanceToClosestPointDominance( p : Point, front : ListBuffer[Point]) : Int =
  {

    var Index : Int = 0
    var Min : Double = Double.MaxValue
    var Dist : Double = 0.0

    for ( i<- 0 until front.length )
    {
      Dist = DominanceDistance(p, front(i))
      if ( Dist < Min)
      {
        Min = Dist
        Index = i
      }
    }

    return Index
  }




}
