
import java.io.{BufferedWriter, File, FileWriter}

import util.control.Breaks._

//import scala.math.BigDecimal
import java.util

import org.apache.spark.mllib.clustering.{KMeans, KMeansModel}
import org.apache.spark.sql.{DataFrame, SparkSession}
import org.apache.spark._
import org.apache.spark.util.Utils

import scala.collection.JavaConverters._
import java.util.Random

import breeze.linalg.squaredDistance.Impl2
import breeze.linalg.{DenseVector, ZippedValues, min, squaredDistance, zipValues}
import org.apache.spark.broadcast.Broadcast

import scala.math.exp
import scala.collection.mutable.{ArrayBuffer, HashMap, HashSet, ListBuffer}
import org.apache.spark.mllib.clustering.{KMeans, KMeansModel}
import org.apache.spark.rdd._
import org.apache.spark.mllib.linalg.{DenseVector, SparseVector, Vector, Vectors}
import org.apache.spark.ml.linalg.SparseVector
import BLAS._
import PSOTS.UpdateFun
import PSOTSKM.{AvgList, MaxList, MinList, StdList}
import WhaleFun.{dim, lb, ub}
import com.google.gson.annotations.Until
import org.apache.spark.sql.types.{DoubleType, IntegerType}

import scala.collection.mutable
//import PSOTSKM.findClosest
//import PSOTSKM.AdjustMaxandMin
import org.apache.spark.storage.StorageLevel
import XORShiftRandom._
import org.apache.spark.mllib.linalg
import org.apache.spark.sql.Row
import org.apache.spark.sql.types.{StructType,StructField,StringType}
import scala.util.control.Breaks._
import org.apache.spark.sql.functions._
import scala.util.control.Exception._
import MOPFun._
import MOQtyInd._


object MOWOATS
{

  var globalK: Int = 1
  var PHar: Double = 2.5
  //var m_quantile : Double = 0.0
  var quantileInt = new ListBuffer[Double]()
  var quantileDiv = new ListBuffer[Double]()
  var MinElFit : Double  = 0.0
  var UpdateFun : String = "PSO"//"Whale"//"PSO"
  var ObjFunGlobal : String = "kmeans"//"Whale"//"PSO"
  var MinObj : Boolean = false
  var nobj : Int = 2
  var str_ObjFun : String = ""
  var WorestFit :ListBuffer[Double] = new ListBuffer[Double]
  var EL: ListBuffer[MOPSONoKM] = new ListBuffer[MOPSONoKM]
  var max_EL : Int = 100
  var Improvement : Boolean =false

  var NonDom: ListBuffer[MOPSONoKM] = new ListBuffer[MOPSONoKM]

  var TL: ListBuffer[MOPSONoKM] = new ListBuffer[MOPSONoKM] //(max_TL)    // Tabu List
  var max_TL : Integer = 50
  val RunNum : Int = 6

  var rand : scala.util.Random = new scala.util.Random() //System.currentTimeMillis
  //val currentTime: Long = System.currentTimeMillis

  def WriteToFile(str: ListBuffer[String]):Unit=
  {
    val ResultPath = "/home/amr/Downloads/result.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      str.foreach(x => bw.write(x))
    }
    finally bw.close()

  }

  def WriteToFile(str: String, Sep : Boolean = false):Unit=
  {
    val ResultPath = "/home/amr/Downloads/result.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      if (Sep == true)
        {bw.newLine()}
      bw.write(str)
    }
    finally bw.close()

  }

  def WriteToFileCenters(str: String, Sep : Boolean = false):Unit=
  {
    val ResultPath = "/home/amr/Downloads/Centers.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      if (Sep == true)
      {bw.newLine()}
      bw.write(str)
    }
    finally bw.close()

  }

  def Stats(x: ListBuffer[Double]) : (Double, Double, Double, Double) = {
    return(MinList(x), MaxList(x), StdList(x), AvgList(x))
  }

  def MaxList(x: ListBuffer[Double]) : Double ={
    var max : Double = Double.MinValue
    for (i<-0 until x.length)
      {
        if ( x(i) > max )
        {
          max = x(i)
        }
      }
    return max
  }


  def MinList(x: ListBuffer[Double]) : Double ={
    var min : Double = Double.MaxValue
    for (i<-0 until x.length)
    {
      if ( x(i) < min )
      {
        min = x(i)
      }
    }
    return min
  }

  def AvgList(x: ListBuffer[Double]) : Double ={
    var Tot : Double = 0.0

    for (i<-0 until x.length)
    {
      Tot = Tot +  x(i)
    }
    return ( Tot / x.length )
  }



  def StdList(x: ListBuffer[Double]) : Double ={
    var Avg : Double = AvgList(x)
    var Std : Double = 0.0
    var Tot : Double = 0.0

    for (i <- 0 until x.length)
    {
      Tot = Tot + math.pow(x(i) - Avg , 2)
    }


    return ( math.sqrt(Tot / x.length)  )

  }



  def CompareObj(x: ListBuffer[Double], y:ListBuffer[Double]) : Boolean =
  {
    /*var d : Boolean =true
    var one : Boolean = false
    var All : Boolean =true

    for ( i <-0 until  y.length)
    {
      if ( x(i) > y(i)   )
      {
        All=false
        //return All
      }

      if (x(i) < y(i)  )
      {
        one = true
      }

    }

    if (All == false & one == false)
      {   return  false   }
    else
      {   return true   }*/

    ////////////////////////////////////////
    ///////////////////////////////////
    var betterInAnyObjective : Boolean = false;
    var worseInAnyObjective : Boolean = false;
    breakable {
      for (i <- 0 until y.length) {

        if (worseInAnyObjective)
        {
          break;
        }

        if ( x(i) < y(i) )
        {
          betterInAnyObjective = true;
        }

        else if (x(i) > y(i))
        {
          worseInAnyObjective = true;
        }

      }
    }

    return !worseInAnyObjective && betterInAnyObjective;

  }

  /*def CompareObj(value: Array[Double], Ref: Array[Double]) : Boolean =
  {
    var RetVal : Boolean = false
    /*if (ObjFunGlobal == "GSOF1" | ObjFunGlobal == "GSOF2" | ObjFunGlobal == "GSOF3")
    {
      if (value > Ref ) //Maximum
        {RetVal = true}
      else
        {RetVal = false}
    }
    else
    {*/


      if (value  < Ref )  //Minimum
      {RetVal = true}
      else
      {RetVal = false}

    //}

    return RetVal

  }*/


  def RouletteWheel(Population: ListBuffer[MOPSONoKM] ) : Int =
  {
    var ObjSum : ListBuffer[Double] = new ListBuffer[Double]()
    var Prop : ListBuffer[Double] = new ListBuffer[Double]()
    var SumAllFit : Double = 0.0

    for (i<- 0 until Population.length)
      {
        ObjSum +=  0.0
        Prop +=  0.0
      }

    for ( i<- 0 until Population.length)
      {
        for (j<- 0 until Population(i).fit.length)
          {
            ObjSum(i) = ObjSum(i) + Population(i).fit(j)
          }
        SumAllFit = SumAllFit + ObjSum(i)
      }

    var sumFit : Double = 0.0

    for ( i<- 0 until Population.length)
    {
      sumFit = 0.0
      for (j<- 0 until Population(i).fit.length)
      {
        sumFit = sumFit + Population(i).fit(j)
      }
      Prop(i) = sumFit / SumAllFit
    }

    val r : Double = rand.nextDouble()
    for ( i <- 0 until Prop.length-1 )
      {
        if (Prop(i) < r & Prop(i+1) > r)
          {
            return i
          }
      }

    return rand.nextInt(Population.length)
  }

  def GetNonDom( Pop: ListBuffer[MOPSONoKM]) =
  {
    NonDom.clear()
    var b_isDom : Boolean = false

    for ( i <- 0 until Pop.length)
      {
        b_isDom = false
        for ( j <- 0 until Pop.length)
        {
          if ( j != i)
            {
              if (CompareObj(Pop(j).fit, Pop(i).fit) )
                {
                  b_isDom = true
                }
            }
        }
        if ( b_isDom == false)
          {
            NonDom += Pop(i)
          }
      }
  }



  def ClusterAlgo( k: Int, VelMin: ListBuffer[Double], VelMax: ListBuffer[Double],
                  minCol: ListBuffer[Double], maxCol:ListBuffer[Double], d : Int)
  : (ListBuffer[Double]) =
  {

    //WorestFit = Double.MinValue
    var RetBestFit: ListBuffer[Double] = new ListBuffer[Double] //.NegativeInfinity

    /*if (ObjFunGlobal == "GSOF1" | ObjFunGlobal == "GSOF2" | ObjFunGlobal == "GSOF3") {
      MinObj = false
      RetBestFit = Double.NegativeInfinity
      WorestFit = Double.PositiveInfinity
    }
    else {*/
    MinObj = true
    //RetBestFit = new Array[Double](nobj) //Double.PositiveInfinity
      //WorestFit = Double.NegativeInfinity
    //}

    //val max_TL = 11
    //var n: Long = data.count()
    EL.clear() //= new ListBuffer[MOPSONoKM]
    TL.clear()
    //var epsilon: Double = 1e-4
    val Np = 100 //Number of particles
    //max_EL = 100
    val MaxIt = 3000
    var Index_TL = 0

    //(max_EL)    // Elite List
    var EL_V: Array[Vector] = new Array[Vector](max_EL) // Best Velocities
    var Population: ListBuffer[MOPSONoKM] = new ListBuffer[MOPSONoKM]
    //(Np)
    var LocalPopulation: ListBuffer[MOPSONoKM] = new ListBuffer[MOPSONoKM]
    //var BestCenters: Array[Double] = new Array[Double]
    var str_Fit: String = ""
    //globalK = k
    //data.cache()

    var b_IorD: String = "0"
    val c1 = 0.5
    val c2 = 1.5
    val w_max = 0.5
    val w_min = -0.5
    //.1
    //val l=1
    var half: Double = 0
    var w: Double = 0
    //val rand = new scala.util.Random()
    var centers: ListBuffer[Double] = new ListBuffer[Double]
    //var newCenters: Array[Double] = new Array[Double](k)
    var cost: ListBuffer[Double] = new ListBuffer[Double] // 0.0
    var Tup: Tuple2[Double, ListBuffer[Double]] = (-1, centers)

    //println("VelMin: " + VelMin)
    for (i <- 0 until Np)
    {
      //println("i :" + i)

      //val numClusters = 2
      //val numIterations = 20
      //val clusters = KMeans.train(data, globalK, 2, KMeans.RANDOM)
      //val Vec = new Array[Double](clusters.clusterCenters.head.size)

      /*for (row<- 0 to clusters.clusterCenters.length-1)
        {
          for (col<- 0 to clusters.clusterCenters(row).size-1)
            {
              Vec.update(col, clusters.clusterCenters(row).toArray(col) )
            }
          centers.update(row,  Vectors.dense(Vec).copy)
        }*/

      //centers = initKMeansParallel(data).clone()
      //centers = AdjustMaxandMin(centers, minCol, maxCol).clone()
      val obj = new MOPSONoKM(k, nobj)

      val (lb, ub, dim ) = MOPFun.GetFunDetail(str_ObjFun)
      var lis = MOPFun.RandPop(dim, ub, lb)
      lis = AdjustMaxandMin(lis, minCol, maxCol)
      cost = MOPFun.ObjFun(str_ObjFun, lis )
      obj.Nobj = cost.length
      nobj = cost.length
      obj.p = lis
      obj.fit = cost
      obj.bp = obj.p
      obj.bfit = obj.fit

      //val (cost, newCenters) =  RecCenters(data, data.sparkContext, centers)
      //val cost = GSOF1(data, data.sparkContext, centers)
      //val (cost, newCenters) = RecCentersHarmonic(data, data.sparkContext, centers, PHar)


      //obj.v = Array.fill(k)(Vectors.zeros(d))//RandVel(k, d, maxCol, minCol).clone()
      /*if (UpdateFun == "PSO")
      {
        obj.v = RandVel(k, d, maxCol, minCol).clone()
        obj.v = AdjustMaxandMin(obj.v, VelMin, VelMax).clone()
      }*/

      //i
      /*else if (CompareObj(obj.fit, RetBestFit))
      {
        //(obj.fit < RetBestFit) {
        RetBestFit = obj.fit
        //BestCenters = obj.p.clone()
        str_Fit = str_Fit  + ":" + RetBestFit.toString
      }*/


      /*if (TL.length == 0 )
      {
        TL = Add2TLOrdered(TL, obj, max_TL)
        Index_TL = Index_TL + 1
        Index_TL = Index_TL % max_TL
        WorestFit = obj.fit
      }
      if (CompareObj(WorestFit, obj.fit)) //( obj.fit > WorestFit)
      {
        //Add2TL(TL, obj, max_TL, Index_TL)
        TL = Add2TLOrdered(TL, obj, max_TL)
        Index_TL = Index_TL + 1
        Index_TL = Index_TL % max_TL
        WorestFit = obj.fit
      }*/

      EL = Add2EL(EL, obj.CopyObj())
      //println("iiiii = " + i)
      Population += obj.CopyObj()
    }



    var PrevIntenseFit : ListBuffer[Double] = new ListBuffer[Double]
    var PrevFit = Double.PositiveInfinity
    //var VelRand: Int = rand.nextInt(2)
    Index_TL = -1
    var d_Arr: ListBuffer[Int] = new ListBuffer[Int]

    var i_Diverse: Int = 0
    var i_Intense: Int = 0
    var i_stIntense: Int = 0
    var i_ndIntense: Int = 0
    var i_stDiverse: Int = 0
    var i_ndDiverse: Int = 0

    var b_stIntense: Boolean = false
    var b_ndIntense: Boolean = false
    var b_stDiverse: Boolean = false
    var b_ndDiverse: Boolean = false
    var index_EL = rand.nextInt(EL.length)
    var prand: Double = 0.0
    var a: Double = 0.0
    var a2: Double = 0.0
    var rand_leader_index: Int = 0


    var iteration = 0
    var NoProgress = 1
    var max_NoProgress = 3

    if (UpdateFun == "PSO")
    {
      max_NoProgress = 3
    }
    else if (UpdateFun == "Whale")
    {
      max_NoProgress = 15//21
    }

    var NoProgDec: Int = 0


    var r1 : Double = 0.0
    var r2 : Double = 0.0
    var A: Double = 0.0//2 * a * r1 - a; // Eq. (2.3) in the paper
    var C: Double = 0.0 //2 * r2; // Eq. (2.4) in the paper
    var b : Double = 1.0; //  parameters in Eq. (2.5)
    var l: Double  = 0.0 //(a2 - 1) * rand.nextDouble() + 1; //  parameters in Eq. (2.5)

    while (iteration < MaxIt)
    {

      //WriteToFile(b_IorD)


      GetNonDom(EL)
      if (b_IorD == "1" | b_IorD == "11") //( b_IntenseFactor == TRUE )//(it%% 5  == 0)
      {
        i_Intense = i_Intense + 1
        val deltarand = rand.nextInt(Np/10) // 7).asInstanceOf[Int] //rand.nextInt( (Np/2).asInstanceOf[Int]) //7//rand.nextInt( (Np/2).asInstanceOf[Int])

        print("intense")

        if (b_IorD == "11") //(PrevIntenseFit == ReturnFit)
        {
          //b_IorD = "011"
          //NoProgress = -1


          //Population = InstensifyFun(Population, Np, minCol, maxCol)
          //Population = CrossOverEliteByCol(Population, EL)

          val ntemp = GenRandList(Np, deltarand)
          /*for (m <- 0 until ntemp.length)
          {
            Population(ntemp(m)) = EL(rand.nextInt(EL.length)).CopyObj()//rand.nextInt(2)).CopyObj()//EL(0).CopyObj() //(rand.nextInt(2)).CopyObj() // EL(0).CopyObj()
          }*/

          Population = CrossOverElite(Population , EL)
          //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, EL)

          b_stIntense = true
        }
        else if (b_IorD == "1")
        {
          //b_IorD = "01"
          //NoProgress = -1

          val ntemp = GenRandList(Np, deltarand)
          /*for (m <- 0 until ntemp.length)
          {
            Population(ntemp(m)) = EL(rand.nextInt(EL.length)).CopyObj()//rand.nextInt(2)).CopyObj()//EL(0).CopyObj() //(rand.nextInt(2)).CopyObj() // EL(0).CopyObj()
          }*/

          //Population = CrossOverElite(Population , EL)
          Population = InstensifyEliteFun(Population, Np, minCol, maxCol, EL)
          b_ndIntense = true
        }

      }
      else if (b_IorD == "2" | b_IorD == "21")
      {


        if (b_IorD == "21")
        {

          Population = CrossOverFun(Population)
          //Population = CrossOverFunByCol(Population)
          b_stDiverse = true
        }

        else if (b_IorD == "2")
        {
          print("diverse 2")

          //b_IorD = "02"
          //NoProgress = -1

          /*i_Intense = i_Intense + 1
          var deltarand = (Np/5).asInstanceOf[Int]//rand.nextInt( (Np/2).asInstanceOf[Int])
          if ( deltarand > EL.length)
          {deltarand = EL.length }
          if (deltarand == 0) { deltarand = 1 }
          val ntemp = GenRandList(Np, deltarand )

          for (m <- 0 until ntemp.length) {
            Population(ntemp(m)) = EL(m).CopyObj()
          }*/

          ///Last Edit 3/4/2018
          //Population = CrossOverTabu(Population , TL, EL)
          //Population = CrossOverFun(Population)
          /*if (TL.length > 0)
            {
              Population = CrossOverElite(Population, TL)
            }
          else
          {
            Population = CrossOverFun(Population)
          }*/
          //Population = CrossOverFun(Population)
          /*if (TL.length > 0 )
            {
              Population = CrossOverTabu(Population , TL, EL)
            }
          else
          {*/
            Population = CrossOverFun(Population)

          //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, EL)
          //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, EL)
          //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, EL)
          //}


          //LocalPopulation = LocalSearch(EL, Np, minCol, maxCol)

          //Population = DiversifyFun(Population, Np, minCol, maxCol)
          b_ndDiverse = true
        }
      }
      /*else if (b_IorD == "22")
      {
        var d_Num: Int = (Np / 5).asInstanceOf[Int] //rand.nextInt(math.round(Np / 5).asInstanceOf[Int]) //base::sample(length(TL)/2, 1)
        if (d_Num == 0) {
          d_Num = 1
        }
        d_Arr = GenRandList(Np, d_Num)
      }*/



      PrevIntenseFit = RetBestFit

      //println("Before Particles")


      //index_EL = rand.nextInt(2)

      /*if (EL.length > 2) {
        index_EL = rand.nextInt(2)
      }
      else {
        index_EL = rand.nextInt(EL.length)
      }*/

      w = w_min + ((w_max - w_min) *
        ((MaxIt.asInstanceOf[Double] - iteration.asInstanceOf[Double]) / MaxIt.asInstanceOf[Double]))

      a = 2.0 - iteration.asInstanceOf[Double] * ((2.0) / MaxIt.asInstanceOf[Double])
      a2 = -1.0 + iteration.asInstanceOf[Double] * ((-1.0) / MaxIt.asInstanceOf[Double])



      //GetNonDom(EL)

      Improvement = false

      for (g <- 0 until Np )
      {

        prand = rand.nextDouble()

        r1 = rand.nextDouble()
        r2 = rand.nextDouble()

        A = 2.0 * a * r1 - a; // Eq. (2.3) in the paper
        C = 2.0 * r2; // Eq. (2.4) in the paper
        b = 1.0; //  parameters in Eq. (2.5)
        l = (a2 - 1.0) * rand.nextDouble() + 1.0; //  parameters in Eq. (2.5)

        //index_EL = rand.nextInt(EL.length) //rand.nextInt(EL.length)


        //val r1 = rand.nextDouble() //RandCof(k, d, maxCol, minCol).clone()  //runif(1,0,1)
        //val r2 = rand.nextDouble() //rand.nextDouble() //RandCof(k, d, maxCol, minCol).clone()

        //index_EL = rand.nextInt(2)

        //prand = rand.nextDouble(); // p in Eq. (2.6)
        //index_EL = 0

        /*if (UpdateFun == "PSO")
        {
          if (b_IorD == "22") //(it%% 5  == 0)
          {
            //make this region to search throughly the region and not to use the velocity at all
            //print("diverse")
            if (d_Arr.contains(g) == false) {
              val velTemp = ComputeVel(Population((g)).bp, Population((g)).p, Population((g)).v,
                EL(index_EL).p, c1, c2, r1, r2, 0.6).clone()

              // Apply Velocity Limits
              Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
              //Population(g).v = velTemp.clone()

              Population(g).p = Add2Vec(Population(g).p, Population((g)).v, "+").clone()
            }
            else {
              if (TL.length > 0) {
                Population((g)).p = TL(rand.nextInt(TL.length)).p.clone()

                val velTemp = ComputeVel(BestCenters, Population((g)).p, Population((g)).v,
                  EL(index_EL).p, c1, c2, r1, r2, w)

                // Apply Velocity Limits
                Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
                //Population(g).v = velTemp.clone()

                Population(g).p = Add2Vec(Population(g).p, Population((g)).v, "+").clone()
              }
            }
          }
          else if (b_IorD == "021" | b_IorD == "00" | b_IorD == "0" | b_IorD == "011" | b_IorD == "01" | b_IorD == "02" | b_IorD == "10" | b_IorD == "110" | b_IorD == "210" | b_IorD == "20") {
            //print("normal")

            val velTemp = ComputeVel(Population(g).bp, Population(g).p, Population(g).v,
              EL(index_EL).p, c1, c2, r1, r2, w)

            // Apply Velocity Limits
            Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
            //Population(g).v = velTemp.clone()

            // Update Position
            Population((g)).p = Add2Vec(Population(g).p, Population((g)).v, "+").clone()
            //Population((g)).P = Population((g)).P + Population((g)).V
          }
        }*/
        if ((UpdateFun == "Whale")  & (b_IorD != "1")  & (b_IorD != "11") & (b_IorD != "2") & (b_IorD != "21"))
        {
          // r1 is a random number in [0,1]
          // r2 is a random number in [0,1]
          //prand = rand.nextDouble(); // p in Eq. (2.6)
          //prand = rand.nextDouble() //rand.nextDouble(); // p in Eq. (2.6)


          if (prand > 0.2)
          {

            if (math.abs(A) >= 1.0)
              {
                //RouletteWheel(Population)
                rand_leader_index = rand.nextInt(Np) //math.floor(Np * rand.nextDouble() ).asInstanceOf[Int]
                //rand_leader_index = rand.nextInt(EL.length)
                /*Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                  EL(index_EL).p, C, A, prand, b, l).clone()*/

                  /*println("g: " + g)
                  println("index_EL: " + index_EL)
                  println("Population: " + Population.length)
                  println("EL: " + EL.length)*/
                index_EL = rand.nextInt(EL.length)

                 Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                 EL(index_EL).p, C, A, prand, b, l).clone()
              }
            else if (math.abs(A) < 1.0)
              {
              //rand_leader_index = rand.nextInt( (EL.length/2).asInstanceOf[Int])//rand.nextInt(Np) //math.floor(Np * rand.nextDouble() ).asInstanceOf[Int]
                //index_EL = rand.nextInt(EL.length)
                rand_leader_index = rand.nextInt(Np)

                Population(g).p = ComputeVelWhale(Population(0).p, Population(g).p,
                  Population(rand_leader_index).p, C, A, prand, b, l).clone()
                  //Population(rand_leader_index).p, C, A, prand, b, l).clone()

              }
          }

          else if (prand <= 0.2)
          {
            //Exploitation Phase
            index_EL = rand.nextInt(EL.length)

            Population(g).p = ComputeVelWhale(Population(0).p, Population(g).p,
              EL(index_EL).p, C, A, prand, b, l).clone()
          }

        }

        /*if (b_IorD == "11") //(PrevIntenseFit == ReturnFit)
        {
          b_IorD = "011"
          NoProgress = -1
        }
        else if (b_IorD == "1")
        {
          b_IorD = "01"
          NoProgress = -1
        }

        if (b_IorD == "21")
        {
          b_IorD = "021"
          NoProgress = -1
        }
        else if (b_IorD == "2")
        {
          b_IorD = "02"
          NoProgress = -1
        }*/

        //We need to optimize the velocity to allow the swarm to migrate effectively
        //We need to keep track of the velocity and best values of it
        //Enhancement is obtained by executing the best velocity
        //Diversification is applied by increasing the velocity to explore far regions

        //println("Evaluation")

        //if ((UpdateFun == "Whale")  & (b_IorD != "2")) //(b_IorD != "11") & (b_IorD != "1") & (b_IorD != "21") &
        //{
        //WriteToFile(iteration.toString +":"+  Population(g).p.head.size.toString  + ":" + Population(g).p.length.toString )

          // Evaluation
          /*if (ObjFunGlobal == "GSOF1")
          {
            cost = GSOF1(data, data.sparkContext, Population(g).p)
          }
          else if (ObjFunGlobal == "GSOF2")
          {
            cost = GSOF2(data, data.sparkContext, Population(g).p)
          }
          else if (ObjFunGlobal == "GSOF3")
          {
            cost = GSOF3(data, data.sparkContext, Population(g).p)
          }
          else if (ObjFunGlobal == "kmeans")
          {
            //Tup = RecCenters(data, data.sparkContext, Population(g).p)
            Tup = RecCentersNew(data, data.sparkContext, Population(g).p)
            cost = Tup._1
            newCenters = Population(g).p.clone()
          }*/

          Population(g).p = AdjustMaxandMin(Population(g).p, minCol, maxCol)

          cost = MOPFun.ObjFun(str_ObjFun, Population(g).p )
          Population(g).fit = cost
          Population(g).Nobj = cost.length

          EL = Add2EL(EL, Population(g).CopyObj())

          /*if (CompareObj(WorestFit, Population(g).fit)) //( Population((g)).fit > WorestFit)
          {
            WorestFit = Population((g)).fit
            TL = Add2TLOrdered(TL, Population((g)), max_TL)
            Index_TL = Index_TL + 1
            Index_TL = Index_TL % max_TL
          }*/


          /*if (EL.length == max_EL)
          {
            if (CompareObj(Population(g).fit, EL(max_EL - 1).fit)) //(Population(g).fit < EL(max_EL-1).fit )
            {
              EL = Add2EL(EL, Population(g), max_EL)
            }
          }
          else if (EL.length < max_EL)
          {
            EL = Add2EL(EL, Population(g), max_EL)
          }

          if (CompareObj(Population(g).fit, RetBestFit)) //(Population(g).fit < RetBestFit)
          {
            RetBestFit = Population((g)).fit
            //BestCenters = Population((g)).p.clone()
          }*/

        /*}
        else if (g < LocalPopulation.length) {
          LocalPopulation(g).p = AdjustMaxandMin(LocalPopulation(g).p, minCol, maxCol).clone()
          // Evaluation
          if (ObjFunGlobal == "GSOF1") {
            cost = GSOF1(data, data.sparkContext, LocalPopulation(g).p)
            newCenters = LocalPopulation(g).p.clone()
          }
          else if (ObjFunGlobal == "GSOF2") {
            cost = GSOF2(data, data.sparkContext, LocalPopulation(g).p)
            newCenters = LocalPopulation(g).p.clone()
          }
          else if (ObjFunGlobal == "GSOF3") {
            cost = GSOF3(data, data.sparkContext, LocalPopulation(g).p)
            newCenters = LocalPopulation(g).p.clone()
          }
          else if (ObjFunGlobal == "kmeans") {
            Tup = RecCenters(data, data.sparkContext, LocalPopulation(g).p)
            cost = Tup._1
            newCenters = LocalPopulation(g).p.clone()
          }

          LocalPopulation((g)).fit = cost

          if (CompareObj(WorestFit, LocalPopulation(g).fit)) //( Population((g)).fit > WorestFit)
          {
            WorestFit = LocalPopulation((g)).fit
            TL = Add2TLOrdered(TL, LocalPopulation((g)), max_TL)
            Index_TL = Index_TL + 1
            Index_TL = Index_TL % max_TL
          }


          if (EL.length == max_EL) {
            if (CompareObj(LocalPopulation(g).fit, EL(max_EL - 1).fit)) //(Population(g).fit < EL(max_EL-1).fit )
            {
              EL = Add2EL(EL, LocalPopulation(g), max_EL)
            }
          }
          else if (EL.length < max_EL) {
            EL = Add2EL(EL, LocalPopulation(g), max_EL)
          }

          if (CompareObj(LocalPopulation(g).fit, RetBestFit)) //(Population(g).fit < RetBestFit)
          {
            RetBestFit = LocalPopulation((g)).fit
            BestCenters = LocalPopulation((g)).p.clone()
          }

        }*/

        //newCenters = Population(g).p.clone()

        //val (cost, newCenters) = RecCenters(data, data.sparkContext, Population(g).p)
        //val (cost, newCenters) = RecCentersHarmonic(data, data.sparkContext, Population(g).p, PHar)

        //Population((g)).p = newCenters.clone()
        //Population((g)).fit = cost

        // Update Personal Best
        /*if (CompareObj(Population(g).fit, Population(g).bfit) ) //(Population(g).fit < Population(g).bfit)
        {
          Population((g)).bp = Population(g).p.clone()
          Population((g)).bv = Population(g).v.clone()
          Population((g)).bfit= Population(g).fit

          if (b_stIntense == true)
            {
              i_stIntense = i_stIntense + 1
              b_stIntense = false
            }
          if (b_ndIntense == true)
          {
            i_ndIntense = i_ndIntense + 1
            b_ndIntense = false
          }
          if (b_stDiverse == true)
          {
            i_stDiverse = i_stDiverse + 1
            b_stDiverse = false
          }
          if (b_ndDiverse  == true)
          {
            i_ndDiverse = i_ndDiverse + 1
            b_ndDiverse = false
          }
        }*/


        /*if (b_stIntense == true)
          {
            i_stIntense = i_stIntense + 1
            b_stIntense = false
          }
          if (b_ndIntense == true)
          {
            i_ndIntense = i_ndIntense + 1
            b_ndIntense = false
          }
          if (b_stDiverse == true)
          {
            i_stDiverse = i_stDiverse + 1
            b_stDiverse = false
          }
          if (b_ndDiverse  == true)
          {
            i_ndDiverse = i_ndDiverse + 1
            b_ndDiverse = false
          }*/


      }

      /*GetNonDom(Population)
      for (tt <-0 until NonDom.length)
        {
          EL += NonDom(tt)
        }
      EL = NonDom*/
      //GetNonDom(EL)



      /*if (b_IorD == "22") {
        b_IorD = "0"
        NoProgress = -1
      }*/
      str_Fit = str_Fit + ":" + RetBestFit.toString

      if (Improvement == false)//PrevIntenseFit == RetBestFit)
      {
        NoProgress = NoProgress + 1
      }
      else
      {
        PrevIntenseFit = RetBestFit
      }

      //println("Adjustments")

      if (NoProgress >= max_NoProgress)
      {

        //NoProgress = 0
        if (b_IorD == "0")
        {
          b_IorD = "1"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "1")
        {
          b_IorD = "11"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "11")
        {
          b_IorD = "011"
          NoProgress = 0
        }

        else if (b_IorD == "011")
        {
          b_IorD = "2"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "2")
        {
          b_IorD = "21"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "21")
        {
          b_IorD = "0"
          NoProgress = 0
        }

      }



      iteration = iteration + 1
    }

    /*if (CompareObj(EL(0).fit, RetBestFit)) //(EL(0).fit <  RetBestFit )
    {
      RetBestFit = EL(0).fit
      //BestCenters = EL(0).p.clone()
    }

    if (UpdateFun == "PSO")
    {
      if (CompareObj(EL(0).bfit, RetBestFit)) //(EL(0).bfit <  RetBestFit )
      {
        RetBestFit = EL(0).bfit
        //BestCenters = EL(0).bp.clone()
      }
    }*/

    /*Tup = RecCenters(data, data.sparkContext, BestCenters)
    cost = Tup._1
    BestCenters = Tup._2.clone()
    BestCenters = AdjustMaxandMin(BestCenters, minCol, maxCol).clone()
    if ( cost < RetBestFit)
      {
        RetBestFit = cost
      }*/

    //BestCenters.foreach(x=> println(x))
    //data.unpersist()
    /*val iterationTimeInSeconds = (System.nanoTime() - iterationStartTime) / 1e9 / 60
    println(f"Iterations took $iterationTimeInSeconds%.3f minutes.")
    println("Number of iterations :" + (iteration))
    println("K :" + k)
    println("RetBestFit :" + RetBestFit)
    println("Fit :" + (RetBestFit * n))
    println("Difference :" + (((RetBestFit * n) - StandardObj) / StandardObj).formatted("0.00000") )*/

    /*WriteToFile("Intensification: " + i_Intense, true)
    WriteToFile("Diversification: " +i_Diverse)
    WriteToFile("First Intense Improvement: " +i_stIntense,true)
    WriteToFile("Second Intense Improvement: " +i_ndIntense,true)
    WriteToFile("First Diverse Improvement: " +i_stDiverse,true)
    WriteToFile("Second Diverse Improvement: " +i_ndDiverse,true)*/

    //WriteToFile("\n" + str_Fit)
    (RetBestFit)

  }

    def main(args: Array[String]): Unit =
    {

      //var str_ObjFun : String = ""
      ObjFunGlobal  = "kmeans"
      UpdateFun = "Whale"
      WriteToFile("/////////////",true)

      val currentTime: Long = System.currentTimeMillis
      //rand = new scala.util.Random(currentTime)
      rand = new scala.util.Random()


      //RunWhale()

      /*var Cov :  ListBuffer[Point] = new ListBuffer[Point]

      for ( j<- 0 until EL.length)
        {
          val p = new Point(EL(j).Nobj)
          p.values = EL(j).fit
          Cov += p
        }

      MOQtyInd.gFunName = str_ObjFun
      val IGD =MOQtyInd.invertedGenerationalDistance("",Cov)
      WriteToFile( "invertedGenerationalDistance" + IGD  ,true)*/

      WriteToFile( "invertedGenerationalDistance" ,true)

      ////UF
      /*for ( u<- 1 to 10)
      {
        str_ObjFun = "UF"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()
      }*/

      /*for ( u<- 6 to 6)
      {
        str_ObjFun = "UF"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()
      }

      for ( u<- 9 to 9)
      {
        str_ObjFun = "UF"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()
      }*/

      //////////ZDT
      for ( u<- 1 to 6)
      {
        if ( u != 5  ) //& u != 3
          {
            str_ObjFun = "ZDT"+u
            //str_ObjFun = "UF1"
            //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
            WriteToFile(UpdateFun,true)

            RunWhale()
          }
      }

      //////////DTLZ
      //var lst: ListBuffer[Integer]= ListBuffer(1,2,4,7)
      /*for ( u<- 7 to 7)
      {
        str_ObjFun = "DTLZ2:"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()

      }*/

      /*for ( u<- 1 to 7)
      {
        str_ObjFun = "DTLZ3:"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()

      }*/

      /*for ( u<- 3 to 3)
      {
        str_ObjFun = "DTLZ2:"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()

      }*/

      /*for ( u<- 7 to 7)
      {
        str_ObjFun = "DTLZ2:"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()

      }*/

      /*for ( u<- 3 to 3)
      {
        str_ObjFun = "DTLZ2:"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()

      }*/

      /*for ( u<- 7 to 7)
      {
        str_ObjFun = "DTLZ2:"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()

      }*/

      /*for ( u<- 8 to 10)
      {
        str_ObjFun = "UF"+u
        //str_ObjFun = "UF1"
        //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)

        RunWhale()

      }*/

      /*for ( u<- 1 to 23)
      {
        str_ObjFun = "F"+u
        RunWhale()
      }

      var b_Run : Boolean = false
      WriteToFile("/////////////",true)
      //WriteToFile("K-means Update Centers",true)
      //WriteToFile(UpdateFun,true)


      val l =  List(14)//1,2,3,4,5,6,7,8,9,10,14
      //val l =  List(10,13)

      //if ( b_Run == false )
      {
        val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test")
          .getOrCreate()

        /*ObjFunGlobal  = "GSOF1"
        UpdateFun = "PSO"
        WriteToFile("/////////////",true)
        WriteToFile("PSO   GSOF1",true)
        WriteToFile(UpdateFun,true)
        for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }*/

        /*ObjFunGlobal  = "GSOF1"
        UpdateFun = "Whale"
        WriteToFile("/////////////",true)
        WriteToFile("Whale   GSOF1",true)
        WriteToFile(UpdateFun,true)
        for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }*/

        /*ObjFunGlobal  = "GSOF2"
        UpdateFun = "PSO"
        WriteToFile("/////////////",true)
        WriteToFile("PSO   GSOF2",true)
        WriteToFile(UpdateFun,true)
         for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }*/

        /*ObjFunGlobal  = "GSOF2"
        UpdateFun = "Whale"
        WriteToFile("/////////////",true)
        WriteToFile("Whale   GSOF2",true)
        WriteToFile(UpdateFun,true)
        for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }*/

        /*ObjFunGlobal  = "GSOF3"
        UpdateFun = "PSO"
        WriteToFile("/////////////",true)
        WriteToFile("PSO   GSOF3",true)
        WriteToFile(UpdateFun,true)
         for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }*/

        /*ObjFunGlobal  = "GSOF3"
        UpdateFun = "Whale"
        WriteToFile("/////////////",true)
        WriteToFile("Whale   GSOF3",true)
        WriteToFile(UpdateFun,true)
        for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }*/

        /*ObjFunGlobal  = "kmeans"
        UpdateFun = "PSO"
        WriteToFile("/////////////",true)
        WriteToFile("PSO   kmeans",true)
        WriteToFile(UpdateFun,true)
         for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }*/

        ObjFunGlobal  = "kmeans"
        UpdateFun = "Whale"
        WriteToFile("/////////////",true)
        WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)
         //for (dataNum <- 0 to l.length)
        //{ RunCluster(l(dataNum), spark) }


        spark.stop()
      }

      //RunCluster(2)
      //Normalization
      //Randomizing the data objects in dataset
      for (kloop<- 10 to 7 by -1)
        {
          println(kloop)
        }

        */

  }

  def RunWhale() =
  {
    val (lb, ub, d ) = GetFunDetail(str_ObjFun)

    //val lis = MOPFun.RandPop(d, ub, lb)

    //val lis : ListBuffer[Double] = ListBuffer (0.3014,    0.0762,    0.8203,    0.9192,    0.2592)
    //MOPFun.ObjFun(str_ObjFun, lis )

    //val(lb, ub, d) =  WhaleFun.GetFunDetail(str_ObjFun)



    //- exception.length
    var maxCol = new ListBuffer[Double]
    if (ub.length <= 1)
    {
      for (i <- 0 until d)
      {
        maxCol += ub(0).asInstanceOf[Double]
      }
    }
    else
    {
      for (i <- 0 until ub.length)
      {
        maxCol += ub(i).asInstanceOf[Double]
      }
    }


    println("maxCol:" + maxCol)

    var minCol = new ListBuffer[Double]
    if (lb.length <= 1)
    {
      for (i <- 0 until d)
      {
        minCol += lb(0).asInstanceOf[Double]
      }
    }
    else
    {
      for (i <- 0 until lb.length)
      {
        minCol += lb(i).asInstanceOf[Double]
      }
    }
    println("minCol:" + minCol)

    quantileInt.clear()
    quantileDiv.clear()

    for (i <- 0 until d)
    {
      //quantileInt += ( minCol(i) +  ( (maxCol(i) - minCol(i)) / 5 ) )
      quantileInt += ( ( (maxCol(i) - minCol(i)) / 3 ) )

      //quantileDiv  +=  ( minCol(i) +  ( ( maxCol(i) - minCol(i) ) / 3) )
      quantileDiv  +=  ( ( ( maxCol(i) - minCol(i) ) / 2) )

    }
    println("quantileInt :" + quantileInt)

    var VelMax = new ListBuffer[Double]()
    for (i <- 0 until d)
    {
      VelMax += ((maxCol(i) - minCol(i)) / 3 )  // 3
      //VelMax += quantileInt(i)
    }
    println("VelMax: " + VelMax)

    var VelMin = new ListBuffer[Double]
    for (i <- 0 until d)
    {
      VelMin += (-1 * VelMax(i))
    }
    println("VelMin: " + VelMin)

    var TimeinLoop_Start: Double = 0.0
    var TimeinLoop_End: Double = 0.0
    var Centers_Str : String = ""

    var IGD : Double = 0.0
    var result: ListBuffer[Double] = new ListBuffer[Double]
    var Cov :  ListBuffer[Point] = new ListBuffer[Point]
    WriteToFile("Function : " + str_ObjFun ,true)
    for ( j<- 0 until RunNum )
    {

      TimeinLoop_Start = System.nanoTime()
      ClusterAlgo(1, VelMin, VelMax, minCol, maxCol, d)
      TimeinLoop_End = (System.nanoTime() - TimeinLoop_Start) / 1e9 / 60
      WriteToFile( "Time: " + TimeinLoop_End  ,true)


      Centers_Str = Centers_Str + str_ObjFun + "\n"
      Centers_Str = Centers_Str + "////////////////////" + "\n"
      Centers_Str = Centers_Str + "["

      Cov.clear() //= new ListBuffer[Point]
      for ( j<- 0 until EL.length)
      {
        val p = new Point(EL(j).Nobj)
        p.values = EL(j).fit.clone()
        Cov += p
        for( m<-0 until EL(j).fit.length )
          {
            if ( m > 0)
              {
                Centers_Str =  Centers_Str + "," + EL(j).fit(m)
              }
            else
              {
                Centers_Str =  Centers_Str +  EL(j).fit(m)
              }
          }
        Centers_Str =  Centers_Str + ";" +  "\n"
      }
      Centers_Str =  Centers_Str + "]"

      WriteToFileCenters(Centers_Str, true)

      //invertedGenerationalDistanceR2Ind
      /*var IGD : Double = 0.0
      MOQtyInd.gFunName = str_ObjFun
      IGD = MOQtyInd.invertedGenerationalDistance(str_ObjFun,Cov)
      result += IGD
      WriteToFile( "invertedGenerationalDistance: " + IGD  ,true)*/


      TimeinLoop_Start = System.nanoTime()
      MOQtyInd.gFunName = str_ObjFun
      //IGD = MOQtyInd.invertedGenerationalDistance(str_ObjFun,Cov)
      IGD = invertedGenerationalDistanceR2Ind(str_ObjFun,Cov)
      result += IGD
      //WriteToFile( "invertedGenerationalDistanceR2Ind: " + IGD  ,true)
      WriteToFile( "invertedGenerationalDistanceR2Ind: " + IGD  ,true)

      /*if (str_ObjFun.contains("UF"))
        {
          IGD = MOQtyInd.SP(str_ObjFun,Cov)
          //result += IGD
          WriteToFile( "SP: " + IGD  ,true)
        }*/

      /*TimeinLoop_End = (System.nanoTime() - TimeinLoop_Start) / 1e9 / 60
      WriteToFile( "Time: " + TimeinLoop_End  ,true)*/

      /*IGD = MOQtyInd.SP(str_ObjFun,Cov)
      //result += IGD
      WriteToFile( "SP: " + IGD  ,true)

      IGD =MOQtyInd.MS(str_ObjFun,Cov)
      //result += IGD
      WriteToFile( "MS: " + IGD  ,true)*/


      /*IGD =MOQtyInd.SP(str_ObjFun,Cov)
      //result += IGD
      WriteToFile( "SP: " + IGD  ,true)

      IGD =MOQtyInd.MS(str_ObjFun,Cov)
      //result += IGD
      WriteToFile( "MS: " + IGD  ,true)

      IGD =MOQtyInd.Spread(str_ObjFun,Cov)
      //result += IGD
      WriteToFile( "Spread: " + IGD  ,true)

      TimeinLoop_End = (System.nanoTime() - TimeinLoop_Start) / 1e9 / 60
      WriteToFile( "Time: " + TimeinLoop_End  ,true)*/

    }

    WriteToFile("Function : " + str_ObjFun ,true)
    WriteToFile("Average Fit : " + sum(result) / result.length ,true)
    WriteToFile("Standard Deviation : " + std(result) ,true)

  }

  def sum(lis : ListBuffer[Double]) : Double =
  {
    var sum: Double = 0.0
    for ( i<- 0 until lis.length)
      {
        sum = sum + lis(i)
      }
    return sum
  }

  def Avg(lis : ListBuffer[Double]) : Double =
  {
    var sum: Double = 0.0
    for ( i<- 0 until lis.length)
    {
      sum = sum + lis(i)
    }
    return (sum / lis.length)
  }

  def std(lis : ListBuffer[Double]) : Double =
  {
    val mean : Double = Avg(lis)

    var sum: Double = 0.0
    for ( i<- 0 until lis.length)
    {
      sum = sum + math.pow( lis(i) - mean, 2)
    }
    sum = sum / lis.length
    return (math.sqrt(sum))
  }

  def ComputeVelWhale(Randp :ListBuffer[Double], p:ListBuffer[Double], EL: ListBuffer[Double],
      C: Double, A: Double, prand: Double, b : Double, l: Double  ): ListBuffer[Double] =
  {

    //val rand = new scala.util.Random()
    var Vec = new ListBuffer[Double]//(p.head.size)
    var result : ListBuffer[Double] = new ListBuffer[Double]

    //X_rand = Positions(rand_leader_index,:);
    //D_X_rand = abs(C * X_rand(j) - Positions(i, j));
    // Eq .(2.7)
    //Positions(i, j) = X_rand(j) - A * D_X_rand;
    var distance2Leader : Double = 0.0

    //for (h <- 0 until p.length)
    {
      for (j <- 0 until p.length)
      {

        if (prand > 0.2)
        {
          if (math.abs(A) >= 1.0)
          {
            //if (p(0) != null & p.length > 0)
            Vec += Randp(j) - ( A * math.abs(C * Randp(j) - p(j)) )
          }
          else if (math.abs(A) < 1.0)
          {
            //D_Leader = abs(C * Leader_pos(j) - Positions(i, j));  // Eq .(2.1)
            //Positions(i, j) = Leader_pos(j) - A * D_Leader;     // Eq.(2.2)
            Vec += EL(j) - ( A * math.abs(C * EL(j) - p(j)) )
          }
        }
        else if (prand <= 0.2)
        {
          //distance2Leader=abs(Leader_pos(j)-Positions(i,j));
          // Eq. (2.5)
          //Positions(i,j)=distance2Leader*exp(b.*l).*cos(l.*2*pi)+Leader_pos(j);
          //Exploitation Phase
          distance2Leader = math.abs(EL(j) - p(j)); // Eq. (2.5)
          Vec += distance2Leader * math.exp(b * l) * math.cos(l * 2.0 * math.Pi) + EL(j);
        }
      }
      //result.update(h,  Vectors.dense(Vec).copy)
    }

    Vec
    //result
  }

  def ComputeVel(bp :Array[Vector] , p:Array[Vector], v:Array[Vector], EL: Array[Vector],
                 c1: Double , c2: Double, r1: Double, r2 : Double, w: Double ): Array[Vector] =
  {

    val result : Array[Vector] = new Array[Vector](p.length)
    //var Vec: Array[Double] = p1(1).toArray

    // val t: Double = iteration / MaxIt
    //val rand = new scala.util.Random()
    var t1: Double = 0.0
    var t2: Double = 0.0
    var r3: Double = r1
    var r4: Double = r2
    val Vec = new Array[Double](p.head.size)

    for (h <- 0 until p.length)
      {

       for (j <- 0 until p.head.size)
          {
            r3 = rand.nextDouble()
            r4 = rand.nextDouble()
            t1 = c1*r3
            t2= c2*r4

            if ( v(0) != null & v.head.size > 0)
              {
                Vec.update(j,  (  (  w * v(h)(j)) +
                  (  t1 *  (bp(h)(j) - p(h)(j) )) +
                  (  t2 *  (EL(h)(j) - p(h)(j) ))
                  ))
              }
            else
              {
                Vec.update(j ,  ( (  t1 * (bp(h)(j) - p(h)(j) )) +
                  (  t2 * (EL(h)(j) - p(h)(j) )) ) )
              }

          }
        result.update(h,  Vectors.dense(Vec).copy)
      }


    /*Population((h)).v <- Vectors.dense(
    ( (iteration / MaxIt)  * Population((h)).v.toArray ) +
      ( (c1*r1)*(Population((h)).bp.toArray - Population((h)).p.toArray)) +
      ((c2*r2)*(EL(0).p.toArray-Population((h)).p.toArray)) )*/

    result
  }

  def Add2Vec(p1:  Array[Vector], p2:  Array[Vector], op:String ) :  Array[Vector] =
  {
    val result : Array[Vector] = new Array[Vector](p1.length)
    //var Vec: Array[Double] = p1(1).toArray
    val Vec = new Array[Double](p1.head.size)

    for (i<- 0 until p1.length)
      {
        for ( j <- 0 until p1.head.size)
          {
            if (op == "+")
            { Vec.update(j , p1(i)(j) + p2(i)(j)) }
            else if (op == "-")
            { Vec.update(j , p1(i)(j) - p2(i)(j)) }
            else if (op == "*")
            { Vec.update(j , p1(i)(j) * p2(i)(j)) }
            else if (op == "/")
            { Vec.update(j , p1(i)(j) / p2(i)(j)) }
          }

        //val  Vec = p1(i).zip(p2(i)).map { case (x, y) => x + y }}

        result.update(i, Vectors.dense(Vec).copy)
      }
    result
  }

  def CrossOverFunByCol(Population : ListBuffer[MOPSONoKM]) : ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    val d = Population(1).p.length//.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)

    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]

    var delta_Row : Int = 0
    var delta_Col : Int = 0

    for (p <- 0 until delta_P)
    {
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.5).asInstanceOf[Int] //rand.nextInt(r/2)//  //base::sample(r,1)
      //delta_Row = math.round(r).asInstanceOf[Int]  //rand.nextInt(r/2) //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1}

      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {
        //delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        //if (delta_Col == 0 )
        //{ delta_Col = 1 }
        //rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        //for( j <- 0 until delta_Col)
        {

          if (rand_P(p) < Population.length - 1) {
            //////////P
            val t1 = Population((rand_P(p) + 1)).p(rand_Row(i))

            Population(rand_P(p) + 1).p(rand_Row(i)) =
              Population((rand_P(p))).p(rand_Row(i))

            Population((rand_P(p))).p(rand_Row(i)) = t1

          }
          else {
            //////////P
            val t1 = Population((rand_P(p))).p(rand_Row(i))

            Population((rand_P(p))).p(rand_Row(i)) =
              Population(((rand_P(p) - 1))).p(rand_Row(i))

            Population(((rand_P(p) - 1))).p(rand_Row(i)) = t1

          }
        }
      }
    }

    Population

  }

  //Intensification To Elite
  def CrossOverEliteByCol(Population: ListBuffer[MOPSONoKM], EL: ListBuffer[MOPSONoKM]) :
  ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    val d = Population(1).p.length
    val Np : Int = Population.length
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (Np/3).asInstanceOf[Int] //math.round(Np).asInstanceOf[Int] //Np
  // val rand_P = Array.range(0 , Np)
    val rand_P = GenRandList(Np, delta_P)

    //Best=Population[[1]]$P
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    var newVal :Double =0.0

    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]

      val index_EL = rand.nextInt(2)

      for ( i <- 0  until delta_Row)
      {

        //delta_Col = rand.nextInt((d).asInstanceOf[Int]) //base::sample(d,1) //d
        //if (delta_Col == 0 )
        //{ delta_Col = 1 }
        //rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        //for (j <- 0  until delta_Col)
        {

          Population(rand_P(p)).p(rand_Row(i)) =
            EL(index_EL).p(rand_Row(i))

        }
      }
    }

    Population

  }

  //Local Search
  /*def LocalSearch( EL : ListBuffer[MOPSONoKM], Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double] )
  : ListBuffer[MOPSONoKM] =
  {

    val rand = new scala.util.Random()
    var Population : ListBuffer[MOPSONoKM] = new ListBuffer[MOPSONoKM]
    var Temp : Array[Vector] = EL(0).p.clone()
    val r : Int = EL(0).p.length
    val d : Int = EL(0).p.head.size
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    var rand_Val: Double = 0.0
    var t: Double = 0.0
    var obj : MOPSONoKM = new MOPSONoKM(r)
    val delta_P = (Np/2).asInstanceOf[Int] //math.round(Np).asInstanceOf[Int] //Np
    // val rand_P = Array.range(0 , Np)
    val rand_P = GenRandList(Np, delta_P)


    for ( p<- 0 until delta_P )
    {
      Temp = EL(rand.nextInt(2)).p.clone()
      //val obj = new MOPSONoKM(r)

      delta_Row = rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row)

      for ( i<- 0 until delta_Row )
      {
        delta_Col = rand.nextInt((d).asInstanceOf[Int]) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col)

        for ( j<- 0 until delta_Col )
        {
          rand_Val = rand.nextDouble()

          if (rand_Val  >= 0.5 )
          {
            t =  0.1 * rand.nextDouble() * ( VarMax(rand_Col(j)) - Temp(rand_Row(i))(rand_Col(j)) )
            t = t + Temp(rand_Row(i))(rand_Col(j))
          }

          else
          {
            t =  0.1 * rand.nextDouble() * ( Temp(rand_Row(i))(rand_Col(j)) - VarMin(rand_Col(j)) )
            t = Temp(rand_Row(i))(rand_Col(j)) - t
          }

          if (t == 0)
            {     t = Temp(rand_Row(i))(rand_Col(j))    }

          Temp(rand_Row(i)).toArray((rand_Col(j))) = t

        }
      }

      obj.p = Temp.clone()
      Population += obj.CopyObj()


    }

    Population

  }*/

  //CrossOver Tabu List
  def CrossOverTabu(Population : ListBuffer[MOPSONoKM], TL: ListBuffer[MOPSONoKM], EL: ListBuffer[MOPSONoKM]) : ListBuffer[MOPSONoKM] =
  {

    val d = Population(1).p.length //.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (0.3 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    //val rand = new scala.util.Random()
    var EL_Index : Int =0 //rand.nextInt(2)
    EL_Index = rand.nextInt(2)
    var delta_Row : Int = 0

    for (p <- 0 until delta_P)
    {
      // = math.round(r * 0.3).asInstanceOf[Int]  //base::sample(r,1)
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row =  1 }

      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      val index_TL  = rand.nextInt(TL.length)
      Population(rand_P(p)).p = EL(rand.nextInt(2)).p.clone()

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)).p(rand_Row(i))  = TL( index_TL ).p(rand_Row(i))

        //////////V
        //Population(( (rand_P(p)) )).v(rand_Row(i)) =
        //Vectors.dense(TL( index_TL ).v(rand_Row(i)).toArray)

        //////////BP
        //Population(( (rand_P(p)) )).bp(rand_Row(i)) =
        //Vectors.dense(TL( index_TL ).bp(rand_Row(i)).toArray)

      }
    }

    Population

  }

  //CrossOver_fun
  def CrossOverFun(Population : ListBuffer[MOPSONoKM]) : ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    val d = Population(1).p.length//.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Population.length/2)//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
    {delta_P = 1}
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)

    var delta_Row : Int = 0
    var Replacement: Int = 0

    for (p <- 0 until delta_P)
    {

      /*Replacement = rand.nextInt(Population.length)
      while(Replacement == rand_P(p))
        {
          Replacement = rand.nextInt(Population.length)
        }*/


      //math.ceil(d/2).asInstanceOf[Int]
      //delta_Row = math.round(r * 0.3).asInstanceOf[Int]  //base::sample(r,1)
      delta_Row = rand.nextInt((r/2).asInstanceOf[Int])  //rand.nextInt(r/2) //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1}

      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {
        if ( rand_P(p) < Population.length-1 )
        {
          //////////P
          val t1 = Population( (rand_P(p)+1) ).p(rand_Row(i))
          //val t1 = Population( Replacement) ).p(rand_Row(i)).toArray

          /*Population(rand_P(p)+1) .p(rand_Row(i))  =
            Vectors.dense(Population(( rand_P(p) )).p(rand_Row(i)).toArray).copy*/

          Population(( rand_P(p) )).p(rand_Row(i)) = t1
          //////////V
          /*val t2 = Population(( (rand_P(p)+1) )).v(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).v(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).v(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( (rand_P(p)+1) )).bp(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).bp(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).bp(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
        else
        {
          //////////P
          val t1 = Population(( rand_P(p) - 1)).p(rand_Row(i))

          /*Population(( rand_P(p) )).p(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).p(rand_Row(i)).toArray).copy*/

          Population(( (rand_P(p)) )).p(rand_Row(i)) = t1
          //////////V
          /*val t2 = Population(( rand_P(p) )).v(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).v(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).v(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( rand_P(p) )).bp(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).bp(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).bp(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
      }
    }

    Population

  }

  //CrossOver Elite List
  def CrossOverElite(Population : ListBuffer[MOPSONoKM], EL: ListBuffer[MOPSONoKM]) : ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    val d = Population(1).p.length
    //val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Population.length/2) //math.round(Population.length * 0.5).asInstanceOf[Int]//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
      {delta_P = 1}
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    var delta_Row: Int = 0

    for (p <- 0 until delta_P)
    {
      delta_Row = rand.nextInt((d).asInstanceOf[Int])//math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1 }
      val rand_Row =  GenRandList(d , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      val index_EL  = rand.nextInt(EL.length)

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)) .p(rand_Row(i))  =
          EL( index_EL ).p(rand_Row(i))

        //Population(rand_P(p)) .p(rand_Row(i))

        //////////V
        //Population(( (rand_P(p)) )).v(rand_Row(i)) =
          //Vectors.dense(EL( index_EL ).v(rand_Row(i)).toArray)

        //////////BP
        //Population(( (rand_P(p)) )).bp(rand_Row(i)) =
          //Vectors.dense(EL( index_EL ).bp(rand_Row(i)).toArray)

      }
    }

    Population

  }



  //Intensification To Elite
  def InstensifyEliteFun(Population: ListBuffer[MOPSONoKM], Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double],
                         EL: ListBuffer[MOPSONoKM]) :
  ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    val d = Population(1).p.length
    //val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P =rand.nextInt(Population.length /2) //Np
    if (delta_P == 0 )
    {delta_P = 1}
    val rand_P = GenRandList(Population.length, delta_P)

    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    //delta_Row = r
    //rand_Row=c(1:r)
    var newVal :Double = 0.0
    for (p <- 0 until delta_P)
    {

      //val index_EL = rand.nextInt(EL.length)

      //for ( i <- 0  until delta_Row)
      {

        delta_Col = rand.nextInt((d/2).asInstanceOf[Int] ) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0  until delta_Col)
        {
          /*oldVal = Population(rand_P(p)).p(rand_Col(j))
          //x= rand.nextInt(2)//base::sample(2,1)
          temp = 0
          newVal= oldVal
          //OLD Method start
          //if (oldVal  > BestCenters(rand_Row(i)).toArray(rand_Col(j)) )
          if (oldVal  > EL(index_EL).p(rand_Col(j)) )
          {
            temp =  rand.nextDouble() * ( oldVal -   EL(index_EL).p(rand_Col(j)) )
            newVal= oldVal - temp

          }
          else if (oldVal  < EL(index_EL).p(rand_Col(j)) )
          {
            temp =   rand.nextDouble() * (  EL(index_EL).p(rand_Col(j)) -  oldVal )
            newVal= oldVal + temp

          }
          if (newVal == 0)
            newVal= oldVal*/

          newVal = VarMin(rand_Col(j)) +  rand.nextDouble() * (VarMax(rand_Col(j)) - VarMin(rand_Col(j)))
          Population(rand_P(p)).p((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  //Intensification Function
  def InstensifyFun(Population: ListBuffer[MOPSONoKM],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[MOPSONoKM] = {

    val d = Population(1).p.length//.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (Np/2).asInstanceOf[Int] //math.round(0.6 * Np).asInstanceOf[Int] // Np
    //val rand_P = Array.range(0 , Np)
    val rand_P = Array.range(0 , Np) //GenRandList(Np, delta_P)
    //val rand = new scala.util.Random()
    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row = 0
    var delta_Col = 0
    //delta_Row = r
    //rand_Row=c(1:r)
    var newVal :Double =0.0
    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt( (r/2).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
        { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]

      for ( i <- 0  until delta_Row)
      {
        //delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        //if (delta_Col == 0 )
        //   { delta_Col = 1 }
        //rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        //for (j <- 0  until delta_Col)
        {
            oldVal = Population(rand_P(p)).p(rand_Row(i))
            x= rand.nextInt(2)//base::sample(2,1)
            temp = 0
            newVal = oldVal
            //OLD Method start
            if (x  == 1  )
            {
              //val temp =  0.0001 * runif(1,0,1) * ( oldVal -  VarMin[1,rand_Col[j]])
              temp =   ( quantileInt(rand_Col(i)) -  VarMin(rand_Col(i)) )  * rand.nextDouble() //* ( oldVal -  VarMin(rand_Col(j)) )
              newVal= oldVal - temp
            }
            else
            {
              temp = ( quantileInt(rand_Col(i)) -  VarMin(rand_Col(i)) ) * rand.nextDouble() //* ( VarMax(rand_Col(j)) - oldVal)
              newVal= oldVal + temp
            }

            Population(rand_P(p)).p(rand_Row(i)) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  def DiversifyFun(Population: ListBuffer[MOPSONoKM],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    val d = Population(1).p.length
    val r = Population(1).p.length //nrow(Population[[1]]$P)
    val delta_P = math.round(0.5 * Np).asInstanceOf[Int] //round(0.7*Np)
    var rand_Row: ListBuffer[Int]  = new ListBuffer[Int]()
    var delta_Col = 0
    var rand_Col: ListBuffer[Int] = GenRandList(d, 1)
    //var temp_Rand : Int = 0
    //var rand_P: ListBuffer[Int] = new ListBuffer[Int]
    val rand_P : ListBuffer[Int] = GenRandList(Np, delta_P)
    var delta_Row = 0
    var newVal: Double = 0.0
    var oldVal = 0.0
    var x = 0
    var temp = 0.0

    for (p <- 0 until delta_P)
    {

      delta_Row = math.round(0.3 * r).asInstanceOf[Int]//rand.nextInt(r) //base::sample(r,1) //r
      if (delta_Row == 0 ) { delta_Row = 1}
      rand_Row = GenRandList(r, delta_Row) //new ListBuffer[Int]

      /*for (v <- 0 until delta_Row) {
        rand_Row += rand.nextInt(r) //base::sample(r,delta_Row,replace=FALSE) //c(1,r)
      }*/


      for (i <- 0 until delta_Row)
      {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if ( delta_Col == 0 )
          { delta_Col = 1 }
        //rand_Col = GenRandList(d, delta_Col)//new ListBuffer[Int]
        /*for (v <- 0 until delta_Col) {
          rand_Col += rand.nextInt(d) //base::sample(r,delta_Row,replace=FALSE) //c(1,r)
        }*/

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        //for (j <- 0 until delta_Col) {

          oldVal = Population(rand_P(p)).p(rand_Row(i))
          x = rand.nextInt(2)
          //base::sample(2,1)
          temp = 0
          //OLD Method start
          newVal = oldVal
          if ( (x == 1) & ( oldVal > VarMin(rand_Col(i))))
          {

            val temp = ( quantileDiv(rand_Col(i)) -  VarMin(rand_Col(i)) ) * rand.nextDouble() //* (oldVal - VarMin(rand_Col(j)))
            newVal = oldVal - temp
          }
          else {

            temp = ( quantileDiv(rand_Col(i)) -  VarMin(rand_Col(i)) ) * rand.nextDouble() //* (VarMax(rand_Col(j)) - oldVal)
            newVal = oldVal + temp
          }

          Population(rand_P(p)).p(rand_Row(i)) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p = AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax)

    Population
  }

  def GenRandList(Np: Int , count: Int) :ListBuffer[Int] =
  {
    //val rand = new scala.util.Random()
    var l : ListBuffer[Int] =  new ListBuffer[Int]
    var temp_Rand : Int = 0
    for (v<-0 until count )
    {
      temp_Rand = rand.nextInt(Np)


      while(l.contains(temp_Rand) == true )
      {
        temp_Rand = rand.nextInt(Np)
      }

      l += temp_Rand
    }
    l
  }


  def AdjustMaxandMin(obj : ListBuffer[Double], VarMin: ListBuffer[Double], VarMax: ListBuffer[Double]) : ListBuffer[Double] =
  {
    //var x = obj
    //val d = obj.head.size
    val d = obj.length
    //for (i<- 0 until obj.length)
      //{
        for (j<-0 until d)
          {
            if ( obj(j) > VarMax(j) )
              {
                obj(j) = VarMax(j)
                //obj(j) = VarMin(j) +  rand.nextDouble() * (VarMax(j) - VarMin(j))
              }
            if ( obj(j) < VarMin(j) )
            {
              obj(j) = VarMin(j)
              //obj(j) = VarMin(j) +  rand.nextDouble() * (VarMax(j) - VarMin(j))
            }
          }
      //}

    obj
  }

  //GSOF1
  def GSOF1(data: RDD[Vector], sc:SparkContext, centers: Array[Vector]) :(Double)=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    //println(bcCenters)
    // Find the new centers
    val newCenters = data.mapPartitions { points =>
      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        val (bestCenter, cost) = findClosest(thisCenters, point)
        val tempcost = cost * cost
        costAccum.add(tempcost)
        counts(bestCenter) += 1
        Dist(bestCenter) = Dist(bestCenter) + cost
      }
      Dist.indices.map(j => (j, ( Dist(j), counts(j) ))).iterator
    }.reduceByKey { case ( (d1, c1), (d2, c2) ) =>
      ( d1 + d2, c1 + c2 )
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    val SSE : Double = costAccum.value

    bcCenters.destroy()
    var IntraDist : ListBuffer[Double] = new ListBuffer[Double]()
    var CnterDist : ListBuffer[Double] = new ListBuffer[Double]()
    var ClustCount : ListBuffer[Double] = new ListBuffer[Double]()

    for ( i<- 0 until globalK)
    {
      IntraDist += 0.0
      CnterDist += 0.0
      ClustCount += 0.0
    }
    // Update the cluster centers and costs
    newCenters.foreach { case (j, newCenter) =>
      IntraDist(j) = newCenter._1
      ClustCount(j) = newCenter._2
    }

    var maxIntraDist : Double = IntraDist(0)
    for ( i<- 1 until globalK )
      {
        if ( maxIntraDist < IntraDist(i) )
          {
            maxIntraDist = IntraDist(i)
          }
      }

    var TotCentDist : Double = 0.0
    for ( i<- 0 until globalK )
      {
        for (j <- i until globalK )
          {
            TotCentDist = TotCentDist + math.pow(ObjFun(centers(i), centers(j)) , 2 )
          }
      }


    var Ret : Double = 0.0
    for ( j<- 0 until globalK)
      {
        Ret = Ret + (((1/data.count().asInstanceOf[Double])  * ClustCount(j)) / (SSE * ( IntraDist(j) / maxIntraDist ) ))
      }


    return (Ret)

  }

  //GSOF2
  def GSOF2(data: RDD[Vector], sc:SparkContext, centers: Array[Vector]) :(Double)=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    //println(bcCenters)
    // Find the new centers
    val newCenters = data.mapPartitions { points =>
      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        val (bestCenter, cost) = findClosest(thisCenters, point)
        val tempcost = cost * cost
        costAccum.add(tempcost)
        counts(bestCenter) += 1
        Dist(bestCenter) = Dist(bestCenter) + cost
      }
      Dist.indices.map(j => (j, ( Dist(j), counts(j) ))).iterator
    }.reduceByKey { case ( (d1, c1), (d2, c2) ) =>
      ( d1 + d2, c1 + c2 )
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    val SSE : Double = costAccum.value

    bcCenters.destroy()
    var IntraDist : ListBuffer[Double] = new ListBuffer[Double]()
    var CnterDist : ListBuffer[Double] = new ListBuffer[Double]()
    var ClustCount : ListBuffer[Double] = new ListBuffer[Double]()

    for ( i<- 0 until globalK)
    {
      IntraDist += 0.0
      CnterDist += 0.0
      ClustCount += 0.0
    }
    // Update the cluster centers and costs
    newCenters.foreach { case (j, newCenter) =>
      IntraDist(j) = newCenter._1
      ClustCount(j) = newCenter._2
    }

    var maxIntraDist : Double = IntraDist(0)
    for ( i<- 1 until globalK )
    {
      if ( maxIntraDist < IntraDist(i) )
      {
        maxIntraDist = IntraDist(i)
      }
    }

    var TotCentDist : Double = 0.0
    for ( i<- 0 until globalK )
    {
      for (j <- i until globalK )
      {
        TotCentDist = TotCentDist + math.pow(ObjFun(centers(i), centers(j)) , 2 )
      }
    }


    var Ret : Double = 0.0
    for ( j<- 0 until globalK)
    {
      Ret = Ret + (((1/data.count().asInstanceOf[Double]) * TotCentDist * ClustCount(j)) / (( IntraDist(j) / maxIntraDist ) ))
    }


    return (Ret)

  }

  //GSOF3
  def GSOF3(data: RDD[Vector], sc:SparkContext, centers: Array[Vector]) :(Double)=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    //println(bcCenters)
    // Find the new centers
    val newCenters = data.mapPartitions { points =>
      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        val (bestCenter, cost) = findClosest(thisCenters, point)
        val tempcost = cost * cost
        costAccum.add(tempcost)
        counts(bestCenter) += 1
        Dist(bestCenter) = Dist(bestCenter) + cost
      }
      Dist.indices.map(j => (j, ( Dist(j), counts(j) ))).iterator
    }.reduceByKey { case ( (d1, c1), (d2, c2) ) =>
      ( d1 + d2, c1 + c2 )
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    val SSE : Double = costAccum.value

    bcCenters.destroy()
    var IntraDist : ListBuffer[Double] = new ListBuffer[Double]()
    var CnterDist : ListBuffer[Double] = new ListBuffer[Double]()
    var ClustCount : ListBuffer[Double] = new ListBuffer[Double]()

    for ( i<- 0 until globalK)
    {
      IntraDist += 0.0
      CnterDist += 0.0
      ClustCount += 0.0
    }
    // Update the cluster centers and costs
    newCenters.foreach { case (j, newCenter) =>
      IntraDist(j) = newCenter._1
      ClustCount(j) = newCenter._2
    }

    var maxIntraDist : Double = IntraDist(0)
    for ( i<- 1 until globalK )
    {
      if ( maxIntraDist < IntraDist(i) )
      {
        maxIntraDist = IntraDist(i)
      }
    }

    var TotCentDist : Double = 0.0
    for ( i<- 0 until globalK )
    {
      for (j <- i until globalK )
      {
        TotCentDist = TotCentDist + math.pow(ObjFun(centers(i), centers(j)) , 2 )
      }
    }


    var Ret : Double = 0.0
    for ( j<- 0 until globalK)
    {
      Ret = Ret + (((1/data.count().asInstanceOf[Double])* TotCentDist  * ClustCount(j)) / (SSE * ( IntraDist(j) / maxIntraDist ) ))
    }


    return (Ret)

  }

  def RecCentersHarmonic(data: RDD[Vector], sc:SparkContext, centers: Array[Vector],
                         p: Double)
  :(Double,Array[Vector])=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    val partNum =  data.partitions.length

    val Mapped = data.mapPartitionsWithIndex{  (index, points) =>

      val counts = Array.fill(partNum)(0.0D)
      var Up: ListBuffer[Vector] = new ListBuffer[Vector]
      var bottom: ListBuffer[Double] = new ListBuffer[Double]
      //Array.fill(thisCenters.length)(Vectors.zeros(dims))

      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      points.foreach{ point =>

        val cost = HarCent(thisCenters, point, p)
        val tempcost = cost // cost
        costAccum.add(tempcost)
        counts(index) = counts(index) +  tempcost
        ///Compute the membership for all centers

        if (Up.length == 0)
        {
          for (j<-0 until thisCenters.length)
          {
            Up += Vectors.dense( Array.fill(dims)(0.0D))
            bottom += 0.0
          }
        }

        var m : Double =0.0
        var w : Double = 0.0
        var CentIndex = 0

        thisCenters.foreach { center =>
          m = ObjFunHar(center, point, (-1 * p) - 2) / HarCent(thisCenters, point, (-1 * p) - 2)
          w = HarCent(thisCenters, point, (-1 * p) - 2) /
                math.pow(HarCent(thisCenters, point, (-1 * p)), 2)
          for (j<-0 until dims)
          {
            Up(CentIndex).toArray.update(j, Up(CentIndex).toArray(j) + (point(j) * m * w) )
          }
          bottom(CentIndex) = bottom(CentIndex) + (m * w)
          CentIndex = CentIndex + 1
        }
      }
      Up.indices.map( j => ( j, (Up(j), bottom(j) ) )).iterator
    }.reduceByKey{ case ((up1, b1), (up2, b2)) =>
      axpy(1.0, up2, up1)
      (up1, b1 + b2)
    }.mapValues { case (sum, count) =>
      scal(1.0 / count, sum)
      Vectors.dense(sum.toArray)
    }.collectAsMap()


    /*counts.indices.filter(counts(_) > 0).map(j => (j, (sums(j), counts(j)))).iterator
  }.reduceByKey { case ((sum1, count1), (sum2, count2)) =>
    axpy(1.0, sum2, sum1)
    (sum1, count1 + count2)
  }.mapValues { case (sum, count) =>
    scal(1.0 / count, sum)
    Vectors.dense(sum.toArray)
  }.collectAsMap()*/

    Mapped.foreach { case (j, newCenter) =>
      centers(j) = newCenter
    }

    bcCenters.destroy()
    (costAccum.value , centers)

  }

  def HarCent(centers: TraversableOnce[Vector], p: Vector, par: Double) :Double =
  {
    var Ret: Double = 0.0
    var t : Double = 0.0
    centers.foreach { center =>
      t = ObjFunHar(center, p, par)
      if( t.equals(Double.NaN) == false )
        {Ret = Ret + ( 1 / t  )}
       //center.norm - point.norm
    }
    if( Ret.equals(Double.NaN) == false )
    {(globalK/ Ret )}
    else
    {0}

  }

  def ObjFunHar(p1: Vector, p2: Vector, par: Double): Double = {
    var squaredDistance : Double = 0.0
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance = math.pow(squaredDistance, par)
    squaredDistance

  }

  def HarSupFun (centers: TraversableOnce[Vector], p: Vector, par: Double) :Double =
  {
    var Ret: Double = 0.0
    var t : Double = 0.0
    centers.foreach { center =>
      t = ObjFunHar(center, p, par )
      if( t.equals(Double.NaN) == false )
      {Ret = Ret +  t  }
    }
    Ret
  }

  def RecCentersNew(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):(Double,Array[Vector])={

    var PointsNew : ListBuffer[ListBuffer[Vector]]= new ListBuffer[ListBuffer[Vector]]()
    var temp: ListBuffer[Vector] = ListBuffer[Vector]()

    for (i<- 0 until globalK)
    {
      PointsNew += temp.clone()

    }
    var TotalPointsCost: Double = 0.0
    var MaxCost: Double = Double.NegativeInfinity
    var Tup: Tuple2[Int, Double] = (-1, -1)
    var bIndex: Int = 0
    var cost : Double = 0.0
    val n : Double = data.count().asInstanceOf[Double]

    data.collect().foreach { point =>
      Tup  = findClosest(centers, point)
      bIndex = Tup._1
      cost = Tup._2
      cost = cost*cost

      PointsNew(bIndex) += point
      TotalPointsCost = TotalPointsCost + cost
      if (MaxCost < cost)
        {MaxCost = cost}
    }

    var tc : Double = 0.0
    tc = TotalPointsCost / (n * MaxCost)


    var TotalCenterCost: Double = 0.0
    var MaxCentCost : Double = Double.NegativeInfinity
    var MaxCentIndex: Double = 1.0

    for ( r<- 0 until globalK)
    {
      for ( g <- r+1 until globalK)
      {

          cost = ObjFun(centers(r), centers(g))
          cost = cost * cost
          if (MaxCentCost < cost)
            {
              MaxCentCost = cost
              MaxCentIndex = r+1.0
            }
          TotalCenterCost = TotalCenterCost + cost

      }
    }

    if ( MaxCentIndex > 1)
      {
        MaxCentIndex = MaxCentIndex * (MaxCentIndex - 1.0)
      }

    var tr = (2.0* TotalCenterCost) /
             (MaxCentCost * MaxCentIndex.asInstanceOf[Double])  //globalK.asInstanceOf[Double] * (globalK - 1).asInstanceOf[Double] )

    var MaxCount : Int = PointsNew(0).length //Int.MinValue
    var MinCount : Int = PointsNew(0).length
    for (i<- 1 until globalK)
      {
        if ( MaxCount <  PointsNew(i).length  )
           { MaxCount =  PointsNew(i).length  }

        if ( MinCount >  PointsNew(i).length  )
            { MinCount =  PointsNew(i).length  }

      }

    val ty:Double = MinCount.asInstanceOf[Double] / MaxCount.asInstanceOf[Double]

    //val Retcost = ( tc + (1.0 - tr) + ( 1.0 - ty) ) / 3.0   //original
    //val Retcost = ( tc + (( 1.0 - ty)*  0.5)  ) / 2.0 //Bwst for the iris 9.733

    val Retcost = ( (tc /2) +  ( (1.0 - tr)/2  )  + (1-ty)  ) / 3.0   //



    (Retcost, centers)

  }


  def RecCenters(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):(Double,Array[Vector])={

    //while (iteration < MaxIt) {
    //&& !converged) {

      val costAccum = sc.doubleAccumulator
      val bcCenters = sc.broadcast(centers)
      //println(bcCenters)

      // Find the new centers
      val newCenters = data.mapPartitions { points =>
        val thisCenters = bcCenters.value
        val dims = thisCenters.head.size
        //println("dims: " + dims)

        val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
        //println("sums: " + sums.toString)
        val counts = Array.fill(thisCenters.length)(0L)
        //println("counts: " + counts)

        points.foreach { point =>
          val (bestCenter, cost) = findClosest(thisCenters, point)
          //println("Single Cost:" + cost + " : Best Center = " + bestCenter.toString)

          val tempcost = cost * cost * cost
          costAccum.add(tempcost)
          //println("costAccum:" + costAccum.value )
          val sum = sums(bestCenter)
          //***************UnKonwn Comment
          axpy(1.0, point, sum)
          //Add2Vec(1.0,point,sum)
          //println("point size:" + point.size + " class:" + point.getClass)
          //println("sum size:" +  sum.size + "   class:" + sum)
          //org.apache.spark.ml.linalg
          //sums.map(x=>println(x))
          counts(bestCenter) += 1
          //println("counts(bestCenter): " + counts(bestCenter))
        }

        counts.indices.filter(counts(_) > 0).map(j => (j, (sums(j), counts(j)))).iterator
      }.reduceByKey { case ((sum1, count1), (sum2, count2)) =>

        //***************UnKonwn Comment
        //println("1111111111111")
        //println("sum2:" + sum2 + "sum1:" + sum1)
        axpy(1.0, sum2, sum1)
        //println("count1: " + count1)
        (sum1, count1 + count2)
      }.mapValues { case (sum, count) =>
        //for(i<-1 to sum.size)
         // {println("Sum Before:" + sum(i))}
        //println("Sum Before:" + sum)
        //println("count Before:" + count)
        //***************UnKonwn Comment
        scal(1.0 / count.asInstanceOf[Double], sum)
        //***************UnKonwn Comment
        //new Vectors.dense(sum.toArray) //do not why this is used
        //for(i<-1 to sum.size)
        //{println("Sum After:" + sum(i))}

        //println("Sum:" + sum)

        Vectors.dense(sum.toArray)
      }.collectAsMap()

      bcCenters.destroy()
      // Update the cluster centers and costs

      //// 24-12-2017
    /*if ( b_RetNewCent == true)
    {
      newCenters.foreach { case (j, newCenter) =>
        centers(j) = newCenter
      }
    }*/

    //println("newCenters")
    /*newCenters.foreach{x=>
      println(x)
     }*/

    /*var InterDist : Double = 0.0
    for ( i<- 0 until globalK )
    {
      for (j <- 0 until globalK )
      {
        if ( i != j)
        {
          InterDist = InterDist + math.pow(ObjFun(centers(i), centers(j)), 2)
        }
      }
    }
    val Retcost = costAccum.value.asInstanceOf[Double] / InterDist //Hybrid SSEE and InterDist*/

    //val Retcost = costAccum.value / data.count().asInstanceOf[Double] //Euclidean Distance
    val Retcost = costAccum.value  // SSEE Distance

    //centers.foreach { x => println(x) }
    //println(s"The cost is $cost.")

    (Retcost, centers)

  }

  def ObjFun(p1: Vector, p2: Vector): Double = {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  def parseVector(line: String): Vector = {
    val x = line.split(',').map(_.toDouble)
    Vectors.dense(x)
  }

  def Row2Vector(r: Row, except: ListBuffer[String]): Vector = {
    var l = new ListBuffer[Double]()
    for (i <- 0 until r.length ) {
      if ( except.contains(r.schema.fields(i).name) == false)
      {
        l += r.get(i).asInstanceOf[Double]
      }
    }
    //println("l :" + l(1))
    Vectors.dense(l.toArray)
  }

  def findClosest(centers: TraversableOnce[Vector], p: Vector): (Int, Double) = {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFun(center, p) //center.norm - point.norm
      if (Dist < bestDistance) {
        bestDistance = Dist
        bestIndex = i
      }
    }
    (bestIndex, bestDistance)
  }

  def findClosestRow(centers: TraversableOnce[Vector], p: org.apache.spark.sql.Row, except: ListBuffer[String]): (Int, Double) = {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFunRow(center, p, except) //center.norm - point.norm
      if (Dist < bestDistance) {
        bestDistance = Dist
        bestIndex = i
        //println("bestIndex " + bestIndex)
      }
      //println("Dist " + i + ":" + Dist)
    }
    (bestIndex, bestDistance)
  }

  def ObjFunRow(p1: Vector, p2: org.apache.spark.sql.Row, except: ListBuffer[String]): Double = {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      if (except.contains(p2.schema.fields(i).name) == false)
      {
        squaredDistance = squaredDistance + math.pow(p1(i) - p2.get(i).asInstanceOf[Double], 2)
      }
    }

    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }


  def CompareMatrix(EL: ListBuffer[MOPSONoKM], p: MOPSONoKM) : Boolean =
  {
    var b_equal: Boolean = true
    var b_break: Boolean = true

    for (v <- 0 until EL.length)
    {
      b_equal = true
      b_break= false

      for (i <- 0 until EL(v).fit.length)
      {
        //for (j <- 0 until EL(v).p.)
        {
          if (EL(v).fit(i) != p.fit(i))
          {
            b_equal = false
            b_break = true
          }
        }
      }
      if ( b_equal == true)
      { return true}
    }

    return b_equal
  }

  def CompareFit(EL: ListBuffer[MOPSONoKM], p: MOPSONoKM) : Boolean =
  {
    var b_equal: Boolean = true

    for (v <- 0 until EL.length)
    {
      b_equal = true
      breakable
      {
        for (i <- 0 until EL(v).fit.length)
        {
          if (EL(v).fit(i) != p.fit(i))
          {
              b_equal = false
              break
          }
        }

        if (b_equal == true)
        {
          return true
        }
      }
    }


    return false
  }


  //def IsIdentical(p1: PSO , p2: PSO): Boolean = {}
  //EL, obj, max_EL
  //Best Old
  def Add2EL(EL: ListBuffer[MOPSONoKM], p: MOPSONoKM): ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    var b_exist: Boolean = false
    if ( EL.length == 0)
    {
      EL  += p.CopyObj
      return EL
    }

    if ( CompareFit(EL, p) == true )
      {
        return EL
      }

    /*if ( EL.length < max_EL)
    {
      EL  += p.CopyObj
      return EL
    }*/

    /*if (SPdistanceToClosestPoint(EL, p) < 0.00521)
    {
      return EL
    }*/

    var Dominated :ListBuffer[Integer] = new ListBuffer[Integer]
    //val maxTemp = EL.length
    //b_isDominated = true
    var b_HasbeenDom : Boolean = false

    for (i <- 0 until EL.length)
    {
      if (CompareObj(p.fit, EL(i).fit)) //( p.fit < EL(i).fit)
      {
        //EL(i) = p.CopyObj
        Dominated += i
        //return EL
      }
      else if (CompareObj(EL(i).fit, p.fit)) //( p.fit < EL(i).fit)
      {
        //EL(i) = p.CopyObj
        b_HasbeenDom = true
        //return EL
      }
    }


    if (Dominated.length > 0 )
      {
        /*if (Dominated.length == 1 )
          EL(Dominated(0)) = p.CopyObj
        else
          EL(Dominated(rand.nextInt(Dominated.length) ) ) = p.CopyObj
          */

        for (i<- Dominated.length-1  to 0 by -1  )
        {
          EL.remove(Dominated(i))
        }
        EL += p.CopyObj
        Improvement = true
      }
    else
      {
        if ( EL.length < max_EL & b_HasbeenDom  == false)
          {
            EL  += p.CopyObj
            Improvement = true
          }
        /*else if (b_HasbeenDom  == false)
          {
            max_EL = max_EL +1
            EL  += p.CopyObj
            EL(rand.nextInt(EL.length) ) = p.CopyObj
          }*/

      }

    return EL
  }

  def Add2ELold(EL: ListBuffer[MOPSONoKM], p: MOPSONoKM): ListBuffer[MOPSONoKM] =
  {

    //val rand = new scala.util.Random()
    var b_exist: Boolean = false
    if ( EL.length == 0)
    {
      EL  += p.CopyObj
      return EL
    }

    /*if ( CompareFit(EL, p) == true )
      {
        return EL
      }*/

    /*if ( EL.length < max_EL)
    {
      EL  += p.CopyObj
      return EL
    }*/

    /*if (SPdistanceToClosestPoint(EL, p) < 0.00521)
    {
      return EL
    }*/

    var Dominated :ListBuffer[Integer] = new ListBuffer[Integer]
    //val maxTemp = EL.length
    //b_isDominated = true
    var b_HasbeenDom : Boolean = false

    for (i <- 0 until EL.length)
    {
      if (CompareObj(p.fit, EL(i).fit)) //( p.fit < EL(i).fit)
      {
        //EL(i) = p.CopyObj
        Dominated += i
        //return EL
      }
      else if (CompareObj(EL(i).fit, p.fit)) //( p.fit < EL(i).fit)
      {
        //EL(i) = p.CopyObj
        b_HasbeenDom = true
        //return EL
      }
    }


    if (Dominated.length > 0 )
    {
      /*if (Dominated.length == 1 )
        EL(Dominated(0)) = p.CopyObj
      else
        EL(Dominated(rand.nextInt(Dominated.length) ) ) = p.CopyObj*/

      for (i<-Dominated.length -1 to 0  by -1 )
        {
          //EL(Dominated(i)) = p.CopyObj
          EL.remove(i)
        }
      EL += p.CopyObj()
    }
    else
    {
      /*if ( EL.length < max_EL)
      {
        EL  += p.CopyObj
      }*/
      if (b_HasbeenDom  == false)
        {
          max_EL = max_EL +1
          EL  += p.CopyObj
          //EL(rand.nextInt(EL.length) ) = p.CopyObj
        }

    }

    return EL
  }

  def SPdistanceToClosestPoint( EL : ListBuffer[MOPSONoKM], p : MOPSONoKM) : Double =
  {

    var Index : Int = 0
    var Min : Double = Double.MaxValue
    var Dist : Double = 0.0

    for ( i<- 0 until EL.length )
    {
      Dist = 0//EuclideanDistance(p.values, frontP(i).values)
      for ( v <- 0 until p.fit.length)
      {
        Dist = Dist + Math.abs(p.fit(v) -  EL(i).fit(v) )
      }
      if ( Dist < Min)
      {
        Min = Dist
        Index = i
      }
    }

    return Min
  }


   def Add2TLOrdered(TL: ListBuffer[MOPSONoKM], p: MOPSONoKM, max_TL: Int): ListBuffer[MOPSONoKM] ={

    var b_exist: Boolean = false

    if ( TL.length == 0 )
    {
      TL  += p.CopyObj()
      return TL
    }

    var Added : Boolean = false
    var i : Int = 0
    if (TL.length < max_TL)
    {
      TL  += p.CopyObj()
      return TL
    }
    else {
      for (i <- 0 until TL.length) {
        if (CompareObj(TL(i).fit, p.fit) ) //( p.fit > TL(i).fit)
        {
          TL(i) = p.CopyObj()
          Added = true
          return TL
        }
      }

    }

    TL
  }



  //TL, obj, max_EL
  def Add2TL(TL: ListBuffer[MOPSONoKM], p: MOPSONoKM, max_TL: Int, Index: Int): ListBuffer[MOPSONoKM] ={

    var b_exist: Boolean = false
    if ( TL.length == 0 )
    {
      TL  += p
      return TL
    }
    else
    {
      for (temp: MOPSONoKM <- TL)
      {
        //temp.p.toArray.deep
        if ( temp != null && (temp.p.toArray.deep == p.p.toArray.deep ))
        {
          b_exist = true
          return TL
        }
      }
    }


    var Added : Boolean = false
    if (TL.length < max_TL)
    {
      TL  += p
      return TL
    }
    else {
      //Index =
      TL.update(Index, p)
      return TL

    }

  }

  def RandVel(k: Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): Array[Vector] =
  {

    //val rand = new scala.util.Random()
    val result : Array[Vector] = new Array[Vector](k)
    val Vec = new Array[Double](d)

    for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec.update(j , rand.nextDouble() * ( quantileInt(j)  - minCol(j) ) )  //(maxCol(j) - minCol(j))  )
        //Vec.update(j , 0.0)
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  def RandCof( k : Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): Array[Vector] =
  {

    //val rand = new scala.util.Random()
    val result : Array[Vector] = new Array[Vector](k)
    val Vec = new Array[Double](d)

    for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec.update(j , rand.nextDouble() )
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  /**
    * Initialize a set of cluster centers using the k-means|| algorithm by Bahmani et al.
    * (Bahmani et al., Scalable K-Means++, VLDB 2012). This is a variant of k-means++ that tries
    * to find dissimilar cluster centers by starting with a random center and then doing
    * passes where more centers are chosen with probability proportional to their squared distance
    * to the current cluster set. It results in a provable approximation to an optimal clustering.
    *
    * The original paper can be found at http://theory.stanford.edu/~sergei/papers/vldb12-kmpar.pdf.
    */
  def initKMeansParallel(data: RDD[Vector]): Array[Vector] = {
    //
    // Initialize empty centers and point costs.
    var costs = data.map(_ => Double.PositiveInfinity)
    val initializationSteps = 3//20

    // Initialize the first center to a random point.

    val seed = new XORShiftRandom(scala.util.Random.nextLong()).nextInt()
    //val seed = scala.util.Random.nextLong()
    val sample = data.takeSample(false, 1, seed)
    // Could be empty if data is empty; fail with a better message early:
    require(sample.nonEmpty, s"No samples available from $data")

    val centers = ArrayBuffer[Vector]()
    var newCenters = Seq(sample.head.toDense)
    centers ++= newCenters

    // On each step, sample 2 * k points on average with probability proportional
    // to their squared distance from the centers. Note that only distances between points
    // and new centers are computed in each iteration.
    var step = 0
    val bcNewCentersList = ArrayBuffer[Broadcast[_]]()
    while (step < initializationSteps) {
      val bcNewCenters = data.context.broadcast(newCenters)
      bcNewCentersList += bcNewCenters
      val preCosts = costs
      costs = data.zip(preCosts).map { case (point, cost) =>
        math.min(findClosest(bcNewCenters.value, point)._2, cost)
      }.persist(StorageLevel.MEMORY_AND_DISK)
      val sumCosts = costs.sum()

      bcNewCenters.unpersist(blocking = false)
      preCosts.unpersist(blocking = false)

      val chosen = data.zip(costs).mapPartitionsWithIndex { (index, pointCosts) =>
        //**********To Be Returned
        val rand = new XORShiftRandom(seed ^ (step << 16) ^ index)
        //val rand = scala.util.Random
        pointCosts.filter { case (_, c) => rand.nextDouble() < 2.0 * c * globalK / sumCosts }.map(_._1)
      }.collect()
      newCenters = chosen.map(_.toDense)
      centers ++= newCenters
      step += 1
    }

    costs.unpersist(blocking = false)
    //bcNewCentersList.foreach(_.destroy(false))
    bcNewCentersList.foreach(_.destroy())

    //println("Centers Type:" + centers.getClass)
    //println("Centers Elements:" + centers)
    /*for (i<- 1 to centers.length) {
      println("i:" + i)
      println("Type: " + centers(i).getClass + ":" + centers(i))
    }*/

    val distinctCenters = centers.distinct //centers.map(_).distinct
    //.map(parseDVector(_)) //new Vector(_))

    //println("distinct Type: " + distinctCenters.getClass())
    //println("distinct Elements: " + distinctCenters)

    //distinctCenters.map (x=> println("Elemnt Type:" + x.getClass + " Value: " + x)

    if (distinctCenters.size <= globalK) {
      distinctCenters.toArray
    } else {
      // Finally, we might have a set of more than k distinct candidate centers; weight each
      // candidate by the number of points in the dataset mapping to it and run a local k-means++
      // on the weighted centers to pick k of them
      val bcCenters = data.context.broadcast(distinctCenters)
      val countMap = data.map(findClosest(bcCenters.value, _)._1).countByValue()

      //bcCenters.destroy(blocking = false)
      bcCenters.destroy()

      val myWeights = distinctCenters.indices.map(countMap.getOrElse(_, 0L).toDouble).toArray
      kMeansPlusPlus(0, distinctCenters.toArray, myWeights, globalK, 30)
    }
  }

  def parseDVector(p :Vector) : Array[Double] ={
    p.toArray
  }

  /**
    * Run K-means++ on the weighted point set `points`. This first does the K-means++
    * initialization procedure and then rounds of Lloyd's algorithm.
    */
  def kMeansPlusPlus(
                      seed: Int,
                      points: Array[Vector],
                      weights: Array[Double],
                      k: Int,
                      MaxIt: Int
                    ): Array[Vector] = {
    val rand = new Random(seed)
    val dimensions = points(0).size
    val centers = new Array[Vector](k)

    // Initialize centers by sampling using the k-means++ procedure.
    centers(0) = pickWeighted(rand, points, weights).toDense
    val costArray = points.map(ObjFun(_, centers(0)))

    for (i <- 1 until k) {
      val sum = costArray.zip(weights).map(p => p._1 * p._2).sum
      val r = rand.nextDouble() * sum
      var cumulativeScore = 0.0
      var j = 0
      while (j < points.length && cumulativeScore < r) {
        cumulativeScore += weights(j) * costArray(j)
        j += 1
      }
      if (j == 0) {
        println("kMeansPlusPlus initialization ran out of distinct points for centers." +
          s" Using duplicate point for center k = $i.")
        centers(i) = points(0).toDense
      } else {
        centers(i) = points(j - 1).toDense
      }

      // update costArray
      for (p <- points.indices) {
        costArray(p) = math.min(ObjFun(points(p), centers(i)), costArray(p))
      }

    }

    // Run up to MaxIt iterations of Lloyd's algorithm
    val oldClosest = Array.fill(points.length)(-1)
    var iteration = 0
    var moved = true
    while (moved && iteration < MaxIt) {
      moved = false
      val counts = Array.fill(k)(0.0)
      val sums = Array.fill(k)(Vectors.zeros(dimensions))
      var i = 0
      while (i < points.length) {
        val p = points(i)
        val index = findClosest(centers, p)._1
        // axpy a*x + y
        axpy(weights(i), p, sums(index))
        counts(index) += weights(i)
        if (index != oldClosest(i)) {
          moved = true
          oldClosest(i) = index
        }
        i += 1
      }
      // Update centers
      var j = 0
      while (j < k) {
        if (counts(j) == 0.0) {
          // Assign center to a random point
          centers(j) = points(rand.nextInt(points.length)).toDense
        } else {
          scal(1.0 / counts(j), sums(j))
          centers(j) = Vectors.dense(sums(j).toArray)//new Vector(sums(j))
        }
        j += 1
      }
      iteration += 1
    }

    if (iteration == MaxIt) {
      println(s"Local KMeans++ reached the max number of iterations: $MaxIt.")
    } else {
      println(s"Local KMeans++ converged in $iteration iterations.")
    }

    centers
  }

  private def pickWeighted[T](rand: Random, data: Array[T], weights: Array[Double]): T = {
    val r = rand.nextDouble() * weights.sum
    var i = 0
    var curWeight = 0.0
    while (i < data.length && curWeight < r) {
      curWeight += weights(i)
      i += 1
    }
    data(i - 1)
  }

}

case class MOPSONoKM(kout: Int, nvar: Int ) {
  //var k : Int=  0
  val k :Int = kout
  var p : ListBuffer[Double] = new ListBuffer[Double]        //= new Array[Vector](k)
  var v :ListBuffer[Double] = new ListBuffer[Double]
  var fit : ListBuffer[Double]  = new ListBuffer[Double]
  var bp :ListBuffer[Double] =  new ListBuffer[Double]
  var bv :ListBuffer[Double] = new ListBuffer[Double]      //: Array[Vector]
  var bfit : ListBuffer[Double]  = new ListBuffer[Double]
  var Nobj : Int = nvar

  def CopyObj(): MOPSONoKM =
  {
    val obj = new MOPSONoKM(this.k, this.Nobj)
    obj.p = this.p        //= new Array[Vector](k)
    obj.v = this.v
    obj.fit = this.fit
    obj.bp = this.bp
    obj.bv  = this.bv      //: Array[Vector]
    obj.bfit  = this.bfit
    obj.Nobj= this.Nobj
    return obj
  }

}

class MOFMEvalNoKM(kout: Int) {
  //var k : Int=  0
  val k :Int = kout
  var Points :ListBuffer[Row]= new ListBuffer[Row]
  var CountCluster = new Array[Int](k)        //= new Array[Vector](k)
  var RepClass : Int  = -1
  var CountClusterSorted = mutable.ListMap[Int, Int]()
  var MapCount = scala.collection.mutable.Map[Int, Int]()

}


  //override def  (obj: PSO) = {

  //}
  /*var v :Array[Vector] //= new Array[Vector](k)        //: Array[Vector]
  var fit : Double  = 0
  var bp :Array[Vector] //=  new Array[Vector](k)      //: Array[Vector]
  var bv :Array[Vector] //= new Array[Vector](k)      //: Array[Vector]
  var bfit : Double  = 0*/


  //var p : Array[Vector]
  /*def SetP(Pout:Array[Vector]) ={
    p=Pout
  }*/

  // Getter
  //def k = _k
  // Setter
  /*def getP: Array[Vector] = p
  def setP(pout:  Array[Vector]): this.type = {
    this.p = pout
    this
  }*/

  /*def bp_=(x$1: Array[Vector]): Unit = ???
  def bv_=(x$1: Array[Vector]): Unit = ???

  def getK: Int = k
  def setK(kout: Int): this.type = {
    this.k = kout
    this
  }

  def getP: Array[Vector] = p
  def setP(pout: Array[Vector]): this.type = {
    this.p = pout
    this
  }

  def getVel: Array[Vector] = v
  def setVel(vout: Array[Vector]): this.type = {
    this.v = vout
    this
  }

  def getFit: Double = fit
  def setFit(fitout: Double): this.type = {
    this.fit = fitout
    this
  }

  def getBestP: Array[Vector] = bp
  def setBestP(bpout: Array[Vector]): this.type = {
    this.bp = bpout
    this
  }

  def getBestV: Array[Vector] = bv
  def setBestV(bvout: Array[Vector]): this.type = {
    this.bv = bvout
    this
  }

  def getBFit: Double = bfit
  def setBFit(bfitout: Double): this.type = {
    this.bfit = bfitout
    this
  }*/



