
import java.io.{BufferedWriter, File, FileWriter}

//import scala.math.BigDecimal
import java.util


import org.apache.spark.sql.{DataFrame, SparkSession}
import org.apache.spark._
import org.apache.spark.util.Utils

import scala.collection.JavaConverters._
import java.util.Random

import breeze.linalg.squaredDistance.Impl2
import breeze.linalg.{DenseVector, ZippedValues, min, squaredDistance, zipValues}
import org.apache.spark.broadcast.Broadcast

import scala.math.exp
import scala.collection.mutable.{ArrayBuffer, HashMap, HashSet, ListBuffer}

import org.apache.spark.rdd._
import org.apache.spark.mllib.linalg.{DenseVector, SparseVector, Vector, Vectors}
import org.apache.spark.ml.linalg.SparseVector
import BLAS._
//import PSOTS.UpdateFun
//import PSOTSKM.{AvgList, MaxList, MinList, StdList}
import WhaleFun.{dim, lb, ub}
import com.google.gson.annotations.Until
import org.apache.spark.sql.types.{DoubleType, IntegerType}

import scala.collection.mutable
//import PSOTSKM.findClosest
//import PSOTSKM.AdjustMaxandMin
import org.apache.spark.storage.StorageLevel
import XORShiftRandom._
import org.apache.spark.mllib.linalg
import org.apache.spark.sql.Row
import org.apache.spark.sql.types.{StructType,StructField,StringType}
import scala.util.control.Breaks._
import org.apache.spark.sql.functions._
import scala.util.control.Exception._

//import breeze.linalg._

import org.apache.spark.sql.{Column, DataFrame, Dataset}
import org.apache.spark.sql.functions.{avg, col, udf}

//import org.apache.spark.ml.clustering.KMeans
//import org.apache.spark.ml.evaluation.ClusteringEvaluator

import org.apache.spark.mllib.clustering.{KMeans, KMeansModel}
import SilhouetteCoefficient._



object MOWOATSKM {

  var DatasetName: String = ""
  var globalK: Int = 0
  var PHar: Double = 2.5
  //var m_quantile : Double = 0.0
  var quantileInt = new ListBuffer[Double]()
  var quantileDiv = new ListBuffer[Double]()
  var MinElFit : Double  = 0.0
  var WorestFit : ListBuffer[Double] = new ListBuffer[Double] // Double.MinValue
  var UpdateFun : String = "Whale"//"Whale"//"PSO"
  var ObjFunGlobal : String = "kmeans"//"Whale"//"PSO"
  var MinObj : Boolean = false
  var nObj : Int = 3
  var Improvement : Boolean =false
  var rand : scala.util.Random = new scala.util.Random()
  var max_EL : Int = 100
  var EL: ListBuffer[MOPSO] = new ListBuffer[MOPSO]

  var NonDom: ListBuffer[MOPSO] = new ListBuffer[MOPSO]
  var TL: ListBuffer[MOPSO] = new ListBuffer[MOPSO] //(max_TL)    // Tabu List
  var max_TL : Integer = 50
  val RunNum : Int = 6
  //var rand : scala.util.Random = new scala.util.Random() //System.currentTimeMillis
  var obj_BioValidIndice : BioValidIndice = new BioValidIndice()
  val ResultPath = "/home/amr/Downloads/resultMicroarray.txt"




  def WriteToFile(str: ListBuffer[String]):Unit=
  {
    //x.

    //val ResultPath = "/home/amr/Downloads/resultMicroarray.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      str.foreach(x => bw.write(x))
    }
    finally bw.close()

  }

  def WriteToFile(str: String, Sep : Boolean = false):Unit=
  {
    //val ResultPath = "/home/amr/Downloads/resultMicroarray.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      if (Sep == true)
      {bw.newLine()}
      bw.write(str)
    }
    finally bw.close()

  }

  def WriteToFileCenters(str: String, Sep : Boolean = false):Unit=
  {
    val ResultPath = "/home/amr/Downloads/Centers.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try
    {
      if (Sep == true)
        {bw.newLine()}
      bw.write(str)
    }
    finally bw.close()

  }

  def Stats(x: ListBuffer[Double]) : (Double, Double, Double, Double) = {
    return(MinList(x), MaxList(x), StdList(x), AvgList(x))
  }

  def MaxList(x: ListBuffer[Double]) : Double =
  {
    var max : Double = Double.MinValue
    for (i<-0 until x.length)
    {
      if ( x(i) > max )
      {
        max = x(i)
      }
    }
    return max
  }


  def MinList(x: ListBuffer[Double]) : Double =
  {
    var min : Double = Double.MaxValue
    for (i<-0 until x.length)
    {
      if ( x(i) < min )
      {
        min = x(i)
      }
    }
    return min
  }

  def AvgList(x: ListBuffer[Double]) : Double ={
    var Tot : Double = 0.0

    for (i<-0 until x.length)
    {
      Tot = Tot +  x(i)
    }
    return ( Tot / x.length.asInstanceOf[Double] )
  }



  def StdList(x: ListBuffer[Double]) : Double ={
    var Avg : Double = AvgList(x)
    var Std : Double = 0.0
    var Tot : Double = 0.0

    for (i <- 0 until x.length)
    {
      Tot = Tot + math.pow(x(i) - Avg , 2)
    }


    return ( math.sqrt(Tot / x.length.asInstanceOf[Double])  )
  }

  def GenerateClusters(dataframe: DataFrame, centers: Array[Vector], exception : ListBuffer[String]  )
  :Unit =
  {
    var Eval: ListBuffer[FMEval] = new ListBuffer[FMEval]
    //var Eval: Array[FMEval] = new Array[FMEval](globalK)
    for (i<- 0 until globalK)
    {
      Eval += new FMEval(globalK)
      for (j<- 0 until globalK)
      {
        Eval(i).CountCluster(j)= 0
      }
    }

    var rIndex = -1
    //collect().foreach
    var bIndex : Int = 0
    var dist : Double = 0.0
    var MinDist : Double = 0.0

    dataframe.collect().foreach { r =>

      MinDist = obj_BioValidIndice.SpearmanCorRow(centers(0), r, exception)._1
      bIndex = 0
      for (j <- 1 until centers.length )
        {
          dist = obj_BioValidIndice.SpearmanCorRow(centers(j), r, exception)._1
          if (dist < MinDist )
            {
              MinDist = dist
              bIndex = j
            }
        }

      Eval(bIndex).Points += r

    }

    var str: String = ""

    for ( i <- 0 until globalK)
      {

        WriteToFile("Center"+ (i+1).toString ,true)
        str = ""
        for (j <- 0 until centers(i).toArray.length)
          {
            str += centers(i).toArray(j).toString +  ","
          }
        str = str.substring(0,str.length-1)
        WriteToFile(str,true)

        for (p <- 0 until Eval(i).Points.length)
          {
            str = ""
            for (l <- 0 until Eval(i).Points(p).size )
              {
                str += Eval(i).Points(p).toSeq(l).toString +  ","
              }
            str = str.substring(0,str.length-1)
            WriteToFile(str,true)
          }
      }
  }


  def RunCluster(Num: Int, spark :  SparkSession): Unit = {

    val sc = spark.sparkContext
    //import spark.implicits._

    val sqlContext = new org.apache.spark.sql.SQLContext(sc)
    import sqlContext.implicits._
    val  schema_string = "name,id,age"
    val schema_rdd = StructType(schema_string.split(",")
          .map(fieldName => StructField(fieldName, StringType, true)) )
    var datafrm = sqlContext.createDataFrame(sc.emptyRDD[Row], schema_rdd)


    //datafrm.createTempView("Empty")
    //val res = sqlContext.sql("select count(*) from Empty")

    //val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test").getOrCreate()
    //val sc = spark.sparkContext
    //import spark.implicits._

    //val sqlContext = new org.apache.spark.sql.SQLContext(sc)
    /////Load Gene Ontology
    //import spark.implicits._
    /*val  schema_str = "id,go_id,Term,Ontology,relationship,parent"
    val schema = StructType(schema_str.split(",")
      .map(fieldName => StructField(fieldName, StringType, true)) )
    val squidString = sc.textFile("hdfs://master:9000/amr/gotbl.txt") //textFile("/home/amr/Downloads/gotbl.txt")
    val rowRDD = squidString.map(_.split(";")).map(x => Row(x(0), x(1), x(2), x(3), x(4), x(5) ))
    val GOFrame = sqlContext.createDataFrame(rowRDD, schema)*/

    var Krange = Seq(1,3)
    var exception = new ListBuffer[String]


    if (Num == 1)
    {
      WriteToFile(""  , true)
      WriteToFile("Arabidopsis Thaliana: "  , true)

      //Arabidopsis.csv
      DatasetName = "Arabidopsis.csv"
      val customSchema = StructType(Array(
        StructField("gid", StringType, true),
        StructField("min15", DoubleType, true),
        StructField("min30", DoubleType, true),
        StructField("min60", DoubleType, true),
        StructField("min90", DoubleType, true),
        StructField("hr3", DoubleType, true),
        StructField("hr6", DoubleType, true),
        StructField("hr9", DoubleType, true),
        StructField("hr24", DoubleType, true)))

      datafrm = spark.read.
        //schema(customSchema).option("header", true).
        option("inferSchema", true).option("header", true).
      csv("hdfs://master:9000/amr/Arabidopsis.csv").
      toDF("gid", "min15", "min30", "min60", "min90", "hr3", "hr6", "hr9", "hr24")

      //automatically infer the schema
      //datafrm = spark.read.
        //option("inferSchema", true).option("header", true).
        //csv("hdfs://master:9000/amr/iris2.data").
        //toDF("pl", "pw", "sw", "sl", "class")

      exception+= "gid"

      Krange = Seq(4,5,6)
      //Krange = Seq(3)
    }
    else if (Num == 2)
    {
      WriteToFile(""  , true)
      WriteToFile("Human : "  , true)
      DatasetName = "Human"

      datafrm = spark.read.
        option("inferSchema", true).option("header", true).
        csv("hdfs://master:9000/amr/Human.csv").
        toDF("Genes", "0HR", "15MIN", "30MIN", "1HR", "2HR", "4HR", "6HR", "8HR", "12HR",
             "16HR", "20HR", "24HR", "UNSYN")

      //automatically infer the schema
      //datafrm = spark.read.
      //option("inferSchema", true).option("header", true).
      //csv("hdfs://master:9000/amr/iris2.data").
      //toDF("pl", "pw", "sw", "sl", "class")

      exception+= "Genes"

      Krange = Seq(4,5,6)
      //Krange = Seq(3)
    }
    else if (Num == 3)
    {
      WriteToFile(""  , true)
      WriteToFile("Rat CNS : "  , true)
      DatasetName = "Rat CNS"
      //Genes,DE11,E13,E15,E18,E21,P0,P7,P14,A
      datafrm = spark.read.
        option("inferSchema", true).option("header", true).
        csv("hdfs://master:9000/amr/Rat.csv").
        toDF("Genes", "DE11", "E13", "E15", "E18", "E21", "P0", "P7", "P14", "A")

      exception+= "Genes"

      Krange = Seq(4,5,6)

    }
    else if (Num == 4)
    {
      WriteToFile(""  , true)
      WriteToFile("Yeast CC: "  , true)
      DatasetName = "Yeast CC"
      //ORF,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17
      datafrm = spark.read.
        option("inferSchema", true).option("header", true).
        csv("hdfs://master:9000/amr/YeastCC.csv").
        toDF("ORF", "1", "2", "3", "4", "5", "6", "7", "8", "9",
          "10", "11", "12", "13", "14", "15", "16", "17")

      exception+= "ORF"

      Krange = Seq(4,5,6)

    }
    else if (Num == 5)
    {
      WriteToFile(""  , true)
      WriteToFile("Yeast Sp: "  , true)
      DatasetName = "Yeast Sp"
      //Genes,t0,t0.5,t2,t5,t7,t9,t11.5
      datafrm = spark.read.
        option("inferSchema", true).option("header", true).
        csv("hdfs://master:9000/amr/YeastSp.csv").
        toDF("Genes", "t0", "t05", "t2", "t5", "t7", "t9", "t115")

      exception+= "Genes"

      Krange = Seq(4,5,6)

    }


    datafrm.cache()

    //"pl", "pw", "sw", "sl", "class"
    val d = datafrm.columns.size //- exception.length
    val n = datafrm.count()
    //println("n:" + n + "d:" + d)
    var max_ColRow = datafrm.agg(sql.functions.max(datafrm.schema.fieldNames(0)).cast("double"),
      sql.functions.max(datafrm.schema.fieldNames(1)).cast("double"))

    if (Num == 1)
    {
      //Arabidopsis Thaliana PreProcessed
      //"gid", "min15", "min30", "min60", "min90", "hr3", "hr6", "hr9", "hr24"
      max_ColRow = datafrm.agg(sql.functions.max("min15").cast("double"),
        sql.functions.max("min30").cast("double"), sql.functions.max("min60").cast("double"),
        sql.functions.max("min90").cast("double"), sql.functions.max("hr3").cast("double"),
        sql.functions.max("hr6").cast("double"), sql.functions.max("hr9").cast("double"),
        sql.functions.max("hr24").cast("double"))
    }
    else if (Num == 2)
    {
      //Human
      //Genes,0HR,15MIN,30MIN,1HR,2HR,4HR,6HR,8HR,12HR,16HR,20HR,24HR,UNSYN
      max_ColRow = datafrm.agg(sql.functions.max("0HR").cast("double"),
        sql.functions.max("15MIN").cast("double"), sql.functions.max("30MIN").cast("double"),
        sql.functions.max("1HR").cast("double"), sql.functions.max("2HR").cast("double"),
        sql.functions.max("4HR").cast("double"), sql.functions.max("6HR").cast("double"),
        sql.functions.max("8HR").cast("double"), sql.functions.max("12HR").cast("double"),
        sql.functions.max("16HR").cast("double"), sql.functions.max("20HR").cast("double"),
        sql.functions.max("24HR").cast("double"), sql.functions.max("UNSYN").cast("double")
      )
    }
    else if (Num == 3)
    {
      //Rat
      //Genes,DE11,E13,E15,E18,E21,P0,P7,P14,A
      max_ColRow = datafrm.agg(sql.functions.max("DE11").cast("double"),
        sql.functions.max("E13").cast("double"), sql.functions.max("E15").cast("double"),
        sql.functions.max("E18").cast("double"), sql.functions.max("E21").cast("double"),
        sql.functions.max("P0").cast("double"), sql.functions.max("P7").cast("double"),
        sql.functions.max("P14").cast("double"), sql.functions.max("A").cast("double")
      )
    }
    else if (Num == 4)
    {
      //YeastCC
      ////ORF,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17
      max_ColRow = datafrm.agg(sql.functions.max("1").cast("double"),
        sql.functions.max("2").cast("double"), sql.functions.max("3").cast("double"),
        sql.functions.max("4").cast("double"), sql.functions.max("5").cast("double"),
        sql.functions.max("6").cast("double"), sql.functions.max("7").cast("double"),
        sql.functions.max("8").cast("double"), sql.functions.max("9").cast("double"),
        sql.functions.max("10").cast("double"), sql.functions.max("11").cast("double"),
        sql.functions.max("12").cast("double"), sql.functions.max("13").cast("double"),
        sql.functions.max("14").cast("double"), sql.functions.max("15").cast("double"),
        sql.functions.max("16").cast("double"), sql.functions.max("17").cast("double")
      )
    }
    else if (Num == 5)
    {
      //YeastSP
      ////Genes,t0,t0.5,t2,t5,t7,t9,t11.5
      max_ColRow = datafrm.agg(sql.functions.max("t0").cast("double"),
        sql.functions.max("t05").cast("double"), sql.functions.max("t2").cast("double"),
        sql.functions.max("t5").cast("double"), sql.functions.max("t7").cast("double"),
        sql.functions.max("t9").cast("double"), sql.functions.max("t115").cast("double")
      )
    }



    var maxCol = new ListBuffer[Double]()
    for (i <- 0 until max_ColRow.head().size )
    {
      if (exception.contains(max_ColRow.schema.fields(i).name) == false)
        {
          maxCol += max_ColRow.head().get(i).asInstanceOf[Double]
        }
    }

    //println("maxCol:" + maxCol)

    var min_ColRow = datafrm.agg(sql.functions.min(datafrm.schema.fieldNames(0)).cast("double"),
      sql.functions.min(datafrm.schema.fieldNames(1)).cast("double"))

    if (Num == 1) {
      //Arabidopsis Thaliana PreProcessed
      //"gid", "min15", "min30", "min60", "min90", "hr3", "hr6", "hr9", "hr24"
      min_ColRow = datafrm.agg(sql.functions.min("min15").cast("double"),
        sql.functions.min("min30").cast("double"), sql.functions.min("min60").cast("double"),
        sql.functions.min("min90").cast("double"), sql.functions.min("hr3").cast("double"),
        sql.functions.min("hr6").cast("double"), sql.functions.min("hr9").cast("double"),
        sql.functions.min("hr24").cast("double"))
    }
    else if (Num == 2) {
      //Genes,0HR,15MIN,30MIN,1HR,2HR,4HR,6HR,8HR,12HR,16HR,20HR,24HR,UNSYN
      min_ColRow = datafrm.agg(sql.functions.min("0HR").cast("double"),
        sql.functions.min("15MIN").cast("double"), sql.functions.min("30MIN").cast("double"),
        sql.functions.min("1HR").cast("double"), sql.functions.min("2HR").cast("double"),
        sql.functions.min("4HR").cast("double"), sql.functions.min("6HR").cast("double"),
        sql.functions.min("8HR").cast("double"), sql.functions.min("12HR").cast("double"),
        sql.functions.min("16HR").cast("double"), sql.functions.min("20HR").cast("double"),
        sql.functions.min("24HR").cast("double"), sql.functions.min("UNSYN").cast("double")
      )
    }
    else if (Num == 3) {
      //Rat
      //Genes,DE11,E13,E15,E18,E21,P0,P7,P14,A
      min_ColRow = datafrm.agg(sql.functions.min("DE11").cast("double"),
        sql.functions.min("E13").cast("double"), sql.functions.min("E15").cast("double"),
        sql.functions.min("E18").cast("double"), sql.functions.min("E21").cast("double"),
        sql.functions.min("P0").cast("double"), sql.functions.min("P7").cast("double"),
        sql.functions.min("P14").cast("double"), sql.functions.min("A").cast("double")
      )
    }
    else if (Num == 4) {
      //YeastCC
      ////ORF,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17
      min_ColRow = datafrm.agg(sql.functions.min("1").cast("double"),
        sql.functions.min("2").cast("double"), sql.functions.min("3").cast("double"),
        sql.functions.min("4").cast("double"), sql.functions.min("5").cast("double"),
        sql.functions.min("6").cast("double"), sql.functions.min("7").cast("double"),
        sql.functions.min("8").cast("double"), sql.functions.min("9").cast("double"),
        sql.functions.min("10").cast("double"), sql.functions.min("11").cast("double"),
        sql.functions.min("12").cast("double"), sql.functions.min("13").cast("double"),
        sql.functions.min("14").cast("double"), sql.functions.min("15").cast("double"),
        sql.functions.min("16").cast("double"), sql.functions.min("17").cast("double")
      )
    }
    else if (Num == 5) {
      //YeastSP
      ////Genes,t0,t0.5,t2,t5,t7,t9,t11.5
      min_ColRow = datafrm.agg(sql.functions.min("t0").cast("double"),
        sql.functions.min("t05").cast("double"), sql.functions.min("t2").cast("double"),
        sql.functions.min("t5").cast("double"), sql.functions.min("t7").cast("double"),
        sql.functions.min("t9").cast("double"), sql.functions.min("t115").cast("double")
      )
    }


    var minCol = new ListBuffer[Double]()
    for (i <- 0 until min_ColRow.head().size ) {
      if (exception.contains(min_ColRow.schema.fields(i).name) == false)
      {
        minCol += min_ColRow.head().get(i).asInstanceOf[Double]
      }
    }
    //println("minCol:" + minCol)

    quantileInt.clear()
    quantileDiv.clear()

    for (i <- 0 until minCol.length)
    {
      //if ( exception.contains(datafrm.schema.fields(i).name) == false )
      //{
        //quantileInt += datafrm.stat.approxQuantile(datafrm.columns(i),
          //Array[Double](0, 0.1), 0)(1)

        quantileInt += ( minCol(i) +  ( (maxCol(i) - minCol(i)) / 3 ) )

        //quantileDiv += datafrm.stat.approxQuantile(datafrm.columns(i),
          //Array[Double](0, 0.3), 0)(1)

        quantileDiv  +=  ( minCol(i) +  ( ( maxCol(i) - minCol(i) ) / 2) )

      //}
    }


    var VelMax = new ListBuffer[Double]()
    for (i <- 0 until maxCol.length) {
      VelMax += ((maxCol(i) - minCol(i)) / 3 )// 3
      //VelMax += quantileInt(i)
    }
    //println("VelMax: " + VelMax)

    var VelMin = new ListBuffer[Double]()
    for (i <- 0 until maxCol.length) {
      VelMin += (-1 * VelMax(i))
    }
    //println("VelMin: " + VelMin)



    val lines = datafrm.rdd
    val data = lines.map(Row2Vector( _, exception)).cache()


    //datafrm.unpersist()

    var Finished: ListBuffer[String] = new ListBuffer[String]
    var TempStr : String = ""
    var Result: Double = 0
    val RunNumber: Int = 0
    var TotalTime: Double = 0
    var TimeinLoop_Start: Double = 0
    var TimeinLoop_End: Double = 0
    var ClusterTime: Double = 0
    var Ent : Double = 0.0
    var Pur: Double = 0.0
    val max_Runs : Int = 5
    var EntList: ListBuffer[Double] = new ListBuffer[Double]()
    var PurList: ListBuffer[Double] = new ListBuffer[Double]()
    var FvalList: ListBuffer[Double] = new ListBuffer[Double]()

    var BestFit: ListBuffer[Double] = new ListBuffer[Double]
    var FVal: Double = 0
    var FValTotal: Double = 0
    var MinEnt, MaxEnt, StdEnt, AvgEnt : Double = 0.0
    var MinPur, MaxPur, StdPur, AvgPur : Double = 0.0
    var MinFval, MaxFval, StdFval, AvgFval : Double = 0.0

    var silIndex : Int = 0
    var silIndexBest : Double = 0
    var sil : Double = 0.0

    //for (RunNumber <- 0 until max_Runs  ) {

    for (kloop <- 0 until  Krange.length  by 1)
    {

      globalK = Krange(kloop)
      WriteToFile("K=" + globalK, true)
      var BestCenters: Array[Vector] = new Array[Vector](globalK)
      Result = 0
      FValTotal = 0
      val iterationStartTime = System.nanoTime()
      for (i <- 0 to max_Runs-1)
      {


        TimeinLoop_Start = System.nanoTime()

        val x = ClusterAlgo(data, Krange(kloop), VelMin, VelMax, minCol, maxCol, d - exception.length)
        BestFit = x._1
        BestCenters = x._2

        TempStr = ""
        //silIndexBest = Double.MaxValue
        SilhouetteCoefficient.k = globalK
        silIndexBest = SilhouetteCoefficient.SilSeqCoeff(datafrm, Num , EL(0).p, exception )
        for ( j <- 1 until EL.length)
          {
            sil = SilhouetteCoefficient.SilSeqCoeff(datafrm, Num , EL(j).p, exception )
            if ( sil  > silIndexBest )
              {
                silIndexBest = sil
                silIndex = j
              }
          }

        TimeinLoop_End = (System.nanoTime() - TimeinLoop_Start) / 1e9 / 60
        WriteToFile("Dataset Name :  " + DatasetName,true)
        WriteToFile("K :  " + globalK.toString,true)
        WriteToFile("Time:  " + TimeinLoop_End.toString,true)
        WriteToFile("Silhouette :  " + silIndexBest.toString,true)
        GenerateClusters(datafrm, EL(silIndex).p, exception)

        //Result = Result + BestFit


      }

      //(MinEnt, MaxEnt, StdEnt, AvgEnt) = Stats(EntList)
      //val EntTup = Stats(EntList)
      //(MinPur, MaxPur, StdPur, AvgPur) = Stats(PurList)
      //val PurTup = Stats(PurList)
      //(MinFval, MaxFval, StdFval, AvgFval) = Stats(FvalList)
      //val FvalTup = Stats(FvalList)


      /*TempStr = ("\n K = " + Krange(kloop) + "\n" +
        " F-Measure (Avg, Std, Max): " + FvalTup._4 +","+ FvalTup._3 +"," + FvalTup._2 + "\n" +
        " Entropy (Avg, Std, Min): " + EntTup._4 +","+ EntTup._3 +"," + EntTup._1 + "\n" +
        " Purity (Avg, Std, Max): " + PurTup._4 +","+ PurTup._3 +"," + PurTup._2 + "\n")

      WriteToFile(TempStr, true)*/


    }

    datafrm.unpersist()
    data.unpersist()

  }

  def InitKCenters(data: Array[Vector]) : Array[Vector] =
  {

    var Centers: Array[Vector] = new Array[Vector](globalK)
    var CSize : Array[Int] = new Array[Int](globalK)
    val n = data.length
    val d = data(0).toArray.length
    var Class : Array[Int] = new Array[Int](n)
    var temp : Int = 0


    for ( i <-  0 until globalK)
    {
      CSize(i) = 0
      Centers(i) = Vectors.zeros(d)
    }

    for (i <- 0 until n  )
    {
      Class(i) = rand.nextInt(globalK)
    }

    for (i <- 0 until n )
    {
      temp = Class(i).asInstanceOf[Int]
      for ( j <- 0 until d )
      {
        Centers(temp).toArray(j) +=  data(i).toArray(j)//0.0
      }
      CSize(temp) += 1
    }

    for (i <- 0 until globalK )
    {
      for ( j <- 0 until d )
      {
        Centers(i).toArray(j) = Centers(i).toArray(j) / CSize(i).asInstanceOf[Double]
      }
    }

    return Centers

  }

  def ClusterAlgo(data :  RDD[Vector] = null, k: Int, VelMin: ListBuffer[Double], VelMax: ListBuffer[Double],
                  minCol: ListBuffer[Double], maxCol:ListBuffer[Double], d : Int)
  : (ListBuffer[Double],Array[Vector]) =
  {


    //WorestFit = Double.MinValue
    var RetBestFit: ListBuffer[Double] = new ListBuffer[Double] //Double.NegativeInfinity

    EL.clear() //= new ListBuffer[MOPSONoKM]
    TL.clear()
    MinObj = true

    var n: Long = data.count()
    var epsilon: Double = 1e-4
    val Np = 30 //Number of particles
    val max_TL = 11
    val max_EL = 50
    var Index_TL = 0
    var EL_V: Array[Vector] = new Array[Vector](max_EL) // Best Velocities
    val MaxIt = 300

    var Population: ListBuffer[MOPSO] = new ListBuffer[MOPSO]
    //(Np)
    var LocalPopulation: ListBuffer[MOPSO] = new ListBuffer[MOPSO]
    var BestCenters: Array[Vector] = new Array[Vector](k)
    var str_Fit: String = ""
    //globalK = k
    //data.cache()

    var b_IorD: String = "0"
    val c1 = 0.5
    //.1  // Internal experience
    val c2 = 1.5
    val w_max = 0.5
    val w_min = -0.5
    //.1
    //val l=1
    var half: Double = 0
    var w: Double = 0
    //val rand = new scala.util.Random()
    var centers: Array[Vector] = new Array[Vector](k)
    var newCenters: Array[Vector] = new Array[Vector](k)
    var cost: ListBuffer[Double] = new ListBuffer[Double] // 0.0
    var Tup: Tuple2[Array[Vector], ListBuffer[Double]] = (newCenters, ListBuffer(-1,-1, -1))
    var obj = new MOPSO(k, nObj)

    //println("VelMin: " + VelMin)
    for (i <- 0 until Np)
    {

      /*val clusters = KMeans.train(data, globalK, 1, KMeans.RANDOM)
      val Vec = new Array[Double](clusters.clusterCenters.head.size)

      for (row<- 0 to clusters.clusterCenters.length-1)
        {
          for (col<- 0 to clusters.clusterCenters(row).size-1)
            {
              Vec.update(col, clusters.clusterCenters(row).toArray(col) )
            }
          centers.update(row,  Vectors.dense(Vec).copy)
        }*/

      /*val kmeans = new KMeans().setK(globalK).setSeed(1L)
      val model = kmeans.fit(data)
      // Make predictions
      val predictions = model.transform(data)
      // Evaluate clustering by computing Silhouette score
      val evaluator = new ClusteringEvaluator()
      val silhouette = evaluator.evaluate(predictions)
      evaluator.predictionCol("")
      println(s"Silhouette with squared euclidean distance = $silhouette")*/

      //centers = initKMeansParallel(data).clone()
      //centers = AdjustMaxandMin(centers, minCol, maxCol).clone()
      centers = InitKCenters(data.collect()).clone()
      obj = new MOPSO(k, nObj)

      //if (ObjFunGlobal == "kmeans") {
        //Tup = RecCenters(data, data.sparkContext, centers)
        //Tup =RecCentersNew(data, data.sparkContext, centers)
      Tup = obj_BioValidIndice.MultDisFun(data, data.sparkContext, centers)
      cost = Tup._2
      //newCenters = Tup._1.clone()
      obj.p = centers.clone()
      //}

      /*9WangSim(centers, data)
      ClustSep(centers, false, ""  )
      OverAllClustRDD(data, sc:SparkContext, centers, false,""  )
      XieBeniRDD(data, sc:SparkContext, centers, false, ""]  ):Double*/



      //newCenters = centers.clone()
      obj.fit = cost
      //obj.bp = obj.p.clone()
      obj.Nobj = cost.length


      EL = Add2EL(EL, obj, max_EL)
      //println("iiiii = " + i)
      Population += obj.CopyObj()
    }


    var PrevIntenseFit : ListBuffer[Double] = new ListBuffer[Double]
    var PrevFit : ListBuffer[Double] = new ListBuffer[Double] //Double.PositiveInfinity
    var VelRand: Int = rand.nextInt(2)
    Index_TL = -1
    var d_Arr: ListBuffer[Int] = new ListBuffer[Int]

    var i_Diverse: Int = 0
    var i_Intense: Int = 0
    var i_stIntense: Int = 0
    var i_ndIntense: Int = 0
    var i_stDiverse: Int = 0
    var i_ndDiverse: Int = 0

    var b_stIntense: Boolean = false
    var b_ndIntense: Boolean = false
    var b_stDiverse: Boolean = false
    var b_ndDiverse: Boolean = false
    var index_EL = rand.nextInt(EL.length)
    var prand: Double = 0.0
    var a: Double = 0.0
    var a2: Double = 0.0
    var rand_leader_index: Int = 0


    var iteration = 0
    var NoProgress = 1
    var max_NoProgress = 3

    if (UpdateFun == "PSO") {
      max_NoProgress = 3
    }
    else if (UpdateFun == "Whale") {
      max_NoProgress = 11 //21
    }
    max_NoProgress = 9

    var NoProgDec: Int = 0
    var  r1 : Double = 0.0
    var  r2 : Double = 0.0

     var A: Double = 0.0//2 * a * r1 - a; // Eq. (2.3) in the paper
     var C: Double = 0.0 //2 * r2; // Eq. (2.4) in the paper
     var b : Double = 1.0; //  parameters in Eq. (2.5)
     var l: Double  = 0.0 //(a2 - 1) * rand.nextDouble() + 1; //  parameters in Eq. (2.5)

    while (iteration < MaxIt)
    {

      //WriteToFile(b_IorD)


      if (b_IorD == "1" | b_IorD == "11") //( b_IntenseFactor == TRUE )//(it%% 5  == 0)
      {
        i_Intense = i_Intense + 1
        //val deltarand = rand.nextInt(Np/10).asInstanceOf[Int] //rand.nextInt( (Np/2).asInstanceOf[Int])

        /*if (deltarand > EL.length) {
          deltarand = EL.length
        }
        if (deltarand == 0) {
          deltarand = 1
        }*/


        print("intense")

        if (b_IorD == "11") //(PrevIntenseFit == ReturnFit)
        {
          //b_IorD = "011"
          //NoProgress = -1


          //val ntemp = GenRandList(Np, deltarand)
          //for (m <- 0 until ntemp.length) {
            //Population(ntemp(m)) = EL(rand.nextInt(2)).CopyObj()//rand.nextInt(2)).CopyObj()//EL(0).CopyObj() //(rand.nextInt(2)).CopyObj() // EL(0).CopyObj()
          //}
          //Population = InstensifyFun(Population, Np, minCol, maxCol)
          //Population = CrossOverElite(Population , EL)
          Population = CrossOverEliteByCol(Population, EL)
          //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, BestCenters, EL)

          b_stIntense = true
        }
        else if (b_IorD == "1")
        {
          //b_IorD = "01"
          //NoProgress = -1

          /*val deltarand = rand.nextInt(Np/7).asInstanceOf[Int]
          val ntemp = GenRandList(Np, deltarand)
          for (m <- 0 until ntemp.length) {
            Population(ntemp(m)) = EL(rand.nextInt(EL.length)).CopyObj()
           }*/

          //Population = CrossOverElite(Population , EL)
          Population = CrossOverEliteByCol(Population , EL)
          //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, BestCenters, EL)
          b_ndIntense = true
        }


      }

      else if (b_IorD == "2" | b_IorD == "21")
      {

        if (b_IorD == "21")
        {


          //Population = CrossOverFun(Population)
          Population = CrossOverFunByCol(Population)
          b_stDiverse = true
        }

        else if (b_IorD == "2")
        {
          print("diverse 2")

          //b_IorD = "02"
          //NoProgress = -1

          /*i_Intense = i_Intense + 1
          var deltarand = (Np/5).asInstanceOf[Int]//rand.nextInt( (Np/2).asInstanceOf[Int])
          if ( deltarand > EL.length)
          {deltarand = EL.length }
          if (deltarand == 0) { deltarand = 1 }
          val ntemp = GenRandList(Np, deltarand )

          for (m <- 0 until ntemp.length) {
            Population(ntemp(m)) = EL(m).CopyObj()
          }*/

          ///Last Edit 3/4/2018
          //Population = CrossOverTabu(Population , TL, EL)
          //Population = CrossOverFun(Population)
          Population = CrossOverFunByCol(Population)
          //LocalPopulation = LocalSearch(EL, Np, minCol, maxCol)

          //Population = DiversifyFun(Population, Np, minCol, maxCol)
          b_ndDiverse = true
        }
      }


      w = w_min + ((w_max - w_min) *
        ((MaxIt.asInstanceOf[Double] - iteration.asInstanceOf[Double]) / MaxIt.asInstanceOf[Double]))

      a = 2.0 - (iteration+1) * ((2.0) / MaxIt.asInstanceOf[Double])
      a2 = -1.0 + (iteration+1) * ((-1.0) / MaxIt.asInstanceOf[Double])
      Improvement = false

      prand = rand.nextDouble()
      r1 = rand.nextDouble()
      r2 = rand.nextDouble()

      for (g <- 0 until Np )
      {


        A = 2.0 * a * r1 - a; // Eq. (2.3) in the paper
        C = 2.0 * r2; // Eq. (2.4) in the paper
        b = 1.0; //  parameters in Eq. (2.5)
        l = (a2 - 1.0) * rand.nextDouble() + 1.0; //  parameters in Eq. (2.5)

        if (  (b_IorD != "1")  & (b_IorD != "11") & (b_IorD != "2") & (b_IorD != "21"))
        {
          if (prand > 0.4)
          {

            if (math.abs(A) >= 1)
              {

                rand_leader_index = rand.nextInt(Np)

                Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                  Population(rand_leader_index).p, C, A, prand, b, l).clone()

              }
            else if (math.abs(A) < 1)
              {
                //rand_leader_index = rand.nextInt( (EL.length/2).asInstanceOf[Int])//rand.nextInt(Np) //math.floor(Np * rand.nextDouble() ).asInstanceOf[Int]
                index_EL = rand.nextInt(EL.length)

                Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                  EL(index_EL).p, C, A, prand, b, l).clone()
              }
          }

          else if (prand <= 0.4)
          {
            index_EL = rand.nextInt(EL.length)
            //Exploitation Phase
            Population(g).p = ComputeVelWhale(Population(0).p, Population(g).p,
              EL(index_EL).p, C, A, prand, b, l).clone()
          }

        }

        //We need to optimize the velocity to allow the swarm to migrate effectively
        //We need to keep track of the velocity and best values of it
        //Enhancement is obtained by executing the best velocity
        //Diversification is applied by increasing the velocity to explore far regions

        //WriteToFile(iteration.toString +":"+  Population(g).p.head.size.toString  + ":" + Population(g).p.length.toString )
          Population(g).p = AdjustMaxandMin(Population(g).p, minCol, maxCol).clone()
          // Evaluation

          //Tup = RecCenters(data, data.sparkContext, Population(g).p)
          /*Tup = RecCentersNew(data, data.sparkContext, Population(g).p)
          cost = Tup._1
          newCenters = Population(g).p.clone()*/

          Tup = obj_BioValidIndice.MultDisFun(data, data.sparkContext, Population(g).p)
          cost = Tup._2
          //newCenters = Tup._1.clone()
          //obj.p = centers.clone()
          //}

          Population((g)).fit = cost
          Population(g).Nobj = cost.length

          EL = Add2EL(EL, Population(g), max_EL)

      }

      /*if (b_IorD == "22") {
        b_IorD = "0"
        NoProgress = -1
      }*/
      str_Fit = str_Fit + ":" + RetBestFit.toString

      if (Improvement == false)//PrevIntenseFit == RetBestFit)
      {
        NoProgress = NoProgress + 1
      }
      else
      {
        PrevIntenseFit = RetBestFit
        /*NoProgress = NoProgress - 1
        if (NoProgress < 0)
        {
          NoProgress = 1
        }*/
      }

      //println("Adjustments")

      if (NoProgress >= max_NoProgress)
      {

        //NoProgress = 0
        if (b_IorD == "0")
        {
          b_IorD = "1"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "1")
        {
          b_IorD = "11"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "11")
        {
          b_IorD = "011"
          NoProgress = 0
        }

        else if (b_IorD == "011")
        {
          b_IorD = "2"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "2")
        {
          b_IorD = "21"
          NoProgress = max_NoProgress - 1
        }

        else if (b_IorD == "21")
        {
          b_IorD = "0"
          NoProgress = 0
        }

      }

      iteration = iteration + 1
    }



    /*Tup = RecCenters(data, data.sparkContext, BestCenters)
    cost = Tup._1
    BestCenters = Tup._2.clone()
    BestCenters = AdjustMaxandMin(BestCenters, minCol, maxCol).clone()
    if ( cost < RetBestFit)
      {
        RetBestFit = cost
      }*/

    //BestCenters.foreach(x=> println(x))
    //data.unpersist()
    /*val iterationTimeInSeconds = (System.nanoTime() - iterationStartTime) / 1e9 / 60
    println(f"Iterations took $iterationTimeInSeconds%.3f minutes.")
    println("Number of iterations :" + (iteration))
    println("K :" + k)
    println("RetBestFit :" + RetBestFit)
    println("Fit :" + (RetBestFit * n))
    println("Difference :" + (((RetBestFit * n) - StandardObj) / StandardObj).formatted("0.00000") )*/

    /*WriteToFile("Intensification: " + i_Intense, true)
    WriteToFile("Diversification: " +i_Diverse)
    WriteToFile("First Intense Improvement: " +i_stIntense,true)
    WriteToFile("Second Intense Improvement: " +i_ndIntense,true)
    WriteToFile("First Diverse Improvement: " +i_stDiverse,true)
    WriteToFile("Second Diverse Improvement: " +i_ndDiverse,true)*/

    WriteToFile("\n" + str_Fit)
    (RetBestFit, BestCenters)

  }

    def main(args: Array[String]): Unit = {

      rand = new scala.util.Random()
      var b_Run : Boolean = false
      WriteToFile("/////////////",true)
      //WriteToFile("K-means Update Centers",true)
      //WriteToFile(UpdateFun,true)

      obj_BioValidIndice = new BioValidIndice()


      val l =  List(1,2,4,5)//1,2,3,4,5,6,7,8,9,10,14
      //val l =  List(10,13)

      //if ( b_Run == false )

      //val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test")
       // .getOrCreate()

        val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test")
          .getOrCreate()


        ObjFunGlobal  = "kmeans"
        UpdateFun = "Whale"
        WriteToFile("/////////////",true)
        WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
        WriteToFile(UpdateFun,true)
        for (dataNum <- 0 to l.length)
        { RunCluster(l(dataNum), spark) }


        spark.stop()


      //RunCluster(2)
      //Normalization
      //Randomizing the data objects in dataset


  }

  def ComputeVelWhale(Randp :Array[Vector], p:Array[Vector], EL: Array[Vector],
      C: Double, A: Double, prand: Double, b : Double, l: Double  ): Array[Vector] =
  {

    //val rand = new scala.util.Random()
    var Vec = new Array[Double](p.head.size)
    var result : Array[Vector] = new Array[Vector](p.length)

    //X_rand = Positions(rand_leader_index,:);
    //D_X_rand = abs(C * X_rand(j) - Positions(i, j));
    // Eq .(2.7)
    //Positions(i, j) = X_rand(j) - A * D_X_rand;
    var distance2Leader : Double = 0.0

    for (h <- 0 until p.length)
    {
      for (j <- 0 until p.head.size)
      {

        if (prand > 0.4) {
          if (math.abs(A) >= 1)
          {
            //if (p(0) != null & p.length > 0)
            Vec.update(j, p(h)(j) - ( (A/4) * ( Randp(h)(j) - p(h)(j)) ) )
          }
          else if (math.abs(A) < 1) {
            //D_Leader = abs(C * Leader_pos(j) - Positions(i, j));  // Eq .(2.1)
            //Positions(i, j) = Leader_pos(j) - A * D_Leader;     // Eq.(2.2)
            Vec.update(j, p(h)(j) - ( (A/4) * ( EL(h)(j) - p(h)(j)) ) )
          }
        }
        else if (prand <= 0.4) {
          //distance2Leader=abs(Leader_pos(j)-Positions(i,j));
          // Eq. (2.5)
          //Positions(i,j)=distance2Leader*exp(b.*l).*cos(l.*2*pi)+Leader_pos(j);
          //Exploitation Phase
          distance2Leader = math.abs(EL(h)(j) - p(h)(j)); // Eq. (2.5)
          Vec.update(j, distance2Leader * math.exp(b * l) * math.cos(l * 2 * math.Pi) + EL(h)(j));
        }
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }

    result
  }

  def ComputeVel(bp :Array[Vector] , p:Array[Vector], v:Array[Vector], EL: Array[Vector],
                 c1: Double , c2: Double, r1: Double, r2 : Double, w: Double ): Array[Vector] =
  {

    val result : Array[Vector] = new Array[Vector](p.length)
    //var Vec: Array[Double] = p1(1).toArray

    // val t: Double = iteration / MaxIt
    val rand = new scala.util.Random()
    var t1: Double = 0.0
    var t2: Double = 0.0
    var r3: Double = r1
    var r4: Double = r2
    val Vec = new Array[Double](p.head.size)

    for (h <- 0 until p.length)
      {

       for (j <- 0 until p.head.size)
          {
            r3 = rand.nextDouble()
            r4 = rand.nextDouble()
            t1 = c1*r3
            t2= c2*r4

            if ( v(0) != null & v.head.size > 0)
              {
                Vec.update(j,  (  (  w * v(h)(j)) +
                  (  t1 *  (bp(h)(j) - p(h)(j) )) +
                  (  t2 *  (EL(h)(j) - p(h)(j) ))
                  ))
              }
            else
              {
                Vec.update(j ,  ( (  t1 * (bp(h)(j) - p(h)(j) )) +
                  (  t2 * (EL(h)(j) - p(h)(j) )) ) )
              }

          }
        result.update(h,  Vectors.dense(Vec).copy)
      }


    /*Population((h)).v <- Vectors.dense(
    ( (iteration / MaxIt)  * Population((h)).v.toArray ) +
      ( (c1*r1)*(Population((h)).bp.toArray - Population((h)).p.toArray)) +
      ((c2*r2)*(EL(0).p.toArray-Population((h)).p.toArray)) )*/

    result
  }

  def Add2Vec(p1:  Array[Vector], p2:  Array[Vector], op:String ) :  Array[Vector] =
  {
    val result : Array[Vector] = new Array[Vector](p1.length)
    //var Vec: Array[Double] = p1(1).toArray
    val Vec = new Array[Double](p1.head.size)

    for (i<- 0 until p1.length)
      {
        for ( j <- 0 until p1.head.size)
          {
            if (op == "+")
            { Vec.update(j , p1(i)(j) + p2(i)(j)) }
            else if (op == "-")
            { Vec.update(j , p1(i)(j) - p2(i)(j)) }
            else if (op == "*")
            { Vec.update(j , p1(i)(j) * p2(i)(j)) }
            else if (op == "/")
            { Vec.update(j , p1(i)(j) / p2(i)(j)) }
          }

        //val  Vec = p1(i).zip(p2(i)).map { case (x, y) => x + y }}

        result.update(i, Vectors.dense(Vec).copy)
      }
    result
  }

    def CrossOverFunByCol(Population : ListBuffer[MOPSO]) : ListBuffer[MOPSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)

    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]

    var delta_Row : Int = 0
    var delta_Col : Int = 0

    for (p <- 0 until delta_P)
    {
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.5).asInstanceOf[Int] //rand.nextInt(r/2)//  //base::sample(r,1)
      //delta_Row = math.round(r).asInstanceOf[Int]  //rand.nextInt(r/2) //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1}

      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        for( j <- 0 until delta_Col)
        {

          if (rand_P(p) < Population.length - 1) {
            //////////P
            val t1 = Population((rand_P(p) + 1)).p(rand_Row(i)).toArray((rand_Col(j)))

            Population(rand_P(p) + 1).p(rand_Row(i)).toArray((rand_Col(j))) =
              Population((rand_P(p))).p(rand_Row(i)).toArray((rand_Col(j)))

            Population((rand_P(p))).p(rand_Row(i)).toArray((rand_Col(j))) = t1

          }
          else {
            //////////P
            val t1 = Population((rand_P(p))).p(rand_Row(i)).toArray((rand_Col(j)))

            Population((rand_P(p))).p(rand_Row(i)).toArray(rand_Col(j)) =
              Population(((rand_P(p) - 1))).p(rand_Row(i)).toArray(rand_Col(j))

            Population(((rand_P(p) - 1))).p(rand_Row(i)).toArray((rand_Col(j))) = t1

          }
        }
      }
    }

    Population

  }

  //Intensification To Elite
  def CrossOverEliteByCol(Population: ListBuffer[MOPSO], EL: ListBuffer[MOPSO]) :
  ListBuffer[MOPSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val Np : Int = Population.length
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (Np/2).asInstanceOf[Int] //math.round(Np).asInstanceOf[Int] //Np
  // val rand_P = Array.range(0 , Np)
    val rand_P = GenRandList(Np, delta_P)

    //Best=Population[[1]]$P
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    var newVal :Double =0.0

    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]

      val index_EL = rand.nextInt(EL.length)

      for ( i <- 0  until delta_Row)
      {

        delta_Col = rand.nextInt((d).asInstanceOf[Int]) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        for (j <- 0  until delta_Col)
        {

          Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) =
            EL(index_EL).p(rand_Row(i)).toArray((rand_Col(j)))

        }
      }
    }

    Population

  }

  //Local Search
  def LocalSearch( EL : ListBuffer[MOPSO], Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double] )
  : ListBuffer[MOPSO] =
  {

    val rand = new scala.util.Random()
    var Population : ListBuffer[MOPSO] = new ListBuffer[MOPSO]
    var Temp : Array[Vector] = EL(0).p.clone()
    val r : Int = EL(0).p.length
    val d : Int = EL(0).p.head.size
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    var rand_Val: Double = 0.0
    var t: Double = 0.0
    var obj : MOPSO = new MOPSO(r, nObj)
    val delta_P = (Np/2).asInstanceOf[Int] //math.round(Np).asInstanceOf[Int] //Np
    // val rand_P = Array.range(0 , Np)
    val rand_P = GenRandList(Np, delta_P)


    for ( p<- 0 until delta_P )
    {
      Temp = EL(rand.nextInt(2)).p.clone()
      //val obj = new PSO(r)

      delta_Row = rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row)

      for ( i<- 0 until delta_Row )
      {
        delta_Col = rand.nextInt((d).asInstanceOf[Int]) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col)

        for ( j<- 0 until delta_Col )
        {
          rand_Val = rand.nextDouble()

          if (rand_Val  >= 0.5 )
          {
            t =  0.1 * rand.nextDouble() * ( VarMax(rand_Col(j)) - Temp(rand_Row(i))(rand_Col(j)) )
            t = t + Temp(rand_Row(i))(rand_Col(j))
          }

          else
          {
            t =  0.1 * rand.nextDouble() * ( Temp(rand_Row(i))(rand_Col(j)) - VarMin(rand_Col(j)) )
            t = Temp(rand_Row(i))(rand_Col(j)) - t
          }

          if (t == 0)
            {     t = Temp(rand_Row(i))(rand_Col(j))    }

          Temp(rand_Row(i)).toArray((rand_Col(j))) = t

        }
      }

      obj.p = Temp.clone()
      Population += obj.CopyObj()


    }

    Population

  }

  //CrossOver Tabu List
  def CrossOverTabu(Population : ListBuffer[MOPSO], TL: ListBuffer[MOPSO], EL: ListBuffer[MOPSO]) : ListBuffer[MOPSO] =
  {

    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (0.3 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    val rand = new scala.util.Random()
    var EL_Index : Int =0 //rand.nextInt(2)
    EL_Index = rand.nextInt(2)
    var delta_Row : Int = 0

    for (p <- 0 until delta_P)
    {
      // = math.round(r * 0.3).asInstanceOf[Int]  //base::sample(r,1)
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row =  1 }

      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      val index_TL  = rand.nextInt(TL.length)
      Population(rand_P(p)).p = EL(rand.nextInt(2)).p.clone()

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)) .p(rand_Row(i))  =
          Vectors.dense(TL( index_TL ).p(rand_Row(i)).toArray).copy

        //////////V
        //Population(( (rand_P(p)) )).v(rand_Row(i)) =
        //Vectors.dense(TL( index_TL ).v(rand_Row(i)).toArray)

        //////////BP
        //Population(( (rand_P(p)) )).bp(rand_Row(i)) =
        //Vectors.dense(TL( index_TL ).bp(rand_Row(i)).toArray)

      }
    }

    Population

  }

  //CrossOver_fun
  def CrossOverFun(Population : ListBuffer[MOPSO]) : ListBuffer[MOPSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Population.length/2)//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
    {delta_P = 1}
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)

    var delta_Row : Int = 0
    var Replacement: Int = 0

    for (p <- 0 until delta_P)
    {

      /*Replacement = rand.nextInt(Population.length)
      while(Replacement == rand_P(p))
        {
          Replacement = rand.nextInt(Population.length)
        }*/


      //math.ceil(d/2).asInstanceOf[Int]
      //delta_Row = math.round(r * 0.3).asInstanceOf[Int]  //base::sample(r,1)
      delta_Row = rand.nextInt((r).asInstanceOf[Int])  //rand.nextInt(r/2) //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1}

      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {
        if ( rand_P(p) < Population.length-1 )
        {
          //////////P
          val t1 = Population( (rand_P(p)+1) ).p(rand_Row(i)).toArray
          //val t1 = Population( Replacement) ).p(rand_Row(i)).toArray

          /*Population(rand_P(p)+1) .p(rand_Row(i))  =
            Vectors.dense(Population(( rand_P(p) )).p(rand_Row(i)).toArray).copy*/

          Population(( rand_P(p) )).p(rand_Row(i)) = Vectors.dense(t1).copy
          //////////V
          /*val t2 = Population(( (rand_P(p)+1) )).v(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).v(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).v(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( (rand_P(p)+1) )).bp(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).bp(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).bp(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
        else{
          //////////P
          val t1 = Population(( rand_P(p) - 1)).p(rand_Row(i)).toArray.clone()

          /*Population(( rand_P(p) )).p(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).p(rand_Row(i)).toArray).copy*/

          Population(( (rand_P(p)) )).p(rand_Row(i)) = Vectors.dense(t1).copy
          //////////V
          /*val t2 = Population(( rand_P(p) )).v(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).v(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).v(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( rand_P(p) )).bp(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).bp(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).bp(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
      }
    }

    Population

  }

  //CrossOver Elite List
  def CrossOverElite(Population : ListBuffer[MOPSO], EL: ListBuffer[MOPSO]) : ListBuffer[MOPSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Population.length/2) //math.round(Population.length * 0.5).asInstanceOf[Int]//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
      {delta_P = 1}
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    var delta_Row: Int = 0

    for (p <- 0 until delta_P)
    {
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1 }
      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      val index_EL  = rand.nextInt(EL.length)

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)) .p(rand_Row(i))  =
          Vectors.dense(EL( index_EL ).p(rand_Row(i)).toArray).copy

        //////////V
        //Population(( (rand_P(p)) )).v(rand_Row(i)) =
          //Vectors.dense(EL( index_EL ).v(rand_Row(i)).toArray)

        //////////BP
        //Population(( (rand_P(p)) )).bp(rand_Row(i)) =
          //Vectors.dense(EL( index_EL ).bp(rand_Row(i)).toArray)

      }
    }

    Population

  }


  //Intensification To Elite
  def InstensifyEliteFun(Population: ListBuffer[MOPSO], Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double],
                         BestCenters : Array[Vector], EL: ListBuffer[MOPSO]) :
  ListBuffer[MOPSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Np/2) //Np
    if (delta_P == 0 )
    {delta_P = 1}
    val rand_P = GenRandList(Np, delta_P)

    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    //delta_Row = r
    //rand_Row=c(1:r)
    var newVal :Double =0.0
    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]

      val index_EL = rand.nextInt(EL.length)

      for ( i <- 0  until delta_Row)
      {

        delta_Col = rand.nextInt((d).asInstanceOf[Int] ) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0  until delta_Col)
        {
          oldVal = Population(rand_P(p)).p(rand_Row(i)).toArray(rand_Col(j))
          //x= rand.nextInt(2)//base::sample(2,1)
          temp = 0
          newVal= oldVal
          //OLD Method start
          //if (oldVal  > BestCenters(rand_Row(i)).toArray(rand_Col(j)) )
          if (oldVal  > EL(index_EL).p(rand_Row(i)).toArray(rand_Col(j)) )
          {
            temp =  rand.nextDouble() * ( oldVal -   EL(index_EL).p(rand_Row(i))(rand_Col(j)) )
              //0.01 *
             newVal= oldVal - temp
          }
          //else if (oldVal  < BestCenters(rand_Row(i)).toArray(rand_Col(j)) )
          else if (oldVal  < EL(index_EL).p(rand_Row(i)).toArray(rand_Col(j)) )
          {
            temp =   rand.nextDouble() * (  EL(index_EL).p(rand_Row(i))(rand_Col(j)) -  oldVal )
            //0.01 *
            newVal= oldVal + temp
          }
          if (newVal == 0)
            newVal= oldVal

          Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  //Intensification Function
  def InstensifyFun(Population: ListBuffer[MOPSO],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[MOPSO] = {

    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (Np/2).asInstanceOf[Int] //math.round(0.6 * Np).asInstanceOf[Int] // Np
    //val rand_P = Array.range(0 , Np)
    val rand_P = Array.range(0 , Np) //GenRandList(Np, delta_P)
    val rand = new scala.util.Random()
    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row = 0
    var delta_Col = 0
    //delta_Row = r
    //rand_Row=c(1:r)
    var newVal :Double =0.0
    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt( (r/2).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
        { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]

      for ( i <- 0  until delta_Row)
      {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if (delta_Col == 0 )
           { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0  until delta_Col)
        {
            oldVal = Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j)))
            x= rand.nextInt(2)//base::sample(2,1)
            temp = 0
            newVal = oldVal
            //OLD Method start
            if (x  == 1  )
            {
              //val temp =  0.0001 * runif(1,0,1) * ( oldVal -  VarMin[1,rand_Col[j]])
              temp =   ( quantileInt(rand_Col(j)) -  VarMin(rand_Col(j)) )  * rand.nextDouble() //* ( oldVal -  VarMin(rand_Col(j)) )
              newVal= oldVal - temp
            }
            else
            {
              temp = ( quantileInt(rand_Col(j)) -  VarMin(rand_Col(j)) ) * rand.nextDouble() //* ( VarMax(rand_Col(j)) - oldVal)
              newVal= oldVal + temp
            }

            Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  def DiversifyFun(Population: ListBuffer[MOPSO],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[MOPSO] = {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r = Population(1).p.length //nrow(Population[[1]]$P)
    val delta_P = math.round(0.5 * Np).asInstanceOf[Int] //round(0.7*Np)
    var rand_Row: ListBuffer[Int]  = new ListBuffer[Int]()
    var delta_Col = 0
    var rand_Col: ListBuffer[Int] = GenRandList(d, 1)
    //var temp_Rand : Int = 0
    //var rand_P: ListBuffer[Int] = new ListBuffer[Int]
    val rand_P : ListBuffer[Int] = GenRandList(Np, delta_P)
    var delta_Row = 0
    var newVal: Double = 0.0
    var oldVal = 0.0
    var x = 0
    var temp = 0.0

    for (p <- 0 until delta_P) {

      delta_Row = math.round(0.3 * r).asInstanceOf[Int]//rand.nextInt(r) //base::sample(r,1) //r
      if (delta_Row == 0 ) { delta_Row = 1}
      rand_Row = GenRandList(r, delta_Row) //new ListBuffer[Int]

      /*for (v <- 0 until delta_Row) {
        rand_Row += rand.nextInt(r) //base::sample(r,delta_Row,replace=FALSE) //c(1,r)
      }*/


      for (i <- 0 until delta_Row) {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if ( delta_Col == 0 )
          { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col)//new ListBuffer[Int]
        /*for (v <- 0 until delta_Col) {
          rand_Col += rand.nextInt(d) //base::sample(r,delta_Row,replace=FALSE) //c(1,r)
        }*/

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0 until delta_Col) {
          oldVal = Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j)))
          x = rand.nextInt(2)
          //base::sample(2,1)
          temp = 0
          //OLD Method start
          newVal = oldVal
          if ( (x == 1) & ( oldVal > VarMin(rand_Col(j))))
          {

            val temp = ( quantileDiv(rand_Col(j)) -  VarMin(rand_Col(j)) ) * rand.nextDouble() //* (oldVal - VarMin(rand_Col(j)))
            newVal = oldVal - temp
          }
          else {

            temp = ( quantileDiv(rand_Col(j)) -  VarMin(rand_Col(j)) ) * rand.nextDouble() //* (VarMax(rand_Col(j)) - oldVal)
            newVal = oldVal + temp
          }

          Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p = AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax)

    }

    Population
  }

  def GenRandList(Np: Int , count: Int) :ListBuffer[Int] =
  {
    val rand = new scala.util.Random()
    var l : ListBuffer[Int] =  new ListBuffer[Int]
    var temp_Rand : Int = 0
    for (v<-0 until count )
    {
      temp_Rand = rand.nextInt(Np)
      //if (temp_Rand == 0 )
        //{ temp_Rand = temp_Rand + 1}
      while(l.contains(temp_Rand) == true )
      {
        temp_Rand = rand.nextInt(Np)
      }
      l += temp_Rand
    }
    l
  }


  def AdjustMaxandMin(obj : Array[Vector], VarMin: ListBuffer[Double], VarMax: ListBuffer[Double]) : Array[Vector] =
  {
    //var x = obj
    val d = obj.head.size
    for (i<- 0 until obj.length)
      {
        for (j<-0 until d)
          {
            if ( obj(i).toArray(j) > VarMax(j) )
              {
                obj(i).toArray(j) = VarMax(j)
              }
            if ( obj(i).toArray(j) < VarMin(j) )
            {
              obj(i).toArray(j) = VarMin(j)
            }
          }
      }

    obj
  }

  def RecCentersNew(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):
  (ListBuffer[Double],Array[Vector])={

    var PointsNew : ListBuffer[ListBuffer[Vector]]= new ListBuffer[ListBuffer[Vector]]()
    var temp: ListBuffer[Vector] = ListBuffer[Vector]()

    for (i<- 0 until globalK)
    {
      PointsNew += temp.clone()

    }
    var TotalPointsCost: Double = 0.0
    var MaxCost: Double = Double.NegativeInfinity
    var Tup: Tuple2[Int, Double] = (-1, -1)
    var bIndex: Int = 0
    var cost : Double = 0.0
    val n : Double = data.count().asInstanceOf[Double]

    data.collect().foreach { point =>
      Tup  = findClosest(centers, point)
      bIndex = Tup._1
      cost = Tup._2
      cost = cost*cost

      PointsNew(bIndex) += point
      TotalPointsCost = TotalPointsCost + cost
      if (MaxCost < cost)
        {MaxCost = cost}
    }

    var tc : Double = 0.0
    tc = TotalPointsCost / (n * MaxCost)


    var TotalCenterCost: Double = 0.0
    var MaxCentCost : Double = Double.NegativeInfinity
    var MaxCentIndex: Double = 1.0

    for ( r<- 0 until globalK)
    {
      for ( g <- r+1 until globalK)
      {

          cost = ObjFun(centers(r), centers(g))
          cost = cost * cost
          if (MaxCentCost < cost)
            {
              MaxCentCost = cost
              MaxCentIndex = r+1.0
            }
          TotalCenterCost = TotalCenterCost + cost

      }
    }

    if ( MaxCentIndex > 1)
      {
        MaxCentIndex = MaxCentIndex * (MaxCentIndex - 1.0)
      }

    var tr = (2.0* TotalCenterCost) /
             (MaxCentCost * MaxCentIndex.asInstanceOf[Double])  //globalK.asInstanceOf[Double] * (globalK - 1).asInstanceOf[Double] )

    var MaxCount : Int = PointsNew(0).length //Int.MinValue
    var MinCount : Int = PointsNew(0).length
    for (i<- 1 until globalK)
      {
        if ( MaxCount <  PointsNew(i).length  )
           { MaxCount =  PointsNew(i).length  }

        if ( MinCount >  PointsNew(i).length  )
            { MinCount =  PointsNew(i).length  }

      }

    val ty:Double = MinCount.asInstanceOf[Double] / MaxCount.asInstanceOf[Double]

    //val Retcost = ( tc + (1.0 - tr) + ( 1.0 - ty) ) / 3.0   //original
    //val Retcost = ( tc + (( 1.0 - ty)*  0.5)  ) / 2.0 //Bwst for the iris 9.733

    val Retcost = ( (tc /2) +  ( (1.0 - tr)/2  )  + (1-ty)  ) / 3.0   //



    (ListBuffer(Retcost, Retcost), centers)

  }


  def RecCenters(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):(Double,Array[Vector])={

    //while (iteration < MaxIt) {
    //&& !converged) {

      val costAccum = sc.doubleAccumulator
      val bcCenters = sc.broadcast(centers)
      //println(bcCenters)

      // Find the new centers
      val newCenters = data.mapPartitions { points =>
        val thisCenters = bcCenters.value
        val dims = thisCenters.head.size
        //println("dims: " + dims)

        val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
        //println("sums: " + sums.toString)
        val counts = Array.fill(thisCenters.length)(0L)
        //println("counts: " + counts)

        points.foreach { point =>
          val (bestCenter, cost) = findClosest(thisCenters, point)
          //println("Single Cost:" + cost + " : Best Center = " + bestCenter.toString)

          val tempcost = cost * cost * cost
          costAccum.add(tempcost)
          //println("costAccum:" + costAccum.value )
          val sum = sums(bestCenter)
          //***************UnKonwn Comment
          axpy(1.0, point, sum)
          //Add2Vec(1.0,point,sum)
          //println("point size:" + point.size + " class:" + point.getClass)
          //println("sum size:" +  sum.size + "   class:" + sum)
          //org.apache.spark.ml.linalg
          //sums.map(x=>println(x))
          counts(bestCenter) += 1
          //println("counts(bestCenter): " + counts(bestCenter))
        }

        counts.indices.filter(counts(_) > 0).map(j => (j, (sums(j), counts(j)))).iterator
      }.reduceByKey { case ((sum1, count1), (sum2, count2)) =>

        //***************UnKonwn Comment
        //println("1111111111111")
        //println("sum2:" + sum2 + "sum1:" + sum1)
        axpy(1.0, sum2, sum1)
        //println("count1: " + count1)
        (sum1, count1 + count2)
      }.mapValues { case (sum, count) =>
        //for(i<-1 to sum.size)
         // {println("Sum Before:" + sum(i))}
        //println("Sum Before:" + sum)
        //println("count Before:" + count)
        //***************UnKonwn Comment
        scal(1.0 / count.asInstanceOf[Double], sum)
        //***************UnKonwn Comment
        //new Vectors.dense(sum.toArray) //do not why this is used
        //for(i<-1 to sum.size)
        //{println("Sum After:" + sum(i))}

        //println("Sum:" + sum)

        Vectors.dense(sum.toArray)
      }.collectAsMap()

      bcCenters.destroy()
      // Update the cluster centers and costs

      //// 24-12-2017
    /*if ( b_RetNewCent == true)
    {
      newCenters.foreach { case (j, newCenter) =>
        centers(j) = newCenter
      }
    }*/

    //println("newCenters")
    /*newCenters.foreach{x=>
      println(x)
     }*/

    /*var InterDist : Double = 0.0
    for ( i<- 0 until globalK )
    {
      for (j <- 0 until globalK )
      {
        if ( i != j)
        {
          InterDist = InterDist + math.pow(ObjFun(centers(i), centers(j)), 2)
        }
      }
    }
    val Retcost = costAccum.value.asInstanceOf[Double] / InterDist //Hybrid SSEE and InterDist*/

    //val Retcost = costAccum.value / data.count().asInstanceOf[Double] //Euclidean Distance
    val Retcost = costAccum.value  // SSEE Distance

    //centers.foreach { x => println(x) }
    //println(s"The cost is $cost.")

    (Retcost, centers)

  }

  def ObjFun(p1: Vector, p2: Vector): Double = {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  def parseVector(line: String): Vector = {
    val x = line.split(',').map(_.toDouble)
    Vectors.dense(x)
  }

  def Row2Vector(r: Row, except: ListBuffer[String]): Vector = {
    var l = new ListBuffer[Double]()
    for (i <- 0 until r.length ) {
      if ( except.contains(r.schema.fields(i).name) == false)
      {
        l += r.get(i).asInstanceOf[Double]
      }
    }
    //println("l :" + l(1))
    Vectors.dense(l.toArray)
  }

  def findClosest(centers: TraversableOnce[Vector], p: Vector): (Int, Double) =
  {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFun(center, p) //center.norm - point.norm
      if (Dist < bestDistance)
      {
        bestDistance = Dist
        bestIndex = i
      }
    }
    (bestIndex, bestDistance)
  }

  def findClosestRow(centers: TraversableOnce[Vector], p: org.apache.spark.sql.Row, except: ListBuffer[String]): (Int, Double) = {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFunRow(center, p, except) //center.norm - point.norm
      if (Dist < bestDistance) {
        bestDistance = Dist
        bestIndex = i
        //println("bestIndex " + bestIndex)
      }
      //println("Dist " + i + ":" + Dist)
    }
    (bestIndex, bestDistance)
  }

  def ObjFunRow(p1: Vector, p2: org.apache.spark.sql.Row, except: ListBuffer[String]): Double = {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      if (except.contains(p2.schema.fields(i).name) == false)
      {
        squaredDistance = squaredDistance + math.pow(p1(i) - p2.get(i).asInstanceOf[Double], 2)
      }
    }

    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  def CompareFit(EL: ListBuffer[MOPSO], p: MOPSO) : Boolean =
  {
    var b_equal: Boolean = true
    var b_break: Boolean = true

    for (v <- 0 until EL.length)
    {
      b_equal = true
      for (i <- 0 until EL(v).fit.length)
      {
        if (EL(v).fit(i) != p.fit(i))
        {
          b_equal = false
          //break
        }
      }
      if (b_equal == true)
      {
        return true
      }
    }

    return false
  }

  def CompareMatrix(EL: ListBuffer[MOPSO], p: MOPSO) : Boolean =
  {
    var b_equal: Boolean = true
    var b_break: Boolean = true

    for (v <- 0 until EL.length)
    {
      b_equal = true
      breakable
      {
        for (i <- 0 until EL(v).p.length) {
          for (j <- 0 until EL(v).p.head.size) {
            if (EL(v).p(i).toArray(j) != p.p(i).toArray(j)) {
              b_equal = false
              b_break = true
            }
          }
        }
        if (b_equal == true) {
          return true
        }
      }
    }

    return b_equal
  }


  def Dominance(x: Array[Double], y:Array[Double]) : Boolean =
  {
    var d : Boolean =true
    var one : Boolean = false
    var All : Boolean =true

    for ( i <-0 until  nObj)
    {
      if (y(i) > x(i)  )
      {
        All=false
        return All
      }

      if (x(i) < y(i)  )
      {
        one = true
      }

    }

    if ( one == false )
    {
      All = false
    }

    return All
  }

  def CompareObj(x: ListBuffer[Double], y:ListBuffer[Double]) : Boolean =
  {
    /*var d : Boolean =true
    var one : Boolean = false
    var All : Boolean =true

    for ( i <-0 until  y.length)
    {
      if ( x(i) > y(i)   )
      {
        All=false
        //return All
      }

      if (x(i) < y(i)  )
      {
        one = true
      }

    }

    if (All == false & one == false)
      {   return  false   }
    else
      {   return true   }*/

    ////////////////////////////////////////
    ///////////////////////////////////
    //Xie-Beni  : Minimization
    //Simplified Silhoutte Maximization
    //Separation Maximization
    //Overall cluster deviation : Minimization
    var betterInAnyObjective : Boolean = false;
    var worseInAnyObjective : Boolean = false;
    breakable {
      for (i <- 0 until y.length)
      {

        if (worseInAnyObjective)
        {
          break;
        }

        if ( i == 0 | i == 2 )
          {
            if ( x(i) < y(i) )
            {
              betterInAnyObjective = true;
            }

            else if (x(i) > y(i))
            {
              worseInAnyObjective = true;
            }
          }
        else
          {
            if ( x(i) > y(i) )
            {
              betterInAnyObjective = true;
            }

            else if (x(i) < y(i))
            {
              worseInAnyObjective = true;
            }
          }

      }
    }

    return !worseInAnyObjective && betterInAnyObjective;

  }

  //def IsIdentical(p1: PSO , p2: PSO): Boolean = {}
  //EL, obj, max_EL
  def Add2EL(EL: ListBuffer[MOPSO], p: MOPSO, max_EL: Int): ListBuffer[MOPSO] =
  {

    //val rand = new scala.util.Random()
    var b_exist: Boolean = false
    if ( EL.length == 0)
    {
      Improvement = true
      EL  += p.CopyObj
      return EL
    }

    if ( CompareFit(EL, p) == true )
    {
      return EL
    }

    /*if ( EL.length < max_EL)
    {
      EL  += p.CopyObj
      return EL
    }*/

    /*if (SPdistanceToClosestPoint(EL, p) < 0.00521)
    {
      return EL
    }*/

    var Dominated :ListBuffer[Integer] = new ListBuffer[Integer]
    //val maxTemp = EL.length
    //b_isDominated = true
    var b_HasbeenDom : Boolean = false

    for (i <- 0 until EL.length)
    {
      if (CompareObj(p.fit, EL(i).fit)) //( p.fit < EL(i).fit)
      {
        //EL(i) = p.CopyObj
        Dominated += i
        //return EL
      }
      else if (CompareObj(EL(i).fit, p.fit))
      {
        b_HasbeenDom = true
      }
    }

    if (Dominated.length > 0 )
    {
      Improvement = true
      /*if (Dominated.length == 1 )
        EL(Dominated(0)) = p.CopyObj
      else
        EL(Dominated(rand.nextInt(Dominated.length) ) ) = p.CopyObj
        */


      for (i<- Dominated.length-1  to 0 by -1  )
      {
        EL.remove(Dominated(i))
      }
      EL += p.CopyObj
      Improvement = true
    }
    else
    {
      if (b_HasbeenDom  == false)
        {
          EL  += p.CopyObj
          Improvement = true
        }
    }

    return EL
  }


   def Add2TLOrdered(TL: ListBuffer[MOPSO], p: MOPSO, max_TL: Int): ListBuffer[MOPSO] ={

    var b_exist: Boolean = false

    if ( TL.length == 0 )
    {
      TL  += p.CopyObj()
      return TL
    }

    var Added : Boolean = false
    var i : Int = 0
    if (TL.length < max_TL)
    {
      TL  += p.CopyObj()
      return TL
    }
    else {
      for (i <- 0 until TL.length) {
        if (CompareObj(TL(i).fit, p.fit) ) //( p.fit > TL(i).fit)
        {
          TL(i) = p.CopyObj()
          Added = true
          return TL
        }
      }

    }

    TL
  }

  //TL, obj, max_EL
  def Add2TL(TL: ListBuffer[MOPSO], p: MOPSO, max_TL: Int, Index: Int): ListBuffer[MOPSO] ={

    var b_exist: Boolean = false
    if ( TL.length == 0 )
    {
      TL  += p
      return TL
    }
    else
    {
      for (temp: MOPSO <- TL)
      {
        //temp.p.toArray.deep
        if ( temp != null && (temp.p.toArray.deep == p.p.toArray.deep ))
        {
          b_exist = true
          return TL
        }
      }
    }


    var Added : Boolean = false
    if (TL.length < max_TL)
    {
      TL  += p
      return TL
    }
    else {
      //Index =
      TL.update(Index, p)
      return TL

    }

  }

  def RandVel(k: Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): Array[Vector] =
  {

    val rand = new scala.util.Random()
    val result : Array[Vector] = new Array[Vector](k)
    val Vec = new Array[Double](d)

    for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec.update(j , rand.nextDouble() * ( quantileInt(j)  - minCol(j) ) )  //(maxCol(j) - minCol(j))  )
        //Vec.update(j , 0.0)
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  def RandCof( k : Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): Array[Vector] =
  {

    val rand = new scala.util.Random()
    val result : Array[Vector] = new Array[Vector](k)
    val Vec = new Array[Double](d)

    for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec.update(j , rand.nextDouble() )
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  /**
    * Initialize a set of cluster centers using the k-means|| algorithm by Bahmani et al.
    * (Bahmani et al., Scalable K-Means++, VLDB 2012). This is a variant of k-means++ that tries
    * to find dissimilar cluster centers by starting with a random center and then doing
    * passes where more centers are chosen with probability proportional to their squared distance
    * to the current cluster set. It results in a provable approximation to an optimal clustering.
    *
    * The original paper can be found at http://theory.stanford.edu/~sergei/papers/vldb12-kmpar.pdf.
    */
  def initKMeansParallel(data: RDD[Vector]): Array[Vector] = {
    //
    // Initialize empty centers and point costs.
    var costs = data.map(_ => Double.PositiveInfinity)
    val initializationSteps = 3//20

    // Initialize the first center to a random point.

    val seed = new XORShiftRandom(scala.util.Random.nextLong()).nextInt()
    //val seed = scala.util.Random.nextLong()
    val sample = data.takeSample(false, 1, seed)
    // Could be empty if data is empty; fail with a better message early:
    require(sample.nonEmpty, s"No samples available from $data")

    val centers = ArrayBuffer[Vector]()
    var newCenters = Seq(sample.head.toDense)
    centers ++= newCenters

    // On each step, sample 2 * k points on average with probability proportional
    // to their squared distance from the centers. Note that only distances between points
    // and new centers are computed in each iteration.
    var step = 0
    val bcNewCentersList = ArrayBuffer[Broadcast[_]]()
    while (step < initializationSteps) {
      val bcNewCenters = data.context.broadcast(newCenters)
      bcNewCentersList += bcNewCenters
      val preCosts = costs
      costs = data.zip(preCosts).map { case (point, cost) =>
        math.min(findClosest(bcNewCenters.value, point)._2, cost)
      }.persist(StorageLevel.MEMORY_AND_DISK)
      val sumCosts = costs.sum()

      bcNewCenters.unpersist(blocking = false)
      preCosts.unpersist(blocking = false)

      val chosen = data.zip(costs).mapPartitionsWithIndex { (index, pointCosts) =>
        //**********To Be Returned
        val rand = new XORShiftRandom(seed ^ (step << 16) ^ index)
        //val rand = scala.util.Random
        pointCosts.filter { case (_, c) => rand.nextDouble() < 2.0 * c * globalK / sumCosts }.map(_._1)
      }.collect()
      newCenters = chosen.map(_.toDense)
      centers ++= newCenters
      step += 1
    }

    costs.unpersist(blocking = false)
    //bcNewCentersList.foreach(_.destroy(false))
    bcNewCentersList.foreach(_.destroy())

    //println("Centers Type:" + centers.getClass)
    //println("Centers Elements:" + centers)
    /*for (i<- 1 to centers.length) {
      println("i:" + i)
      println("Type: " + centers(i).getClass + ":" + centers(i))
    }*/

    val distinctCenters = centers.distinct //centers.map(_).distinct
    //.map(parseDVector(_)) //new Vector(_))

    //println("distinct Type: " + distinctCenters.getClass())
    //println("distinct Elements: " + distinctCenters)

    //distinctCenters.map (x=> println("Elemnt Type:" + x.getClass + " Value: " + x)

    if (distinctCenters.size <= globalK) {
      distinctCenters.toArray
    } else {
      // Finally, we might have a set of more than k distinct candidate centers; weight each
      // candidate by the number of points in the dataset mapping to it and run a local k-means++
      // on the weighted centers to pick k of them
      val bcCenters = data.context.broadcast(distinctCenters)
      val countMap = data.map(findClosest(bcCenters.value, _)._1).countByValue()

      //bcCenters.destroy(blocking = false)
      bcCenters.destroy()

      val myWeights = distinctCenters.indices.map(countMap.getOrElse(_, 0L).toDouble).toArray
      kMeansPlusPlus(0, distinctCenters.toArray, myWeights, globalK, 30)
    }
  }

  def parseDVector(p :Vector) : Array[Double] ={
    p.toArray
  }

  /**
    * Run K-means++ on the weighted point set `points`. This first does the K-means++
    * initialization procedure and then rounds of Lloyd's algorithm.
    */
  def kMeansPlusPlus(
                      seed: Int,
                      points: Array[Vector],
                      weights: Array[Double],
                      k: Int,
                      MaxIt: Int
                    ): Array[Vector] = {
    val rand = new Random(seed)
    val dimensions = points(0).size
    val centers = new Array[Vector](k)

    // Initialize centers by sampling using the k-means++ procedure.
    centers(0) = pickWeighted(rand, points, weights).toDense
    val costArray = points.map(ObjFun(_, centers(0)))

    for (i <- 1 until k) {
      val sum = costArray.zip(weights).map(p => p._1 * p._2).sum
      val r = rand.nextDouble() * sum
      var cumulativeScore = 0.0
      var j = 0
      while (j < points.length && cumulativeScore < r) {
        cumulativeScore += weights(j) * costArray(j)
        j += 1
      }
      if (j == 0) {
        println("kMeansPlusPlus initialization ran out of distinct points for centers." +
          s" Using duplicate point for center k = $i.")
        centers(i) = points(0).toDense
      } else {
        centers(i) = points(j - 1).toDense
      }

      // update costArray
      for (p <- points.indices) {
        costArray(p) = math.min(ObjFun(points(p), centers(i)), costArray(p))
      }

    }

    // Run up to MaxIt iterations of Lloyd's algorithm
    val oldClosest = Array.fill(points.length)(-1)
    var iteration = 0
    var moved = true
    while (moved && iteration < MaxIt) {
      moved = false
      val counts = Array.fill(k)(0.0)
      val sums = Array.fill(k)(Vectors.zeros(dimensions))
      var i = 0
      while (i < points.length) {
        val p = points(i)
        val index = findClosest(centers, p)._1
        // axpy a*x + y
        axpy(weights(i), p, sums(index))
        counts(index) += weights(i)
        if (index != oldClosest(i)) {
          moved = true
          oldClosest(i) = index
        }
        i += 1
      }
      // Update centers
      var j = 0
      while (j < k) {
        if (counts(j) == 0.0) {
          // Assign center to a random point
          centers(j) = points(rand.nextInt(points.length)).toDense
        } else {
          scal(1.0 / counts(j), sums(j))
          centers(j) = Vectors.dense(sums(j).toArray)//new Vector(sums(j))
        }
        j += 1
      }
      iteration += 1
    }

    if (iteration == MaxIt) {
      println(s"Local KMeans++ reached the max number of iterations: $MaxIt.")
    } else {
      println(s"Local KMeans++ converged in $iteration iterations.")
    }

    centers
  }

  private def pickWeighted[T](rand: Random, data: Array[T], weights: Array[Double]): T = {
    val r = rand.nextDouble() * weights.sum
    var i = 0
    var curWeight = 0.0
    while (i < data.length && curWeight < r) {
      curWeight += weights(i)
      i += 1
    }
    data(i - 1)
  }

}

case class MOPSO(kout: Int, nvar: Int ) {
  //var k : Int=  0
  val k :Int = kout
  var p : Array[Vector] = new Array[Vector](k)        //= new Array[Vector](k)
  //var v :Array[Vector] = new Array[Vector](k)
  var fit : ListBuffer[Double]  = new ListBuffer[Double]
  //var bp :Array[Vector] =  new Array[Vector](k)
  //var bv :Array[Vector] = new Array[Vector](k)      //: Array[Vector]
  var bfit : ListBuffer[Double]  = new ListBuffer[Double]
  var Nobj : Int = nvar

  def CopyObj(): MOPSO =
  {
    val obj = new MOPSO(this.k, this.nvar)
    obj.p = this.p        //= new Array[Vector](k)
    //obj.v = this.v
    obj.fit = this.fit
    //obj.bp = this.bp
    //obj.bv  = this.bv      //: Array[Vector]
    obj.bfit  = this.bfit
    obj.Nobj= this.Nobj
    return obj
  }

}

class MOFMEval(kout: Int) {
  //var k : Int=  0
  val k :Int = kout
  var Points :ListBuffer[Row]= new ListBuffer[Row]
  var CountCluster = new Array[Int](k)        //= new Array[Vector](k)
  var RepClass : Int  = -1
  var CountClusterSorted = mutable.ListMap[Int, Int]()
  var MapCount = scala.collection.mutable.Map[Int, Int]()

}




