import scala.collection.mutable.ListBuffer
import java.io.BufferedReader
import java.io.FileInputStream
import java.io.FileNotFoundException
import java.io.IOException
import java.io.InputStream
import java.io.InputStreamReader
import java.util
import java.util.Comparator
import java.util.StringTokenizer
import scala.util._


class Point(numberOfObjectives : Int)
{
  var values: ListBuffer[Double] = new ListBuffer[Double]
  var Obj: Int = numberOfObjectives
  def Point( Obj: Int) =
  {
    this.Obj = Obj
  }

  def compare( pointOne : Point, pointTwo : Point) : Int =
  {
    if (pointOne ==  null) {
      throw new Exception("PointOne is null") ;
    } else if (pointTwo == null) {
      throw new Exception("PointTwo is null");
    }

    // Determine the first i such as pointOne[i] != pointTwo[i];
    var index : Int = 0;
    while ((index < pointOne.Obj)
      && (index < pointTwo.Obj)
      && pointOne.values(index) == pointTwo.values(index)) {
      index+= 1
    }

    var result : Int = 0 ;
    if ((index >= pointOne.Obj) || (index >= pointTwo.Obj)) {
      result = 0;
    } else if (pointOne.values(index) < pointTwo.values(index)) {
      result = -1;
    } else if (pointOne.values(index) > pointTwo.values(index)) {
      result = 1;
    }
    return result ;
  }
}

object PFValues
{

  def main(args: Array[String]): Unit = {
    ReadFile("/home/amr/Downloads/Pareto Front Values/UF/UF1.pf")


  }

  var PF : ListBuffer[Point] = new ListBuffer[Point]

  def ReadFile(fileName: String) : ListBuffer[Point] =
  {
    //fileName = "/home/amr/Downloads/Pareto Front Values/UF/UF1.pf"
    //var inputStream : InputStream = createInputStream(fileName) ;
    var inputStream : InputStream = createInputStream(fileName) ;

    var isr : InputStreamReader = new InputStreamReader(inputStream);
    var br : BufferedReader = new BufferedReader(isr);

    //List<Point> list = new ArrayList<>();

    try
    {
      var nObj : Int = 0
      var aux : String = ""

      aux = br.readLine();

      while (aux != null)
      {
        var tokenizer : StringTokenizer  = new StringTokenizer(aux);
        var i : Int  = 0;
        if (nObj == 0)
        {
          nObj = tokenizer.countTokens();
        }
        else if (nObj != tokenizer.countTokens())
        {
          throw new Exception("Invalid number of points read. "
            + "Expected: " + nObj + ", received: " + tokenizer.countTokens()) ;
        }

        var point : Point  = new Point(nObj) ;
        while (tokenizer.hasMoreTokens())
        {
          var value : Double  = tokenizer.nextToken().toDouble    //new Double(tokenizer.nextToken());
          //point.setDimensionValue(i, value);
          point.values += value
          i += 1;
        }
        //list.add(point);
        PF += point
        aux = br.readLine();
      }
      br.close();
    }
    catch
    {
     case (e: IOException) =>
      {
        throw new Exception("Error reading file", e);
      }
      case ( e: NumberFormatException ) =>
      {
        throw new Exception("Format number exception when reading file", e);
      }
    }

    val numberOfPoints : Int = PF.length;

    return PF

  }

  def createInputStream(fileName : String) : InputStream =
  {
    var inputStream : InputStream  = getClass().getResourceAsStream(fileName);
    if (inputStream == null)
    {
      inputStream = new FileInputStream(fileName) ;
    }

    return inputStream ;
  }






}
