
import java.io.{BufferedWriter, File, FileWriter}

import scala.math.BigDecimal
import java.util

import org.apache.spark.sql.{DataFrame, SparkSession}
import org.apache.spark._
import org.apache.spark.util.Utils

import scala.collection.JavaConverters._
import java.util.Random

import breeze.linalg.squaredDistance.Impl2
import breeze.linalg.{DenseVector, ZippedValues, min, squaredDistance, zipValues}
import org.apache.spark.broadcast.Broadcast

import scala.math.exp
import scala.collection.mutable.{ArrayBuffer, HashMap, HashSet, ListBuffer}
import org.apache.spark.mllib.clustering.{KMeans, KMeansModel}
import org.apache.spark.rdd._
import org.apache.spark.mllib.linalg.{DenseVector, SparseVector, Vector, Vectors}
import org.apache.spark.ml.linalg.SparseVector
//import BLAS._
import WhaleFun.{dim, lb, ub}
import org.apache.spark.sql.types.{DoubleType, IntegerType}

import scala.collection.mutable
//import PSOTSKM.findClosest
//import PSOTSKM.AdjustMaxandMin
import org.apache.spark.storage.StorageLevel
import XORShiftRandom._
import org.apache.spark.mllib.linalg
import org.apache.spark.sql.Row
import org.apache.spark.sql.types.{StructType,StructField,StringType}
import scala.util.control.Breaks._
import org.apache.spark.sql.functions._
//import scala.util.control.BreakControl

object PSOTS {

  var globalK: Int = 0
  //var m_quantile : Double = 0.0
  var quantileInt = new ListBuffer[Double]()
  var quantileDiv = new ListBuffer[Double]()
  var str_ObjFun : String = "F1"
  var WorestFit : Double = Double.MinValue
  var UpdateFun : String = "PSO"//"Whale"//"PSO"


  def WriteToFile(str: ListBuffer[String]):Unit=
  {
    val ResultPath = "/home/amr/Downloads/result.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      str.foreach(x => bw.write(x))
    }
    finally bw.close()

  }

  def WriteToFile(str: String, Sep : Boolean = false):Unit=
  {
    val ResultPath = "/home/amr/Downloads/result.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      if (Sep == true)
      {bw.newLine()}
      bw.write(str)
    }
    finally bw.close()

  }




  def ClusterAlgo(k :Int = 1, VelMin: ListBuffer[Double], VelMax: ListBuffer[Double],
                  minCol: ListBuffer[Double], maxCol:ListBuffer[Double], d : Int)
  : (Double) =
  {
    //,ListBuffer[Double]
    //var n: Long = data.count()
    var epsilon: Double = 1e-4
    WorestFit = Double.MinValue
    val Np = 30  //Number of particles
    val max_TL = 23
    val max_EL = 11
    var Index_TL = 0
    var TL : ListBuffer[PSONoKM] = new ListBuffer[PSONoKM] //(max_TL)    // Tabu List
    var EL : ListBuffer[PSONoKM] = new ListBuffer[PSONoKM]//(max_EL)    // Elite List
    var EL_V : Array[Vector] =  new Array[Vector] (max_EL)  // Best Velocities
    val MaxIt = 500
    var BestFit = Double.PositiveInfinity
    var Population : ListBuffer[PSONoKM] = new ListBuffer[PSONoKM]//(Np)

    var BestCenters : ListBuffer[Double] = new ListBuffer[Double]
    //globalK = k

    //data.cache()

    var iteration = 0
    var NoProgress = 1

    var max_NoProgress = 3
    if ( UpdateFun == "PSO")
    {max_NoProgress = 3}
    else if (UpdateFun == "Whale")
    { max_NoProgress = 17  }

    var b_IorD: String = "0"
    val c1 = 0.5//.1  // Internal experience
    val c2 = 1.9    //best position
    val w_max = 0.2
    val w_min = -0.2//.1
    var half:Double = 0
    var w:Double = 0
    val rand = new scala.util.Random()
    var centers: ListBuffer[Double] = new  ListBuffer[Double]

    println("VelMin: " + VelMin)
    for (i <- 0 until Np)
    {
      println("i :" + i)
      centers = RandPop(k, d, maxCol, minCol).clone()
      centers = AdjustMaxandMin(centers, minCol, maxCol).clone()
      val obj = new PSONoKM(k)

      //val (cost, newCenters) = RecCenters(data, data.sparkContext, centers)
      obj.p = centers.clone()
      val cost = WhaleFun.ObjFun(str_ObjFun, centers)
      obj.fit = cost
      obj.bp = obj.p.clone()
      //obj.v = Array.fill(k)(Vectors.zeros(d))//RandVel(k, d, maxCol, minCol).clone()
      obj.v = RandVel(k, d, maxCol, minCol).clone()
      obj.v = AdjustMaxandMin(obj.v.clone, VelMin, VelMax).clone()
      obj.bfit = obj.fit

      if (obj.fit < BestFit )
      {
        BestFit = obj.fit
        BestCenters = obj.p.clone()
      }

      if ( obj.fit > WorestFit)
      {
        //Add2TL(TL, obj, max_TL, Index_TL)
        TL= Add2TLOrdered(TL, obj, max_TL)
        Index_TL +=1
        Index_TL = Index_TL % max_TL
        WorestFit = obj.fit
      }

      EL = Add2EL(EL, obj, max_EL)
      println("iiiii = " + i)
      Population += obj.CopyObj()
    }


    var PrevIntenseFit=Double.PositiveInfinity
    var PrevFit = Double.PositiveInfinity
    var VelRand : Int = rand.nextInt(2)
    Index_TL = -1
    var d_Arr: ListBuffer[Int]  = new ListBuffer[Int]

    var i_Diverse : Int = 0
    var i_Intense : Int = 0
    var i_stIntense : Int = 0
    var i_ndIntense : Int = 0
    var i_stDiverse : Int = 0
    var i_ndDiverse : Int = 0

    var b_stIntense : Boolean = false
    var b_ndIntense : Boolean = false
    var b_stDiverse : Boolean = false
    var b_ndDiverse : Boolean = false
    var index_EL = rand.nextInt(EL.length)
    var deltarand : Int =0
    var  ntemp : ListBuffer[Int] = new ListBuffer[Int]
    var a : Double = 0.0
    var a2 : Double = 0.0
    var rand_leader_index : Int = 0
    var prand = rand.nextDouble(); // p in Eq. (2.6)

    while (iteration < MaxIt) {
      w = w_min + ((w_max - w_min) *
        ((MaxIt.asInstanceOf[Double] - iteration.asInstanceOf[Double]) / MaxIt.asInstanceOf[Double]))

      a=2-iteration*((2)/MaxIt)
      a2 = -1+iteration*((-1)/MaxIt)

      if (b_IorD == "1" | b_IorD == "11") //( b_IntenseFactor == TRUE )//(it%% 5  == 0)
      {
        i_Intense = i_Intense + 1
        deltarand = (Np/4).asInstanceOf[Int] //rand.nextInt( (Np/2).asInstanceOf[Int])
        if ( deltarand > EL.length)
        {deltarand = EL.length }
        if (deltarand == 0) { deltarand = 1 }
        ntemp = GenRandList(Np, deltarand )

        print("intense")

        if (b_IorD == "11") //(PrevIntenseFit == ReturnFit)
        {
          for (m <- 0 until ntemp.length) {
            Population(ntemp(m)) = EL(rand.nextInt(2)).CopyObj()
          }
          //Population = InstensifyFun(Population, Np, minCol, maxCol)
          Population = CrossOverElite(Population , EL)
          //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, BestCenters, EL)

          b_stIntense = true
        }
        else if (b_IorD == "1")
        {
          //for (m <- 0 until ntemp.length) {
          // Population(ntemp(m)) = EL(m).CopyObj()
          //}
          //Population = CrossOverElite(Population , EL)
          Population = InstensifyEliteFun(Population, Np, minCol, maxCol, BestCenters, EL)
          b_ndIntense = true
        }
      }
      else if (b_IorD == "2" | b_IorD == "21")
      {
        i_Diverse = i_Diverse + 1
        if (b_IorD == "21") {
          print("diverse 21")
          Population = CrossOverFun(Population)
          //Population = CrossOverTabu(Population , TL, EL)
          b_stDiverse = true
        }

        else if (b_IorD == "2")
        {
          print("diverse 2")
          /*
          for (m <- 0 until ntemp.length) {
            Population(ntemp(m)) = EL(m).CopyObj()
          }*/

          Population = CrossOverTabu(Population , TL, EL)
          //Population = DiversifyFun(Population, Np, minCol, maxCol)
          b_ndDiverse = true
        }
      }
      else if(b_IorD == "22")
      {
        var d_Num: Int = (Np / 5).asInstanceOf[Int]//rand.nextInt(math.round(Np / 5).asInstanceOf[Int]) //base::sample(length(TL)/2, 1)
        if (d_Num == 0) {
          d_Num = 1
        }
        d_Arr = GenRandList(Np, d_Num)
      }

      PrevIntenseFit = BestFit

      println("Before Particles")

      prand = rand.nextDouble(); // p in Eq. (2.6)
      index_EL = rand.nextInt(2)

      for ( g <- 0 to Np-1)
      {

        val r1= rand.nextDouble() //RandCof(k, d, maxCol, minCol).clone()  //runif(1,0,1)
        val r2 = rand.nextDouble()//rand.nextGaussian() //RandCof(k, d, maxCol, minCol).clone()

        if ( UpdateFun == "PSO" )
        {

          if (b_IorD == "22") //(it%% 5  == 0)
          {
            if (d_Arr.contains(g) == false) {
              //val velTemp = ComputeVel(Population((g)).bp, Population((g)).p, Population((g)).v,
              //EL(index_EL).p, c1, c2, r1, r2, 0.6).clone()

              // Apply Velocity Limits
              //Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
              //Population(g).v = velTemp.clone()

              Population(g).p = Add2Vec(Population(g).p, EL(index_EL).v, "+").clone()
            }
            else {
              if (TL.length > 0) {
                Population((g)).p = TL(rand.nextInt(TL.length)).p.clone()

                val velTemp = ComputeVel(BestCenters, Population((g)).p, Population((g)).v,
                  EL(index_EL).p, c1, c2, r1, r2, w)

                // Apply Velocity Limits
                Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
                //Population(g).v = velTemp.clone()

                Population(g).p = Add2Vec(Population(g).p, Population((g)).v, "+").clone()
              }
            }
          }
          else if (b_IorD == "00" | b_IorD == "0" | b_IorD == "01" | b_IorD == "02" | b_IorD == "10" | b_IorD == "110" | b_IorD == "210" | b_IorD == "20") {
            //print("normal")

            val velTemp = ComputeVel(Population(g).bp, Population(g).p, Population(g).v,
              EL(index_EL).p, c1, c2, r1, r2, w)

            // Apply Velocity Limits
            Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
            //Population(g).v = velTemp.clone()

            // Update Position
            Population((g)).p = Add2Vec(Population(g).p, Population((g)).v, "+").clone()
            //Population((g)).P = Population((g)).P + Population((g)).V
          }
        }
        else if ( UpdateFun == "Whale" )
        {
          // r1 is a random number in [0,1]
          // r2 is a random number in [0,1]
          //prand = rand.nextDouble(); // p in Eq. (2.6)
          //index_EL = 0//rand.nextInt(4)

          val A: Double = 2 * a * r1 - a; // Eq. (2.3) in the paper
          val C: Double = 2 * r2; // Eq. (2.4) in the paper
          val b = 1.0; //  parameters in Eq. (2.5)
          val l = (a2 - 1) * rand.nextDouble() + 1; //  parameters in Eq. (2.5)

          if (prand < 0.5)
          {
            if (math.abs(A) >= 1)
            {

              rand_leader_index = rand.nextInt(Np)//math.floor(Np * rand.nextDouble() ).asInstanceOf[Int]

              Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                EL(index_EL).p, C, A, prand, b, l).clone()
            }
            else if (math.abs(A) < 1) {
              Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                EL(index_EL).p, C, A, prand, b, l).clone()
            }
          }

          else if(prand >= 0.5)
          {
            Population(g).p = ComputeVelWhale(Population(0).p, Population(g).p,
              EL(index_EL).p, C, A, prand, b, l).clone()
          }
        }





        //We need to optimize the velocity to allow the swarm to migrate effectively
        //We need to keep track of the velocity and best values of it
        //Enhancement is obtained by executing the best velocity
        //Diversification is applied by increasing the velocity to explore far regions



        println("Evaluation")

        Population(g).p = AdjustMaxandMin(Population(g).p, minCol, maxCol).clone()
        // Evaluation
        //val (cost, newCenters) = RecCenters(data, data.sparkContext, Population(g).p)
        //Population((g)).p = newCenters.clone()
        //Population((g)).fit = cost

        val cost = WhaleFun.ObjFun(str_ObjFun, Population(g).p)
        Population(g).fit = cost

        // Update Personal Best
        if (Population(g).fit < Population(g).bfit)
        {
          Population((g)).bp = Population(g).p.clone()
          Population((g)).bv = Population(g).v.clone()
          Population((g)).bfit= Population(g).fit

          if (b_stIntense == true)
          {
            i_stIntense = i_stIntense + 1
            b_stIntense = false
          }
          if (b_ndIntense == true)
          {
            i_ndIntense = i_ndIntense + 1
            b_ndIntense = false
          }
          if (b_stDiverse == true)
          {
            i_stDiverse = i_stDiverse + 1
            b_stDiverse = false
          }
          if (b_ndDiverse  == true)
          {
            i_ndDiverse = i_ndDiverse + 1
            b_ndDiverse = false
          }
        }

        if ( Population((g)).fit > WorestFit)
        {
          //Add2TL(TL, Population((g)), max_TL, Index_TL)
          TL = Add2TLOrdered(TL, Population((g)), max_TL)
          Index_TL +=1
          Index_TL = Index_TL % max_TL
          WorestFit = Population((g)).fit
        }


        if (EL.length == max_EL)
        {
          if (Population(g).fit < EL(max_EL-1).fit )
          {
            EL = Add2EL(EL, Population(g), max_EL)
          }
        }
        else if (EL.length < max_EL) {
          EL = Add2EL(EL, Population(g), max_EL)
        }

        //EL = Add2EL(EL, Population(g), max_EL)

        if (Population(g).fit < BestFit)
        {
          BestFit = Population((g)).fit
          BestCenters = Population((g)).p.clone()

          if (b_stIntense == true)
          {
            i_stIntense = i_stIntense + 1
            b_stIntense = false
          }
          if (b_ndIntense == true)
          {
            i_ndIntense = i_ndIntense + 1
            b_ndIntense = false
          }
          if (b_stDiverse == true)
          {
            i_stDiverse = i_stDiverse + 1
            b_stDiverse = false
          }
          if (b_ndDiverse  == true)
          {
            i_ndDiverse = i_ndDiverse + 1
            b_ndDiverse = false
          }

        }

      }

      println("Adjustments")

      if (PrevIntenseFit == BestFit)
      {
        if ( b_IorD == "11" )
        {
          b_IorD = "01"
          NoProgress = 0//max_NoProgress-1
        }
        else if ( b_IorD == "1" )
        {
          b_IorD = "11"
          NoProgress = 0 //max_NoProgress-1
        }
        else if ( b_IorD == "22" )
        {
          b_IorD = "02"
          NoProgress =  0 //max_NoProgress - 1
        }
        else if ( b_IorD == "21" )    //(it%% 5  == 0)
        {
          if ( UpdateFun == "PSO")
          {b_IorD = "22"}
          else if (UpdateFun == "Whale")
            { b_IorD = "02"  }
          NoProgress =0
        }
        else if ( b_IorD == "2" )    //(it%% 5  == 0)
        {
          b_IorD = "21"
          NoProgress =0
        }
      }
      else
      {
        PrevIntenseFit = BestFit
        NoProgress = NoProgress - 1
        if (NoProgress < 0)
        {NoProgress= 1 }
      }

      if (PrevFit == BestFit)
      {
        NoProgress = NoProgress + 1
        if ( NoProgress >= max_NoProgress)
        {
          NoProgress = 1
          if ( b_IorD == "0"  )
          { b_IorD = "1"     }

          else if ( b_IorD == "01" )
          {  b_IorD = "00"  }

          else if ( b_IorD == "00"  )
          {  b_IorD = "2"      }

          else if ( b_IorD == "02"  )
          {  b_IorD = "0"     }
          //b_IorD = (b_IorD + 1) %% 3
        }
      }
      else
      {
        PrevFit = BestFit
        NoProgress = 1
      }

      iteration = iteration + 1
    }

    if (EL(0).fit <  BestFit )
    {
      BestFit = EL(0).fit
      BestCenters = EL(0).p.clone()
    }

    if (EL(0).bfit <  BestFit )
    {
      BestFit = EL(0).bfit
      BestCenters = EL(0).bp.clone()
    }

    //BestCenters.foreach(x=> println(x))
    //data.unpersist()
    /*val iterationTimeInSeconds = (System.nanoTime() - iterationStartTime) / 1e9 / 60
    println(f"Iterations took $iterationTimeInSeconds%.3f minutes.")
    println("Number of iterations :" + (iteration))
    println("K :" + k)
    println("BestFit :" + BestFit)
    println("Fit :" + (BestFit * n))
    println("Difference :" + (((BestFit * n) - StandardObj) / StandardObj).formatted("0.00000") )*/

    //WriteToFile("Function : " +str_ObjFun,true)
    /*WriteToFile("Intensification: " + i_Intense, true)
    WriteToFile("Diversification: " +i_Diverse)
    WriteToFile("First Intense Improvement: " +i_stIntense,true)
    WriteToFile("Second Intense Improvement: " +i_ndIntense,true)
    WriteToFile("First Diverse Improvement: " +i_stDiverse,true)
    WriteToFile("Second Diverse Improvement: " +i_ndDiverse,true)
    WriteToFile("BestFit : " + BestFit,true)*/

    //(BestFit, BestCenters)
    BestFit

  }

  def ComputeVelWhale(Randp :ListBuffer[Double], p:ListBuffer[Double], EL: ListBuffer[Double],
                      C: Double, A: Double, prand: Double, b : Double, l: Double  ): ListBuffer[Double] =
  {
    val rand = new scala.util.Random()
    var Vec : ListBuffer[Double] = new ListBuffer[Double]

    //X_rand = Positions(rand_leader_index,:);
    //D_X_rand = abs(C * X_rand(j) - Positions(i, j));
    // Eq .(2.7)
    //Positions(i, j) = X_rand(j) - A * D_X_rand;
    var distance2Leader : Double = 0.0
    for (h <- 0 until p.length)
    {
      if (prand < 0.5 ) {
        if (math.abs(A) >= 1) {
          //if (p(0) != null & p.length > 0)
          Vec += Randp(h) - A * math.abs(C * Randp(h) - p(h))
        }
        else if (A < 1) {
          //D_Leader = abs(C * Leader_pos(j) - Positions(i, j));  // Eq .(2.1)
          //Positions(i, j) = Leader_pos(j) - A * D_Leader;     // Eq.(2.2)
          Vec += EL(h) - A * math.abs(C * EL(h) - p(h))
        }
      }
      else if ( prand >= 0.5 )
      {
        //distance2Leader=abs(Leader_pos(j)-Positions(i,j));
        // Eq. (2.5)
        //Positions(i,j)=distance2Leader*exp(b.*l).*cos(l.*2*pi)+Leader_pos(j);

        distance2Leader = math.abs(EL(h) - p(h)); // Eq. (2.5)
        Vec += distance2Leader*math.exp(b*l)* math.cos(l*2* math.Pi) + EL(h);
      }
    }

    Vec
  }



  def main(args: Array[String]): Unit = {

    var b_Run : Boolean = true

    WriteToFile("/////////////",true)
    WriteToFile(UpdateFun,true)

    for ( u<- 1 to 23)
    {
      str_ObjFun = "F"+u
      RunWhale()
    }


    //RunCluster(2)
    //Normalization
    //Randomizing the data objects in dataset
    for (kloop<- 10 to 7 by -1)
    {
      println(kloop)
    }

  }

  def RunWhale() =
  {
    val(lb, ub, d) =  WhaleFun.GetFunDetail(str_ObjFun)

    //- exception.length
    var maxCol = new ListBuffer[Double]()
    if (ub.length <= 1) {
      for (i <- 0 until d) {
        maxCol += ub(0).asInstanceOf[Double]
      }
    }
    else{
      for (i <- 0 until ub.length) {
        maxCol += ub(i).asInstanceOf[Double]
      }
    }


    println("maxCol:" + maxCol)

    var minCol = new ListBuffer[Double]()
    if (lb.length <= 1) {
      for (i <- 0 until d) {
        minCol += lb(0).asInstanceOf[Double]
      }
    }
    else{
      for (i <- 0 until lb.length) {
        minCol += lb(i).asInstanceOf[Double]
      }
    }
    println("minCol:" + minCol)

    quantileInt.clear()
    quantileDiv.clear()

    for (i <- 0 until d)
    {
      //quantileInt += ( minCol(i) +  ( (maxCol(i) - minCol(i)) / 5 ) )
      quantileInt += ( ( (maxCol(i) - minCol(i)) / 3 ) )

      //quantileDiv  +=  ( minCol(i) +  ( ( maxCol(i) - minCol(i) ) / 3) )
      quantileDiv  +=  ( ( ( maxCol(i) - minCol(i) ) / 2) )

    }
    println("quantileInt :" + quantileInt)

    var VelMax = new ListBuffer[Double]()
    for (i <- 0 until d) {
      VelMax += ((maxCol(i) - minCol(i)) / 3 )  // 3
      //VelMax += quantileInt(i)
    }
    println("VelMax: " + VelMax)

    var VelMin = new ListBuffer[Double]()
    for (i <- 0 until d) {
      VelMin += (-1 * VelMax(i))
    }
    println("VelMin: " + VelMin)

    var result: ListBuffer[Double] = new ListBuffer[Double]
    for ( j<- 0 until 30 )
    {
      result += ClusterAlgo(1, VelMin, VelMax, minCol, maxCol, d)
    }

    WriteToFile("Function : " + str_ObjFun ,true)
    WriteToFile("Average Fit : " + sum(result) / result.length ,true)
    WriteToFile("Standard Deviation : " + std(result) ,true)

  }

  def sum(a : ListBuffer[Double]) : Double =
  {
    var sum : Double = 0.0
    for ( x <- 0 until a.length)
    {
      sum = sum + a(x)
    }
    return sum
  }

  def std(a : ListBuffer[Double]) : Double =
  {
    val mean : Double = sum(a) / a.length.asInstanceOf[Double]
    var tList = new ListBuffer[Double]()
    for ( x <- 0 until a.length)
    {
      tList += math.pow(a(x) - mean , 2)
      //sum = sum + a(x)
    }

    return math.sqrt(sum(tList) / a.length.asInstanceOf[Double])
  }

  def ComputeVel(bp :ListBuffer[Double] , p:ListBuffer[Double], v:ListBuffer[Double], EL: ListBuffer[Double],
                 c1: Double , c2: Double, r1: Double, r2 : Double, w: Double ): ListBuffer[Double] =
  {

    val result : Array[Vector] = new Array[Vector](p.length)
    val rand = new scala.util.Random()
    var t1: Double = 0.0
    var t2: Double = 0.0
    var r3: Double = 0.0
    var r4: Double = 0.0
    var Vec : ListBuffer[Double] = new ListBuffer[Double]

    for (h <- 0 until p.length)
    {

      r3 = rand.nextGaussian()
      r4 = rand.nextDouble()
      t1 = c1 * r3
      t2 = c2 * r4

      if (v(0) != null & v.length > 0) {
        Vec += ((w * v(h)) +
          (t1 * (bp(h) - p(h))) +
          (t2 * (EL(h) - p(h))))

        // Vec +=   w *   t2 *  (EL(h) - p(h) )

      }
      else {
        Vec += ((t1 * (bp(h) - p(h))) +
          (t2 * (EL(h) - p(h))))
      }
    }

      //result.update(h,  Vectors.dense(Vec).copy)

      /*Population((h)).v <- Vectors.dense(
      ( (iteration / MaxIt)  * Population((h)).v.toArray ) +
        ( (c1*r1)*(Population((h)).bp.toArray - Population((h)).p.toArray)) +
        ((c2*r2)*(EL(0).p.toArray-Population((h)).p.toArray)) )*/

    Vec
  }


  def Add2Vec(p1:  ListBuffer[Double], p2:  ListBuffer[Double], op:String ) :  ListBuffer[Double] =
  {
    //val result : Array[Vector] = new Array[Vector](p1.length)
    //var Vec: Array[Double] = p1(1).toArray
    var Vec : ListBuffer[Double] = new ListBuffer[Double]

    for (i<- 0 until p1.length)
    {
      //for ( j <- 0 until p1.head.size)
      {
        if (op == "+")
        { Vec += (p1(i) + p2(i)) }
        else if (op == "-")
        { Vec += (p1(i) - p2(i)) }
        else if (op == "*")
        { Vec += (p1(i) * p2(i)) }
        else if (op == "/")
        { Vec += (p1(i) / p2(i)) }
      }

      //val  Vec = p1(i).zip(p2(i)).map { case (x, y) => x + y }}

      //result.update(i, Vectors.dense(Vec).copy)
    }
    Vec
  }


  //CrossOver_fun
  def CrossOverFun(Population : ListBuffer[PSONoKM]) : ListBuffer[PSONoKM] =
  {

    val d = Population(1).p.length
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = math.round(0.4 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    val rand = new scala.util.Random()

    for (p <- 0 until delta_P)
    {
      val delta_Row = math.round(r * 0.5).asInstanceOf[Int]  //base::sample(r,1)
      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {
        if ( rand_P(p) < Population.length-1 )
        {
          //////////P
          val t1 = Population( (rand_P(p)+1) ).p(rand_Row(i))

          Population(rand_P(p)+1) .p(rand_Row(i))  = Population(( rand_P(p) )).p(rand_Row(i))

          Population(( rand_P(p) )).p(rand_Row(i)) = t1

        }
        else{
          //////////P
          val t1 = Population(( rand_P(p) )).p(rand_Row(i))

          Population(( rand_P(p) )).p(rand_Row(i)) = Population(( (rand_P(p)-1) )).p(rand_Row(i))

          Population(( (rand_P(p)-1) )).p(rand_Row(i)) = t1

        }
      }
    }

    Population

  }

  //CrossOver Tabu List
  def CrossOverTabu(Population : ListBuffer[PSONoKM], TL: ListBuffer[PSONoKM], EL: ListBuffer[PSONoKM]) : ListBuffer[PSONoKM] =
  {

    val d = Population(1).p.length
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    val rand = new scala.util.Random()
    var EL_Index : Int =0 //rand.nextInt(2)
    EL_Index = rand.nextInt(2)
    for (p <- 0 until delta_P)
    {
      val delta_Row = math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      val index_TL  = rand.nextInt(TL.length)

      //Population(rand_P(p)).p = EL(EL_Index).p.clone()//EL(rand.nextInt(2)).p.clone()

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)).p(rand_Row(i))  = TL(index_TL).p(rand_Row(i))
      }
    }

    Population

  }

  //CrossOver Elite List
  def CrossOverElite(Population : ListBuffer[PSONoKM], EL: ListBuffer[PSONoKM]) : ListBuffer[PSONoKM] =
  {

    val d = Population(1).p.length
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = math.round(0.7 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    val rand = new scala.util.Random()



    for (p <- 0 until delta_P)
    {
      val delta_Row = math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      val index_EL  = rand.nextInt(2)

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)).p(rand_Row(i))  = EL( index_EL ).p(rand_Row(i))

        //////////V
        //Population(( (rand_P(p)) )).v(rand_Row(i)) =
        //Vectors.dense(EL( index_EL ).v(rand_Row(i)).toArray)

        //////////BP
        //Population(( (rand_P(p)) )).bp(rand_Row(i)) =
        //Vectors.dense(EL( index_EL ).bp(rand_Row(i)).toArray)

      }
    }

    Population

  }

  //Intensification To Elite
  def InstensifyEliteFun(Population: ListBuffer[PSONoKM],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double],
                         BestCenters : ListBuffer[Double], EL: ListBuffer[PSONoKM]) :
  ListBuffer[PSONoKM] = {

    val d = Population(1).p.length
    val r=1//Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P =Np //math.round(0.6 * Np).asInstanceOf[Int] //  math.round(0.6 * Np).asInstanceOf[Int]
    val rand_P = Array.range(0 , Np)
    //val rand_P = GenRandList(Np, delta_P)
    val rand = new scala.util.Random()
    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : Array[Int] = new Array[Int](d)
    var delta_Row = 0
    var delta_Col = 0
    //delta_Row = r
    //rand_Row=c(1:r)

    val index_EL = rand.nextInt(2)

    var newVal :Double =0.0
    for (p <- 0 until delta_P)
    {
     /* delta_Row =  rand.nextInt(r) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]
      */

      //for ( i <- 0  until delta_Row)
      //{
        delta_Col =  d//rand.nextInt(d) //d// //base::sample(d,1) //d
        //if (delta_Col < (d/2) )
        //{ delta_Col = d }
        rand_Col = Array.range(0 , delta_Col) //GenRandList(d, delta_Col) //new ListBuffer[Int]

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)
        var rval = rand.nextDouble()

        for (j <- 0  until delta_Col)
        {
          oldVal = Population(rand_P(p)).p(rand_Col(j))
          //x= rand.nextInt(2)//base::sample(2,1)
          rval = rand.nextDouble()
          //if (rval < 0.5)
          //{     rval = rval + 0.5     }

          temp = 0
          newVal= oldVal
          //OLD Method start
          //if (oldVal  > BestCenters(rand_Row(i)).toArray(rand_Col(j)) )
          if (oldVal  > EL(index_EL).p(rand_Col(j)) )
          {
            //val temp =  0.0001 * runif(1,0,1) * ( oldVal -  VarMin[1,rand_Col[j]])
            temp = rval * ( oldVal -   EL(index_EL).p(rand_Col(j)) )
            newVal= oldVal - temp
          }
          //else if (oldVal  < BestCenters(rand_Row(i)).toArray(rand_Col(j)) )
          else if (oldVal  < EL(index_EL).p(rand_Col(j)) )
          {
            temp =   rval * (  EL(index_EL).p(rand_Col(j)) -  oldVal )
            newVal= oldVal + temp
          }


          Population(rand_P(p)).p((rand_Col(j))) = newVal

        }
      //}
      // Apply Position Limits
      //Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  //Intensification Function
  def InstensifyFun(Population: ListBuffer[PSONoKM],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[PSONoKM] = {

    val d = Population(1).p.length
    val r=1 //Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = Np //math.round(0.6 * Np).asInstanceOf[Int] // Np
    //val rand_P = Array.range(0 , Np)
    val rand_P = (0 to Np).toArray //GenRandList(Np, delta_P)
    val rand = new scala.util.Random()
    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row = 0
    var delta_Col = 0
    //delta_Row = r
    //rand_Row=c(1:r)
    var newVal :Double =0.0
    for (p <- 0 until delta_P)
    {
      /*delta_Row =  rand.nextInt(r) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]
      */
      //for ( i <- 0  until delta_Row)
      {
        delta_Col = d //rand.nextInt(d) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        for (t<- 0 until d)
          {
            rand_Col += t
          }
        // (0 to (d-1)).toArray//GenRandList(d, delta_Col) //new ListBuffer[Int]

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0  until delta_Col)
        {
          oldVal = Population(rand_P(p)).p((rand_Col(j)))
          x= rand.nextInt(2)//base::sample(2,1)
          temp = 0
          newVal = oldVal

          /*var rval = rand.nextDouble()
          if (rval < 0.5)
          {     rval = rval + 0.5     }*/

          //OLD Method start
          if (x  == 1 )
          {
            //val temp =  0.0001 * runif(1,0,1) * ( oldVal -  VarMin[1,rand_Col[j]])
            temp =   rand.nextDouble() * ( ( oldVal -  VarMin(rand_Col(j) ) ) )
            newVal= oldVal - temp
          }
          else
          {
            temp = rand.nextDouble() * (( VarMax(rand_Col(j)) - oldVal) )
            newVal= oldVal + temp
          }

          Population(rand_P(p)).p((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  def DiversifyFun(Population: ListBuffer[PSONoKM],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[PSONoKM] = {

    val rand = new scala.util.Random()
    val d = Population(1).p.length
    val r = 1//Population(1).p.length //nrow(Population[[1]]$P)
    val delta_P = math.round(0.5 * Np).asInstanceOf[Int] //round(0.7*Np)
    var rand_Row: ListBuffer[Int]  = new ListBuffer[Int]()
    var delta_Col = 0
    var rand_Col: ListBuffer[Int] = GenRandList(d, 1)
    //var temp_Rand : Int = 0
    //var rand_P: ListBuffer[Int] = new ListBuffer[Int]
    val rand_P : ListBuffer[Int] = GenRandList(Np, delta_P)
    var delta_Row = 0
    var newVal: Double = 0.0
    var oldVal = 0.0
    var x = 0
    var temp = 0.0

    for (p <- 0 until delta_P) {

      /*delta_Row = math.round(0.3 * r).asInstanceOf[Int]//rand.nextInt(r) //base::sample(r,1) //r
      if (delta_Row == 0 ) { delta_Row = 1}
      rand_Row = GenRandList(r, delta_Row) //new ListBuffer[Int]
      */

      //for (i <- 0 until delta_Row)
      {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if ( delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col)//new ListBuffer[Int]
        /*for (v <- 0 until delta_Col) {
          rand_Col += rand.nextInt(d) //base::sample(r,delta_Row,replace=FALSE) //c(1,r)
        }*/

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0 until delta_Col)
        {
          oldVal = Population(rand_P(p)).p((rand_Col(j)))
          x = rand.nextInt(2)
          //base::sample(2,1)
          temp = 0
          //OLD Method start
          newVal = oldVal
          if ( (x == 1) & ( oldVal > VarMin(rand_Col(j))))
          {

            val temp = rand.nextDouble() * (oldVal - VarMin(rand_Col(j))) //( quantileDiv(rand_Col(j))  )
            newVal = oldVal - temp
          }
          else {

            temp = rand.nextDouble() * (VarMax(rand_Col(j)) - oldVal) //( quantileDiv(rand_Col(j))  ) *
            newVal = oldVal + temp
          }

          Population(rand_P(p)).p((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      //Population(rand_P(p)).p = AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax)

    }

    Population
  }

  def GenRandList(Np: Int , count: Int) :ListBuffer[Int] =
  {
    val rand = new scala.util.Random()
    var l : ListBuffer[Int] =  new ListBuffer[Int]
    var temp_Rand : Int = 0
    for (v<-0 until count )
    {
      temp_Rand = rand.nextInt(Np)
      if (temp_Rand == 0 )
      { temp_Rand = temp_Rand + 1}
      while(l.contains(temp_Rand) == true )
      {
        temp_Rand = rand.nextInt(Np)
      }
      l += temp_Rand
    }
    l
  }


  def AdjustMaxandMin(obj : ListBuffer[Double], VarMin: ListBuffer[Double], VarMax: ListBuffer[Double]) :
  ListBuffer[Double] =
  {
    //var x = obj
    val d = obj.length
    for (i<- 0 until obj.length)
    {
      //for (j<-0 until d)
      {
        if ( obj(i) > VarMax(i) )
        {
          obj(i) = VarMax(i)
        }
        if ( obj(i) < VarMin(i) )
        {
          obj(i) = VarMin(i)
        }
      }
    }

    obj
  }


  def CompareMatrix(EL: ListBuffer[PSONoKM], p: PSONoKM) : Boolean =
  {
    var b_equal: Boolean = true
    var b_break: Boolean = true

    for (v <- 0 until EL.length)
    {
      b_equal = true
      b_break= false

      for (j <- 0 until EL(v).p.length)
      {
        if (EL(v).p(j) != p.p(j))
        {
          b_equal =  false
          b_break= true
        }
      }
      if ( b_equal == true)
        { return true}
    }
    return b_equal
  }


   //def IsIdentical(p1: PSONoKM , p2: PSONoKM): Boolean = {}
  //EL, obj, max_EL
  def Add2EL(EL: ListBuffer[PSONoKM], p: PSONoKM, max_EL: Int): ListBuffer[PSONoKM] ={

    var b_exist: Boolean = false

    if ( EL.length == 0 )
    {
      EL  += p.CopyObj
      println("Add2EL: Added in 0")
      return EL
    }

    if  ( CompareMatrix(EL ,p) == true )
    {
      return EL
    }

    println("Add2EL : Search for location")
    var Added : Boolean = false
    var i : Int = 0
    /*if (EL.length < max_EL)
    {
      EL  += p
      return EL
    }
    else {*/
    val maxTemp = EL.length

    for (i <- 0 until maxTemp)
    {
      if ( p.fit < EL(i).fit)
      {
        for (l<-maxTemp until i by -1)
        {
          if (EL(l-1) != null)
          {
            if ( l < max_EL)
            {
              if( l < EL.length )
              { EL(l) = EL(l-1).CopyObj }
              else
              {
                EL  += EL(l-1).CopyObj }
            }
            //else {}
          }
        }
        EL(i) = p.CopyObj
        Added = true
        println("Add2EL: Added in " + i)
        return EL
      }
    }

    if (  EL.length < (max_EL - 1) )
    {
      EL  += p.CopyObj
    }

    EL
  }


  def Add2TLOrdered(TL: ListBuffer[PSONoKM], p: PSONoKM, max_TL: Int): ListBuffer[PSONoKM] ={

    var b_exist: Boolean = false

    if ( TL.length == 0 )
    {
      TL  += p.CopyObj()
      return TL
    }

    var Added : Boolean = false
    var i : Int = 0
    if (TL.length < max_TL)
    {
      TL  += p.CopyObj()
      return TL
    }
    else {
      for (i <- 0 until TL.length) {
        if ( p.fit > TL(i).fit)
        {
          TL(i) = p.CopyObj()
          Added = true
          return TL
        }
      }

    }

    TL
  }

  //TL, obj, max_EL
  def Add2TL(TL: ListBuffer[PSONoKM], p: PSONoKM, max_TL: Int, Index: Int): ListBuffer[PSONoKM] ={

    var b_exist: Boolean = false
    if ( TL.length == 0 )
    {
      TL  += p
      return TL
    }
    else
    {
      for (temp: PSONoKM <- TL)
      {
        //temp.p.toArray.deep
        if ( temp != null && (temp.p.toArray.deep == p.p.toArray.deep ))
        {
          b_exist = true
          return TL
        }
      }
    }


    var Added : Boolean = false
    if (TL.length < max_TL)
    {
      TL  += p
      return TL
    }
    else {
      //Index =
      TL.update(Index, p)
      return TL

    }

  }

  def RandVel(k: Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): ListBuffer[Double] =
  {
    val rand = new scala.util.Random()
    //val result : Array[Vector] = new Array[Vector](k)
    var Vec = new ListBuffer[Double]

    //for (h <- 0 until k)
    {
      var rval = rand.nextDouble()
      for (j <- 0 until d)
      {

        rval = rand.nextDouble()

        //if (rval < 0.5)
        //{     rval = rval + 0.5     }

        Vec += ( rval * ( quantileDiv(j)   ) )  //(maxCol(j) - minCol(j))  )
      }
      //result.update(h,  Vectors.dense(Vec).copy)
    }
    Vec
  }

  def RandPop(k: Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): ListBuffer[Double] =
  {



    val rand = new scala.util.Random()
    //val result : Array[Vector] = new Array[Vector](k)
    //val Vec = new Array[Double](d)
    var Vec =  new ListBuffer[Double]

    //for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec += minCol(j)  + (rand.nextDouble() * ( maxCol(j)  - minCol(j) )  )
      }
      //result.update(h,  Vectors.dense(Vec).copy)
    }
    Vec
  }

  /*def RandCof( k : Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): ListBuffer[Double] =
  {

    val rand = new scala.util.Random()
    val result : Array[Vector] = new Array[Vector](k)
    val Vec = new Array[Double](d)

    for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec.update(j , rand.nextDouble() )
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }*/



  def parseDVector(p :Vector) : Array[Double] ={
    p.toArray
  }





}

case class PSONoKM(kout: Int) {
  //var k : Int=  0
  val k :Int = kout
  var p : ListBuffer[Double] = new ListBuffer[Double]
  var v : ListBuffer[Double] = new ListBuffer[Double]
  var fit : Double  = 0
  var bp :ListBuffer[Double] = new ListBuffer[Double]
  var bv :ListBuffer[Double] = new ListBuffer[Double]
  var bfit : Double  = 0

  def CopyObj(): PSONoKM =
  {
    val obj = new PSONoKM(this.k)
    obj.p = this.p        //= new Array[Vector](k)
    obj.v = this.v
    obj.fit = this.fit
    obj.bp = this.bp
    obj.bv  = this.bv      //: Array[Vector]
    obj.bfit  = this.bfit
    return obj
  }

}
