

//import scala.math.BigDecimal
import java.util

import org.apache.spark.mllib.clustering.{KMeans, KMeansModel}
import org.apache.spark.sql.{DataFrame, SparkSession}
import org.apache.spark._
import org.apache.spark.util.Utils

import scala.collection.JavaConverters._
import java.util.Random

import breeze.linalg.squaredDistance.Impl2
import breeze.linalg.{DenseVector, ZippedValues, min, squaredDistance, zipValues}
import org.apache.spark.broadcast.Broadcast

import scala.math.exp
import scala.collection.mutable.{ArrayBuffer, HashMap, HashSet, ListBuffer}
import org.apache.spark.mllib.clustering.{KMeans, KMeansModel}
import org.apache.spark.rdd._
import org.apache.spark.mllib.linalg.{DenseVector, SparseVector, Vector, Vectors}
import org.apache.spark.ml.linalg.SparseVector
import BLAS._
import PSOTS.UpdateFun
import PSOTSKM.{AvgList, MaxList, MinList, StdList}
import WhaleFun.{dim, lb, ub}
import com.google.gson.annotations.Until
import org.apache.spark.sql.types.{DoubleType, IntegerType}

import scala.collection.mutable
//import PSOTSKM.findClosest
//import PSOTSKM.AdjustMaxandMin
import org.apache.spark.storage.StorageLevel
import XORShiftRandom._
import org.apache.spark.mllib.linalg
import org.apache.spark.sql.Row
import org.apache.spark.sql.types.{StructType,StructField,StringType}
import scala.util.control.Breaks._
import org.apache.spark.sql.functions._
import scala.util.control.Exception._
import java.util.StringTokenizer
import scala.io.Source
import java.io._


object PSOTSKM {

  var globalK: Int = 0
  var PHar: Double = 2.5
  //var m_quantile : Double = 0.0
  var quantileInt = new ListBuffer[Double]()
  var quantileDiv = new ListBuffer[Double]()
  var MinElFit : Double  = 0.0
  var WorestFit : Double = Double.MinValue
  var UpdateFun : String = "PSO"//"Whale"//"PSO"
  var Alg: String = ""
  var ObjFunGlobal : String = "kmeans"//"Whale"//"PSO"
  var MinObj : Boolean = false
  var mb_OnlyIntense : Boolean = false
  var mb_OnlyDiverse : Boolean = false
  var mb_IntenseDiverse : Boolean = false
  val ResultPath = "/home/amr/Downloads/resultComponents.txt"
  val rand = new scala.util.Random()
  var max_NoProgress : Int = 11
  var encycle: Int = 2
  var l: Double  = 0.0
  var iteration : Int = 0

  var MaxItbefInt : Int = 0
  var IntFact : Double = 0.3

  def Entropy(dataframe: DataFrame, DataNum: Int, centers: Array[Vector],
             exception : ListBuffer[String]  ):Double=
  {
    var Eval: ListBuffer[FMEval] = new ListBuffer[FMEval]
    //var Eval: Array[FMEval] = new Array[FMEval](globalK)
    for (i<- 0 until globalK)
    {
      Eval += new FMEval(globalK)
      for (j<- 0 until globalK)
      {
        Eval(i).CountCluster(j)= 0
      }
    }

    //collect().foreach
    dataframe.collect().foreach { r =>
      val bIndex = findClosestRow(centers, r, exception)._1

      Eval(bIndex).Points += r

      try {
        Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) =
          Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) + 1
      }
      catch {
        case e: Exception => println("Exception:" + e.toString)
          System.exit(1)
      }

    }

    var Per: Double = 0.0
    var Rec: Double = 0.0
    var FMeasure: Double = 0.0
    var EntTemp: Double = 0.0
    var SumTemp: Double = 0.0
    var Entropy : Double = 0.0
    var MaxFMTemp : ListBuffer[Double] = new ListBuffer[Double]
    var MaxFM : ListBuffer[Double] = new ListBuffer[Double]

    //var ii = (20/141)

    for ( i<- 0 until globalK)
    {

      SumTemp = 0

      for (j<- 0 until globalK)
      {
        if ( Eval(i).CountCluster(j).asInstanceOf[Double] > 0 )
        {
          SumTemp =  SumTemp +
            (  ( Eval(i).CountCluster(j).asInstanceOf[Double] /
              Eval(i).Points.length.asInstanceOf[Double] ) *
              ( scala.math.log( (Eval(i).CountCluster(j).asInstanceOf[Double] /
                Eval(i).Points.length.asInstanceOf[Double]) )  )  )
        }

      }

      EntTemp = ((-1) / (scala.math.log(globalK)) ) * SumTemp

      EntTemp = ( Eval(i).Points.length.asInstanceOf[Double] /
        dataframe.count().asInstanceOf[Double] ) *
                                    EntTemp

      Entropy = Entropy + EntTemp

    }

    //FMeasure = FMeasure / dataframe.count()

    //println("Entropy : " + Entropy)

    return Entropy

  }

  /*
 * val mincol = df.columns.map(name=> min(col(name)))
 * val mincol = df.columns.map(name=> max(col(name)))*/

  def Purity(dataframe: DataFrame, DataNum: Int, centers: Array[Vector],
             exception : ListBuffer[String]  ):Double=
  {
    var Eval: ListBuffer[FMEval] = new ListBuffer[FMEval]
    //var Eval: Array[FMEval] = new Array[FMEval](globalK)
    for (i<- 0 until globalK)
    {
      Eval += new FMEval(globalK)
      for (j<- 0 until globalK)
      {
        Eval(i).CountCluster(j)= 0
      }
    }

    var rIndex = -1
    //collect().foreach
    dataframe.collect().foreach { r =>
      val bIndex = findClosestRow(centers, r, exception)._1

      Eval(bIndex).Points += r
      rIndex = rIndex + 1

      try {
        Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) =
          Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) + 1
      }
      catch {
        case e: Throwable => println("Exception:" + e.toString)
          System.exit(1)
      }

    }

    var Per: Double = 0.0
    var Rec: Double = 0.0
    var FMeasure: Double = 0.0
    var FVal: Double = 0.0
    var MaxFMTemp : ListBuffer[Double] = new ListBuffer[Double]
    var MaxFM : ListBuffer[Double] = new ListBuffer[Double]

    //var ii = (20/141)

    for ( i<- 0 until globalK)
    {
      MaxFMTemp.clear()
      for (j<- 0 until globalK)
      {
        MaxFMTemp += Eval(j).CountCluster(i).asInstanceOf[Double]
      }
      MaxFMTemp = MaxFMTemp.sortWith( _ > _)

      FMeasure = FMeasure + MaxFMTemp(0).asInstanceOf[Double]
    }

    FMeasure = FMeasure / dataframe.count().asInstanceOf[Double]

    //println("FMeasure : " + FMeasure)

    return FMeasure

  }


  def FMeasure(dataframe: DataFrame, DataNum: Int, centers: Array[Vector],
               exception : ListBuffer[String]  ):Double=
  {


    var ClassCount : ListBuffer[Long] = new ListBuffer[Long]

    for ( i <- 0 until globalK)
    {
      ClassCount += dataframe.filter("class="+(i+1)).collect().length
    }

    //ClassCount += dataframe.filter("class=1").collect().length //.count()
    //ClassCount += dataframe.filter("class=2").collect().length
    //ClassCount += dataframe.filter("class=3").collect().length


    ///////////////////////// Class Descritption
    /*val k :Int = kout
    var Points :ListBuffer[Row]= new ListBuffer[Row]
    var CountCluster = new Array[Int](k)        //= new Array[Vector](k)
    var RepClass : Int  = 0
    var CountClusterSorted = new mutable.ListMap()(k)*/
    /////////////////////////

    var Eval: ListBuffer[FMEval] = new ListBuffer[FMEval]
    //var Eval: Array[FMEval] = new Array[FMEval](globalK)
    for (i<- 0 until globalK)
    {
      Eval += new FMEval(globalK)
      for (j<- 0 until globalK)
      {
        Eval(i).CountCluster(j)= 0
      }
    }

    //collect().foreach
    dataframe.collect().foreach { r =>
      val bIndex = findClosestRow(centers, r, exception)._1

      Eval(bIndex).Points += r

      try {
        Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) =
          Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) + 1
      }
      catch {
        case e: Exception => println("Exception:" + e.toString)
          System.exit(1)
      }

    }



   /* for ( i<- 0 until globalK)
    {
      for ( j<- 0 until globalK)
      {
        Eval(i).MapCount +=  ( (j+1) -> Eval(i).CountCluster(j) )
      }
    }

    /*for ( i<- 0 until globalK)
    {
        Eval(i).CountClusterSorted = mutable.ListMap( Eval(i).MapCount.toSeq.sortBy(_._1):_* ) //( (j+1) -> Eval(i).CountCluster(j) )
    }*/
    var MapCountTemp = scala.collection.mutable.Map[Int, Int]()
    var Sorted = mutable.ListMap(Eval(0).MapCount.toSeq.sortBy(_._2):_*)

    val Lst : ListBuffer[Int] = new ListBuffer[Int]
    var RepClass : Int = 0
    var ClassIndex : Int = 0
    var Index : Int = 1
    for (i <- 0 until globalK)
    {

      MapCountTemp.clear()

      for ( j<- 0 until globalK)
      {
        for (v <-0 until globalK )
        {
          if (Eval(j).MapCount.toSeq(v)._1.asInstanceOf[Int] == (i+1).asInstanceOf[Int] )
          {
            MapCountTemp += ( (j+1) ->  Eval(j).MapCount.toSeq(v)._2.asInstanceOf[Int] )
          }
          Index = Index + 1
        }
      }

      RepClass = 0
      ClassIndex=0

      val xx = MapCountTemp.toSeq.sortWith(_._2 > _._2)
      //mutable.ListMap(MapCountTemp.toSeq.sortWith(_._2 > _._2):_*)

      var j : Int = 0
      while (   j <=  globalK)
      {
        if ( Eval((xx.toSeq(j)._1 - 1) ).RepClass == -1 )
          {
            Eval((xx.toSeq(j)._1-1)).RepClass = (i+1)
            j =  globalK
          }
        j+=1
      }
    }*/

    var Per: Double = 0.0
    var Rec: Double = 0.0
    var FMeasure: Double = 0.0
    var FVal: Double = 0.0
    var MaxFMTemp : ListBuffer[Double] = new ListBuffer[Double]
    var MaxFM : ListBuffer[Double] = new ListBuffer[Double]

    //var ii = (20/141)

    for ( i<- 0 until globalK)
    {
      MaxFMTemp.clear()
      for (j<- 0 until globalK)
      {

        if (Eval(j).Points.length.asInstanceOf[Double] > 0 & Eval(j).CountCluster(i).asInstanceOf[Double] > 0 ) {
          //Per = (Eval(j).MapCount.toSeq(i)._2.asInstanceOf[Double] /
          //Eval(j).Points.length.asInstanceOf[Double])

          Per = (Eval(j).CountCluster(i).asInstanceOf[Double] /
            Eval(j).Points.length.asInstanceOf[Double])

          //Rec = (Eval(j).MapCount.toSeq(i)._2.asInstanceOf[Double] /
          //ClassCount(i).asInstanceOf[Double])

          Rec = (Eval(j).CountCluster(i).asInstanceOf[Double] /
            ClassCount(i).asInstanceOf[Double])

          if (Per.equals(Double.NaN)) {
            Per = 0
          }

          if (Rec.equals(Double.NaN)) {
            Rec = 0
          }

          if ((Per + Rec) == 0) {
            FVal = 0
          }
          else {
            FVal = (2 * Per * Rec) / (Per + Rec)
          }

          MaxFMTemp += FVal
        }
        else {
          MaxFMTemp += 0.0
        }

      }
      MaxFMTemp = MaxFMTemp.sortWith( _ > _)
      //MaxFM += MaxFMTemp(0)

      FMeasure = FMeasure + ( (ClassCount(i).asInstanceOf[Double] /
        dataframe.count.asInstanceOf[Double]) * MaxFMTemp(0).asInstanceOf[Double] )
    }

   //println("FMeasure : " + FMeasure)

    return FMeasure

    //dataframe.select("class").groupBy("class").count()//.orderBy($"count".desc).show()
    /*val dtClass1=dataframe.filter("class=1").collect()
     //dataframe.filter("class='setosa'").count()
    val dtClass2=dataframe.filter("class=2").collect()
    //val ClassCount2=dataframe.filter("class='versicolor'").count()
    val dtClass3=dataframe.filter("class=3").collect()
    //val ClassCount3=dataframe.filter("class='virginica'").count()*/

    //dataframe.col("class").equalTo("setosa") = "1"


  }

  def Accuracy(dataframe: DataFrame, DataNum: Int, centers: Array[Vector],
               exception : ListBuffer[String]  ):Double=
  {


    var ClassCount : ListBuffer[Long] = new ListBuffer[Long]

    for ( i <- 0 until globalK)
    {
      ClassCount += dataframe.filter("class="+(i+1)).collect().length
    }


    var Eval: ListBuffer[FMEval] = new ListBuffer[FMEval]
    //var Eval: Array[FMEval] = new Array[FMEval](globalK)
    for (i<- 0 until globalK)
    {
      Eval += new FMEval(globalK)
      for (j<- 0 until globalK)
      {
        Eval(i).CountCluster(j)= 0
      }
    }

    //collect().foreach
    dataframe.collect().foreach { r =>
      val bIndex = findClosestRow(centers, r, exception)._1

      Eval(bIndex).Points += r

      try {
        Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) =
          Eval(bIndex).CountCluster(r.getAs[Int](dataframe.columns.length - 1) - 1) + 1
      }
      catch {
        case e: Exception => println("Exception:" + e.toString)
          System.exit(1)
      }

    }

    var TotTp: Double = 0.0
    var TotTn: Double = 0.0
    var TotFp: Double = 0.0
    var TotFn: Double = 0.0

    //var ii = (20/141)
    var x : Int = 0
    var Min : Int = 0
    var MinIndex : Int = 0

    for ( i<- 0 until globalK)
    {

      Min = Int.MaxValue

      for (j<- 0 until globalK)
      {
        x = math.abs((ClassCount(i) - Eval(j).CountCluster(i) ).asInstanceOf[Int])
        if ( x < Min )
          {
            Min = x
            MinIndex = j
          }
      }

      TotTp += ( Eval(MinIndex).CountCluster(i) /
        (  Eval(MinIndex).Points.length).asInstanceOf[Double] * 100)
        //( ( ClassCount(i)  -  Min ) + Eval(MinIndex).Points.length).asInstanceOf[Double] * 100)

    }

    val Acc = TotTp / globalK.asInstanceOf[Double]

    return Acc




  }

  def RunCluster(Num: Int, spark :  SparkSession): Unit =
  {

    val sc = spark.sparkContext
    //import spark.implicits._

    val sqlContext = new org.apache.spark.sql.SQLContext(sc)
    import sqlContext.implicits._
    val  schema_string = "name,id,age"
    val schema_rdd = StructType(schema_string.split(",")
          .map(fieldName => StructField(fieldName, StringType, true)) )
    var datafrm = sqlContext.createDataFrame(sc.emptyRDD[Row], schema_rdd)
    //datafrm.createTempView("Empty")
    //val res = sqlContext.sql("select count(*) from Empty")

    var Krange = Seq(1,3)
    val exception = new ListBuffer[String]
    var maxCol = new ListBuffer[Double]()
    var minCol = new ListBuffer[Double]()
    var data_Lines : Array[Vector] = new Array[Vector](5) //
    var d : Int = 0 //data_Lines(0).toArray.length
    var n : Long = 0 //data_Lines.length.toLong

    if (Num == 111)
    {
      //iris
      /*val customSchema = StructType(Array(
        StructField("pl", DoubleType, true),
        StructField("pw", DoubleType, true),
        StructField("sw", DoubleType, true),
        StructField("sl", DoubleType, true),
        StructField("class", IntegerType, true)))


      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/iris2.data").
        toDF("pl", "pw", "sw", "sl", "class")


      exception+= "class"*/


      datafrm.cache()

      data_Lines =  ReadFile("/home/amr/Downloads/iris2.txt")
      var max_col : Double = Double.MinValue
      var min_col : Double = Double.MaxValue

      for ( j <- 0 until data_Lines(0).toArray.length )
        {
          max_col = Double.MinValue
          min_col = Double.MaxValue
          for ( i <- 0 until data_Lines.length )
            {
              if ( data_Lines(i).toArray(j) > max_col )
                {
                  max_col = data_Lines(i).toArray(j)
                }

              if ( data_Lines(i).toArray(j) < min_col )
                {
                  min_col = data_Lines(i).toArray(j)
                }
            }

          maxCol += max_col
          minCol += min_col
        }

      //Krange = Seq(3,4,5,6,7,8,9,10)
      Krange = Seq(3)
    }
    else if (Num == 1)
    {
      //iris
      val customSchema = StructType(Array(
        StructField("pl", DoubleType, true),
        StructField("pw", DoubleType, true),
        StructField("sw", DoubleType, true),
        StructField("sl", DoubleType, true),
        StructField("class", IntegerType, true)))


      datafrm = spark.read.
        schema(customSchema).
      csv("hdfs://master:9000/amr/iris2.data").
      toDF("pl", "pw", "sw", "sl", "class")

      //automatically infer the schema
      //datafrm = spark.read.
        //option("inferSchema", true).option("header", true).
        //csv("hdfs://master:9000/amr/iris2.data").
        //toDF("pl", "pw", "sw", "sl", "class")

      //datafrm = datafrm.drop("class")
      //datafrm = datafrm.withColumn("pl", $"pl".cast("double"))
      //datafrm = datafrm.withColumn("pw", $"pw".cast("double"))
      //datafrm = datafrm.withColumn("sw", $"sw".cast("double"))
      //datafrm = datafrm.withColumn("sl", $"sl".cast("double"))
      exception+= "class"

      //Krange = Seq(3,4,5,6,7,8,9,10)
      Krange = Seq(3)
    }
    else if (Num == 2)
    {
      //breast Cancer
      val customSchema = StructType(Array(
        StructField("id", IntegerType, true),
        StructField("ClTh", DoubleType, true),
        StructField("CellSize", DoubleType, true),
        StructField("CellShape", DoubleType, true),
        StructField("Adhesion", DoubleType, true),
        StructField("Epithelial", DoubleType, true),
        StructField("Nuclei", DoubleType, true),
        StructField("Chromatin", DoubleType, true),
        StructField("NormalNucleoli", DoubleType, true),
        StructField("Mitoses", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/breast2.data").
        toDF("id", "ClTh", "CellSize", "CellShape", "Adhesion","Epithelial","Nuclei",
          "Chromatin","NormalNucleoli", "Mitoses","class")
      //datafrm = datafrm.drop("id", "class")

      exception+= "id"
      exception+= "class"
      Krange = Seq(2)
    }
    else if (Num == 3)
    {
      //CMC
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),
        StructField("f4", DoubleType, true),
        StructField("f5", DoubleType, true),
        StructField("f6", DoubleType, true),
        StructField("f7", DoubleType, true),
        StructField("f8", DoubleType, true),
        StructField("f9", DoubleType, true),
        StructField("class", IntegerType, true)))


      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/CMC2.data").
        toDF("f1", "f2", "f3", "f4","f5","f6", "f7","f8","f9","class")
      //datafrm = datafrm.drop("class")

     exception+= "class"

      Krange = Seq(3)
    }
    else if (Num == 4)
    {
      //Glass
      val customSchema = StructType(Array(
        StructField("RI", DoubleType, true),
        StructField("Na", DoubleType, true),
        StructField("Mg", DoubleType, true),
        StructField("Al", DoubleType, true),
        StructField("Si", DoubleType, true),
        StructField("K", DoubleType, true),
        StructField("Ca", DoubleType, true),
        StructField("Ba", DoubleType, true),
        StructField("Fe", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/glass2.data").
        toDF("RI","Na","Mg","Al","Si","K","Ca","Ba","Fe","class")
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(6)
    }
    else if (Num == 5)
    {
      //Wine
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),
        StructField("f4", DoubleType, true),
        StructField("f5", DoubleType, true),
        StructField("f6", DoubleType, true),
        StructField("f7", DoubleType, true),
        StructField("f8", DoubleType, true),
        StructField("f9", DoubleType, true),
        StructField("f10", DoubleType, true),
        StructField("f11", DoubleType, true),
        StructField("f12", DoubleType, true),
        StructField("f13", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/wine2.data").
        toDF("f1","f2","f3","f4","f5","f6","f7","f8","f9","f10",
          "f11","f12","f13","class")
      //datafrm = datafrm.drop("class")
     exception+= "class"
      Krange = Seq(3)
    }
    else if (Num == 6)
    {
      //Balance f1, f2, f3, f4
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),
        StructField("f4", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/Balance2.data").
        toDF("f1","f2","f3","f4","class")
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(3)
    }
    else if (Num == 7)
    {
      ///Seed f1 - f7
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),
        StructField("f4", DoubleType, true),
        StructField("f5", DoubleType, true),
        StructField("f6", DoubleType, true),
        StructField("f7", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/seed2.data").
        toDF("f1","f2","f3","f4","f5","f6","f7","class")
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(3)
    }
    else if (Num == 8)
    {
      //mouse2 f1 , f2
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/mouse2.data").
        toDF("f1","f2","class")
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(3)
    }
    else if (Num == 9)
    {
      //VaryDensity2 f1, f2
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/VaryDensity2.data").
        toDF("f1","f2","class")
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(3)
    }
    else if (Num == 10)
    {
      //Magic2.csv f1 , f2
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),
        StructField("f4", DoubleType, true),
        StructField("f5", DoubleType, true),
        StructField("f6", DoubleType, true),
        StructField("f7", DoubleType, true),
        StructField("f8", DoubleType, true),
        StructField("f9", DoubleType, true),
        StructField("f10", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/Magic2.data").
        toDF("f1","f2","f3","f4","f5","f6","f7","f8","f9","f10","class")
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(2)
    }
    else if (Num == 11)
    {
      //Poker2.csv f1 - f10
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),
        StructField("f4", DoubleType, true),
        StructField("f5", DoubleType, true),
        StructField("f6", DoubleType, true),
        StructField("f7", DoubleType, true),
        StructField("f8", DoubleType, true),
        StructField("f9", DoubleType, true),
        StructField("f10", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/Poker2.data").
        toDF("f1","f2","f3","f4","f5","f6","f7","f8","f9","f10","class")
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(10)
    }
    else if (Num == 12)
    {
      //covertype2.csv f1 - f10
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),StructField("f2", DoubleType, true),StructField("f3", DoubleType, true),StructField("f4", DoubleType, true),StructField("f5", DoubleType, true),StructField("f6", DoubleType, true),StructField("f7", DoubleType, true),StructField("f8", DoubleType, true),StructField("f9", DoubleType, true),StructField("f10", DoubleType, true),
        StructField("f11", DoubleType, true),StructField("f12", DoubleType, true),StructField("f13", DoubleType, true),StructField("f14", DoubleType, true),StructField("f15", DoubleType, true),StructField("f16", DoubleType, true),StructField("f17", DoubleType, true),StructField("f18", DoubleType, true),StructField("f19", DoubleType, true),StructField("f20", DoubleType, true),
        StructField("f21", DoubleType, true),StructField("f22", DoubleType, true),StructField("f23", DoubleType, true),StructField("f24", DoubleType, true),StructField("f25", DoubleType, true),StructField("f26", DoubleType, true),StructField("f27", DoubleType, true),StructField("f28", DoubleType, true),StructField("f29", DoubleType, true),StructField("f30", DoubleType, true),
        StructField("f31", DoubleType, true),StructField("f32", DoubleType, true),StructField("f33", DoubleType, true),StructField("f34", DoubleType, true),StructField("f35", DoubleType, true),StructField("f36", DoubleType, true),StructField("f37", DoubleType, true),StructField("f38", DoubleType, true),StructField("f39", DoubleType, true),StructField("f40", DoubleType, true),
        StructField("f41", DoubleType, true),StructField("f42", DoubleType, true),StructField("f43", DoubleType, true),StructField("f44", DoubleType, true),StructField("f45", DoubleType, true),StructField("f46", DoubleType, true),StructField("f47", DoubleType, true),StructField("f48", DoubleType, true),StructField("f49", DoubleType, true),StructField("f50", DoubleType, true),
        StructField("f51", DoubleType, true),StructField("f52", DoubleType, true),StructField("f53", DoubleType, true),StructField("f54", DoubleType, true),
        StructField("class", IntegerType, true)
        ))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/covertype2.data").
        toDF()
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(7)
    }
    else if (Num == 13)
    {
      //Electricity.csv f1 - f10
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),StructField("f4", DoubleType, true),
        StructField("f5", DoubleType, true),StructField("f6", DoubleType, true),
        StructField("f7", DoubleType, true),StructField("f8", DoubleType, true),
        StructField("class", IntegerType, true)
      ))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/elec.data").
        toDF()
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(2)
    }
    else if (Num == 14)
    {
      //BankNote.csv f1 - f10
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),StructField("f4", DoubleType, true),
        StructField("class", IntegerType, true)
      ))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/banknote.data").
        toDF()
      //datafrm = datafrm.drop("class")

      exception+= "class"
      Krange = Seq(2)
    }
    else if (Num == 15)
    {
      //Tae
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("f3", DoubleType, true),
        StructField("f4", DoubleType, true),
        StructField("f5", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/tae.data").
        toDF("f1","f2","f3","f4","f5", "class")
      //datafrm = datafrm.drop("class")
      exception+= "class"
      Krange = Seq(3)
    }
    else if (Num == 16)
    {
      //Flame
      val customSchema = StructType(Array(
        StructField("f1", DoubleType, true),
        StructField("f2", DoubleType, true),
        StructField("class", IntegerType, true)))

      datafrm = spark.read.
        schema(customSchema).
        csv("hdfs://master:9000/amr/flame.data").
        toDF("f1","f2","class")
      //datafrm = datafrm.drop("class")
      exception+= "class"
      Krange = Seq(2)
    }



    //"pl", "pw", "sw", "sl", "class"
    d = datafrm.columns.size //- exception.length
    n = datafrm.count()
    //println("n:" + n + "d:" + d)
    var max_ColRow = datafrm.agg(sql.functions.max(datafrm.schema.fieldNames(0)).cast("double"),
      sql.functions.max(datafrm.schema.fieldNames(1)).cast("double"))

    var min_ColRow = datafrm.agg(sql.functions.min(datafrm.schema.fieldNames(0)).cast("double"),
      sql.functions.min(datafrm.schema.fieldNames(1)).cast("double"))


    if (Num != 111)
    {

      if (Num == 1) {
        //iris
        max_ColRow = datafrm.agg(sql.functions.max("pl").cast("double"),
          sql.functions.max("pw").cast("double"), sql.functions.max("sw").cast("double"),
          sql.functions.max("sl").cast("double"))
      }
      else if (Num == 2) {
        //breast
        max_ColRow = datafrm.agg(sql.functions.max("ClTh").cast("double"), sql.functions.max("CellSize").cast("double"), sql.functions.max("CellShape").cast("double"),
          sql.functions.max("Adhesion").cast("double"), sql.functions.max("Epithelial").cast("double"), sql.functions.max("Nuclei").cast("double"),
          sql.functions.max("Chromatin").cast("double"), sql.functions.max("NormalNucleoli").cast("double"), sql.functions.max("Mitoses").cast("double")
        )

      }
      else if (Num == 3) {
        //CMC
        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"), sql.functions.max("f3").cast("double"),
          sql.functions.max("f4").cast("double"), sql.functions.max("f5").cast("double"), sql.functions.max("f6").cast("double"),
          sql.functions.max("f7").cast("double"), sql.functions.max("f8").cast("double"), sql.functions.max("f9").cast("double"))
      }
      else if (Num == 4) {
        //Glass
        max_ColRow = datafrm.agg(sql.functions.max("RI").cast("double"), sql.functions.max("Na").cast("double"), sql.functions.max("Mg").cast("double"),
          sql.functions.max("Al").cast("double"), sql.functions.max("Si").cast("double"), sql.functions.max("K").cast("double"),
          sql.functions.max("Ca").cast("double"), sql.functions.max("Ba").cast("double"), sql.functions.max("Fe").cast("double"))
      }
      else if (Num == 5) {
        //Wine
        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"), sql.functions.max("f3").cast("double"),
          sql.functions.max("f4").cast("double"), sql.functions.max("f5").cast("double"), sql.functions.max("f6").cast("double"),
          sql.functions.max("f7").cast("double"), sql.functions.max("f8").cast("double"), sql.functions.max("f9").cast("double"), sql.functions.max("f10").cast("double"),
          sql.functions.max("f11").cast("double"), sql.functions.max("f12").cast("double"), sql.functions.max("f13").cast("double")
        )
      }
      else if (Num == 6) {
        //Balance f1, f2, f3, f4
        WriteToFile("", true)
        WriteToFile("Balance: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"), sql.functions.max("f3").cast("double"),
          sql.functions.max("f4").cast("double"))
      }
      else if (Num == 7) {
        //Seed f1 - f7
        WriteToFile("", true)
        WriteToFile("Seed: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"), sql.functions.max("f3").cast("double"),
          sql.functions.max("f4").cast("double"), sql.functions.max("f5").cast("double"), sql.functions.max("f6").cast("double"),
          sql.functions.max("f7").cast("double"))
      }
      else if (Num == 8) {
        //mouse2 f1 , f2
        WriteToFile("", true)
        WriteToFile("Mouse: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"))
      }
      else if (Num == 9) {
        //VaryDensity2 f1, f2
        WriteToFile("", true)
        WriteToFile("VaryDensity: ", true)
        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"))
      }
      else if (Num == 10) {
        //Magic2.csv f1 , f2
        WriteToFile("", true)
        WriteToFile("Magic: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"),
          sql.functions.max("f3").cast("double"), sql.functions.max("f4").cast("double"),
          sql.functions.max("f5").cast("double"), sql.functions.max("f6").cast("double"),
          sql.functions.max("f7").cast("double"), sql.functions.max("f8").cast("double"),
          sql.functions.max("f9").cast("double"), sql.functions.max("f10").cast("double")
        )

      }
      else if (Num == 11) {
        //Poker2.csv f1 - f10
        WriteToFile("", true)
        WriteToFile("Poker: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"),
          sql.functions.max("f3").cast("double"), sql.functions.max("f4").cast("double"),
          sql.functions.max("f5").cast("double"), sql.functions.max("f6").cast("double"),
          sql.functions.max("f7").cast("double"), sql.functions.max("f8").cast("double"),
          sql.functions.max("f9").cast("double"), sql.functions.max("f10").cast("double")
        )

      }
      else if (Num == 12) {
        //covertype2.csv f1 - f10
        WriteToFile("", true)
        WriteToFile("Covertype: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"),
          sql.functions.max("f3").cast("double"), sql.functions.max("f4").cast("double"),
          sql.functions.max("f5").cast("double"), sql.functions.max("f6").cast("double"),
          sql.functions.max("f7").cast("double"), sql.functions.max("f8").cast("double"),
          sql.functions.max("f9").cast("double"), sql.functions.max("f10").cast("double"),
          sql.functions.max("f11").cast("double"), sql.functions.max("f12").cast("double"), sql.functions.max("f13").cast("double"), sql.functions.max("f14").cast("double"), sql.functions.max("f15").cast("double"), sql.functions.max("f16").cast("double"), sql.functions.max("f17").cast("double"), sql.functions.max("f18").cast("double"), sql.functions.max("f19").cast("double"), sql.functions.max("f20").cast("double"),
          sql.functions.max("f21").cast("double"), sql.functions.max("f22").cast("double"), sql.functions.max("f23").cast("double"), sql.functions.max("f24").cast("double"), sql.functions.max("f25").cast("double"), sql.functions.max("f26").cast("double"), sql.functions.max("f27").cast("double"), sql.functions.max("f28").cast("double"), sql.functions.max("f29").cast("double"), sql.functions.max("f30").cast("double"),
          sql.functions.max("f31").cast("double"), sql.functions.max("f32").cast("double"), sql.functions.max("f33").cast("double"), sql.functions.max("f34").cast("double"), sql.functions.max("f35").cast("double"), sql.functions.max("f36").cast("double"), sql.functions.max("f37").cast("double"), sql.functions.max("f38").cast("double"), sql.functions.max("f39").cast("double"), sql.functions.max("f40").cast("double"),
          sql.functions.max("f41").cast("double"), sql.functions.max("f42").cast("double"), sql.functions.max("f43").cast("double"), sql.functions.max("f44").cast("double"), sql.functions.max("f45").cast("double"), sql.functions.max("f46").cast("double"), sql.functions.max("f47").cast("double"), sql.functions.max("f48").cast("double"), sql.functions.max("f49").cast("double"), sql.functions.max("f50").cast("double"),
          sql.functions.max("f51").cast("double"), sql.functions.max("f52").cast("double"), sql.functions.max("f53").cast("double"), sql.functions.max("f54").cast("double")
        )

      }
      else if (Num == 13) {
        //Electricity.csv f1 - f10
        WriteToFile("", true)
        WriteToFile("Electricity: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"),
          sql.functions.max("f3").cast("double"), sql.functions.max("f4").cast("double"),
          sql.functions.max("f5").cast("double"), sql.functions.max("f6").cast("double"),
          sql.functions.max("f7").cast("double"), sql.functions.max("f8").cast("double")
        )

      }
      else if (Num == 14) {
        //banknote.csv f1 - f4
        WriteToFile("", true)
        WriteToFile("BankNote: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"),
          sql.functions.max("f3").cast("double"), sql.functions.max("f4").cast("double")
        )
      }
      else if (Num == 15) {
        //Tae.csv f1 , f2
        WriteToFile("", true)
        WriteToFile("Tae: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double"),
          sql.functions.max("f3").cast("double"), sql.functions.max("f4").cast("double"),
          sql.functions.max("f5").cast("double")
        )

      }

      else if (Num == 16) {
        //Flame.csv f1 , f2
        WriteToFile("", true)
        WriteToFile("Flame: ", true)

        max_ColRow = datafrm.agg(sql.functions.max("f1").cast("double"), sql.functions.max("f2").cast("double")  )

      }





      //.show()
      //println("max_Col :" + max_Col.head().get(0) + ":" + max_Col.head().get(1))
      for (i <- 0 until d - exception.length) {
        maxCol += max_ColRow.head().get(i).asInstanceOf[Double]
      }

      //println("maxCol:" + maxCol)

      if (Num == 1) {
        //iris
        WriteToFile("", true)
        WriteToFile("iris : ", true)
        min_ColRow = datafrm.agg(sql.functions.min("pl").cast("double"), sql.functions.min("pw").cast("double"),
          sql.functions.min("sw").cast("double"), sql.functions.min("sl").cast("double"))
      }
      else if (Num == 2) {
        //breast
        WriteToFile("", true)
        WriteToFile("Breast Cancer: ", true)
        min_ColRow = datafrm.agg(sql.functions.min("ClTh").cast("double"), sql.functions.min("CellSize").cast("double"),
          sql.functions.min("CellShape").cast("double"), sql.functions.min("Adhesion").cast("double"),
          sql.functions.min("Epithelial").cast("double"), sql.functions.min("Nuclei").cast("double"), sql.functions.min("Chromatin").cast("double"),
          sql.functions.min("NormalNucleoli").cast("double"), sql.functions.min("Mitoses").cast("double"))

      }
      else if (Num == 3) {
        //CMC
        WriteToFile("", true)
        WriteToFile("CMC: ", true)
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"),
          sql.functions.min("f3").cast("double"), sql.functions.min("f4").cast("double"), sql.functions.min("f5").cast("double"),
          sql.functions.min("f6").cast("double"), sql.functions.min("f7").cast("double"),
          sql.functions.min("f8").cast("double"), sql.functions.min("f9").cast("double"))
      }
      else if (Num == 4) {
        //Glass
        WriteToFile("", true)
        WriteToFile("Glass: ", true)
        min_ColRow = datafrm.agg(sql.functions.min("RI").cast("double"), sql.functions.min("Na").cast("double"), sql.functions.min("Mg").cast("double"),
          sql.functions.min("Al").cast("double"), sql.functions.min("Si").cast("double"), sql.functions.min("K").cast("double"),
          sql.functions.min("Ca").cast("double"), sql.functions.min("Ba").cast("double"), sql.functions.min("Fe").cast("double"))
      }
      else if (Num == 5) {
        //Wine
        WriteToFile("", true)
        WriteToFile("Wine: ", true)
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"), sql.functions.min("f3").cast("double"),
          sql.functions.min("f4").cast("double"), sql.functions.min("f5").cast("double"), sql.functions.min("f6").cast("double"),
          sql.functions.min("f7").cast("double"), sql.functions.min("f8").cast("double"), sql.functions.min("f9").cast("double"), sql.functions.min("f10").cast("double"),
          sql.functions.min("f11").cast("double"), sql.functions.min("f12").cast("double"), sql.functions.min("f13").cast("double"))
      }
      else if (Num == 6) {
        //Balance f1, f2, f3, f4
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"), sql.functions.min("f3").cast("double"),
          sql.functions.min("f4").cast("double"))
      }
      else if (Num == 7) {
        //Seed f1 - f7
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"), sql.functions.min("f3").cast("double"),
          sql.functions.min("f4").cast("double"), sql.functions.min("f5").cast("double"), sql.functions.min("f6").cast("double"),
          sql.functions.min("f7").cast("double"))
      }
      else if (Num == 8) {
        //mouse2 f1 , f2
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"))
      }
      else if (Num == 9) {
        //VaryDensity2 f1, f2
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"))
      }
      else if (Num == 10) {
        //Magic2.csv f1 , f2
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"),
          sql.functions.min("f3").cast("double"), sql.functions.min("f4").cast("double"),
          sql.functions.min("f5").cast("double"), sql.functions.min("f6").cast("double"),
          sql.functions.min("f7").cast("double"), sql.functions.min("f8").cast("double"),
          sql.functions.min("f9").cast("double"), sql.functions.min("f10").cast("double")
        )

      }
      else if (Num == 11) {
        //Poker2.csv f1 - f10
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"),
          sql.functions.min("f3").cast("double"), sql.functions.min("f4").cast("double"),
          sql.functions.min("f5").cast("double"), sql.functions.min("f6").cast("double"),
          sql.functions.min("f7").cast("double"), sql.functions.min("f8").cast("double"),
          sql.functions.min("f9").cast("double"), sql.functions.min("f10").cast("double")
        )

      }
      else if (Num == 12) {
        //covertype2.csv f1 - f10
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"),
          sql.functions.min("f3").cast("double"), sql.functions.min("f4").cast("double"),
          sql.functions.min("f5").cast("double"), sql.functions.min("f6").cast("double"),
          sql.functions.min("f7").cast("double"), sql.functions.min("f8").cast("double"),
          sql.functions.min("f9").cast("double"), sql.functions.min("f10").cast("double"),
          sql.functions.min("f11").cast("double"), sql.functions.min("f12").cast("double"), sql.functions.min("f13").cast("double"), sql.functions.min("f14").cast("double"), sql.functions.min("f15").cast("double"), sql.functions.min("f16").cast("double"), sql.functions.min("f17").cast("double"), sql.functions.min("f18").cast("double"), sql.functions.min("f19").cast("double"), sql.functions.min("f20").cast("double"),
          sql.functions.min("f21").cast("double"), sql.functions.min("f22").cast("double"), sql.functions.min("f23").cast("double"), sql.functions.min("f24").cast("double"), sql.functions.min("f25").cast("double"), sql.functions.min("f26").cast("double"), sql.functions.min("f27").cast("double"), sql.functions.min("f28").cast("double"), sql.functions.min("f29").cast("double"), sql.functions.min("f30").cast("double"),
          sql.functions.min("f31").cast("double"), sql.functions.min("f32").cast("double"), sql.functions.min("f33").cast("double"), sql.functions.min("f34").cast("double"), sql.functions.min("f35").cast("double"), sql.functions.min("f36").cast("double"), sql.functions.min("f37").cast("double"), sql.functions.min("f38").cast("double"), sql.functions.min("f39").cast("double"), sql.functions.min("f40").cast("double"),
          sql.functions.min("f41").cast("double"), sql.functions.min("f42").cast("double"), sql.functions.min("f43").cast("double"), sql.functions.min("f44").cast("double"), sql.functions.min("f45").cast("double"), sql.functions.min("f46").cast("double"), sql.functions.min("f47").cast("double"), sql.functions.min("f48").cast("double"), sql.functions.min("f49").cast("double"), sql.functions.min("f50").cast("double"),
          sql.functions.min("f51").cast("double"), sql.functions.min("f52").cast("double"), sql.functions.min("f53").cast("double"), sql.functions.min("f54").cast("double")
        )

      }
      else if (Num == 13) {
        //Poker2.csv f1 - f10
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"),
          sql.functions.min("f3").cast("double"), sql.functions.min("f4").cast("double"),
          sql.functions.min("f5").cast("double"), sql.functions.min("f6").cast("double"),
          sql.functions.min("f7").cast("double"), sql.functions.min("f8").cast("double")
        )

      }
      else if (Num == 14) {
        //banknote.csv f1 - f4
        WriteToFile("", true)
        WriteToFile("BankNote: ", true)

        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"),
          sql.functions.min("f3").cast("double"), sql.functions.min("f4").cast("double")
        )

      }
      else if (Num == 15) {
        //Tae.data f1 , f2
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double"),
          sql.functions.min("f3").cast("double"), sql.functions.min("f4").cast("double"),
          sql.functions.min("f5").cast("double")
        )

      }

      else if (Num == 16) {
        //Flame.data f1 , f2
        min_ColRow = datafrm.agg(sql.functions.min("f1").cast("double"), sql.functions.min("f2").cast("double") )

      }

      for (i <- 0 until d - exception.length) {
        minCol += min_ColRow.head().get(i).asInstanceOf[Double]
      }
    }
    //println("minCol:" + minCol)

    quantileInt.clear()
    quantileDiv.clear()

    for (i <- 0 until d - exception.length)
    {
        quantileInt += ( minCol(i) +  ( (maxCol(i) - minCol(i)) / 5 ) )

        quantileDiv  +=  ( minCol(i) +  ( ( maxCol(i) - minCol(i) ) / 3) )

    }
    //println("quantileInt :" + quantileInt)

    /*for (i <- 0 until d-exception.length)
    {
      if (quantileInt(i) == minCol(i) )
        {
          quantileInt(i) = minCol(i) +  ( (maxCol(i) - minCol(i)) / 10)
        }
      if (quantileDiv(i) == minCol(i) )
      {
        quantileDiv(i) = minCol(i) +  ( ( maxCol(i) - minCol(i) ) / 7 )
      }
    }*/

    var VelMax = new ListBuffer[Double]()
    for (i <- 0 until d-exception.length) {
      VelMax += ((maxCol(i) - minCol(i)) *.1  )// 3
      //VelMax += quantileInt(i)
    }
    //println("VelMax: " + VelMax)

    var VelMin = new ListBuffer[Double]()
    for (i <- 0 until d-exception.length) {
      VelMin += (-1 * VelMax(i))
    }
    //println("VelMin: " + VelMin)



    val lines = datafrm.rdd
    val data = lines.map(Row2Vector( _, exception)).cache()


    //datafrm.unpersist()

    var Finished: ListBuffer[String] = new ListBuffer[String]
    var TempStr : String = ""
    var Result: Double = 0
    val RunNumber: Int = 0
    var TotalTime: Double = 0
    var TimeinLoop_Start: Double = 0
    var TimeinLoop_End: Double = 0
    var ClusterTime: Double = 0

    var Ent : Double = 0.0
    var Pur: Double = 0.0
    var max_Runs : Int = 3
    var EntList: ListBuffer[Double] = new ListBuffer[Double]()
    var PurList: ListBuffer[Double] = new ListBuffer[Double]()
    var FvalList: ListBuffer[Double] = new ListBuffer[Double]()

    var BestFit: Double = 0

    val StandardObj: Array[Double] = Array(1, 152.35, 78.851, 57.228, 46.446,
      39.04, 34.298, 29.989, 27.786, 25.834)

    var FVal: Double = 0
    var FValTotal: Double = 0
    var MinEnt, MaxEnt, StdEnt, AvgEnt : Double = 0.0
    var MinPur, MaxPur, StdPur, AvgPur : Double = 0.0
    var MinFval, MaxFval, StdFval, AvgFval : Double = 0.0
    var Acc : Double = 0.0

    //for (RunNumber <- 0 until max_Runs  ) {

    for (kloop <- 0 until  Krange.length  by 1) {

      globalK = Krange(kloop)
      var BestCenters: Array[Vector] = new Array[Vector](globalK)
      Result = 0
      FValTotal = 0
      val iterationStartTime = System.nanoTime()
      for (i <- 0 to max_Runs-1) {


        TimeinLoop_Start = System.nanoTime()

        val x = ClusterAlgo(data, Krange(kloop), VelMin, VelMax, minCol, maxCol, d - exception.length)
        //val x = ClusterAlgo(data_Lines, Krange(kloop), VelMin, VelMax, minCol, maxCol, d - exception.length)
        BestFit = x._1
        BestCenters = x._2.clone()

        if (Num == 1 & Krange(kloop) == 3)
        {
          //iris
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 2 & Krange(kloop) == 2) {
          //breast
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 3 & Krange(kloop) == 3) {
          //CMC
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 4 & Krange(kloop) == 6) {
          //Glass
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 5 & Krange(kloop) == 3) {
          //Wine
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 6) {
          //Balance
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 7) {
          //Seed
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 8) {
          //Mouse
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 9) {
          //VaryDensity
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 15) {
          //Tae
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 16) {
          //Flame
          Acc = Accuracy(datafrm, Num, BestCenters, exception)
          FVal = FMeasure(datafrm, Num, BestCenters, exception)
          FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          Ent = Entropy(datafrm, Num, BestCenters, exception)
        }
        else if (Num == 10) {
          //Magic
          FVal = 0
          //FVal = FMeasure(datafrm, Num, BestCenters,exception)
          //FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          // Ent = Entropy(datafrm, Num, BestCenters,exception)
          Ent =0
        }
        else if (Num == 11) {
          //Poker
          //FVal = FMeasure(datafrm, Num, BestCenters,exception)
          FVal = 0
          //FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          //Ent = Entropy(datafrm, Num, BestCenters,exception)
          Ent =0
        }
        else if (Num == 12) {
          //CoverType
          FVal = 0
          //FVal = FMeasure(datafrm, Num, BestCenters,exception)
          //FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          //Ent = Entropy(datafrm, Num, BestCenters,exception)
          Ent =0
        }
        else if (Num == 13) {
          //Electricity
          FVal = 0
          //FVal = FMeasure(datafrm, Num, BestCenters,exception)
          //FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          //Ent = Entropy(datafrm, Num, BestCenters,exception)
          Ent = 0
        }
        else if (Num == 14) {
          //Electricity
          FVal = 0
          FVal = FMeasure(datafrm, Num, BestCenters,exception)
          //FValTotal = FValTotal + FVal
          Pur = Purity(datafrm, Num, BestCenters, exception)
          //Ent = Entropy(datafrm, Num, BestCenters,exception)
          Ent = 0
        }
        else {
          //None
          FVal = 0
          FValTotal = 0
          Pur = 0
          Ent = 0
        }

        EntList += Ent
        PurList += Pur
        FvalList += FVal



        Result = Result + BestFit
        TimeinLoop_End = (System.nanoTime() - TimeinLoop_Start) / 1e9 / 60

        TempStr = ( " Run Num = " + i + "\n" +
          "\n K = " + Krange(kloop) + "\n" +
          f"Time " + TimeinLoop_End + "% minutes. \n" +
          "BestFit :" + BestFit + "\n" +
          "Difference :" +
          ((BestFit  - StandardObj(Krange(kloop) - 1)) / StandardObj(Krange(kloop) - 1)) + "\n" +
          " Accuracy : " + Acc + "\n" +
          " F-Measure : " + FVal + "\n" +
          " Entropy : " + Ent + "\n" +
          " Purity : " + Pur + "\n")

        //println("Time = " + TimeinLoop_End)

        WriteToFile(TempStr, true)

      }

      //(MinEnt, MaxEnt, StdEnt, AvgEnt) = Stats(EntList)
      val EntTup = Stats(EntList)

      //(MinPur, MaxPur, StdPur, AvgPur) = Stats(PurList)
      val PurTup = Stats(PurList)
      //(MinFval, MaxFval, StdFval, AvgFval) = Stats(FvalList)
      val FvalTup = Stats(FvalList)


      TempStr = ("\n K = " + Krange(kloop) + "\n" +
        " F-Measure (Avg, Std, Max): " + FvalTup._4 +","+ FvalTup._3 +"," + FvalTup._2 + "\n" +
        " Entropy (Avg, Std, Min): " + EntTup._4 +","+ EntTup._3 +"," + EntTup._1 + "\n" +
        " Purity (Avg, Std, Max): " + PurTup._4 +","+ PurTup._3 +"," + PurTup._2 + "\n")

      WriteToFile(TempStr, true)


    }

    datafrm.unpersist()
    data.unpersist()


    Finished.foreach(x => WriteToFile(x, true) )
    //Finished.foreach(x => println(x))
    //println("Total Time = " + TotalTime)

  }

  def WriteToFile(str: ListBuffer[String]):Unit=
  {
    //val ResultPath = "/home/amr/Downloads/result.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      str.foreach(x => bw.write(x))
    }
    finally bw.close()

  }

  def WriteToFile(str: String, Sep : Boolean = false):Unit=
  {
    //val ResultPath = "/home/amr/Downloads/result.txt"
    val file = new File(ResultPath)
    val bw = new BufferedWriter(new FileWriter(file,true))
    try {
      if (Sep == true)
        {bw.newLine()}
      bw.write(str)
    }
    finally bw.close()

  }

  def Stats(x: ListBuffer[Double]) : (Double, Double, Double, Double) = {
    return(MinList(x), MaxList(x), StdList(x), AvgList(x))
  }

  def MaxList(x: ListBuffer[Double]) : Double ={
    var max : Double = Double.MinValue
    for (i<-0 until x.length)
      {
        if ( x(i) > max )
        {
          max = x(i)
        }
      }
    return max
  }


  def MinList(x: ListBuffer[Double]) : Double ={
    var min : Double = Double.MaxValue
    for (i<-0 until x.length)
    {
      if ( x(i) < min )
      {
        min = x(i)
      }
    }
    return min
  }

  def AvgList(x: ListBuffer[Double]) : Double ={
    var Tot : Double = 0.0

    for (i<-0 until x.length)
    {
      Tot = Tot +  x(i)
    }
    return ( Tot / x.length )
  }



  def StdList(x: ListBuffer[Double]) : Double ={
    var Avg : Double = AvgList(x)
    var Std : Double = 0.0
    var Tot : Double = 0.0

    for (i <- 0 until x.length)
    {
      Tot = Tot + math.pow(x(i) - Avg , 2)
    }


    return ( math.sqrt(Tot / x.length)  )
  }


  def InitKCenters(data: Array[Vector]) : Array[Vector] =
  {

    var Centers: Array[Vector] = new Array[Vector](globalK)
    var CSize : Array[Int] = new Array[Int](globalK)
    val n = data.length
    val d = data(0).toArray.length
    var Class : Array[Int] = new Array[Int](n)
    var temp : Int = 0


    for ( i <-  0 until globalK)
      {
        CSize(i) = 0
        Centers(i) = Vectors.zeros(d)
      }

    for (i <- 0 until n  )
     {
        Class(i) = rand.nextInt(globalK)
     }

    for (i <- 0 until n )
    {
      temp = Class(i).asInstanceOf[Int]
      for ( j <- 0 until d )
      {
        Centers(temp).toArray(j) +=  data(i).toArray(j)//0.0
      }
      CSize(temp) += 1
    }

    for (i <- 0 until globalK )
      {
        for ( j <- 0 until d )
          {
            Centers(i).toArray(j) = Centers(i).toArray(j) / CSize(i).asInstanceOf[Double]
          }
      }

    return Centers

  }


  def CompareObj(value: Double, Ref: Double) : Boolean =
  {
    var RetVal : Boolean = false
    /*if (ObjFunGlobal == "GSOF1" | ObjFunGlobal == "GSOF2" | ObjFunGlobal == "GSOF3")
    {
      if (value > Ref ) //Maximum
        {RetVal = true}
      else
        {RetVal = false}
    }
    else
    {*/
      if (value  < Ref )  //Minimum
      {RetVal = true}
      else
      {RetVal = false}
    //}
    return RetVal

  }

  def ClusterAlgo(data :  RDD[Vector] = null, k: Int, VelMin: ListBuffer[Double], VelMax: ListBuffer[Double],
                  minCol: ListBuffer[Double], maxCol:ListBuffer[Double], d : Int)
  : (Double,Array[Vector]) = //{
  /*def ClusterAlgo(data :  Array[Vector] , k: Int, VelMin: ListBuffer[Double], VelMax: ListBuffer[Double],
                  minCol: ListBuffer[Double], maxCol:ListBuffer[Double], d : Int)
  : (Double,Array[Vector]) =*/
  {

    WorestFit = Double.MinValue
    var RetBestFit: Double = Double.MaxValue

    /*if (ObjFunGlobal == "GSOF1" | ObjFunGlobal == "GSOF2" | ObjFunGlobal == "GSOF3") {
      MinObj = false
      RetBestFit = Double.NegativeInfinity
      WorestFit = Double.PositiveInfinity
    }
    else {*/
    MinObj = true
    RetBestFit = Double.PositiveInfinity
    WorestFit = Double.NegativeInfinity
    //}

    var n: Long = data.count()
    var epsilon: Double = 1e-4
    val Np = 21 //Number of particles
    val max_TL = 5
    val max_EL = 5
    var Index_TL = 0
    var TL: ListBuffer[PSO] = new ListBuffer[PSO] //(max_TL)    // Tabu List
    var EL: ListBuffer[PSO] = new ListBuffer[PSO]
    //(max_EL)    // Elite List
    var EL_V: Array[Vector] = new Array[Vector](max_EL) // Best Velocities
    val MaxIt = 300

    MaxItbefInt = ( (( MaxIt / 100) - IntFact ) * 100 ).toInt

    var TCost : Double = 0.0
    var minMSE : Double = Double.MaxValue

    var Population: ListBuffer[PSO] = new ListBuffer[PSO]
    //(Np)
    var LocalPopulation: ListBuffer[PSO] = new ListBuffer[PSO]
    var BestCenters: Array[Vector] = new Array[Vector](k)
    var str_Fit: String = ""
    //globalK = k
    //data.cache()

    var b_IorD: String = "0"
    //.1
    //val l=1
    var half: Double = 0
    //val rand = new scala.util.Random()
    var centers: Array[Vector] = new Array[Vector](k)
    var newCenters: Array[Vector] = new Array[Vector](k)
    var cost: Double = 0.0
    var Tup: Tuple3[Double, Array[Vector], Double] = (1, newCenters, 1)

    //println("VelMin: " + VelMin)
    for (i <- 0 until Np)
    {
      //println("i :" + i)

      //val numClusters = 2
      //val numIterations = 20
      //val clusters = KMeans.train(data, globalK, 10, KMeans.RANDOM)
      //val Vec = new Array[Double](clusters.clusterCenters.head.size)

      /*for (row<- 0 to clusters.clusterCenters.length-1)
        {
          for (col<- 0 to clusters.clusterCenters(row).size-1)
            {
              Vec.update(col, clusters.clusterCenters(row).toArray(col) )
            }
          centers.update(row,  Vectors.dense(Vec).copy)
        }*/

      centers  = InitKCenters(data.collect()).clone()
      /*centers = initKMeansParallel(data, 1).clone()
      while(centers.length < globalK  )
        {
          centers = initKMeansParallel(data, 1).clone()
        }*/
      //centers = AdjustMaxandMin(centers, minCol, maxCol).clone()
      val obj = new PSO(k)
      if (ObjFunGlobal == "GSOF1")
      {
        //cost = GSOF1(data, data.sparkContext, centers)
        obj.p = centers.clone()
      }
      else if (ObjFunGlobal == "GSOF2") {
        //cost = GSOF2(data, data.sparkContext, centers)
        obj.p = centers.clone()
      }
      else if (ObjFunGlobal == "GSOF3") {
        //cost = GSOF3(data, data.sparkContext, centers)
        obj.p = centers.clone()
      }
      else if (ObjFunGlobal == "kmeans")
      {
        Tup = RecCentersNoCenters(data, data.sparkContext, centers)
        //Tup =RecCentersNewDist(data, data.sparkContext, centers)
        //Tup = RecCentersNoCentersArray(data, centers)
        //Tup =RecCentersNew(data, data.sparkContext, centers)
        cost = Tup._1
        obj.p = centers.clone()//Tup._2.clone()
        TCost = Tup._3

      }

      //78.851

      if ( TCost < minMSE  )
        {minMSE = TCost }
      //newCenters = centers.clone()
      obj.fit = cost
      obj.bfit = cost
      obj.bp = obj.p.clone()
      //val (cost, newCenters) =  RecCenters(data, data.sparkContext, centers)
      //val cost = GSOF1(data, data.sparkContext, centers)
      //val (cost, newCenters) = RecCentersHarmonic(data, data.sparkContext, centers, PHar)


      //obj.v = Array.fill(k)(Vectors.zeros(d))//RandVel(k, d, maxCol, minCol).clone()
      /*if (UpdateFun == "PSO")
      {
        obj.v = RandVel(k, d, maxCol, minCol).clone()
        obj.v = AdjustMaxandMin(obj.v, VelMin, VelMax).clone()
      }*/
      if (obj.fit < RetBestFit )//CompareObj(obj.fit, RetBestFit))
      {
        //(obj.fit < RetBestFit) {
        RetBestFit = obj.fit
        BestCenters = obj.p.clone()
        //str_Fit = str_Fit  + "," +  RetBestFit.toString
      }


      /*if (CompareObj(WorestFit, obj.fit)) //( obj.fit > WorestFit)
      {
        //Add2TL(TL, obj, max_TL, Index_TL)
        //TL = Add2TLOrdered(TL, obj, max_TL)
        Index_TL = Index_TL + 1
        Index_TL = Index_TL % max_TL
        WorestFit = obj.fit
      }*/

      EL = Add2EL(EL, obj, max_EL)
      //println("iiiii = " + i)
      Population += obj.CopyObj()
    }

    WriteToFile("Iteration  :Fit  ")
    WriteToFile(""+ RetBestFit)
    str_Fit += "," + RetBestFit

    var PrevIntenseFit = Double.PositiveInfinity
    var PrevFit = Double.PositiveInfinity
    //var VelRand: Int = rand.nextInt(2)
    Index_TL = -1
    var d_Arr: ListBuffer[Int] = new ListBuffer[Int]

    var i_Diverse: Int = 0
    var i_Intense: Int = 0
    var i_stIntense: Int = 0
    var i_ndIntense: Int = 0
    var i_stDiverse: Int = 0
    var i_ndDiverse: Int = 0

    var b_stIntense: Boolean = false
    var b_ndIntense: Boolean = false
    var b_stDiverse: Boolean = false
    var b_ndDiverse: Boolean = false
    var index_EL = 0//rand.nextInt(EL.length)
    var prand: Double = 0.0
    var aa: Double = 0.0
    var a2: Double = 0.0
    var rand_leader_index: Int = 0


    iteration = 0
    var NoProgress = 1
    //var max_NoProgress = 3

    /*if (UpdateFun == "PSO") {
      max_NoProgress = 3
    }
    else if (UpdateFun == "Whale") {
      max_NoProgress = 13
    }*/

    max_NoProgress = 9
    var NoProgDec: Int = 0
    var  r1 : Double = 0.0
    var  r2 : Double = 0.0

    val c1 = 2
    val c2 = 2
    val w_max = 0.9
    val w_min = 0.2
    var w: Double = 0

     var A: Double = 0.0//2 * a * r1 - a; // Eq. (2.3) in the paper
     var C: Double = 0.0 //2 * r2; // Eq. (2.4) in the paper
     var b : Double = 1.0; //  parameters in Eq. (2.5)
      //(a2 - 1) * rand.nextDouble() + 1; //  parameters in Eq. (2.5)

    var intense_count : Int = 0
    var Diverse_count : Int = 0

    while (iteration < MaxIt)
    {

      //WriteToFile(b_IorD)

      //intense_count  = 0
      Diverse_count = 0
      if (UpdateFun == "WhaleTS")
      {

        if (b_IorD == "1" | b_IorD == "11") //( b_IntenseFactor == TRUE )//(it%% 5  == 0)
        {
          i_Intense = i_Intense + 1

          var deltarand = (Np / 7).asInstanceOf[Int] //rand.nextInt( (Np/2).asInstanceOf[Int])
          if (deltarand > EL.length) {
            deltarand = EL.length
          }
          if (deltarand == 0) {
            deltarand = 1
          }

          val ntemp = GenRandList(Np, deltarand)
          for (m <- 0 until ntemp.length) {
            //rand.nextInt(EL.length)
            //Population(ntemp(m)) = EL(rand.nextInt(2)).CopyObj()//EL(0).CopyObj() //(rand.nextInt(2)).CopyObj() // EL(0).CopyObj()
          }

          if (b_IorD == "11") //(PrevIntenseFit == ReturnFit)
          {
            //b_IorD = "011"
            //NoProgress = -1

            //var deltarand = 4//(Np / 7).asInstanceOf[Int] //rand.nextInt( (Np/2).asInstanceOf[Int])
            //if (deltarand > EL.length) {
            //  deltarand = EL.length
            //}

            //if (deltarand == 0) {
            // deltarand = 1
            //}

            //Population = InstensifyFun(Population, Np, minCol, maxCol)
            Population = CrossOverElite(Population, EL)


            //Population = CrossOverFun(Population)
            //Population = CrossOverEliteByCol(Population, EL)
            //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, BestCenters, EL)

            /*val ntemp = GenRandList(Np, deltarand)
            for (m <- 0 until ntemp.length) {
              //rand.nextInt(EL.length)
              Population(ntemp(m)) = EL(rand.nextInt(2)).CopyObj()//EL(0).CopyObj() //(rand.nextInt(2)).CopyObj() // EL(0).CopyObj()
            }*/

            b_stIntense = true
          }
          else if (b_IorD == "1") {
            //b_IorD = "01"
            //NoProgress = -1
            //rand.nextInt(3)c
            //for (m <- 0 until ntemp.length) {
              //Population(ntemp(m)) = EL(rand.nextInt(2)).CopyObj()
            //}
            //Population = C         rossOverElite(Population , EL)
            //Population = InstensifyEliteFun(Population, Np, minCol, maxCol, BestCenters, EL)
            Population = CrossOverElite(Population, EL)
            //Population = LocalElite(Population, EL, minCol, maxCol)
            b_ndIntense = true
          }


        }
        else if (b_IorD == "2" | b_IorD == "21") {

          if (b_IorD == "21") {
            //Population = CrossOverFunEl(Population,EL)
            //Population = CrossOverFunByCol(Population)
            Population = CrossOverFun(Population)
            //Population = LocalElite(Population, EL, minCol, maxCol)

            //Population = LocalElite(Population, EL, minCol, maxCol)
            b_stDiverse = true
          }

          else if (b_IorD == "2") {
            print("diverse 2")

            //Population = CrossOverFun(Population)
            ///Last Edit 3/4/2018
            //Population = CrossOverTabu(Population , TL, EL)
            Population = CrossOverFun(Population)
            //Population = LocalSearch(Population, Np, minCol, maxCol)
            //Population = DiversifyFun(Population, Np, minCol, maxCol)
            b_ndDiverse = true
          }
        }
      }
      /*else if (b_IorD == "22") {
        var d_Num: Int = (Np / 5).asInstanceOf[Int] //rand.nextInt(math.round(Np / 5).asInstanceOf[Int]) //base::sample(length(TL)/2, 1)
        if (d_Num == 0) {
          d_Num = 1
        }
        d_Arr = GenRandList(Np, d_Num)
      }*/

      PrevIntenseFit = RetBestFit

      //println("Before Particles")
      //index_EL = rand.nextInt(2)
      /*if (EL.length > 2) {
        index_EL = rand.nextInt(2)
      }
      else {
        index_EL = rand.nextInt(EL.length)
      }*/

      if ( (UpdateFun == "WhaleTS")  )
        {
          //Population = LocalElite(Population, EL, minCol, maxCol)
        }



      w= w_max - iteration *(( w_max - w_min ) / MaxIt.asInstanceOf[Double]);
      //w = w_min + ((w_max - w_min) * ((MaxIt - (iteration+1)) / MaxIt.asInstanceOf[Double]))
      //Population = LocalElite(Population, EL, minCol, maxCol)

      //Population(rand.nextInt(Population.length)) = EL(rand.nextInt(EL.length)).CopyObj()
      //WriteToFile("a:" + a.toString)

      //a=2-t*((2)/Max_iter); % a decreases linearly fron 2 to 0 in Eq. (2.3)

      // a2 linearly dicreases from -1 to -2 to calculate t in Eq. (3.12)
      //a2=-1+t*((-1)/Max_iter);


      aa = 2.0 - (iteration+1) * ((2.0) / MaxIt.asInstanceOf[Double])
      a2 = -1.0 + (iteration+1) * ((-1.0) / MaxIt.asInstanceOf[Double])
      prand = rand.nextDouble()

      for (g <- 0 until Np )
      {
        //index_EL = rand.nextInt(2)
        r1 = rand.nextDouble()
        r2 = rand.nextDouble()

        A =  2.0 * aa * r1 - aa; // Eq. (2.3) in the paper
        //A = aa
        C = 2.0 * r2; // Eq. (2.4) in the paper
        //C =aa

        b = 1.0; //  parameters in Eq. (2.5)
        l = (a2 - 1.0) * rand.nextDouble() + 1.0; //  parameters in Eq. (2.5)


        if (UpdateFun == "PSO")
        {
          val velTemp = PSOVel(Population((g)).bp, Population((g)).p, Population((g)).v,
            EL(0).p, c1, c2, w).clone()

          // Apply Velocity Limits
          Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
          //Population(g).v = velTemp.clone()\
          Population(g).p = Add2Vec(Population(g).p, Population((g)).v, "+").clone()
        }
        else if (UpdateFun == "Whale")
        {
          if (prand < 0.5)
          {
            if ( math.abs(A) >= 1 )
            {
              rand_leader_index = rand.nextInt(Np)
              Population(g).p = WhaleVel(Population(rand_leader_index).p, Population(g).p,
                EL(0).p, C, A, prand, b, l).clone()
            }
            else if ( math.abs (A) < 1 )
            {
              //D_Leader = abs(C * Leader_pos(j) - Positions(i, j));  % Eq.(2.1)
              //Positions(i, j) = Leader_pos(j) - A * D_Leader;       % Eq.(2.2)
              Population(g).p = WhaleVel(Population(0).p, Population(g).p,
                EL(0).p , C, A, prand, b, l).clone()

            }
            else if ( prand >= 0.5  ) {
              //distance2Leader = abs(Leader_pos(j) - Positions(i, j)); % Eq.(2.5)
              //Positions(i, j) = distance2Leader * exp(b.* l).* cos (l.* 2 * pi) +Leader_pos(j);
              Population(g).p = WhaleVel(Population(0).p, Population(g).p,
                EL(0).p, C, A, prand, b, l).clone() //rand.nextInt(3)

            }
          }

        }
        else if ((UpdateFun == "WhaleTS") )//& (b_IorD != "1") & (b_IorD != "11") & (b_IorD != "2") & (b_IorD != "21"))
        {
          //rand.nextGaussian()//.nextDouble() //rand.nextDouble(); // p in Eq. (2.6)
          //WriteToFile(prand.toString, true)
          //index_EL = rand.nextInt(2)//EL.length)
          if (prand <= 0.5)
          {
            var velTemp : Array[Vector] = new Array[Vector](globalK)
            if (math.abs(A) >= 1)
            {
              rand_leader_index = rand.nextInt(Np)
              //velTemp = PSOVel(Population((g)).bp, Population((g)).p, Population((g)).v,
                //Population(rand_leader_index).p, c1, c2, w).clone()
              Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                EL(rand.nextInt(2)).p, C, A, prand, b, l).clone()
            }
            else //if (math.abs(A) < 1)
            {
              if (iteration < MaxItbefInt)
              {
                Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                  EL(rand.nextInt(EL.length)).p, C, A, prand, b, l).clone()
                //velTemp = PSOVel(Population((g)).bp, Population((g)).p, Population((g)).v,
                  //EL(rand.nextInt(EL.length)).p, c1, c2, w).clone()
              }
              else{
                Population(g).p = ComputeVelWhale(Population(rand_leader_index).p, Population(g).p,
                  EL(rand.nextInt(2)).p, C, A, prand, b, l).clone()
                //velTemp = PSOVel(Population((g)).bp, Population((g)).p, Population((g)).v,
                  //EL(rand.nextInt(2)).p, c1, c2, w).clone()
              }

              //Population(g).p = ComputeVelWhale(Population(0).p, Population(g).p,
                //EL(rand.nextInt(3)).p , C, A, prand, b, l).clone()

            }
            //Population(g).v = AdjustMaxandMin(velTemp, VelMin, VelMax).clone()
            //Population(g).p = Add2Vec(Population(g).p, Population((g)).v, "+").clone()
          }

          else if (prand > 0.5)
          {
            intense_count  += 1
            index_EL = rand.nextInt(2)

            //Exploitation Phase
            Population(g).p = ComputeVelWhale(Population(0).p, Population(g).p,
              EL(index_EL).p, C, A, prand, b, l).clone() //rand.nextInt(3)
          }


        }

        //We need to optimize the velocity to allow the swarm to migrate effectively
        //We need to keep track of the velocity and best values of it
        //Enhancement is obtained by executing the best velocity
        //Diversification is applied by increasing the velocity to explore far regions

        //println("Evaluation")

        //if ((UpdateFun == "Whale")  & (b_IorD != "2")) //(b_IorD != "11") & (b_IorD != "1") & (b_IorD != "21") &
        //{
        //WriteToFile(iteration.toString +":"+  Population(g).p.head.size.toString  + ":" + Population(g).p.length.toString )
        Population(g).p = AdjustMaxandMin(Population(g).p, minCol, maxCol).clone()
        // Evaluation
        if (ObjFunGlobal == "GSOF1") {
          //cost = GSOF1(data, data.sparkContext, Population(g).p)
        }
        else if (ObjFunGlobal == "GSOF2") {
          //cost = GSOF2(data, data.sparkContext, Population(g).p)
        }
        else if (ObjFunGlobal == "GSOF3") {
          //cost = GSOF3(data, data.sparkContext, Population(g).p)
        }
        else if (ObjFunGlobal == "kmeans") {
          //Tup = RecCentersNoCentersArray(data, Population(g).p)
          Tup = RecCentersNoCenters(data, data.sparkContext, Population(g).p)
          //Tup =RecCentersNewDist(data, data.sparkContext, Population(g).p)
          //Tup = RecCentersNew(data, data.sparkContext, Population(g).p)
          cost = Tup._1
          //newCenters = Population(g).p.clone()
          //Population(g).p = Tup._2.clone()
          TCost = Tup._3
        }

        Population((g)).fit = cost
        if ( Population((g)).fit < Population((g)).bfit )
          {
            Population((g)).bp = Population((g)).p
            Population((g)).bfit = Population((g)).fit
          }

        if ( TCost <  minMSE )
        {minMSE = TCost }

        if (EL.length == max_EL) {
          if (Population(g).fit < EL(max_EL - 1).fit) //(Population(g).fit < EL(max_EL-1).fit )
          {
            EL = Add2EL(EL, Population(g), max_EL)
          }
        }
        else if (EL.length < max_EL) {
          EL = Add2EL(EL, Population(g), max_EL)
        }

        if (Population(g).fit < RetBestFit) //(Population(g).fit < RetBestFit)
        {
          RetBestFit = Population((g)).fit
          BestCenters = Population((g)).p.clone()
        }

      }

      str_Fit +=  "," + RetBestFit.toString
      //str_Fit +=  "," + minMSE.toString

      if (PrevIntenseFit == RetBestFit)
      {
        NoProgress = NoProgress + 1
      }
      else
      {
        PrevIntenseFit = RetBestFit
      }


      //println("Adjustments")
      if (UpdateFun == "WhaleTS")
      {
        if (NoProgress >= max_NoProgress) {
          if (mb_OnlyIntense == true | mb_OnlyDiverse == true | mb_IntenseDiverse == true) {
            if (mb_OnlyIntense == true) {
              //NoProgress = 0
              if (b_IorD == "0") {
                b_IorD = "1"
                NoProgress = max_NoProgress - 1
              }
              else if (b_IorD == "1") {
                b_IorD = "11"
                NoProgress = max_NoProgress - 1 //-1
              }
              else if (b_IorD == "11") {
                b_IorD = "0"
                NoProgress = 0 //max_NoProgress - 2
              }
            }
            else if (mb_OnlyDiverse == true) {
              if (b_IorD == "0") {
                b_IorD = "2"
                NoProgress = max_NoProgress - 1
              }
              else if (b_IorD == "2") //(PrevIntenseFit == ReturnFit)
              {
                b_IorD = "21"
                NoProgress = max_NoProgress - 1
              }
              else if (b_IorD == "21") {
                b_IorD = "0"
                NoProgress = 0 //max_NoProgress - 2
              }
            }
            else if (mb_IntenseDiverse == true) {
              //NoProgress = 0
              if (b_IorD == "0") {
                b_IorD = "1" //"1"
                NoProgress = max_NoProgress - 1
              }
              else if (b_IorD == "1") {
                b_IorD = "011"
                NoProgress = max_NoProgress - 1 //-1
              }
              else if (b_IorD == "11") {
                b_IorD = "011"
                NoProgress = 0 //max_NoProgress - 2
              }
              else if (b_IorD == "011") {
                b_IorD = "21" //"2"
                NoProgress = max_NoProgress - 1
              }
              else if (b_IorD == "2") //(PrevIntenseFit == ReturnFit)
              {
                b_IorD = "21"
                NoProgress = max_NoProgress - 1
              }
              else if (b_IorD == "21") {
                b_IorD = "0"
                NoProgress = 0 //max_NoProgress - 2
              }
            }
          }
        }
      }
      //WriteToFile( iteration.toString + ":" + RetBestFit.toString , true )
      //WriteToFile( iteration.toString + ":" + minMSE.toString , true )

      iteration = iteration + 1
    }

    if (CompareObj(EL(0).fit, RetBestFit)) //(EL(0).fit <  RetBestFit )
    {
      RetBestFit = EL(0).fit
      BestCenters = EL(0).p.clone()
    }

    /*if (UpdateFun == "PSO")
    {
      if (CompareObj(EL(0).bfit, RetBestFit)) //(EL(0).bfit <  RetBestFit )
      {
        RetBestFit = EL(0).bfit
        BestCenters = EL(0).bp.clone()
      }
    }*/


    //str_Fit += "," + RetBestFit
    str_Fit += "," + minMSE
    WriteToFile( str_Fit , true )

    /*Tup = RecCenters(data, data.sparkContext, BestCenters)
    cost = Tup._1
    BestCenters = Tup._2.clone()
    BestCenters = AdjustMaxandMin(BestCenters, minCol, maxCol).clone()
    if ( cost < RetBestFit)
      {
        RetBestFit = cost
      }*/

    //BestCenters.foreach(x=> println(x))
    //data.unpersist()
    /*val iterationTimeInSeconds = (System.nanoTime() - iterationStartTime) / 1e9 / 60
    println(f"Iterations took $iterationTimeInSeconds%.3f minutes.")
    println("Number of iterations :" + (iteration))
    println("K :" + k)
    println("RetBestFit :" + RetBestFit)
    println("Fit :" + (RetBestFit * n))
    println("Difference :" + (((RetBestFit * n) - StandardObj) / StandardObj).formatted("0.00000") )*/

    /*WriteToFile("Intensification: " + i_Intense, true)
    WriteToFile("Diversification: " +i_Diverse)
    WriteToFile("First Intense Improvement: " +i_stIntense,true)
    WriteToFile("Second Intense Improvement: " +i_ndIntense,true)
    WriteToFile("First Diverse Improvement: " +i_stDiverse,true)
    WriteToFile("Second Diverse Improvement: " +i_ndDiverse,true)*/

    //WriteToFile("\n" + str_Fit)
    (RetBestFit, BestCenters)

  }

  def WhaleVel(Randp :Array[Vector], p:Array[Vector], EL: Array[Vector],
                C: Double, A: Double, prand: Double, b : Double, l: Double  ): Array[Vector] =
  {

    val Vec = new Array[Double](p.head.size)
    val result : Array[Vector] = p.clone()//new Array[Vector](p.length)
    var distance2Leader : Double = 0.0
    var delta_d : Int = 0
    var d: Int = p.head.size
    val r = p.length

    for ( h <- 0 until r )//p.length )
    {
      for (j <- 0 until d )//p.head.size)
      {
        if (prand < 0.5)
        {
          if (math.abs(A) >= 1)
          {
            Vec.update(j, Randp(h)(j) - ( A * math.abs( C * Randp(h)(j) - p(h)(j)) ) )
          }
          else if (math.abs(A) < 1)
          {
            Vec.update(j, EL(h)(j) - (A * math.abs( C * EL(h)(j) - p(h)(j))))
          }
        }
        else if (prand >= 0.5)
        {
          distance2Leader = math.abs(EL(h).toArray(j) - p(h).toArray(j)); // Eq. (2.5)

          Vec.update(j, distance2Leader * math.exp(b * l) * math.cos(l * 2 * math.Pi) +
            EL(h).toArray(j));
        }
      }
      result.update(h,  Vectors.dense(Vec).copy)

    }
    result
  }

  def ComputeVelWhale(Randp :Array[Vector], p:Array[Vector], EL: Array[Vector],
                      C: Double, A: Double, prand: Double, b : Double, l: Double  ): Array[Vector] =
  {

    //val rand = new scala.util.Random()
    val Vec = new Array[Double](p.head.size)
    var result : Array[Vector] = p.clone()//new Array[Vector](p.length)

    //X_rand = Positions(rand_leader_index,:);
    //D_X_rand = abs(C * X_rand(j) - Positions(i, j));
    // Eq .(2.7)
    //Positions(i, j) = X_rand(j) - A * D_X_rand;
    var distance2Leader : Double = 0.0
    var delta_d : Int = 0
    var d: Int = p.head.size
    var GList : ListBuffer[Int] = new ListBuffer[Int]()
    for ( ttl <- 0 until d)
      {
        GList += ttl
      }
    val r = p.length

    for ( h <- 0 until r )//p.length )
    {
      delta_d = d//rand.nextInt(d) // d
      if (delta_d  == 0)
      {
        delta_d = 1
      }
      //val GList = GenRandList(d, delta_d)

      for (j <- 0 until delta_d )//p.head.size)
      {

        if (prand <= 0.5)
        {
          if (math.abs(A) >= 1)
          {
            //Vec.update(GList(j), p(h)(GList(j)) -( A * (  Randp(h)(GList(j)) -  p(h)(GList(j))) ) )
            result(h).toArray(GList(j)) =  p(h).toArray(GList(j)) -
              ( (A/4.0) * (  Randp(h).toArray(GList(j)) -  p(h).toArray(GList(j))) )
            //Vec.update(j, p(h)(j) + ( C * (  Randp(h)(j) -  p(h)(j)) ) )
          }
          else if (math.abs(A) < 1)
          {
             //Vec.update(GList(j), p(h)(GList(j)) - ( A  * (  EL(h)(GList(j)) -   p(h)(GList(j))) ) )
            result(h).toArray(GList(j)) = p(h).toArray(GList(j)) - ( (A/4.0)* (  EL(h).toArray(GList(j)) -   p(h).toArray(GList(j))) )
            //Vec.update(j, p(h)(j) + ( C * (  EL(h)(j) -   p(h)(j)) ) )
          }
        }
        else if (prand > 0.5)
        {
          distance2Leader = math.abs(EL(h).toArray(GList(j)) - p(h).toArray(GList(j))); // Eq. (2.5)
          //Vec.update(GList(j), distance2Leader * math.exp(b * l) * math.cos(l * 2 * math.Pi) + EL(h).toArray(GList(j)));
          //p(h).toArray(GList(j)))
          result(h).toArray(GList(j)) = EL(h).toArray(GList(j)) + (distance2Leader * math.exp(b * l) * math.cos(l * 2 * math.Pi))
        }
      }
     // result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  def PSOVel(bp :Array[Vector] , p:Array[Vector], v:Array[Vector], EL: Array[Vector],
             c1: Double , c2: Double, w: Double ): Array[Vector] =
  {
    val result : Array[Vector] = new Array[Vector](p.length)
    val rand = new scala.util.Random()
    var t1: Double = 0.0
    var t2: Double = 0.0
    val Vec = new Array[Double](p.head.size)
    //vel(i,j)=w*vel(i,j)+c1*rand()*(pBest(i,j)-pos(i,j))+c2*rand()*(gBest(j)-pos(i,j));
    for (h <- 0 until p.length)
    {
      for (j <- 0 until p.head.size)
      {
        t1 = c1*rand.nextDouble()
        t2= c2*rand.nextDouble()

        if ( v(0) != null )
        {
          Vec.update(j,  (  (  w * v(h)(j)) +
            (  t1 *  (bp(h)(j) - p(h)(j) )) +
            (  t2 *  (EL(h)(j) - p(h)(j) ))
            ))
        }
        else
        {
          Vec.update(j ,  ( (  t1 * (bp(h)(j) - p(h)(j) )) +
            (  t2 * (EL(h)(j) - p(h)(j) )) ) )
        }
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  def main(args: Array[String]): Unit =
  {

    var b_Run: Boolean = false
    WriteToFile("/////////////", true)
    //WriteToFile("K-means Update Centers",true)
    //WriteToFile(UpdateFun,true)
    //max_Runs = 3

    val l = List(4,5,6,7,8,9,10)//4, 3,5,2,4, 15,16 )//List(1, 15, 16, 2, 4, 5 ) //1,2,3,4,5,6,7,8,9,10,14
    WriteToFile("/////////////", true)
    //WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
    //WriteToFile(UpdateFun,true)
    //val l =  List(10,13)

    //if ( b_Run == false )
    //mb_OnlyDiverse = true

    val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test")
      .getOrCreate()

    ObjFunGlobal = "kmeans"
    UpdateFun = "Whale"
    UpdateFun = "PSO"
    UpdateFun = "PSO"

    //for (ttt <- 1 until 5) {

    for (i <- 0 until l.length)
    {
      //UpdateFun = "Whale"
      /*for (j <- 0 until 4) {
        if (j == 1) {
          WriteToFile("Intensification Only", true)
          mb_OnlyIntense = true
          mb_OnlyDiverse = false
          mb_IntenseDiverse = false
        }
        else if (j == 2) {
          WriteToFile("Diversification Only", true)
          mb_OnlyIntense = false
          mb_OnlyDiverse = true
          mb_IntenseDiverse = false
        }
        else if (j == 0) {
          WriteToFile("Both Intensification and Diversification", true)
          mb_OnlyIntense = false
          mb_OnlyDiverse = false
          mb_IntenseDiverse = true
        }
        else if (j == 3) {
          WriteToFile("Neither Intensification nor Diversification", true)
          mb_OnlyIntense = false
          mb_OnlyDiverse = false
          mb_IntenseDiverse = false
        }

        RunCluster(i, spark)
      }*/
      //mb_OnlyDiverse = false
      //mb_OnlyIntense = false


      mb_IntenseDiverse = true
      UpdateFun = "WhaleTS"
      WriteToFile(UpdateFun, true)
      RunCluster(l(i), spark)

      UpdateFun = "Whale"
      WriteToFile(UpdateFun, true)
      RunCluster(l(i), spark)

      UpdateFun = "PSO"
      WriteToFile(UpdateFun, true)
      RunCluster(l(i), spark)

      /*for ( max_NoProgress <- 7 until 15 by 2) {
        WriteToFile("max_NoProgress: " + max_NoProgress.toString)
        RunCluster(l(i), spark)
      }*/


    //}
    }

    spark.stop()
    return

    //for (kloop<- 10 to 7 by -1)
     // {
       // println(kloop)
      //}

    /*ObjFunGlobal  = "GSOF1"
     UpdateFun = "PSO"
     WriteToFile("/////////////",true)
     WriteToFile("PSO   GSOF1",true)
     WriteToFile(UpdateFun,true)
     for (dataNum <- 0 to l.length)
     { RunCluster(l(dataNum), spark) }*/

    /*ObjFunGlobal  = "GSOF1"
    UpdateFun = "Whale"
    WriteToFile("/////////////",true)
    WriteToFile("Whale   GSOF1",true)
    WriteToFile(UpdateFun,true)
    for (dataNum <- 0 to l.length)
    { RunCluster(l(dataNum), spark) }*/

    /*ObjFunGlobal  = "GSOF2"
    UpdateFun = "PSO"
    WriteToFile("/////////////",true)
    WriteToFile("PSO   GSOF2",true)
    WriteToFile(UpdateFun,true)
     for (dataNum <- 0 to l.length)
    { RunCluster(l(dataNum), spark) }*/

    /*ObjFunGlobal  = "GSOF2"
    UpdateFun = "Whale"
    WriteToFile("/////////////",true)
    WriteToFile("Whale   GSOF2",true)
    WriteToFile(UpdateFun,true)
    for (dataNum <- 0 to l.length)
    { RunCluster(l(dataNum), spark) }*/

    /*ObjFunGlobal  = "GSOF3"
    UpdateFun = "PSO"
    WriteToFile("/////////////",true)
    WriteToFile("PSO   GSOF3",true)
    WriteToFile(UpdateFun,true)
     for (dataNum <- 0 to l.length)
    { RunCluster(l(dataNum), spark) }*/

    /*ObjFunGlobal  = "GSOF3"
    UpdateFun = "Whale"
    WriteToFile("/////////////",true)
    WriteToFile("Whale   GSOF3",true)
    WriteToFile(UpdateFun,true)
    for (dataNum <- 0 to l.length)
    { RunCluster(l(dataNum), spark) }*/

    /*ObjFunGlobal  = "kmeans"
    UpdateFun = "PSO"
    WriteToFile("/////////////",true)
    WriteToFile("PSO   kmeans",true)
    WriteToFile(UpdateFun,true)
     for (dataNum <- 0 to l.length)
    { RunCluster(l(dataNum), spark) }*/

    /*ObjFunGlobal  = "kmeans"
    UpdateFun = "Whale"
    WriteToFile("/////////////",true)
    WriteToFile( UpdateFun + "   "  + ObjFunGlobal ,true)
    WriteToFile(UpdateFun,true)
    for (dataNum <- 0 to l.length)
    { RunCluster(l(dataNum), spark) }


    spark.stop()*/

  }




  def ComputeVel(bp :Array[Vector] , p:Array[Vector], v:Array[Vector], EL: Array[Vector],
                 c1: Double , c2: Double, r1: Double, r2 : Double, w: Double ): Array[Vector] =
  {

    val result : Array[Vector] = new Array[Vector](p.length)
    //var Vec: Array[Double] = p1(1).toArray

    // val t: Double = iteration / MaxIt
    val rand = new scala.util.Random()
    var t1: Double = 0.0
    var t2: Double = 0.0
    var r3: Double = r1
    var r4: Double = r2
    val Vec = new Array[Double](p.head.size)

    for (h <- 0 until p.length)
      {

       for (j <- 0 until p.head.size)
          {
            r3 = rand.nextDouble()
            r4 = rand.nextDouble()
            t1 = c1*r3
            t2= c2*r4

            if ( v(0) != null & v.head.size > 0)
              {
                Vec.update(j,  (  (  w * v(h)(j)) +
                  (  t1 *  (bp(h)(j) - p(h)(j) )) +
                  (  t2 *  (EL(h)(j) - p(h)(j) ))
                  ))
              }
            else
              {
                Vec.update(j ,  ( (  t1 * (bp(h)(j) - p(h)(j) )) +
                  (  t2 * (EL(h)(j) - p(h)(j) )) ) )
              }

          }
        result.update(h,  Vectors.dense(Vec).copy)
      }


    /*Population((h)).v <- Vectors.dense(
    ( (iteration / MaxIt)  * Population((h)).v.toArray ) +
      ( (c1*r1)*(Population((h)).bp.toArray - Population((h)).p.toArray)) +
      ((c2*r2)*(EL(0).p.toArray-Population((h)).p.toArray)) )*/

    result
  }

  def Add2Vec(p1:  Array[Vector], p2:  Array[Vector], op:String ) :  Array[Vector] =
  {
    val result : Array[Vector] = new Array[Vector](p1.length)
    //var Vec: Array[Double] = p1(1).toArray
    val Vec = new Array[Double](p1.head.size)

    for (i<- 0 until p1.length)
      {
        for ( j <- 0 until p1.head.size)
          {
            if (op == "+")
            { Vec.update(j , p1(i)(j) + p2(i)(j)) }
            else if (op == "-")
            { Vec.update(j , p1(i)(j) - p2(i)(j)) }
            else if (op == "*")
            { Vec.update(j , p1(i)(j) * p2(i)(j)) }
            else if (op == "/")
            { Vec.update(j , p1(i)(j) / p2(i)(j)) }
          }

        //val  Vec = p1(i).zip(p2(i)).map { case (x, y) => x + y }}

        result.update(i, Vectors.dense(Vec).copy)
      }
    result
  }


  //Local Search
  def LocalSearch( Population : ListBuffer[PSO], Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double] )
  : ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    //var Population : ListBuffer[PSO] = new ListBuffer[PSO]
    //var Temp : Array[Vector] = Population(0).p.clone()
    val r : Int = Population(0).p.length
    val d : Int = Population(0).p.head.size
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]()
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]()
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    var rand_Val: Double = 0.0
    var t: Double = 0.0
    var obj : PSO = new PSO(r)
    val delta_P = rand.nextInt((Np/2).asInstanceOf[Int]) //math.round(Np).asInstanceOf[Int] //Np
    // val rand_P = Array.range(0 , Np)
    val rand_P = GenRandList(Np, delta_P)


    for ( p<- 0 until delta_P )
    {
      val Temp = Population(rand_P(p)).p.clone()
      //val obj = new PSO(r)

      delta_Row = rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row)

      for ( i<- 0 until delta_Row )
      {
        delta_Col = rand.nextInt((d).asInstanceOf[Int]) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col)

        for ( j<- 0 until delta_Col )
        {
          rand_Val = rand.nextDouble()

          if (rand_Val  >= 0.5 )
          {
            t =  0.1 * rand.nextDouble() * ( VarMax(rand_Col(j)) - Temp(rand_Row(i))(rand_Col(j)) )
            t = t + Temp(rand_Row(i))(rand_Col(j))
          }

          else
          {
            t =  0.1 * rand.nextDouble() * ( Temp(rand_Row(i))(rand_Col(j)) - VarMin(rand_Col(j)) )
            t = Temp(rand_Row(i))(rand_Col(j)) - t
          }

          if (t == 0)
            {     t = Temp(rand_Row(i))(rand_Col(j))    }

          Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) = t

        }
      }

      //obj.p = Temp.clone()
      //Population += obj.CopyObj()
    }

    Population

  }

  //CrossOver Tabu List
  def CrossOverTabu(Population : ListBuffer[PSO], TL: ListBuffer[PSO], EL: ListBuffer[PSO]) : ListBuffer[PSO] =
  {

    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = (Population.length / 2).asInstanceOf[Int] //Np //round(0.7*Np)
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    val rand = new scala.util.Random()
    var EL_Index : Int =0 //rand.nextInt(2)
    EL_Index = rand.nextInt(2)
    var delta_Row : Int = 0

    for (p <- 0 until delta_P)
    {
      // = math.round(r * 0.3).asInstanceOf[Int]  //base::sample(r,1)
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row =  1 }

      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      val index_TL  = rand.nextInt(TL.length)
      Population(rand_P(p)).p = EL(rand.nextInt(2)).p.clone()

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)) .p(rand_Row(i))  =
          Vectors.dense(TL( index_TL ).p(rand_Row(i)).toArray).copy

        //////////V
        //Population(( (rand_P(p)) )).v(rand_Row(i)) =
        //Vectors.dense(TL( index_TL ).v(rand_Row(i)).toArray)

        //////////BP
        //Population(( (rand_P(p)) )).bp(rand_Row(i)) =
        //Vectors.dense(TL( index_TL ).bp(rand_Row(i)).toArray)

      }
    }

    Population

  }

  //CrossOver_fun
  def CrossOverFun(Population : ListBuffer[PSO]) : ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    var Np: Int = Population.length
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Np)//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
    {delta_P = 1}
    val rand_P =  GenRandList(Np, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)

    var delta_Row : Int = 0
    var Replacement: Int = 0


    for (p <- 0 until delta_P)
    {

      //math.ceil(d/2).asInstanceOf[Int]
      //delta_Row = math.round(r * 0.3).asInstanceOf[Int]  //base::sample(r,1)
      delta_Row = rand.nextInt((r).asInstanceOf[Int])  //rand.nextInt(r/2) //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1}

      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {
        if ( rand_P(p) < Np-1 )
        {
          //////////P
          //val xxx= rand.nextInt(Np)
          //val t1 = Population( xxx).p(rand_Row(i)).toArray//(rand_P(p)+1) ).p(rand_Row(i)).toArray

          val t1 = Population( rand_P(p)+1 ).p(rand_Row(i)).toArray//(rand_P(p)+1) ).p(rand_Row(i)).toArray

          /*Population(rand_P(p)+1) .p(rand_Row(i))  =
            Vectors.dense(Population(( rand_P(p) )).p(rand_Row(i)).toArray).copy*/

          Population(( rand_P(p) )).p(rand_Row(i)) = Vectors.dense(t1).copy
          //////////V
          /*val t2 = Population(( (rand_P(p)+1) )).v(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).v(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).v(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( (rand_P(p)+1) )).bp(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).bp(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).bp(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
        else{
          //////////P
          //val xxx= rand.nextInt(Np)
          //val t1 = Population(xxx).p(rand_Row(i)).toArray.clone() //rand_P(p) - 1)).p(rand_Row(i)).toArray.clone()

          val t1 = Population(rand_P(p) - 1).p(rand_Row(i)).toArray.clone() //rand_P(p) - 1)).p(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)) )).p(rand_Row(i)) = Vectors.dense(t1).copy

          /*Population(( rand_P(p) )).p(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).p(rand_Row(i)).toArray).copy*/
          //////////V
          /*val t2 = Population(( rand_P(p) )).v(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).v(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).v(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( rand_P(p) )).bp(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).bp(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).bp(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
      }
    }

    Population

  }

  //CrossOver_fun
  def CrossOverFunEl(Population : ListBuffer[PSO], EL : ListBuffer[PSO] ) : ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Population.length/2)//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
    {delta_P = 1}
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)

    var delta_Row : Int = 0
    var Replacement: Int = 0
    val xxx= rand.nextInt(EL.length)

    for (p <- 0 until delta_P)
    {

      //delta_Row = math.round(r * 0.3).asInstanceOf[Int]  //base::sample(r,1)
      delta_Row = rand.nextInt((r).asInstanceOf[Int])  //rand.nextInt(r/2) //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1}

      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {

        val t1 = EL( xxx).p(rand_Row(i)).toArray//(rand_P(p)+1) ).p(rand_Row(i)).toArray

        if ( rand_P(p) < Population.length-1 )
        {
          //////////P
          //val t1 = Population( Replacement) ).p(rand_Row(i)).toArray

          /*Population(rand_P(p)+1) .p(rand_Row(i))  =
            Vectors.dense(Population(( rand_P(p) )).p(rand_Row(i)).toArray).copy*/

          Population(( rand_P(p) )).p(rand_Row(i)) = Vectors.dense(t1).copy
          //////////V
          /*val t2 = Population(( (rand_P(p)+1) )).v(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).v(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).v(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( (rand_P(p)+1) )).bp(rand_Row(i)).toArray.clone()

          Population(( (rand_P(p)+1) )).bp(rand_Row(i)) =
          Vectors.dense(Population(( rand_P(p) )).bp(rand_Row(i)).toArray).copy

          Population(( rand_P(p) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
        else{
          //////////P

          Population(( (rand_P(p)) )).p(rand_Row(i)) = Vectors.dense(t1).copy

          /*Population(( rand_P(p) )).p(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).p(rand_Row(i)).toArray).copy*/
          //////////V
          /*val t2 = Population(( rand_P(p) )).v(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).v(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).v(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).v(rand_Row(i)) = Vectors.dense(t2).copy
          //////////BP
          val t3 = Population(( rand_P(p) )).bp(rand_Row(i)).toArray.clone()

          Population(( rand_P(p) )).bp(rand_Row(i)) =
            Vectors.dense(Population(( (rand_P(p)-1) )).bp(rand_Row(i)).toArray).copy

          Population(( (rand_P(p)-1) )).bp(rand_Row(i)) = Vectors.dense(t3).copy*/
        }
      }
    }

    Population

  }

  def CrossOverFunByCol(Population : ListBuffer[PSO]) : ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = rand.nextInt(( Population.length/2).asInstanceOf[Int]) //Np //round(0.7*Np)

    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]

    var delta_Row : Int = 0
    var delta_Col : Int = 0

    for (p <- 0 until delta_P)
    {
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.5).asInstanceOf[Int] //rand.nextInt(r/2)//  //base::sample(r,1)
      //delta_Row = math.round(r).asInstanceOf[Int]  //rand.nextInt(r/2) //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1}

      val rand_Row =  GenRandList(r , delta_Row)//base::sample(r,delta_Row,replace=FALSE)
      for( i <- 0 until delta_Row)
      {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        for( j <- 0 until delta_Col)
        {

          if (rand_P(p) < Population.length - 1) {
            //////////P
            val t1 = Population((rand_P(p) + 1)).p(rand_Row(i)).toArray((rand_Col(j)))

            Population(rand_P(p) + 1).p(rand_Row(i)).toArray((rand_Col(j))) =
              Population((rand_P(p))).p(rand_Row(i)).toArray((rand_Col(j)))

            Population((rand_P(p))).p(rand_Row(i)).toArray((rand_Col(j))) = t1

          }
          else {
            //////////P
            val t1 = Population((rand_P(p))).p(rand_Row(i)).toArray((rand_Col(j)))

            Population((rand_P(p))).p(rand_Row(i)).toArray(rand_Col(j)) =
              Population(((rand_P(p) - 1))).p(rand_Row(i)).toArray(rand_Col(j))

            Population(((rand_P(p) - 1))).p(rand_Row(i)).toArray((rand_Col(j))) = t1

          }
        }
      }
    }

    Population

  }

  def CrossOverEliteByCol(Population: ListBuffer[PSO], EL: ListBuffer[PSO]) :
  ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val Np : Int = Population.length
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = rand.nextInt(Np/2).asInstanceOf[Int] //math.round(Np).asInstanceOf[Int] //Np
  // val rand_P = Array.range(0 , Np)
    val rand_P = GenRandList(Np, delta_P)

    //Best=Population[[1]]$P
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    var newVal :Double =0.0

    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]

      val index_EL = 0//rand.nextInt(EL.length)//rand.nextInt(2)

      for ( i <- 0  until delta_Row)
      {

        delta_Col = rand.nextInt((d).asInstanceOf[Int]) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        for (j <- 0  until delta_Col)
        {

          Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) =
            EL(index_EL).p(rand_Row(i)).toArray((rand_Col(j)))

        }
      }
    }

    Population

  }

  //CrossOver Elite List
  def CrossOverElite(Population : ListBuffer[PSO], EL: ListBuffer[PSO]) : ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Population.length)//2) //math.round(Population.length * 0.5).asInstanceOf[Int]//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
      {delta_P = 1}
    val rand_P =  GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    var delta_Row: Int = 0
    var index_EL :Int = 0

    for (p <- 0 until delta_P)
    {
      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)
      if (delta_Row == 0 )
      { delta_Row = 1 }
      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)
      //EL.length)
      if (iteration < MaxItbefInt)
      { index_EL  = rand.nextInt(EL.length)}
      else {
        index_EL  = rand.nextInt(2)
      }

      for( i <- 0 until delta_Row)
      {
        //////////P
        Population(rand_P(p)) .p(rand_Row(i))  =
          Vectors.dense(EL( index_EL ).p(rand_Row(i)).toArray).copy

      }
    }

    Population

  }

  //LocalElite List
  def LocalElite(Population : ListBuffer[PSO], EL: ListBuffer[PSO],
                 VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) : ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Population.length/2)//EL.length //rand.nextInt(EL.length) //rand.nextInt(Population.length)//2) //math.round(Population.length * 0.5).asInstanceOf[Int]//math.round(0.5 * Population.length).asInstanceOf[Int] //Np //round(0.7*Np)
    if (delta_P == 0 )
       {delta_P = 1}
    val rand_P = GenRandList(Population.length, delta_P) //base::sample(1:length(Population),delta_P,replace=FALSE)
    //var delta_Row: Int = 0
    var distance2Leader : Double = 0.0

    //val Vec = new Array[Double](d)
    //val result : Array[Vector] = new Array[Vector](r)
    //var b : Double = 1.0; //  parameters in Eq. (2.5)
    //var l : Double = 0.0//(-2.0) * rand.nextDouble() + 2.0;
    var pelrand: Double = 0.0
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    //var delta_Row : Int = 0

    for (p <- 0 until delta_P) {

      //l = (-2.0) * rand.nextDouble() + 2.0;


      delta_Row = rand.nextInt((r).asInstanceOf[Int])//math.round(r * 0.4).asInstanceOf[Int]  //base::sample(r,1)

      if (delta_Row == 0 )
      { delta_Row = 1 }
      val rand_Row =  GenRandList(r , delta_Row) //base::sample(r,delta_Row,replace=FALSE)

      val index_EL : Int = rand.nextInt(2)
      for (h <- 0 until delta_Row)
      {
        delta_Col = rand.nextInt((d)) //base::sample(d,1) //d
         if (delta_Col == 0 )
          { delta_Col = 1 }
        val rand_Col = GenRandList(d, delta_Col)

        for (j <- 0 until delta_Col)
        {
          distance2Leader = math.abs(EL(index_EL).p(rand_Row(h)).toArray(rand_Col(j)) - Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) ); // Eq. (2.5)

          Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) = distance2Leader * math.exp(1.0 * l) * math.cos(l * 2 * math.Pi) +
            EL(index_EL).p(rand_Row(h)).toArray(rand_Col(j))
          /*
          distance2Leader = rand.nextDouble() * ( ( VarMax(rand_Col(j)) - VarMin(rand_Col(j)) ) / 3) //- Population(rand_P(p)).p(h).toArray(j)); // Eq. (2.5)
          pelrand = rand.nextDouble()
          if (   pelrand >= 0.5  ) {
            Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) = distance2Leader  +
              EL(p).p(rand_Row(h)).toArray(rand_Col(j))
          }
          else{
            Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) =
              EL(p).p(rand_Row(h)).toArray(rand_Col(j)) - distance2Leader
          }

          if ( Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) > VarMax(rand_Col(j)))
            {
              Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) = VarMax(rand_Col(j))
            }
          else if ( Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) < VarMin(rand_Col(j)))
            {
              Population(rand_P(p)).p(rand_Row(h)).toArray(rand_Col(j)) = VarMin(rand_Col(j))
            }
          */

        }
      }
    }


    Population

  }



  //Intensification To Elite
  def InstensifyEliteFun(Population: ListBuffer[PSO], Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double],
                         BestCenters : Array[Vector], EL: ListBuffer[PSO]) :
  ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    var delta_P = rand.nextInt(Np/2) //Np
    if (delta_P == 0 )
    {delta_P = 1}
    val rand_P = GenRandList(Np, delta_P)

    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row : Int = 0
    var delta_Col : Int = 0
    //delta_Row = r
    //rand_Row=c(1:r)

    var distance2Leader : Double = 0.0
    var newVal :Double =0.0
    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt((r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
      { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]


      val index_EL = rand.nextInt(EL.length)

      for ( i <- 0  until delta_Row)
      {

        /*delta_Col = rand.nextInt((d).asInstanceOf[Int] ) //base::sample(d,1) //d
        if (delta_Col == 0 )
        { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]
        */
        delta_Col = d
        rand_Col.clear()
        for (vl <- 0 until d)
          {
            rand_Col += vl
          }

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0  until delta_Col)
        {

          //distance2Leader = math.abs(EL(index_EL).p(rand_Row(i)).toArray(rand_Col(j)) - Population(rand_P(p)).p(rand_Row(i)).toArray(rand_Col(j)) ); // Eq. (2.5)

          //Population(rand_P(p)).p(rand_Row(i)).toArray(rand_Col(j)) = distance2Leader * math.exp(1.0 * l) * math.cos(l * 2 * math.Pi) +
            //EL(index_EL).p(rand_Row(i)).toArray(rand_Col(j))


          oldVal = Population(rand_P(p)).p(rand_Row(i)).toArray(rand_Col(j))
          newVal= oldVal
          temp =   (VarMax(rand_Col(j)) - VarMin(rand_Col(j)) ) / 10

          if (oldVal  > EL(index_EL).p(rand_Row(i)).toArray(rand_Col(j)) )
          {
            //temp =   0.3 * rand.nextDouble() * ( oldVal -   EL(index_EL).p(rand_Row(i))(rand_Col(j)) )

             newVal=  EL(index_EL).p(rand_Row(i))(rand_Col(j)) + temp
          }
          else if (oldVal  < EL(index_EL).p(rand_Row(i)).toArray(rand_Col(j)) )
          {
            //temp =   0.3 * rand.nextDouble() * (  EL(index_EL).p(rand_Row(i))(rand_Col(j)) -  oldVal )
            newVal=  EL(index_EL).p(rand_Row(i))(rand_Col(j)) - temp
          }
          if (newVal == 0)
            newVal= oldVal


          Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) = newVal


        }
      }
      // Apply Position Limits
     // Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  //Intensification Function
  def InstensifyFun(Population: ListBuffer[PSO],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[PSO] = {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r=Population(1).p.length  //nrow(Population[[1]]$P)
    val delta_P = rand.nextInt((Np/2).asInstanceOf[Int])  //math.round(0.6 * Np).asInstanceOf[Int] // Np
    //val rand_P = Array.range(0 , Np)
    val rand_P = GenRandList(Np, delta_P)
    //Best=Population[[1]]$P
    var temp = 0.0
    var oldVal =0.0
    var x = 0.0
    var rand_Row : ListBuffer[Int] = new ListBuffer[Int]
    var rand_Col : ListBuffer[Int] = new ListBuffer[Int]
    var delta_Row = 0
    var delta_Col = 0
    //delta_Row = r
    //rand_Row=c(1:r)
    var newVal :Double =0.0
    for (p <- 0 until delta_P)
    {
      delta_Row =  rand.nextInt( (r).asInstanceOf[Int]) //base::sample(r,1) //r
      if (delta_Row == 0 )
        { delta_Row = 1 }
      rand_Row= GenRandList(r, delta_Row) //new ListBuffer[Int]

      for ( i <- 0  until delta_Row)
      {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if (delta_Col == 0 )
           { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col) //new ListBuffer[Int]

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0  until delta_Col)
        {
            oldVal = Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j)))
            x= rand.nextInt(2)//base::sample(2,1)
            temp = 0
            newVal = oldVal
            //OLD Method start
            if (rand.nextDouble()  >= 0.5  )
            {
              //val temp =  0.0001 * runif(1,0,1) * ( oldVal -  VarMin[1,rand_Col[j]])
              temp =   ( quantileInt(rand_Col(j)) -  VarMin(rand_Col(j)) )  * rand.nextDouble() //* ( oldVal -  VarMin(rand_Col(j)) )
              newVal= oldVal - temp
            }
            else
            {
              temp = ( quantileInt(rand_Col(j)) -  VarMin(rand_Col(j)) ) * rand.nextDouble() //* ( VarMax(rand_Col(j)) - oldVal)
              newVal= oldVal + temp
            }

            Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      Population(rand_P(p)).p =  AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax) //pmax(Population[[rand_P[p]]]$P,VarMin, na.rm = TRUE);

      //Population(rand_P(p)).p = pmin(Population[[rand_P[p]]]$P,VarMax, na.rm = TRUE);

    }

    Population

  }

  def DiversifyFun(Population: ListBuffer[PSO],Np: Int ,VarMin: ListBuffer[Double],VarMax: ListBuffer[Double]) :
  ListBuffer[PSO] =
  {

    val rand = new scala.util.Random()
    val d = Population(1).p.head.size
    val r = Population(1).p.length //nrow(Population[[1]]$P)
    val delta_P = rand.nextInt(math.round(0.3 * Np).asInstanceOf[Int]) //round(0.7*Np)
    var rand_Row: ListBuffer[Int]  = new ListBuffer[Int]()
    var delta_Col = 0
    var rand_Col: ListBuffer[Int] = GenRandList(d, 1)
    //var temp_Rand : Int = 0
    //var rand_P: ListBuffer[Int] = new ListBuffer[Int]
    val rand_P : ListBuffer[Int] = GenRandList(Np, delta_P)
    var delta_Row = 0
    var newVal: Double = 0.0
    var oldVal = 0.0
    var x = 0
    var temp = 0.0

    for (p <- 0 until delta_P) {

      delta_Row = rand.nextInt(r)//.asInstanceOf[Int]//rand.nextInt(r) //base::sample(r,1) //r
      if (delta_Row == 0 ) { delta_Row = 1}
      rand_Row = GenRandList(r, delta_Row) //new ListBuffer[Int]

      /*for (v <- 0 until delta_Row) {
        rand_Row += rand.nextInt(r) //base::sample(r,delta_Row,replace=FALSE) //c(1,r)
      }*/


      for (i <- 0 until delta_Row)
      {
        delta_Col = rand.nextInt(d) //base::sample(d,1) //d
        if ( delta_Col == 0 )
          { delta_Col = 1 }
        rand_Col = GenRandList(d, delta_Col)//new ListBuffer[Int]
        /*for (v <- 0 until delta_Col) {
          rand_Col += rand.nextInt(d) //base::sample(r,delta_Row,replace=FALSE) //c(1,r)
        }*/

        //rand_Col=base::sample(d,delta_Col,replace=FALSE) // c(1:d)

        for (j <- 0 until delta_Col)
        {
          //newVal = VarMin(rand_Col(j)) + rand.nextDouble() * (VarMax(rand_Col(j)) - VarMin(rand_Col(j)) )

          oldVal = Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j)))
          x = rand.nextInt(2)
          temp = 0
          newVal = oldVal
          if ( (rand.nextDouble() >= 0.5) & ( oldVal > VarMin(rand_Col(j))))
          {

            temp = ( quantileDiv(rand_Col(j)) -  VarMin(rand_Col(j)) ) * rand.nextDouble()
            newVal = oldVal - temp
          }
          else {

            temp = ( quantileDiv(rand_Col(j)) -  VarMin(rand_Col(j)) ) * rand.nextDouble()
            newVal = oldVal + temp
          }


          Population(rand_P(p)).p(rand_Row(i)).toArray((rand_Col(j))) = newVal

        }
      }
      // Apply Position Limits
      Population(rand_P(p)).p = AdjustMaxandMin(Population(rand_P(p)).p, VarMin, VarMax)

    }

    Population
  }

  def GenRandList(Np: Int , count: Int) :ListBuffer[Int] =
  {
    //val rand = new scala.util.Random()
    var l : ListBuffer[Int] =  new ListBuffer[Int]
    var temp_Rand : Int = 0
    for (v<-0 until count )
    {

      temp_Rand = rand.nextInt(Np)
      //if (temp_Rand == 0 )
        //{ temp_Rand = temp_Rand + 1}
      while(l.contains(temp_Rand) == true )
      {
        temp_Rand = rand.nextInt(Np)
      }
      l += temp_Rand
    }
    l
  }


  def AdjustMaxandMin(obj : Array[Vector], VarMin: ListBuffer[Double], VarMax: ListBuffer[Double]) : Array[Vector] =
  {
    //var x = obj
    val d = obj.head.size
    for (i<- 0 until obj.length)
      {
        for (j<-0 until d)
          {
            if ( obj(i).toArray(j) > VarMax(j) )
              {
                obj(i).toArray(j) = VarMax(j)
              }
            if ( obj(i).toArray(j) < VarMin(j) )
            {
              obj(i).toArray(j) = VarMin(j)
            }
          }
      }

    obj
  }

  //GSOF1
  def GSOF1(data: RDD[Vector], sc:SparkContext, centers: Array[Vector]) :(Double)=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    //println(bcCenters)
    // Find the new centers
    val newCenters = data.mapPartitions { points =>
      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        val (bestCenter, cost) = findClosest(thisCenters, point)
        val tempcost = cost * cost
        costAccum.add(tempcost)
        counts(bestCenter) += 1
        Dist(bestCenter) = Dist(bestCenter) + cost
      }
      Dist.indices.map(j => (j, ( Dist(j), counts(j) ))).iterator
    }.reduceByKey { case ( (d1, c1), (d2, c2) ) =>
      ( d1 + d2, c1 + c2 )
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    val SSE : Double = costAccum.value

    bcCenters.destroy()
    var IntraDist : ListBuffer[Double] = new ListBuffer[Double]()
    var CnterDist : ListBuffer[Double] = new ListBuffer[Double]()
    var ClustCount : ListBuffer[Double] = new ListBuffer[Double]()

    for ( i<- 0 until globalK)
    {
      IntraDist += 0.0
      CnterDist += 0.0
      ClustCount += 0.0
    }
    // Update the cluster centers and costs
    newCenters.foreach { case (j, newCenter) =>
      IntraDist(j) = newCenter._1
      ClustCount(j) = newCenter._2
    }

    var maxIntraDist : Double = IntraDist(0)
    for ( i<- 1 until globalK )
      {
        if ( maxIntraDist < IntraDist(i) )
          {
            maxIntraDist = IntraDist(i)
          }
      }

    var TotCentDist : Double = 0.0
    for ( i<- 0 until globalK )
      {
        for (j <- i until globalK )
          {
            TotCentDist = TotCentDist + math.pow(ObjFun(centers(i), centers(j)) , 2 )
          }
      }


    var Ret : Double = 0.0
    for ( j<- 0 until globalK)
      {
        Ret = Ret + (((1/data.count().asInstanceOf[Double])  * ClustCount(j)) / (SSE * ( IntraDist(j) / maxIntraDist ) ))
      }


    return (Ret)

  }

  //GSOF2
  def GSOF2(data: RDD[Vector], sc:SparkContext, centers: Array[Vector]) :(Double)=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    //println(bcCenters)
    // Find the new centers
    val newCenters = data.mapPartitions { points =>
      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        val (bestCenter, cost) = findClosest(thisCenters, point)
        val tempcost = cost * cost
        costAccum.add(tempcost)
        counts(bestCenter) += 1
        Dist(bestCenter) = Dist(bestCenter) + cost
      }
      Dist.indices.map(j => (j, ( Dist(j), counts(j) ))).iterator
    }.reduceByKey { case ( (d1, c1), (d2, c2) ) =>
      ( d1 + d2, c1 + c2 )
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    val SSE : Double = costAccum.value

    bcCenters.destroy()
    var IntraDist : ListBuffer[Double] = new ListBuffer[Double]()
    var CnterDist : ListBuffer[Double] = new ListBuffer[Double]()
    var ClustCount : ListBuffer[Double] = new ListBuffer[Double]()

    for ( i<- 0 until globalK)
    {
      IntraDist += 0.0
      CnterDist += 0.0
      ClustCount += 0.0
    }
    // Update the cluster centers and costs
    newCenters.foreach { case (j, newCenter) =>
      IntraDist(j) = newCenter._1
      ClustCount(j) = newCenter._2
    }

    var maxIntraDist : Double = IntraDist(0)
    for ( i<- 1 until globalK )
    {
      if ( maxIntraDist < IntraDist(i) )
      {
        maxIntraDist = IntraDist(i)
      }
    }

    var TotCentDist : Double = 0.0
    for ( i<- 0 until globalK )
    {
      for (j <- i until globalK )
      {
        TotCentDist = TotCentDist + math.pow(ObjFun(centers(i), centers(j)) , 2 )
      }
    }


    var Ret : Double = 0.0
    for ( j<- 0 until globalK)
    {
      Ret = Ret + (((1/data.count().asInstanceOf[Double]) * TotCentDist * ClustCount(j)) / (( IntraDist(j) / maxIntraDist ) ))
    }


    return (Ret)

  }

  //GSOF3
  def GSOF3(data: RDD[Vector], sc:SparkContext, centers: Array[Vector]) :(Double)=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    //println(bcCenters)
    // Find the new centers
    val newCenters = data.mapPartitions { points =>
      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
      val counts = Array.fill(thisCenters.length)(0L)
      val Dist = Array.fill(thisCenters.length)(0.0D)

      points.foreach { point =>
        val (bestCenter, cost) = findClosest(thisCenters, point)
        val tempcost = cost * cost
        costAccum.add(tempcost)
        counts(bestCenter) += 1
        Dist(bestCenter) = Dist(bestCenter) + cost
      }
      Dist.indices.map(j => (j, ( Dist(j), counts(j) ))).iterator
    }.reduceByKey { case ( (d1, c1), (d2, c2) ) =>
      ( d1 + d2, c1 + c2 )
    }.mapValues { case (sum, count) =>
      (sum, count)
    }.collectAsMap()

    val SSE : Double = costAccum.value

    bcCenters.destroy()
    var IntraDist : ListBuffer[Double] = new ListBuffer[Double]()
    var CnterDist : ListBuffer[Double] = new ListBuffer[Double]()
    var ClustCount : ListBuffer[Double] = new ListBuffer[Double]()

    for ( i<- 0 until globalK)
    {
      IntraDist += 0.0
      CnterDist += 0.0
      ClustCount += 0.0
    }
    // Update the cluster centers and costs
    newCenters.foreach { case (j, newCenter) =>
      IntraDist(j) = newCenter._1
      ClustCount(j) = newCenter._2
    }

    var maxIntraDist : Double = IntraDist(0)
    for ( i<- 1 until globalK )
    {
      if ( maxIntraDist < IntraDist(i) )
      {
        maxIntraDist = IntraDist(i)
      }
    }

    var TotCentDist : Double = 0.0
    for ( i<- 0 until globalK )
    {
      for (j <- i until globalK )
      {
        TotCentDist = TotCentDist + math.pow(ObjFun(centers(i), centers(j)) , 2 )
      }
    }


    var Ret : Double = 0.0
    for ( j<- 0 until globalK)
    {
      Ret = Ret + (((1/data.count().asInstanceOf[Double])* TotCentDist  * ClustCount(j)) / (SSE * ( IntraDist(j) / maxIntraDist ) ))
    }


    return (Ret)

  }

  def RecCentersHarmonic(data: RDD[Vector], sc:SparkContext, centers: Array[Vector],
                         p: Double)
  :(Double,Array[Vector])=
  {

    val costAccum = sc.doubleAccumulator
    val bcCenters = sc.broadcast(centers)
    val partNum =  data.partitions.length

    val Mapped = data.mapPartitionsWithIndex{  (index, points) =>

      val counts = Array.fill(partNum)(0.0D)
      var Up: ListBuffer[Vector] = new ListBuffer[Vector]
      var bottom: ListBuffer[Double] = new ListBuffer[Double]
      //Array.fill(thisCenters.length)(Vectors.zeros(dims))

      val thisCenters = bcCenters.value
      val dims = thisCenters.head.size

      points.foreach{ point =>

        val cost = HarCent(thisCenters, point, p)
        val tempcost = cost // cost
        costAccum.add(tempcost)
        counts(index) = counts(index) +  tempcost
        ///Compute the membership for all centers

        if (Up.length == 0)
        {
          for (j<-0 until thisCenters.length)
          {
            Up += Vectors.dense( Array.fill(dims)(0.0D))
            bottom += 0.0
          }
        }

        var m : Double =0.0
        var w : Double = 0.0
        var CentIndex = 0

        thisCenters.foreach { center =>
          m = ObjFunHar(center, point, (-1 * p) - 2) / HarCent(thisCenters, point, (-1 * p) - 2)
          w = HarCent(thisCenters, point, (-1 * p) - 2) /
                math.pow(HarCent(thisCenters, point, (-1 * p)), 2)
          for (j<-0 until dims)
          {
            Up(CentIndex).toArray.update(j, Up(CentIndex).toArray(j) + (point(j) * m * w) )
          }
          bottom(CentIndex) = bottom(CentIndex) + (m * w)
          CentIndex = CentIndex + 1
        }
      }
      Up.indices.map( j => ( j, (Up(j), bottom(j) ) )).iterator
    }.reduceByKey{ case ((up1, b1), (up2, b2)) =>
      axpy(1.0, up2, up1)
      (up1, b1 + b2)
    }.mapValues { case (sum, count) =>
      scal(1.0 / count, sum)
      Vectors.dense(sum.toArray)
    }.collectAsMap()


    /*counts.indices.filter(counts(_) > 0).map(j => (j, (sums(j), counts(j)))).iterator
  }.reduceByKey { case ((sum1, count1), (sum2, count2)) =>
    axpy(1.0, sum2, sum1)
    (sum1, count1 + count2)
  }.mapValues { case (sum, count) =>
    scal(1.0 / count, sum)
    Vectors.dense(sum.toArray)
  }.collectAsMap()*/

    Mapped.foreach { case (j, newCenter) =>
      centers(j) = newCenter
    }

    bcCenters.destroy()
    (costAccum.value , centers)

  }

  def HarCent(centers: TraversableOnce[Vector], p: Vector, par: Double) :Double =
  {
    var Ret: Double = 0.0
    var t : Double = 0.0
    centers.foreach { center =>
      t = ObjFunHar(center, p, par)
      if( t.equals(Double.NaN) == false )
        {Ret = Ret + ( 1 / t  )}
       //center.norm - point.norm
    }
    if( Ret.equals(Double.NaN) == false )
    {(globalK/ Ret )}
    else
    {0}

  }

  def ObjFunHar(p1: Vector, p2: Vector, par: Double): Double = {
    var squaredDistance : Double = 0.0
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance = math.pow(squaredDistance, par)
    squaredDistance

  }

  def HarSupFun (centers: TraversableOnce[Vector], p: Vector, par: Double) :Double =
  {
    var Ret: Double = 0.0
    var t : Double = 0.0
    centers.foreach { center =>
      t = ObjFunHar(center, p, par )
      if( t.equals(Double.NaN) == false )
      {Ret = Ret +  t  }
    }
    Ret
  }

  def RecCentersNew(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):
  (Double,Array[Vector], Double)={

    var PointsNew : ListBuffer[Int]= new ListBuffer[Int]()
    var temp: ListBuffer[Vector] = ListBuffer[Vector]()
    var sum : Double = 0.0

    for (i<- 0 until globalK)
    {
      PointsNew += 0

    }
    var TotalPointsCost: Double = 0.0
    var MaxCost: Double = Double.NegativeInfinity
    var Tup: Tuple2[Int, Double] = (-1, -1)
    var bIndex: Int = 0
    var cost : Double = 0.0
    val n : Double = data.count().asInstanceOf[Double]

    data.collect().foreach { point =>
      Tup  = findClosest(centers, point)
      bIndex = Tup._1
      cost = Tup._2
      cost = cost*cost
      sum = sum + cost

      PointsNew(bIndex) = PointsNew(bIndex) + 1
      TotalPointsCost = TotalPointsCost + cost
      if (MaxCost < cost)
        {MaxCost = cost}
    }

    var tc : Double = 0.0
    tc = TotalPointsCost / (n * MaxCost).asInstanceOf[Double]



    var TotalCenterCost: Double = 0.0
    var MaxCentCost : Double = Double.NegativeInfinity
    var MaxCentIndex: Double = 1.0

    for ( r<- 0 until globalK)
    {
      for ( g <- r+1 until globalK)
      {

          cost = ObjFun(centers(r), centers(g))
          cost = cost * cost
          if (MaxCentCost < cost)
            {
              MaxCentCost = cost
              MaxCentIndex = r+1
            }
          TotalCenterCost = TotalCenterCost + cost

      }
    }

    MaxCentIndex = centers.length
    if ( MaxCentIndex > 1)
      {
        MaxCentIndex = MaxCentIndex * (MaxCentIndex - 1.0)
      }

    var tr = (2.0* TotalCenterCost) / (MaxCentCost * MaxCentIndex).asInstanceOf[Double]  //globalK.asInstanceOf[Double] * (globalK - 1).asInstanceOf[Double] )

    var MaxCount : Int = PointsNew(0) //Int.MinValue
    var MinCount : Int = PointsNew(0)
    for (i<- 1 until globalK)
      {
        if ( MaxCount <  PointsNew(i) )
           { MaxCount =  PointsNew(i) }

        if ( MinCount >  PointsNew(i) )
            { MinCount =  PointsNew(i)     }

      }

    val ty  = MinCount.asInstanceOf[Double] / MaxCount.asInstanceOf[Double]

    //val Retcost = ( tc + (1.0 - tr) + ( 1.0 - ty) ) / 3.0   //original
    //val Retcost = ( tc + (( 1.0 - ty)*  0.5)  ) / 2.0 //Bwst for the iris 9.733

    val Retcost = ( tc  +   (1 - tr)    + (1-ty)  ) / 3.0   //



    (Retcost, centers, sum)

  }

  def RecCentersNoCenters(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):
  (Double,Array[Vector], Double)={

    //while (iteration < MaxIt) {
    //&& !converged) {

    var Retcost : Double = 0.0
    var d : Int = data.take(1)(0).toArray.length
    //println(bcCenters)

    var NewCenters : Array[Vector] = new Array[Vector](globalK)

    /*for ( i<- 0 until globalK)
      {
        NewCenters(i) =  Vectors.zeros(d)
      }
    var Count : ListBuffer[Int] = new ListBuffer[Int]()
    for ( i<- 0 until globalK)
    {
      Count +=  0
    }*/
      // Find the new centers
     data.collect().foreach{   point =>
         val (bestCenter, cost) = findClosest(centers, point)
         //println("Single Cost:" + cost + " : Best Center = " + bestCenter.toString)
         Retcost +=  ( (cost )  )//(cost * cost * cost * cost)
         /*for ( j <- 0 until d)
           {
             NewCenters(bestCenter).toArray(j) = NewCenters(bestCenter).toArray(j) +  point(j)
           }
         Count(bestCenter) = Count(bestCenter) + 1*/
       }

    /*for ( i <- 0 until globalK)
    {
      for ( j <- 0 until d)
      {
        NewCenters(i).toArray(j) = NewCenters(i).toArray(j) / d.asInstanceOf[Double]
      }
    }*/

    (Retcost, NewCenters, Retcost)

  }

  def RecCentersNewDist(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):
  (Double,Array[Vector], Double)={


    var TotalPointsCost: Double = 0.0
    var MaxCost: Double = Double.NegativeInfinity
    var Tup: Tuple2[Int, Double] = (-1, -1)
    var bIndex: Int = 0
    var cost : Double = 0.0
    val n : Double = data.count().asInstanceOf[Double]

    data.collect().foreach { point =>
      Tup  = findClosest(centers, point)
      bIndex = Tup._1
      cost = Tup._2
      TotalPointsCost = TotalPointsCost + cost
      if (MaxCost < cost)
      {MaxCost = cost}
    }

    var tc : Double = 0.0
    tc = TotalPointsCost / (n * MaxCost).asInstanceOf[Double]



    var TotalCenterCost: Double = 0.0
    var MaxCentCost : Double = Double.NegativeInfinity

    for ( r<- 0 until globalK-1)
    {
      for ( g <- r+1 until globalK)
      {

        if ( r != g)
        {
          cost = ObjFun(centers(r), centers(g))
          if (MaxCentCost < cost) {
            MaxCentCost = cost
          }
          TotalCenterCost = TotalCenterCost + cost
        }

      }
    }

    var tr =  TotalCenterCost / (MaxCentCost * globalK  ).asInstanceOf[Double]  //globalK.asInstanceOf[Double] * (globalK - 1).asInstanceOf[Double] )



    //val Retcost = ( tc + (1.0 - tr) + ( 1.0 - ty) ) / 3.0   //original
    //val Retcost = ( tc + (( 1.0 - ty)*  0.5)  ) / 2.0 //Bwst for the iris 9.733

    val Retcost = ( tc  +   (1 - tr)     ) // 2.0   //



    (Retcost, centers, Retcost)

  }

  def RecCentersNoCentersArray(data: Array[Vector], centers: Array[Vector], b_RetNewCent: Boolean = false):
  (Double,Array[Vector], Double)={

    //while (iteration < MaxIt) {
    //&& !converged) {

    var Retcost : Double = 0.0
    //println(bcCenters)

    // Find the new centers
    data.foreach{   point =>
      val (bestCenter, cost) = findClosest(centers, point)
      //println("Single Cost:" + cost + " : Best Center = " + bestCenter.toString)
      Retcost += (cost* cost)//(cost * cost * cost * cost)
    }


    (Retcost, centers, Retcost)

  }

  def RecCenters(data: RDD[Vector], sc:SparkContext, centers: Array[Vector], b_RetNewCent: Boolean = false):(Double,Array[Vector])={

    //while (iteration < MaxIt) {
    //&& !converged) {

      val costAccum = sc.doubleAccumulator
      val bcCenters = sc.broadcast(centers)
      //println(bcCenters)

      // Find the new centers
      val newCenters = data.mapPartitions { points =>
        val thisCenters = bcCenters.value
        val dims = thisCenters.head.size
        //println("dims: " + dims)

        val sums = Array.fill(thisCenters.length)(Vectors.zeros(dims))
        //println("sums: " + sums.toString)
        val counts = Array.fill(thisCenters.length)(0L)
        //println("counts: " + counts)

        points.foreach { point =>
          val (bestCenter, cost) = findClosest(thisCenters, point)
          //println("Single Cost:" + cost + " : Best Center = " + bestCenter.toString)

          val tempcost = cost * cost * cost * cost
          costAccum.add(tempcost)
          //println("costAccum:" + costAccum.value )
          val sum = sums(bestCenter)
          //***************UnKonwn Comment
          axpy(1.0, point, sum)
          //Add2Vec(1.0,point,sum)
          //println("point size:" + point.size + " class:" + point.getClass)
          //println("sum size:" +  sum.size + "   class:" + sum)
          //org.apache.spark.ml.linalg
          //sums.map(x=>println(x))
          counts(bestCenter) += 1
          //println("counts(bestCenter): " + counts(bestCenter))
        }

        counts.indices.filter(counts(_) > 0).map(j => (j, (sums(j), counts(j)))).iterator
      }.reduceByKey { case ((sum1, count1), (sum2, count2)) =>

        //***************UnKonwn Comment
        //println("1111111111111")
        //println("sum2:" + sum2 + "sum1:" + sum1)
        axpy(1.0, sum2, sum1)
        //println("count1: " + count1)
        (sum1, count1 + count2)
      }.mapValues { case (sum, count) =>
        //for(i<-1 to sum.size)
         // {println("Sum Before:" + sum(i))}
        //println("Sum Before:" + sum)
        //println("count Before:" + count)
        //***************UnKonwn Comment
        scal(1.0 / count.asInstanceOf[Double], sum)
        //***************UnKonwn Comment
        //new Vectors.dense(sum.toArray) //do not why this is used
        //for(i<-1 to sum.size)
        //{println("Sum After:" + sum(i))}

        //println("Sum:" + sum)

        Vectors.dense(sum.toArray)
      }.collectAsMap()

    val Retcost = costAccum.value  // SSEE Distance

    bcCenters.destroy()
      // Update the cluster centers and costs

      //// 24-12-2017
    /*if ( b_RetNewCent == true)
    {
      newCenters.foreach { case (j, newCenter) =>
        centers(j) = newCenter
      }
    }*/

    //println("newCenters")
    /*newCenters.foreach{x=>
      println(x)
     }*/

    /*var InterDist : Double = 0.0
    for ( i<- 0 until globalK )
    {
      for (j <- 0 until globalK )
      {
        if ( i != j)
        {
          InterDist = InterDist + math.pow(ObjFun(centers(i), centers(j)), 2)
        }
      }
    }
    val Retcost = costAccum.value.asInstanceOf[Double] / InterDist //Hybrid SSEE and InterDist*/

    //val Retcost = costAccum.value / data.count().asInstanceOf[Double] //Euclidean Distance


    //centers.foreach { x => println(x) }
    //println(s"The cost is $cost.")

    (Retcost, centers)

  }

  def ObjFun(p1: Vector, p2: Vector): Double = {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
      //squaredDistance = squaredDistance +  math.abs( ( p1(i) - p2(i) ) )
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  def parseVector(line: String): Vector = {
    val x = line.split(',').map(_.toDouble)
    Vectors.dense(x)
  }

  def Row2Vector(r: Row, except: ListBuffer[String]): Vector = {
    var l = new ListBuffer[Double]()
    for (i <- 0 until r.length ) {
      if ( except.contains(r.schema.fields(i).name) == false)
      {
        l += r.get(i).asInstanceOf[Double]
      }
    }
    //println("l :" + l(1))
    Vectors.dense(l.toArray)
  }

  def findClosest(centers: TraversableOnce[Vector], p: Vector): (Int, Double) = {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1
    //var tot: Double = 0.0

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFun(center, p) //center.norm - point.norm
      //tot += Dist
      if (Dist < bestDistance) {
        bestDistance = Dist
        bestIndex = i
      }
    }
    (bestIndex, bestDistance)
  }

  def findClosestRow(centers: TraversableOnce[Vector], p: org.apache.spark.sql.Row, except: ListBuffer[String]): (Int, Double) = {
    var bestIndex = 0
    var bestDistance = Double.PositiveInfinity
    var Dist: Double = 0.0
    var i = -1

    centers.foreach { center =>
      i = i + 1
      Dist = ObjFunRow(center, p, except) //center.norm - point.norm
      if (Dist < bestDistance) {
        bestDistance = Dist
        bestIndex = i
        //println("bestIndex " + bestIndex)
      }
      //println("Dist " + i + ":" + Dist)
    }
    (bestIndex, bestDistance)
  }

  def ObjFunRow(p1: Vector, p2: org.apache.spark.sql.Row, except: ListBuffer[String]): Double =
  {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      if (except.contains(p2.schema.fields(i).name) == false)
      {
        squaredDistance = squaredDistance + math.pow(p1(i) - p2.get(i).asInstanceOf[Double], 2)
        //squaredDistance = squaredDistance + math.abs(p1(i) - p2.get(i).asInstanceOf[Double])
      }
    }

    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  /*def createInputStream(fileName : String) : InputStream =
  {
    var inputStream : InputStream  = getClass().getResourceAsStream(fileName);
    if (inputStream == null)
    {
      inputStream = new FileInputStream(fileName) ;
    }

    return inputStream ;
  }*/

  def ReadFile(fileName: String) : Array[Vector] =
  {
    var list: ListBuffer[Double] = new ListBuffer[Double]()
    var Ret : Array[Vector] = new Array[Vector](150)//scala.io.Source.fromFile(fileName).getLines.length) //
    var l: Int  = 0
    var aux : String = ""
    var nObj : Int = 0
    var i : Int  = 0;
    var value : Double = 0.0
    //var Tokens : ListBuffer[String] = new ListBuffer[String]()
    val lines = scala.io.Source.fromFile(fileName).getLines.toTraversable

    for (line <- lines )
    {
      //var tokenizer : StringTokenizer  = new StringTokenizer(line, ",");
      //Tokens.clear()
      val Tokens = line.split(",")///.asInstanceOf[ListBuffer[String]]


      /*if (nObj == 0)
      {
        nObj = tokenizer.countTokens();
      }
      else if (nObj != tokenizer.countTokens())
      {
        throw new Exception("Invalid number of points read. "
          + "Expected: " + nObj + ", received: " + tokenizer.countTokens()) ;
      }*/

      list.clear()

      for (i <- 0 until Tokens.length )
      {
        value = java.lang.Double.parseDouble(Tokens(i).toString)
        // = Tokens(i)//.asInstanceOf[Double]    //new Double(tokenizer.nextToken());
        //point.setDimensionValue(i, value);
        list += value
      }
      val vec = new Array[Double](list.length)
      for( j<-0 until list.length)
      {
        vec.update(j, list(j))
      }
      //var point : Vector  = Vectors.dense(list.to)//Vectors.dense()
      //list.add(point);
      //PF += point
      Ret(l) = Vectors.dense(vec) //vec//
      l += 1

    }

/*

    //fileName = "/home/amr/Downloads/Pareto Front Values/UF/UF1.pf"
    //var inputStream : InputStream = createInputStream(fileName) ;
    var inputStream : InputStream = createInputStream(fileName) ;
    var isr : InputStreamReader = new InputStreamReader(inputStream);
    var br : BufferedReader = new BufferedReader(isr);

    //List<Point> list = new ArrayList<>();


    try
    {
      var nObj : Int = 0
      var aux : String = ""

      aux = br.readLine();

      while (aux != null)
      {
        var tokenizer : StringTokenizer  = new StringTokenizer(aux);
        var i : Int  = 0;
        if (nObj == 0)
        {
          nObj = tokenizer.countTokens();
        }
        else if (nObj != tokenizer.countTokens())
        {
          throw new Exception("Invalid number of points read. "
            + "Expected: " + nObj + ", received: " + tokenizer.countTokens()) ;
        }

        list.clear()
        while (tokenizer.hasMoreTokens())
        {
          var value : Double  = tokenizer.nextToken().toDouble    //new Double(tokenizer.nextToken());
          //point.setDimensionValue(i, value);
          list += value
          i += 1;
        }
        val vec = new Array[Double](list.length)
        for( j<-0 until list.length)
          {
            vec.update(j, list(j))
          }
        //var point : Vector  = Vectors.dense(list.to)//Vectors.dense()
        //list.add(point);
        //PF += point
        Ret(l) = Vectors.dense(vec) //vec//
        l += 1
        aux = br.readLine();
      }
      br.close();
    }
    catch
      {
        case (e: IOException) =>
        {
          throw new Exception("Error reading file", e);
        }
        case ( e: NumberFormatException ) =>
        {
          throw new Exception("Format number exception when reading file", e);
        }
      }
    //val numberOfPoints : Int = PF.length;
    */
    return Ret

  }


  def CompareMatrix(EL: ListBuffer[PSO], p: PSO) : Boolean =
  {
    var b_equal: Boolean = true
    var b_break: Boolean = true

    for (v <- 0 until EL.length)
    {
      b_equal = true
      b_break= false

      for (i <- 0 until EL(v).p.length)
      {
        for (j <- 0 until EL(v).p.head.size)
        {
          if (EL(v).p(i).toArray(j) != p.p(i).toArray(j))
          {
            b_equal = false
            b_break = true
          }
        }
      }
      if ( b_equal == true)
      { return true}
    }

    return b_equal
  }


  //def IsIdentical(p1: PSO , p2: PSO): Boolean = {}
  //EL, obj, max_EL
  def Add2EL(EL: ListBuffer[PSO], p: PSO, max_EL: Int): ListBuffer[PSO] ={

    var b_exist: Boolean = false
    if ( EL.length == 0 )
    {
      EL  += p.CopyObj
      //println("Add2EL: Added in 0")
      return EL
    }


    if  ( CompareMatrix(EL ,p) == true )
    {
      return EL
    }


    //println("Add2EL : Search for location")
    var Added : Boolean = false
    var i : Int = 0
    /*if (EL.length < max_EL)
    {
      EL  += p
      return EL
    }
    else {*/
    val maxTemp = EL.length

    for (i <- 0 until maxTemp)
    {
      if (CompareObj(p.fit, EL(i).fit) ) //( p.fit < EL(i).fit)
      {
        for (l<-maxTemp until i by -1)
        {
          if (EL(l-1) != null)
          {
            if ( l < max_EL)
            {
              if( l < EL.length )
                { EL(l) = EL(l-1).CopyObj }
              else
              {
                EL  += EL(l-1).CopyObj
              }
            }
            //else {}
          }
        }
        EL(i) = p.CopyObj
        Added = true
        //println("Add2EL: Added in " + i)
        return EL
      }
    }

    if (  EL.length < (max_EL - 1) )
    {
      EL  += p.CopyObj
    }

    EL
  }


   def Add2TLOrdered(TL: ListBuffer[PSO], p: PSO, max_TL: Int): ListBuffer[PSO] ={

    var b_exist: Boolean = false

    if ( TL.length == 0 )
    {
      TL  += p.CopyObj()
      return TL
    }

    var Added : Boolean = false
    var i : Int = 0
    if (TL.length < max_TL)
    {
      TL  += p.CopyObj()
      return TL
    }
    else {
      for (i <- 0 until TL.length) {
        if (CompareObj(TL(i).fit, p.fit) ) //( p.fit > TL(i).fit)
        {
          TL(i) = p.CopyObj()
          Added = true
          return TL
        }
      }

    }

    TL
  }

  //TL, obj, max_EL
  def Add2TL(TL: ListBuffer[PSO], p: PSO, max_TL: Int, Index: Int): ListBuffer[PSO] ={

    var b_exist: Boolean = false
    if ( TL.length == 0 )
    {
      TL  += p
      return TL
    }
    else
    {
      for (temp: PSO <- TL)
      {
        //temp.p.toArray.deep
        if ( temp != null && (temp.p.toArray.deep == p.p.toArray.deep ))
        {
          b_exist = true
          return TL
        }
      }
    }


    var Added : Boolean = false
    if (TL.length < max_TL)
    {
      TL  += p
      return TL
    }
    else {
      //Index =
      TL.update(Index, p)
      return TL

    }

  }

  def RandVel(k: Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): Array[Vector] =
  {

    val rand = new scala.util.Random()
    val result : Array[Vector] = new Array[Vector](k)
    val Vec = new Array[Double](d)

    for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec.update(j , rand.nextDouble() * ( quantileInt(j)  - minCol(j) ) )  //(maxCol(j) - minCol(j))  )
        //Vec.update(j , 0.0)
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  def RandCof( k : Int, d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): Array[Vector] =
  {

    val rand = new scala.util.Random()
    val result : Array[Vector] = new Array[Vector](k)
    val Vec = new Array[Double](d)

    for (h <- 0 until k)
    {
      for (j <- 0 until d)
      {
        Vec.update(j , rand.nextDouble() )
      }
      result.update(h,  Vectors.dense(Vec).copy)
    }
    result
  }

  /**
    * Initialize a set of cluster centers using the k-means|| algorithm by Bahmani et al.
    * (Bahmani et al., Scalable K-Means++, VLDB 2012). This is a variant of k-means++ that tries
    * to find dissimilar cluster centers by starting with a random center and then doing
    * passes where more centers are chosen with probability proportional to their squared distance
    * to the current cluster set. It results in a provable approximation to an optimal clustering.
    *
    * The original paper can be found at http://theory.stanford.edu/~sergei/papers/vldb12-kmpar.pdf.
    */
  //def initKMeansParallel(data: RDD[Vector], steps: Int): Array[Vector] = {
  def initKMeansParallel(data: RDD[Vector], steps: Int): Array[Vector] =
  {
    //
    // Initialize empty centers and point costs.
    var costs = data.map(_ => Double.PositiveInfinity)
    val initializationSteps = steps//20

    // Initialize the first center to a random point.

    val seed = new XORShiftRandom(scala.util.Random.nextLong()).nextInt()
    //val seed = scala.util.Random.nextLong()
    val sample = data.takeSample(false, 1, seed)
    // Could be empty if data is empty; fail with a better message early:
    require(sample.nonEmpty, s"No samples available from $data")

    val centers = ArrayBuffer[Vector]()
    var newCenters = Seq(sample.head.toDense)
    centers ++= newCenters

    // On each step, sample 2 * k points on average with probability proportional
    // to their squared distance from the centers. Note that only distances between points
    // and new centers are computed in each iteration.
    var step = 0
    val bcNewCentersList = ArrayBuffer[Broadcast[_]]()
    while (step < initializationSteps) {
      val bcNewCenters = data.context.broadcast(newCenters)
      bcNewCentersList += bcNewCenters
      val preCosts = costs
      costs = data.zip(preCosts).map { case (point, cost) =>
        math.min(findClosest(bcNewCenters.value, point)._2, cost)
      }.persist(StorageLevel.MEMORY_AND_DISK)
      val sumCosts = costs.sum()

      bcNewCenters.unpersist(blocking = false)
      preCosts.unpersist(blocking = false)

      val chosen = data.zip(costs).mapPartitionsWithIndex { (index, pointCosts) =>
        //**********To Be Returned
        val rand = new XORShiftRandom(seed ^ (step << 16) ^ index)
        //val rand = scala.util.Random
        pointCosts.filter { case (_, c) => rand.nextDouble() < 2.0 * c * globalK / sumCosts }.map(_._1)
      }.collect()
      newCenters = chosen.map(_.toDense)
      centers ++= newCenters
      step += 1
    }

    costs.unpersist(blocking = false)
    //bcNewCentersList.foreach(_.destroy(false))
    bcNewCentersList.foreach(_.destroy())

    val distinctCenters = centers.distinct //centers.map(_).distinct

    if (distinctCenters.size <= globalK) {
      distinctCenters.toArray
    } else {
      // Finally, we might have a set of more than k distinct candidate centers; weight each
      // candidate by the number of points in the dataset mapping to it and run a local k-means++
      // on the weighted centers to pick k of them
      val bcCenters = data.context.broadcast(distinctCenters)
      val countMap = data.map(findClosest(bcCenters.value, _)._1).countByValue()

      //bcCenters.destroy(blocking = false)
      bcCenters.destroy()

      val myWeights = distinctCenters.indices.map(countMap.getOrElse(_, 0L).toDouble).toArray
      kMeansPlusPlus(0, distinctCenters.toArray, myWeights, globalK, steps)
    }
  }

  def parseDVector(p :Vector) : Array[Double] ={
    p.toArray
  }

  /**
    * Run K-means++ on the weighted point set `points`. This first does the K-means++
    * initialization procedure and then rounds of Lloyd's algorithm.
    */
  def kMeansPlusPlus(
                      seed: Int,
                      points: Array[Vector],
                      weights: Array[Double],
                      k: Int,
                      MaxIt: Int
                    ): Array[Vector] = {
    val rand = new Random(seed)
    val dimensions = points(0).size
    val centers = new Array[Vector](k)

    // Initialize centers by sampling using the k-means++ procedure.
    centers(0) = pickWeighted(rand, points, weights).toDense
    val costArray = points.map(ObjFun(_, centers(0)))

    for (i <- 1 until k) {
      val sum = costArray.zip(weights).map(p => p._1 * p._2).sum
      val r = rand.nextDouble() * sum
      var cumulativeScore = 0.0
      var j = 0
      while (j < points.length && cumulativeScore < r) {
        cumulativeScore += weights(j) * costArray(j)
        j += 1
      }
      if (j == 0) {
        println("kMeansPlusPlus initialization ran out of distinct points for centers." +
          s" Using duplicate point for center k = $i.")
        centers(i) = points(0).toDense
      } else {
        centers(i) = points(j - 1).toDense
      }

      // update costArray
      for (p <- points.indices) {
        costArray(p) = math.min(ObjFun(points(p), centers(i)), costArray(p))
      }

    }

    // Run up to MaxIt iterations of Lloyd's algorithm
    val oldClosest = Array.fill(points.length)(-1)
    var iteration = 0
    var moved = true
    while (moved && iteration < MaxIt) {
      moved = false
      val counts = Array.fill(k)(0.0)
      val sums = Array.fill(k)(Vectors.zeros(dimensions))
      var i = 0
      while (i < points.length) {
        val p = points(i)
        val index = findClosest(centers, p)._1
        // axpy a*x + y
        axpy(weights(i), p, sums(index))
        counts(index) += weights(i)
        if (index != oldClosest(i)) {
          moved = true
          oldClosest(i) = index
        }
        i += 1
      }
      // Update centers
      var j = 0
      while (j < k) {
        if (counts(j) == 0.0) {
          // Assign center to a random point
          centers(j) = points(rand.nextInt(points.length)).toDense
        } else {
          scal(1.0 / counts(j), sums(j))
          centers(j) = Vectors.dense(sums(j).toArray)//new Vector(sums(j))
        }
        j += 1
      }
      iteration += 1
    }

    if (iteration == MaxIt) {
      println(s"Local KMeans++ reached the max number of iterations: $MaxIt.")
    } else {
      println(s"Local KMeans++ converged in $iteration iterations.")
    }

    centers
  }

  private def pickWeighted[T](rand: Random, data: Array[T], weights: Array[Double]): T = {
    val r = rand.nextDouble() * weights.sum
    var i = 0
    var curWeight = 0.0
    while (i < data.length && curWeight < r) {
      curWeight += weights(i)
      i += 1
    }
    data(i - 1)
  }

}

case class PSO(kout: Int) {
  //var k : Int=  0
  val k :Int = kout
  var p : Array[Vector] = new Array[Vector](k)        //= new Array[Vector](k)
  var v :Array[Vector] = new Array[Vector](k)
  var fit : Double  = 0
  var bp :Array[Vector] =  new Array[Vector](k)
  var bv :Array[Vector] = new Array[Vector](k)      //: Array[Vector]
  var bfit : Double  = 0

  def CopyObj(): PSO =
  {
    val obj = new PSO(this.k)
    obj.p = this.p        //= new Array[Vector](k)
    obj.v = this.v
    obj.fit = this.fit
    obj.bp = this.bp
    obj.bv  = this.bv      //: Array[Vector]
    obj.bfit  = this.bfit
    return obj
  }

}

class FMEval(kout: Int) {
  //var k : Int=  0
  val k :Int = kout
  var Points :ListBuffer[Row]= new ListBuffer[Row]
  var CountCluster = new Array[Int](k)        //= new Array[Vector](k)
  var RepClass : Int  = -1
  var CountClusterSorted = mutable.ListMap[Int, Int]()
  var MapCount = scala.collection.mutable.Map[Int, Int]()

}


  //override def  (obj: PSO) = {

  //}
  /*var v :Array[Vector] //= new Array[Vector](k)        //: Array[Vector]
  var fit : Double  = 0
  var bp :Array[Vector] //=  new Array[Vector](k)      //: Array[Vector]
  var bv :Array[Vector] //= new Array[Vector](k)      //: Array[Vector]
  var bfit : Double  = 0*/


  //var p : Array[Vector]
  /*def SetP(Pout:Array[Vector]) ={
    p=Pout
  }*/

  // Getter
  //def k = _k
  // Setter
  /*def getP: Array[Vector] = p
  def setP(pout:  Array[Vector]): this.type = {
    this.p = pout
    this
  }*/

  /*def bp_=(x$1: Array[Vector]): Unit = ???
  def bv_=(x$1: Array[Vector]): Unit = ???

  def getK: Int = k
  def setK(kout: Int): this.type = {
    this.k = kout
    this
  }

  def getP: Array[Vector] = p
  def setP(pout: Array[Vector]): this.type = {
    this.p = pout
    this
  }

  def getVel: Array[Vector] = v
  def setVel(vout: Array[Vector]): this.type = {
    this.v = vout
    this
  }

  def getFit: Double = fit
  def setFit(fitout: Double): this.type = {
    this.fit = fitout
    this
  }

  def getBestP: Array[Vector] = bp
  def setBestP(bpout: Array[Vector]): this.type = {
    this.bp = bpout
    this
  }

  def getBestV: Array[Vector] = bv
  def setBestV(bvout: Array[Vector]): this.type = {
    this.bv = bvout
    this
  }

  def getBFit: Double = bfit
  def setBFit(bfitout: Double): this.type = {
    this.bfit = bfitout
    this
  }*/



