
import java.util

import com.google.common.base.Preconditions
import com.google.common.collect.Lists
import org.apache.hadoop.mapreduce.v2.app.ClusterInfo
import org.apache.spark.api.java.JavaPairRDD
import org.apache.spark.api.java.JavaRDD
import org.apache.spark.api.java.function.PairFunction
import org.apache.spark.mllib.linalg.{Matrix, Vector, Vectors}

import scala.Tuple2
import scala.util._
import scala.io._
import scala.collection.mutable.ListBuffer
//import scala.collection.immutable.Vector
import org.apache.spark.SparkContext
import org.apache.spark.rdd._
import org.apache.spark.sql.{DataFrame, Row, SparkSession}

import scala.collection.mutable
//import BioValidIndice


object SilhouetteCoefficient {

  val obj_Bio : BioValidIndice = new BioValidIndice()
  type Point = ListBuffer[Double]
  type ClustPoints  = ListBuffer[Point]

  var k : Int = 3

  def ClosestCentSpearman( centers: Array[Vector], y: org.apache.spark.sql.Row,
      except:ListBuffer[String] = ListBuffer[String]("")) : (Int, Double) =
  {

    var minDist : Double = Double.MaxValue
    var dist : Double = 0.0
    var Index : Int = 0
    dist = obj_Bio.SpearmanCorRow(centers(0), y, except )._2
    minDist = dist

    for ( j<- 1 until centers.length )
      {
        dist = obj_Bio.SpearmanCorRow(centers(j), y, except )._2
        if ( dist < minDist )
          {
            minDist = dist
            Index = j
          }
      }

    return (Index, minDist)
  }

  def main( args: Array[String]) : Unit =
  {
    //scala.collection.immutable.Vector.empty
    //println("Month, Income, Expenses, Profit")
    //val dt = DataTable("NewTable", Seq(stringCol, integerCol, booleanCol))
  }
  def SilSeqCoeff(dataframe: DataFrame, DataNum: Int, centers: Array[Vector],
                  exception : ListBuffer[String] ) : Double =
  {


    var Eval: ListBuffer[FMEDilval] = new ListBuffer[FMEDilval]

    for (i<- 0 until k)
    {
      Eval += new FMEDilval(k)
      for (j<- 0 until k)
      {
        Eval(i).CountCluster(j)= 0
      }
    }


    /*var Data : ListBuffer[Point] = new ListBuffer[Point]
    var Row : Point = new Point
    val bufferedSource = io.Source.fromFile(
      "F:\\Amr\\MultiObjective WOA\\Code\\NNGWO_AllDatasets\\NNGWO_AllDatasets\\NNGWO\\Iris.txt")
    n = bufferedSource.getLines.length
    d = bufferedSource.getLines.take(0).toString().split(",").length
    for (line <- bufferedSource.getLines) {
      val cols = line.split(",").map(_.trim)
      Row.clear()
      cols.foreach( v => Row += v.asInstanceOf[Double])
      Data += Row
    }
    bufferedSource.close

    val bufferedCenters = io.Source.fromFile(
      "F:\\Amr\\MultiObjective WOA\\Code\\NNGWO_AllDatasets\\NNGWO_AllDatasets\\NNGWO\\centers.txt")
    var Centers : ListBuffer[Point] = new ListBuffer[Point]
    for (line <- bufferedCenters.getLines) {
      val cols = line.split(",").map(_.trim)
      Row.clear()
      cols.foreach( v => Row += v.asInstanceOf[Double])
      Centers += Row
    }
    bufferedCenters.close*/

    //var CIndex : Int = 0

    /*C1.clear()
    C2.clear()
    C3.clear()

    for ( i<- 0 until Data.length )
    {
      CIndex = Closest(Centers, Data(i))_1
      if (CIndex == 0 )
      {   C1 += Data(i)   }
      else if (CIndex == 1 )
      {   C2 += Data(i)   }
      else if (CIndex == 2 )
      {   C3 += Data(i)   }
    }*/

    var rIndex : Int = -1

    dataframe.collect().foreach { r =>
      val bIndex = ClosestCentSpearman(centers, r, exception)._1

      Eval(bIndex).Points += r
      rIndex = rIndex + 1

    }

    var d = 0
    var n = rIndex//150

    var silhCoeff : Double = 0
    var totalCount : Int = 0;
    var currP : Point = new Point()
    var S : ListBuffer[Double] = new ListBuffer[Double]();
    var clusteringMean: Double = 0;

    for ( j<-0 until k )
    {
      System.out.println("Computing Silhouette Coeff Cluster " + j)
      //System.out.println("Number of document in cluster : " + Eval(j).Points.length)
      var clusterMean : Double = 0;
      //val CPoints = Eval(j).Points //RetClusterPoints(j)

      for ( p <-0 until Eval(j).Points.length )
      {
        var A : Double =0;
        var B : Double =0;
        var sumA : Double = 0;

        for ( notp <-0 until Eval(j).Points.length )
        {
          if ( p != notp)
            sumA += obj_Bio.SpearmanCorRow2Row(Eval(j).Points(p), Eval(j).Points(notp), exception )._2
           //   Dist(CPoints(p), CPoints(notp))
        }
        if (Eval(j).Points.length > 1)
        { A = sumA / (Eval(j).Points.length - 1).asInstanceOf[Double]   }
        var minDist = Double.MaxValue
        var closestClusterIndex : Int = 0

        for (jj <- 0 until k )
        {
          if (jj != j)
          {
            if (Eval(jj).Points.length > 0)
            {
              val distTemp = obj_Bio.SpearmanCor(centers(j), centers(jj))._2;
              if (distTemp < minDist) {
                minDist = distTemp;
                closestClusterIndex = jj;
              }
            }
          }
        }

        var sumB : Double = 0;
        //val ClosestCP =  RetClusterPoints(closestClusterIndex)
        for (closestIdex <- 0 until  Eval(closestClusterIndex).Points.length )
        {
          //if (d==D){continue;}
          val tempB =obj_Bio.SpearmanCorRow2Row(Eval(closestClusterIndex).Points(closestIdex),
            Eval(j).Points(p), exception)._2;
          sumB = sumB +  tempB
        }
        B = sumB / Eval(closestClusterIndex).Points.length.asInstanceOf[Double]

        var Si : Double = (B-A)/Math.max(B, A);
        if (Math.max(B, A)==0){
          Si = 0;
        }
        clusterMean += Si;

      }

      if (Eval(j).Points.length > 0)
      {
        clusterMean=clusterMean/Eval(j).Points.length.asInstanceOf[Double];
      }

      System.out.println("Silhoutte Coefficient for Cluster "+j+" : "+clusterMean);
      System.out.println();
      S += clusterMean
      //count++;
      clusteringMean += clusterMean;


    }

    clusteringMean = clusteringMean/ k.asInstanceOf[Double] ;
    //this.score = clusteringMean;

    /*IOFile io = new IOFile();
    io.openWriteFile("Silhouette.csv");
    io.write(C.ID);
    io.write(",");
    io.write(Double.toString(this.score));
    io.write("\n");
    io.close();*/
    System.out.println("Silhouette Coefficient for CLUSTERING : "+clusteringMean);

    return clusteringMean


  }

  def Closest ( centers: ListBuffer[ListBuffer[Double]], p : ListBuffer[Double] ): (Int, Double) =
  {
    var mIndex : Int = 0
    var mVal : Double = Double.MaxValue
    var dist : Double = 0.0

    for ( i <- 0 until centers.length )
    {
      dist = Dist(centers(i) , p)
      if ( dist < mVal )
      {
        mVal = dist
        mIndex = i
      }
    }


    return (mIndex, mVal)
  }

  def Dist ( p1: ListBuffer[Double], p2: ListBuffer[Double] ) : Double =
  {
    var v: Double = 0
    for ( i<- 0 until p1.length)
    {
      v += math.pow(p1(i) - p2(i),2)
    }
    val ret = math.sqrt(v)

    return ret
  }


  /*
  private val MAX_SAMPLE_SIZE = 100000

  def fetchSampleData(evalData: JavaRDD[Vector]): JavaRDD[Vector] =
  {
    var data = evalData
    val count = evalData.count
    if (count > MAX_SAMPLE_SIZE) data = evalData.sample(false, MAX_SAMPLE_SIZE.toDouble / count)
    data
  }

  def silhouetteCoefficient(ai: Double, bi: Double): Double =
  {
    if (ai < bi) return 1.0 - (ai / bi)
    if (ai > bi) return (bi / ai) - 1.0
    0.0
  }

  @SuppressWarnings(Array("unchecked")) private def iterableToList[T](it: Iterable[T]) = if (it.isInstanceOf[util.List[_]]) it.asInstanceOf[util.List[T]]
  else Lists.newArrayList(it)
}

final class SilhouetteCoefficient(val clusters: List[ClusterInfo]) extends Nothing(clusters)
{
  def evaluate(evalData: JavaRDD[Vector]): Double =
    silhouetteCoefficient(fetchClusteredPoints(SilhouetteCoefficient.fetchSampleData(evalData)).collectAsMap)

  /**
    * Computes the Silhouette Coefficient for this clustering.
    * See https://en.wikipedia.org/wiki/Silhouette_(clustering)
    *
    * @param clusterPointsByID map of cluster ID to points that map to that cluster,
    *                          for whom Silhouette coefficient needs to be computed
    * @return Silhouette Coefficient in range [-1,1]; higher is better
    */
  def silhouetteCoefficient(clusterPointsByID: util.Map[Integer, Iterable[Array[Double]]]): Double =
  {
    var totalSilhouetteCoefficient = 0.0
    var sampleCount = 0L
    import scala.collection.JavaConversions._
    for (entry <- clusterPointsByID.entrySet) {
      val clusteredPoints = SilhouetteCoefficient.iterableToList(entry.getValue)
      val clusterSize = clusteredPoints.size
      // Increment the total sample count for computing silhouette coefficient
      sampleCount += clusterSize
      // if there's only one element in a cluster, then assume the silhouetteCoefficient for
      // the cluster = 0, this is an arbitrary choice per Section 2: Construction of Silhouettes
      // in the referenced paper
      if (clusterSize > 1) {
        import scala.collection.JavaConversions._
        for (point <- clusteredPoints) {
          val pointIntraClusterDissimilarity = clusterDissimilarityForPoint(point, clusteredPoints, true)
          val pointInterClusterDissimilarity = minInterClusterDissimilarityForPoint(entry.getKey, point, clusterPointsByID)
          totalSilhouetteCoefficient += SilhouetteCoefficient.silhouetteCoefficient(pointIntraClusterDissimilarity, pointInterClusterDissimilarity)
        }
      }
    }
    if (sampleCount == 0) 0.0
    else totalSilhouetteCoefficient / sampleCount
  }

  def ObjFun(p1: Array[Double], p2: Array[Double]): Double =
  {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  def ObjFun(p1: Vector, p2: Vector): Double =
  {
    var squaredDistance : Double = 0.0
    //println("Dim P1:" + p1.size)
    for (i<- 0 until p1.size)
    {
      squaredDistance = squaredDistance +  math.pow( ( p1(i) - p2(i) ) , 2)
    }
    squaredDistance = math.sqrt(squaredDistance)
    squaredDistance

    //math.sqrt((p1.toArray zip p2.toArray).map { case (x, y) => math.pow(y - x, 2) }.sum)

  }

  private def fetchClusteredPoints(evalData: JavaRDD[Vector]) =
    evalData.mapToPair(new PairFunction[Vector, Integer, Array[Double]]() {
    override def call(vector: Vector): Tuple2[Integer, Array[Double]] = {
      var closestDist = Double.PositiveInfinity
      var minClusterID = Integer.MIN_VALUE
      val vec = vector.toArray
      val distanceFn = getDistanceFn
      val clusters = getClustersByID
      import scala.collection.JavaConversions._
      for (cluster <- clusters.values) {
        val distance = ObjFun(cluster.getCenter, vec)//distanceFn.distance(cluster.getCenter, vec)
        if (distance < closestDist) {
          closestDist = distance
          minClusterID = cluster.getID
        }
      }
      Preconditions.checkState(!java.lang.Double.isInfinite(closestDist) && !java.lang.Double.isNaN(closestDist))
      new Tuple2[Integer, Array[Double]](minClusterID, vec)
    }
  }).groupByKey

  def clusterDissimilarityForPoint(point: Array[Double], clusterPoints: util.List[Array[Double]], ownCluster: Boolean) = {
    val distanceFn = getDistanceFn
    var totalDissimilarity = 0.0
    import scala.collection.JavaConversions._
    for (clusterPoint <- clusterPoints) {
      totalDissimilarity += ObjFun(point, clusterPoint)//distanceFn.distance(point, clusterPoint)
    }
    if (ownCluster) { // (points.size -1) because a point's dissimilarity is being measured with other
      // points in its own cluster, hence there would be (n - 1) dissimilarities computed
      totalDissimilarity / (clusterPoints.size - 1)
    }
    else { // point dissimilarity is being measured with all points of one of other clusters
      totalDissimilarity / clusterPoints.size
    }
  }

  private def minInterClusterDissimilarityForPoint(otherClusterID: Int, point: Array[Double], clusteredPointsMap: util.Map[Integer, Iterable[Array[Double]]]) = {
    var minInterClusterDissimilarity = Double.PositiveInfinity
    import scala.collection.JavaConversions._
    for (entry <- clusteredPointsMap.entrySet) { // only compute dissimilarities with other clusters
      if (!(entry.getKey == otherClusterID)) {
        val clusteredPoints = SilhouetteCoefficient.iterableToList(entry.getValue)
        minInterClusterDissimilarity =
          Math.min(minInterClusterDissimilarity, clusterDissimilarityForPoint(point, clusteredPoints, false))
      }
    }
    minInterClusterDissimilarity
  }
  */
}


class FMEDilval(kout: Int) {
  //var k : Int=  0
  val k :Int = kout
  var Points :ListBuffer[Row]= new ListBuffer[Row]
  var CountCluster = new Array[Int](k)        //= new Array[Vector](k)
  var RepClass : Int  = -1
  var CountClusterSorted = mutable.ListMap[Int, Int]()
  var MapCount = scala.collection.mutable.Map[Int, Int]()

}
